#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct functable{
 int lineNum;
 char funName[256];
 char fileName[256];
}FTAB;

typedef struct sourceinfo{
 int lineNum;
 int scope;
 int stmtID;
 int parent;
 int isExecutable;
}SINFO;

typedef struct intermediateFiles{
  char   fileName[256];
  SINFO  *lineInfo;
}FILES ;

FILES *files=NULL,*tfiles;
FTAB  *functab=NULL,*tftab;
SINFO *tsinfo;

main(argc, argv)
int argc;
char *argv[];
{
  FILE *fp;
  char lines[256],*ptr,fname[256];
  int nfuncs=0,numOfFiles=0;
  int j,i,k,filelen,newfuncs;
 
  if (argc < 2){
    printf("Unknown file name \n");
    return;
  }

  fp = fopen(argv[1],"r");


  /* read comment "File Name" */
   fgets(lines,256,fp);
  
  while(!feof(fp))
  {
     /* read comment "File Name" */
    /*fgets(lines,256,fp); */
   
     /* read file name */
     fgets(lines,256,fp);
     strcpy(fname,strtok(lines,"\n\r\t "));
     printf("file name = %s\n",fname);

     /*read comment "Length of File " */
     fgets(lines,256,fp);
     /* read file length */
     fgets(lines,256,fp);
     filelen = atoi(lines);
     printf("length of file = %d\n",filelen);

     /* read comment "number of functions" */
     fgets(lines,256,fp);
     /* read number of functions */
     fgets(lines,256,fp);
     newfuncs = atoi(lines);
     printf("nfuncs = %d\n",newfuncs);

     /* read comment "LineNumber  FunctionName FileName" */
     fgets(lines,256,fp);
     /* allocate function table structure */
     functab = (FTAB *)realloc(functab,(newfuncs+nfuncs)*sizeof(FTAB));
     
     for(i=nfuncs;i<nfuncs+newfuncs;i++){
       /* read one line of function info */
       fgets(lines,256,fp);
       ptr = strtok(lines,"\n\r\t ");
       functab[i].lineNum = atoi(ptr);
       strcpy(functab[i].funName, strtok(NULL,"\n\r\t "));
       strcpy(functab[i].fileName, fname);
       printf("%d   %s  %s\n", functab[i].lineNum,functab[i].funName,
          functab[i].fileName);
     }

     /* accumulate total number of functions */
     nfuncs += newfuncs ; 

     /* read comment "LineNumber Scope stmtID parent isExecutable" */
     fgets(lines,256,fp);
     
     /* allocate source line info structure */
     files  = (FILES *)realloc(files,(numOfFiles+1)*sizeof(FILES));
     files[numOfFiles].lineInfo = NULL;
     files[numOfFiles].lineInfo = (SINFO *)realloc(files[numOfFiles].lineInfo,
                     filelen*sizeof(SINFO));
      
     i = numOfFiles;
     for(j=0;j <filelen;j++){
       /* read line number */
       fgets(lines,256,fp);
       k = atoi(strtok(lines,"\n\r\t "));
       files[i].lineInfo[k].lineNum = k;
       files[i].lineInfo[k].scope = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].stmtID = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].parent = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isExecutable = atoi(strtok(NULL,"\n\r\t "));
       printf("%d  %d  %d  %d %d \n",files[i].lineInfo[k].lineNum, 
          files[i].lineInfo[k].scope   ,
          files[i].lineInfo[k].stmtID  ,
          files[i].lineInfo[k].parent  ,
          files[i].lineInfo[k].isExecutable );
     }
     numOfFiles++;

     /* read comment "File Name" */
     fgets(lines,256,fp);
  }
  fclose(fp);
  
}
