program test2d_gauss3d
integer, parameter         :: asize=25
real(KIND=8), dimension(asize,asize,asize) :: r
real(KIND=8), dimension(asize,asize) :: a,b,p1x,p1y,p1z
real(KIND=8), dimension(asize)     :: x,y,z,c
real(KIND=8) sigma, ampl, timei,offset

!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE (*,BLOCK) ONTO P :: a,b,p1x,p1y,p1z
!HPF$ DISTRIBUTE y(BLOCK) ONTO P
!HPF$ DISTRIBUTE r(*,BLOCK,*) ONTO P

interface
subroutine compute_r(ampl,sigma,r)

real(KIND=8) ampl,sigma
real(KIND=8), dimension(:,:,:), intent(out) :: r
!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE *(*,BLOCK,*) ONTO *P :: r

end subroutine



end interface  

integer i,j,k,l,m

np=NUMBER_OF_PROCESSORS()
ampl=1.0d-02
sigma=20.d0
offset=asize/2.0d0

forall(i=1:asize) x(i)=i*1.d0
forall(i=1:asize) y(i)=i*1.d0
forall(i=1:asize) z(i)=i*1.d0

w=3.0
do k=1,20,2

do ii=1,1000000
xx=(xx+1)**3+(xx-1)**5
enddo

sigma=sigma*1.25

!Send b,c,r to Webflow
call compute_r(ampl,sigma,r)

forall(i=1:asize,j=1:asize) &
  a(i,j)=ampl* exp(-((x(i)-offset)**2/sigma))*   &
               exp(-((y(j)-offset)**2/sigma))

forall(i=1:asize,j=1:asize) &
  b(i,j)=ampl*sin(0.1d0*(x(i)+k))*cos(0.1d0*(y(j)-k))

c=a(:,10)
p1x=r(10,:,:)
p1y=r(:,10,:)
p1z=r(:,:,10)

timei=1.0d0*k

!call SciViz2d(1,timei,x,y,p1z,np)
!call SciViz2d(2,timei,x,y,b,np)
!call SciViz1d(3,timei,x,c,np)
!call SciViz2d(4,timei,x,y,p1x,np)
!call SciViz2d(5,timei,x,y,p1y,np)

enddo

do l=1,19,2

sigma=sigma/1.25

call compute_r(ampl,sigma,r)

forall(i=1:asize,j=1:asize) &
  a(i,j)=ampl* exp(-((x(i)-offset)**2/sigma))*   &
               exp(-((y(j)-offset)**2/sigma))

forall(i=1:asize,j=1:asize) &
  b(i,j)=ampl*sin(0.1d0*(x(i)+k))*cos(0.1d0*(y(j)-k))

c=a(:,10)
p1x=r(10,:,:)
p1y=r(:,10,:)
p1z=r(:,:,10)
k=k+1
timei=1.0d0*k

!call SciViz2d(1,timei,x,y,p1z,np)
!call SciViz2d(2,timei,x,y,b,np)
!call SciViz1d(3,timei,x,c,np)
!call SciViz2d(4,timei,x,y,p1x,np)
!call SciViz2d(5,timei,x,y,p1y,np)

enddo

end

subroutine compute_r(ampl,sigma,r)

real(KIND=8) ampl,sigma
real(KIND=8), dimension(:,:,:), intent(out) :: r

real(KIND=8), dimension(size(r,dim=1)):: x,y,z

!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE *(*,BLOCK,*) ONTO *P :: r

!HPF$ DISTRIBUTE (BLOCK) :: y

integer asize,offset
integer i,j,k

asize=size(r,dim=1)
offset=asize/2

forall(i=1:asize) x(i)=i*1.d0
forall(i=1:asize) y(i)=i*1.d0
forall(i=1:asize) z(i)=i*1.d0

forall(i=1:asize,j=1:asize,k=1:asize) &
  r(i,j,k)=ampl*sin(0.1d0*(x(i)+k))*   &
               exp(-((y(j)-offset)**2/sigma))*   &
               exp(-((z(k)-offset)**2/sigma))

end








