#include "debugger.h"

#define P(i) (stack[ind[i+1]].buf)
#define D(i) (stack[ind[i+1]].desc)
char *toLowerCase(char *exfuncName);
void *makeFuncCall();
char (*fptr)();

int callFuncDynamic(char *hpfStmtList, char *curHpfFunc,ERRBUF *errbuf)
{
    char *funcInBuf;  
    FILE *fp;
    int pid,status,numOfusedVars;
    char funcName[128],libname[128],cmnd[256];
    char *usedVars[128];
    void *handle;
    int *iptr;
    int  retval=0;
    char *exfuncName ,*genFunc;
    pthread_t	tid;
    int ind[32],nparams,n;
    sigset_t new;

    retval = generateNewFunction(hpfStmtList,curHpfFunc,
           funcName,usedVars,&numOfusedVars,genFunc);

    if (retval != 0){
      errbuf->type = COMPILE_ERROR;
      errbuf->status = retval;
      return retval;
    }

    if (DEBUG){
       fprintf(fpout,"I got the string : %s nusedvars:%d\n",
              hpfStmtList,numOfusedVars);
       fprintf(fpout,"its function is : %s\n",genFunc);
    }

    exfuncName = (char *)malloc(sizeof(funcName)+2);
    strcpy(exfuncName,funcName);
    strcat(exfuncName,"_");

    if (HOST){
       /* Build shared object from the on-the-fly generated function */
       strcpy(cmnd,"pghpf -Mfree -G -dy foos.hpf -o libfoo.so > errout 2>&1");
       if (DEBUG)
	 fprintf(fpout,"I execute this: %s\n",cmnd);
       retval = system(cmnd);
       /* I checked whether user input syntax errors at "generateNewFunction"
          function as above ,the first stmt of "callFuncDynamic" function */ 
    }

    if ((handle = dlopen("libfoo.so",RTLD_LAZY)) == 0)
       fatal("%s\n",dlerror());

    if ((fptr = (char (*)())dlsym(handle,toLowerCase(exfuncName))) == 0)
       fatal("%s\n",dlerror());
    
    nparams = calcIndices(curHpfFunc,usedVars,numOfusedVars,&ind[1]); 
    ind[0]  = nparams;

    sigfillset(&new);
    pthread_sigmask(SIG_BLOCK, &new, NULL);
    if ( n = pthread_create( &tid, NULL, makeFuncCall, (void *)ind ) ) {
	fprintf( stderr, "pthread_create: %s\n", strerror( n ) );
	exit( 1 );
    }

    if ( n = pthread_join( tid, NULL ) ) {
	fprintf( stderr, "pthread_join: %s\n", strerror( n ) );
	exit( 1 );
    }

    errbuf->type = RUNTIME_ERROR;
    errbuf->status = funcCallStatus ;
   
    dlclose(handle);
    if (errbuf->status != 0)
      return (errbuf->status);
    else
      return 0;      
}
   
char *toLowerCase(char *s)
{
  int i;

  for(i=0;i<strlen(s);i++){
     if ((s[i]>=65)&&(s[i]<=90))
       s[i] += 32;
  }
  return s;
}


void  interrupt(int sig)
{
   funcCallStatus = sig;
   pthread_exit( 0 ); 
   return;
}

void *makeFuncCall(void *indx)
{
  int nparams,*ind = (int *)indx;
  struct sigaction act;  
  sigset_t new;  

  funcCallStatus = 0;
  set_signal_handler(interrupt);
  /*
  act.sa_handler = interrupt;
  sigaction(SIGFPE, &act, NULL); 
  sigaction(SIGSEGV, &act, NULL);
  sigfillset(&new);     
  pthread_sigmask(SIG_UNBLOCK, &new, NULL); 
  */
  
  nparams = ind[0];
  switch(nparams)
    {
    case 0: (*fptr)();
      break;
    case 1:(*fptr)(P(0),D(0)); 
      break;
    case 2:(*fptr)(P(0),P(1),D(0),D(1));
     break;
    case 3:(*fptr)(P(0),P(1),P(2),D(0),D(1),D(2));
     break;
    case 4:(*fptr)(P(0),P(1),P(2),P(3),D(0),D(1),D(2),D(3));
     break;
    case 5:(*fptr)(P(0),P(1),P(2),P(3),P(4),D(0),D(1),D(2),D(3),D(4));
     break;
    case 6:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),
           D(0),D(1),D(2),D(3),D(4),D(5));
    break;
    case 7:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6));
    break;
    case 8:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7));
    break;
    case 9:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8));
    break;
    case 10:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8),D(9));
    break;
    case 11:
       (*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),P(10),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8),D(9),D(10));
    break;
    case 12:
    (*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),P(10),P(11),
       D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8),D(9),D(10),D(11));
    break;
 
    case 13:
    (*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),P(10),P(11),
        P(12),D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8),D(9),D(10),D(11),
	    D(12));
 
    break;
    
    }  
    pthread_exit( 0 ); 
}
 
int  calcIndices(char *curHpfFunc,char *usedVars[],int numOfusedVars,int *ind)
{
   int i,r,cnt;

   for (i=0,cnt=0;i<numOfusedVars;i++)
   {
     if ((r = find_var(curHpfFunc,usedVars[i])) < 0){
        if (DEBUG)
          fprintf(fpout,"I couldn't find the var : %s in function :%s\n",
		usedVars[i], curHpfFunc);
     }
     else
        ind[cnt++] = r;
   }
   if (DEBUG)
      fprintf(fpout,"After calcIndices nvars=%d\n",cnt);
   return cnt;
}
    

void fatal(char *s1, char *s2)
{
  
  printf(s1,s2);
  exit(0);
}

