#include <stdio.h>
#include "compilerApi.h"
#include <malloc.h>
#include <string.h>
#include "deftypes.h"


// LINK WITH inslib.o to build executable
void insert_decls(SgStatement *,int numOfNDVars,char *notDefinedVars[]);
void insert_register_defined_vars(SgStatement *s,
		int numOfNDVars,  char *notDefinedVars[]);

extern int max_push_id;
extern DATA stack[MAX_VARS];

main(int argc,char *argv[])
{
    int  numOfNDVars;
    char *notDefinedVars[argc];
    char depfile[512],sourcefile[512];
    char *tempBuf,command[512];

    strcpy(depfile,argv[1]);
    numOfNDVars = argc-2;
    for(int i=2;i<numOfNDVars+2;i++){
      notDefinedVars[i-2] = (char *)malloc(512);
      strcpy(notDefinedVars[i-2],argv[i]);
    }
    
    char *myargs[3]={NULL,NULL,(char *)NULL};
    myargs[1] =  (char *)malloc(256);
    strcpy(myargs[1],depfile);
    SgProject *project = new SgProject("test.prj",2,myargs);
    SgFile *tempSgFile = &(project->file(0));
    
    /* add registration for variables user defined now */
    SgStatement *firstStmt = tempSgFile->functions(0);
    insert_decls(firstStmt,numOfNDVars,notDefinedVars);
    insert_register_defined_vars(firstStmt, numOfNDVars, notDefinedVars);
    tempBuf = firstStmt->unparseToBuf(); 
    
    strcpy(sourcefile,depfile);
    *(strchr(sourcefile,'.')) = 0;
    strcat(sourcefile,".hpf");

    tempSgFile->saveDepFile("tempxxx.dep");
    sprintf(command,"unparse  %s > %s ","tempxxx.dep",sourcefile);
    system(command);
}
