#include <stdio.h> 
#include "compilerApi.h"
#include <malloc.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <assert.h>
/*#include <iostream.h>
#include <fstream.h> */  

#define SLOCAL       1
#define DISTRIBUTED  2
#define BEFORE       0
#define AFTER        1

// Find the enclosing function/subroutine unit

// decl for lexical analyser
#define VARID   509
#define MAXVARS 256
char *input_file;
FILE *inf_ptr;
#undef YYLMAX
#define YYLMAX 8192
extern char yytext[YYLMAX];
extern int yylineno;


SgFile *curSgFile;
extern "C" char *generateNewFunction(char *hpfStmtList,char *calledfunc,
           char *funcName,char *usedVars[],int *numOfusedVars,int nextFIndex, 
	   int  *interface, int ME); 
extern "C" void openNewProject(char *depfileName); 

extern "C" int find_var(char *origProgName,char *usedVars);
extern "C" int symbAttributes(int index);
extern "C" int isModuleVar(int index);
extern "C" int createInterpretFunc(int nextModule, char *moduleNames[], 
				   int  interface,char *filename); 
int isDecl(SgStatement *chld);
insertList(char *list[],int *len,char *key);
void findUsedVars(char *inputFile,char *hpfFile,char *usedVars[],int *nVars);
SgStatement *find_first_exec_stmt(SgStatement *);

struct Internalfunctable{
  SgStatement *startAddr;
  char *fname;
}curFuncTable[256];
static int    numOfFuncs;
      
void openNewProject(char *depFileName)
{
   int j,fcnt=0;
   char *myargs[3]={NULL,NULL,(char *)0};
   myargs[1] =  new char[256];//(char *)malloc(256);

   strcpy(myargs[1],depFileName);
   SgProject *project = new SgProject("",2,myargs);
   curSgFile = &(project->file(0));

   for(j=0;j<curSgFile->numberOfFunctions();j++){
     SgStatement *sub = curSgFile->functions(j);
     if (sub->controlParent()->variant() !=  INTERFACE_STMT){
	 curFuncTable[fcnt].startAddr = sub;
	 SgSymbol *subsym  =  (curFuncTable[fcnt].startAddr)->symbol();
	 curFuncTable[fcnt].fname     = subsym->identifier();
	 fcnt++;
     }
   }
   numOfFuncs = fcnt;

} 
  

int findex(char *name)
{
   int found = -1;  

   for(int j=0;j<numOfFuncs;j++){
     if (!strcmp(name,curFuncTable[j].fname )){
         found = j;
	 break;
     }
   }  
  
   if ((found<0)||(found==numOfFuncs)){
      printf("I could not find file : %s\n",name);
      exit(0);
   }
   return found;

}

int inUsedList(char *list[],int len,SgSymbol  *key)
{
  int found = 0;
  
  for(int i=0;i<len;i++)
    if (!strcmp(list[i],key->identifier())){
      found = 1;
      break;
    }
  return found;

}

int isParamOrModuleVar(int index)
{
  int atts,fmod,fparam=0;
  atts = symbAttributes(index);
  if (atts & PARAMETER_BIT)
     fparam = 1;
  return fparam;
   
  //fmod = isModuleVar(index);
  //if (fparam || fmod)
  //  return 1;
  //else
  //  return 0;
}
   
char *generateNewFunction(char *hpfStmtList,   char *calledFunc,
                          char *funcName,      char *usedVars[],
			  int  *numOfusedVars, int nextFIndex,
			  int  *interface,      int ME)  
{
  SgFunctionSymb *fsymb;
  SgStatement    *prev,*s,*ptfunc;
  SgStatement *curStmt;
  static char fname[256],tmp[256];
  static char *ts=NULL;
  int retval,cnt = 0,nVars ;
  char *tempBuf1,*tempBuf2,*tts;
  SgType *type;
  static FILE *fTemp; 
  
 
  /* Store the user's HPF stsmts into temporary File */

  printf("in generateNewFunction : 1..=%d\n",strlen(hpfStmtList));
  
  int slen = strlen(hpfStmtList)+5;
  ts = new char[slen];  
  
  printf("in generateNewFunction : 1-1..\n");
  strcpy(ts,hpfStmtList);  
  printf("in generateNewFunction : 2..\n");

  sprintf(fname,"tmpFile_%d",ME);
  fTemp = fopen(fname,"w");
  fprintf(fTemp,"%s",ts);
  fclose(fTemp); 
  
  printf("in generateNewFunction : 3..\n");

   // get the scope and name of enclosing program unit
  int index = findex(calledFunc);
  SgStatement *origProgUnit = curFuncTable[index].startAddr;
  char *origProgName = (((SgProgHedrStmt *)origProgUnit)->name()).identifier();

  nVars = 0;
  //Find the variables used in the HPF stmts user gave in intercative mode
  findUsedVars(fname ,origProgName,usedVars,&nVars);
  
  // Add also unused original parameters of main function in which
  // we are requesting interpreter statements
  SgProgHedrStmt *hedr   = (SgProgHedrStmt *)origProgUnit;
  SgFunctionSymb *paramsSymb = (SgFunctionSymb *)(&hedr->name());
  int nparams = paramsSymb->numberOfParameters();
  for(int i=0;i<nparams;i++){
     SgSymbol *nsymb = &paramsSymb->parameter(i)->copy();
     if (!inUsedList(usedVars,nVars,nsymb))
	insertList(usedVars,&nVars,nsymb->identifier());
  }
  *numOfusedVars = nVars;

  // Create first new function
  char *newSubName          = new char[512];//(char *)malloc(512);
  sprintf(newSubName, "newfunction_%d", nextFIndex);
  strcpy(funcName,newSubName);
  type = new SgType(T_VOID);
  fsymb   = new SgFunctionSymb(PROCEDURE_NAME,newSubName,
			       *type,*(origProgUnit->controlParent()));
  ptfunc  = new SgProcHedrStmt(*fsymb);

  // Add used variables as parameters to new function
  for(int i=0;i<nVars;i++){
      int index = find_var(origProgName,usedVars[i]);

	printf("usedvars[%d] = %s\n",i,usedVars[i]);
	if (index >=0 )
	  printf("%s is appended as parameter \n",usedVars[i]);

      if (index >= 0){
          SgVariableSymb *ns = new SgVariableSymb(usedVars[i]);
          fsymb->insertParameter(cnt++,*ns);
       }
  }

  // add all the declaration stmts of original function
  int totdecls=0;
  prev = ptfunc;
  int numOfChildren = origProgUnit->numberOfChildrenList1()-1;
  for(int i=0;i<numOfChildren;i++){
    SgStatement *chld = origProgUnit->childList1(i);
    if (isDecl(chld))
     {
        s = &chld->copy();
        prev->insertStmtAfter(*s,*ptfunc);
        prev = s;
	totdecls++;
     }
  }  
  
  //add the user's HPF stmts as comments before "subroutine End" stmt
  SgStatement *endStmt =ptfunc->childList1(ptfunc->numberOfChildrenList1()-1);
  endStmt ->addComment(hpfStmtList); 
  tempBuf1 = ptfunc->unparseToBuf();
  printf("UNPARSE of FIRST FUNCTION = \n %s\n",tempBuf1);

  ///////////////////////////////////////////////////////
  /////////////////////////////////////////////////////
  *interface = totdecls;
  int len = strlen(tempBuf1);
  char *fileOutput = new char[len+1];//(char *)malloc(len+1);
  strcpy(fileOutput,tempBuf1);
  return  fileOutput;     

}

int createInterpretFunc(int nextModule, char *moduleNames[],
			int  interface,char *filename)
{
    int pid,status,ret;
    char cmnd[256],depfile[256],*tempBuf;
    char command[5096];
 
    strcpy(depfile,filename);
    *(strchr(depfile,'.')) = 0;
    strcat(depfile,".dep");
    
    /* make dep. file */
    sprintf(cmnd,"hpf2dep %s",filename);
    system(cmnd);

    strcpy(command,"instrumentInterpreter  ");
    strcat(command,depfile);
    
    for(int i=0;i<= nextModule;i++){
      strcat(command," ");
      strcat(command,moduleNames[i]);
    }
    strcpy(cmnd,"");
    tempBuf = lltostr(interface,cmnd);
    strcat(command," ");
    strcat(command,tempBuf);

    if ((ret=system(command)) < 0)
      printf("system error : %d\n",ret);

    return 0;

}


void findUsedVars(char *inputFile,char *hpfFile,char *usedVars[],int *nVars)
{

  int cnt=0,token;

  input_file = new char[strlen(inputFile)+1];
  //(char *)malloc(strlen(inputFile)+1);
  strcpy(input_file,inputFile);
 
  if (!(inf_ptr = fopen(input_file,"r"))){
    printf("I can not open input file : %s\n",input_file);
    exit(0);
  }
  
  while((token=yylex())){
    if (token == VARID){
      int index = find_var(hpfFile,yytext);
      /* Don insert constant parameter (PARAM(...))  and vars defined 
	 at interpreter mode as argument */
      if ((index >= 0)&&(!isParamOrModuleVar(index)))
	 insertList(usedVars,&cnt,yytext);
    }
  }

  fclose(inf_ptr);  
  *nVars = cnt;

}

insertList(char *list[],int *len,char *key)
{
  int found = 0;

  for(int i=0;i<(*len);i++)
    if (!strcmp(list[i],key)){
      found = 1;
      break;
    }
  if (!found){
    list[(*len)] = new char[strlen(key)+1];//(char *)malloc(strlen(key)+1);
    strcpy(list[(*len)],key);
    (*len)++;
  }
}

