#include "debugger.h"
#define	BUFSIZE		20480
#define VARLEN            256
#ifndef INADDR_NONE
#define INADDR_NONE 0xffffffff
#endif  /* INADDR_NONE */
extern int  errno;
extern char *sys_errlist[];


int GetInstrumentedCode(int nextModule,char *funcName,char *hpfStmtList,
			char *usedVars[],int *numOfVars,int sockfd)
{
  FILE *fTemp;
  char filename[VARLEN],fname[VARLEN];
  char instrumentedCode[BUFSIZE];
  int k,nVars,*rs,errcode;
  int pid,status;

  if (DEBUG)  
    fprintf(fpout,"nextModule = %d funcName=%s hpfStmtList=%s\n",
	 nextModule, funcName,hpfStmtList);
  
  /* Send INSTRUMENT+nextModule+funcName+nVars+usedVars+hpfStmtList 
     to HPFFrontEnd Server */
  if (HOST){
     send_int(sockfd,INSTRUMENT);
     send_int(sockfd,nextModule);
     send_String(sockfd,funcName);
     send_String(sockfd,hpfStmtList);
  }
  
  /* receive error code */
  if (HOST)
    recv_int(sockfd,&errcode);
  distribute_oneitem_(&errcode);
  /* receive number of parameters */
  if (HOST)
    recv_int(sockfd,&nVars);
  distribute_oneitem_(&nVars);
  /* receive parameters */
  for(k=0;k<nVars;k++){
    usedVars[k] = (char *)malloc(sizeof(char)*VARLEN);
    if (HOST)
      recv_String(sockfd,receivedHPFList);
    distribute_string_(); 
    strcpy(usedVars[k],receivedHPFList);
  }
  /*receive the instrumented code */
  if (HOST){
    recv_String(sockfd,instrumentedCode);
    if (DEBUG)
      fprintf(fpout,"I received instrumented code : %s\n",instrumentedCode);
    /* write received instrumented code to file */
    fTemp = fopen("foos.f","w");
    fprintf(fTemp,"%s", instrumentedCode);
    fclose(fTemp);
  }
  /* set Number of used variabels which will be parameters */
  *numOfVars = nVars;
  
  return errcode;
  
}


/*------------------------------------------------------------------------
 * connectsock - allocate & connect a socket using TCP or UDP
 *------------------------------------------------------------------------
 */
int
connectsock( host, service, protocol )
char    *host;      /* name of host to which connection is desired  */
char    *service;   /* service associated with the desired port */
char    *protocol;  /* name of protocol to use ("tcp" or "udp") */
{
    struct hostent  *phe;   /* pointer to host information entry    */
    struct servent  *pse;   /* pointer to service information entry */
    struct protoent *ppe;   /* pointer to protocol information entry*/
    struct sockaddr_in sin; /* an Internet endpoint address     */
    int s, type;    /* socket descriptor and socket type    */
 
 
    bzero((char *)&sin, sizeof(sin));
    sin.sin_family = AF_INET;
 
    /* Map service name to port number */
    if ( pse = getservbyname(service, protocol) )
        sin.sin_port = pse->s_port;
    else if ( (sin.sin_port = htons((u_short)atoi(service))) == 0 )
        errexit("can't get \"%s\" service entry\n", service);
 
    /* Map host name to IP address, allowing for dotted decimal */
    if ( phe = gethostbyname(host) )
 
        bcopy(phe->h_addr, (char *)&sin.sin_addr, phe->h_length);
    else if ( (sin.sin_addr.s_addr = inet_addr(host)) == INADDR_NONE )
        errexit("can't get \"%s\" host entry\n", host);
 
    /* Map protocol name to protocol number */
    if ( (ppe = getprotobyname(protocol)) == 0)
        errexit("can't get \"%s\" protocol entry\n", protocol);
 
    /* Use protocol to choose a socket type */
    if (strcmp(protocol, "udp") == 0)
        type = SOCK_DGRAM;
    else
        type = SOCK_STREAM;
 
    /* Allocate a socket */
    s = socket(PF_INET, type, ppe->p_proto);
    if (s < 0)
        errexit("can't create socket: %s\n", sys_errlist[errno]);
 
    /* Connect the socket */
    if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) < 0)
        errexit("can't connect to %s.%s: %s\n", host, service,
            sys_errlist[errno]);
    return s;
}

int errexit(char *format, ...)

{
    va_list args;
 
    va_start(args,format);
    _doprnt(format, args, stderr);
    va_end(args);
    exit(1);
}   
