#include "debugger.h"

int find_var(char *funcName,char *name)
{
  int i,found=-1;
  
  for(i=0;i< max_push_id;i++){
     if (((!strcasecmp(stack[i].funcName,funcName))||
          (strstr(stack[i].funcName,"newfunction_")))&&
	  (!strcasecmp(stack[i].name,name))){
       found = i;
       break;
    }
  }  
  
  return found;
}

void register_var_(int *var_type, int *var_id, long var,
char *name, int *var_ndims,char *funcName,int *isDist, ...)

{
  va_list ap;
  int item_len,nelems,i;
  int type = *var_type,ndims=*var_ndims;
  float *ptr;
  int id,myid,found;
  char *sptr;
 
 
  if (DEBUG)
     fprintf(fpout,"I will register -%s- type=%d ndims=%d  func=%s \n",
        name, *var_type,*var_ndims, funcName );
  
  /* look for whether we registered this variable with name,"name", and
     scope ,"scope" */
  /* this is just debugging tool */
  if (find_var(funcName,name) >= 0){
    if (DEBUG)
       fprintf(fpout,"We registered... before ...this var=%s func=%s\n",name,
       funcName);
    return;
  }

  id =  max_push_id++; 
  *var_id = id;

  /* remove trailing (white) space characters  */
  strcpy(stack[id].funcName, funcName);
  sptr = strchr(stack[id].funcName,' ');
  if (sptr)  
    *sptr = 0;

  strcpy(stack[id].name, name);
  sptr = strchr(stack[id].name,' ');
  if (sptr)
    *sptr = 0; 

  if (*isDist == 0){
    char *p ;
    if (p = strstr(stack[id].name,"LOCAL_")){
      int index;

      index = find_var(stack[id].funcName,p+6);
      if (index >= 0){
        stack[index].localIndex = id;
        if (DEBUG)
	 fprintf(fpout,"%d is local of %d \n",id,index);
      }
    }  
  }



  stack[id].isDistributed = (*isDist);
  /* read data descriptor*/
  va_start(ap,isDist);
 
  stack[id].type = type;
  stack[id].ndims = ndims;
  /* if variable is ARRAY,calculates its uppper and lower bounds and size */
  if (ndims > 0){
     int *lb = va_arg(ap, int *);
     int *ub = va_arg(ap, int *);
     for(i=0;i<ndims;i++){
        stack[id].lbounds[i] = lb[i];
        stack[id].ubounds[i] = ub[i];
        stack[id].dim_info[i] =  ub[i] - lb[i] +1;
        /* printf("dim[%d]for%d = %d\n",i,id,stack[id].dim_info[i]); */
     }
     if (DEBUG)
        fprintf(fpout,"for id=%d lbounds=%d-%d and ubounds=%d-%d \n",id,
           stack[id].lbounds[0],stack[id].lbounds[1],
           stack[id].ubounds[0],stack[id].ubounds[1]);  
  }

 
   /* calculate size of component length in bytes */
   /* transform bool,byte and short vars to int var */

   stack[id].buf = var;
   switch(type){
   case T_CHAR  :  item_len = 1;break;
   case T_INT   :  item_len = 4;break;
   case T_FLOAT :  item_len = 4;break;
   case T_LONG  :  item_len = 8;break;
   case T_DOUBLE:  item_len = 8;break;
   /* convert bool,byte and short vars into integer cars */
   case T_BOOL  :  item_len = 1;break;
   case T_BYTE  :  item_len = 1;break;
   case T_SHORT :  item_len = 2;break;
   }

   stack[id].elsize = item_len;

   stack[id].sockfd = -1;
   stack[id].port   = 0;

   /*calculate total length of variable in bytes:calculate # of elemens 
   first.The the total sizeof */
  
   for(i=0,nelems = 1;i<ndims;i++)
     nelems *= (stack[id].dim_info[i])    ;
   stack[id].nelems = nelems;

   stack[id].sizeof_data = nelems*(stack[id].elsize);
   stack[id].connected = UNCONNECTED; 
   stack[id].javabuflen = stack[id].sizeof_data;

   /* XDR encode the char/bool/short/byte data as integer.Therefore
      XDR encoded buffer length should be made multiple of 4 */ 
   if ((type == T_BOOL)||(type == T_CHAR)||(type == T_BYTE))
      stack[id].javabuflen *= 4;
   else if (type == T_SHORT)
      stack[id].javabuflen *= 2;
   else if (type == T_RECORD)
      stack[id].javabuflen = nelems*(stack[id].elsize);

   /* read data descriptor*/
   va_arg(ap, long); 
   va_arg(ap, long); 
   /* read desc */
   stack[id].desc = va_arg(ap, long); 
   va_end(ap);

   /*
   if (!strcmp(stack[id].name,"sock_recv_bits"))
      SOCK_RECV = id;
   */

   if (DEBUG)
      fprintf(fpout,"variable =%s with func=%s id= %d was registered totalsize=%d javalen = %d \n",name,funcName,id,stack[id].sizeof_data,
stack[id].javabuflen);

   
}

XDR_data(id,XDR_flag,xdrs)
int id ;
int XDR_flag;
XDR  *xdrs;
{

  int datalen,elsize,type,ndims;
  int nelems;
  void *dptr;
  int i,tind,j;
  bool_t ret;
  float *fp;
  

  elsize  = stack[id].elsize;
  type    = stack[id].type;
  ndims   = stack[id].ndims;

  type = stack[id].type;
  nelems = stack[id].nelems;

  switch(type){
   case T_CHAR : 
               dptr = (char *)(stack[id].buf);
               if (ndims > 0) /* Character string */
                 ret = xdr_vector(xdrs,(char *)dptr,nelems,elsize,xdr_char);
               else /* just only one character . sent it as int var.*/
                 ret = xdr_char(xdrs,dptr);
               break;

  case T_INT  : case T_BOOL : case T_SHORT:case T_BYTE:
               dptr = (int *)(stack[id].buf);
               if (ndims > 0) /* array */
                 ret = xdr_vector(xdrs,dptr,nelems,elsize,xdr_int);
               else 
                 ret = xdr_int(xdrs,dptr);
               break;
   case T_FLOAT: 
               dptr = (float *)(stack[id].buf);
               if (ndims > 0) /* array */
                 ret = xdr_vector(xdrs,dptr,nelems,elsize,xdr_float);
               else
                 ret = xdr_float(xdrs,dptr); 
               break;
   
   case T_LONG : 
               dptr = (long int *)(stack[id].buf);
               if (ndims > 0) /* array */
                 ret = xdr_vector(xdrs,dptr,nelems,elsize,xdr_long);
               else
                 ret = xdr_long(xdrs,dptr); 
               break;

   case T_DOUBLE:  
               dptr = (double *)(stack[id].buf);
               if (ndims > 0) /* array */
                 ret = xdr_vector(xdrs,dptr,nelems,elsize,xdr_double);
               else
                 ret = xdr_double(xdrs,dptr); 
               break;
 
  }
  
   if (ret == FALSE){
      if (DEBUG)
         fprintf(fpout,"There is error while encoding send data  with type=%d\n",type);
      exit(0);  
  }
}

/* id for stack array . XDR_flag : XDR_DECODE or XDR_ENCODE */
encode_send_data(id,sendbuf,XDR_flag)
int id ;
SBUF *sendbuf;
int XDR_flag;
{
  XDR xdrs;
  char *buf;
  int datalen;
  int ret;
  float *fp;
  int i,j;
  
  
  datalen = stack[id].javabuflen;
  buf = (char *)malloc(datalen); 
  
  xdrmem_create(&xdrs,buf,datalen,XDR_flag);
  XDR_data(id,XDR_flag,&xdrs);

  sendbuf->sbuf = buf;
  sendbuf->len  = xdr_getpos(&xdrs);
  sendbuf->xdrs = xdrs;

}

send_data_(int id,int sockfd)
{
  SBUF sendbuf;
  int  len;
  char *ptr;
  int nleft,nwritten;
  float *fp;
  int i,j;
  

  encode_send_data(id,&sendbuf,XDR_ENCODE);
  len = sendbuf.len;
  ptr = (char *)(sendbuf.sbuf);
  nleft = len;

  while (nleft > 0) {
    nwritten = write(sockfd, ptr, nleft);
    if (nwritten<=0)
      err("send_buffer: nwritten <= 0");
    nleft -= nwritten;
    ptr += nwritten;
  }
  xdr_destroy(&(sendbuf.xdrs));
  free(sendbuf.sbuf);
  if (DEBUG) 
     fprintf(fpout,"I send data for id=%d sett len =%d\n",id,len);

}  


decode_recv_data(id,recvbuf,datalen,XDR_flag)
int id ;/* id for stack array . XDR_flag : XDR_DECODE or XDR_ENCODE */
char  *recvbuf;
int datalen; /* total data length received */
int XDR_flag;
{
  XDR xdrs;
  char *buf;

  buf = (char *)malloc(datalen);
  xdrmem_create(&xdrs,buf,datalen,XDR_flag);
  bcopy(recvbuf,buf,datalen);
  XDR_data(id,XDR_flag,&xdrs);
  
  xdr_destroy(&xdrs);
  free(buf);

}


recv_data_(int id,int sockfd)
{
  int  len;
  XDR xdrs;
  char *buf;
  int datalen,type,ndims;
  
  datalen = stack[id].javabuflen; 
  type    = stack[id].type;
  ndims   = stack[id].ndims;

  buf = (char *)malloc(datalen);
  len = recv_raw_data(sockfd,buf,datalen);
  decode_recv_data(id,buf,len,XDR_DECODE);
  if (DEBUG)
     fprintf(fpout,"%d bytes read for var =%d original = %d\n",len,id,datalen);
}  

/* receive the value of one parameter and set it to received value */
int set_variable(int sockfd,int id)
{

  if (HOST){  
     send_int(sockfd,stack[id].type);
     recv_data_(id,sockfd);
   }   
}


int recv_raw_data(fd, buf, nbytes)
register int    fd;
register char   *buf;
register int    nbytes;
{
    int nleft, nread;
    char *ptr = buf;
    
    nleft = nbytes;
    while (nleft > 0) {
        nread = read(fd, ptr, nleft);
        if (nread < 0)
            return(nread);      /* error, return < 0 */
        else if (nread == 0)
            break;          /* EOF */

        nleft -= nread;
        ptr   += nread;
    }
    if (DEBUG)
       fprintf(fpout,"%d bytes read for var =%d original = %d left =%d\n",ptr-buf,
         fd,nbytes,nleft);

    return(nbytes - nleft);     /* return >= 0 */

}

send_raw_data(int sockfd,char *buf,int len)
{
  char *ptr;
  int nleft,nwritten;

  ptr   = buf;
  nleft = len;

  while (nleft > 0) {
    nwritten = write(sockfd, ptr, nleft);
    if (nwritten<=0)
      err("send_buffer: nwritten <= 0");
    nleft -= nwritten;
    ptr += nwritten;
  }
  
  if (DEBUG)
     fprintf(fpout,"I send raw data sent len =%d\n",len);
}



send_registration_info_(int tag,char *variableName,int type,int ndims
		       ,int nelems,int *dims,int sockfd)
{
   char buffer[REGBUFSIZE];
   XDR xdrs;
   int len;
   

   /* Send the registration info about "variableName":
      tag+variableName+type+ndims+dims */
   /* Be aware that xdr_string will put the length of variableName
      into the beginning of translated version */
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE);

   xdr_int(&xdrs,&tag);
   xdr_string(&xdrs,&variableName,strlen(variableName));
   xdr_int(&xdrs,&type);
   xdr_int(&xdrs,&ndims);
   xdr_int(&xdrs,&nelems);
   if (ndims > 0)
     xdr_vector(&xdrs,(char *)dims,ndims,sizeof(int),xdr_int);

   len = xdr_getpos(&xdrs);
   send_raw_data(sockfd,buffer,len);
   xdr_destroy(&xdrs);

   if (DEBUG)
     fprintf(fpout,"I sent registration info. for : %s\n",variableName);
}

sendrecv_string(char *buf,int sockfd,int XDR_FLAG)
{
   char *buffer;
   XDR xdrs;
   int len;

   len = strlen(buf);
   buffer = (char *)malloc(len);
   xdrmem_create(&xdrs,buffer,len,XDR_FLAG);
   
   xdr_string(&xdrs,&buf,len);
   len = xdr_getpos(&xdrs);
   send_raw_data(sockfd,buffer,len);
   xdr_destroy(&xdrs);
   free(buffer);
}


int send_registered_data(char *variableName, int id, int sockfd)
{ 

   if (DEBUG)
     fprintf(fpout,"We will sent the var . with id =%d\n",id);
   fclose(fpout);
   /* If the variable is local, then */
   if (!(stack[id].isDistributed )){
     if ( HOST){
        if (DEBUG)
           fprintf(fpout,"local data will be sent ....\n");
        send_int(sockfd,0); /* local data will be local_tag(0)+data */
        /* set the message tag to zero */
        send_registration_info_(0, variableName, stack[id].type, 
             stack[id].ndims ,stack[id].nelems, stack[id].dim_info, sockfd); 
        send_data_(id,sockfd);
        if (DEBUG)
          fprintf(fpout,"I send the local variable =%s \n",variableName);
     }
     if (DEBUG)
           fprintf(fpout,"We sent local data will be sent ....\n");
     return; 
   }

  if (DEBUG)
     fprintf(fpout,"I am sending distributed data : %s\n",variableName);

  /* Send the distributed data. First copy from parallel data to serial one */
  copy_from_parallel_to_serial(id);

  if (DEBUG)
    fprintf(fpout,"I copied from parallel to serial : %s\n",variableName);
  
  if (HOST ){
    /* set the message tag to zero */
    send_int(sockfd,1);
    /* parallel data will be parallel_tag(0)+registration info. +data */   
    send_registration_info_(0, variableName, stack[id].type, stack[id].ndims
	  ,stack[id].nelems, stack[id].dim_info, sockfd); 
    send_data_(stack[id].localIndex,sockfd); 
    if (DEBUG)
        fprintf(fpout,"I send the parallel variable =%s \n", variableName);
  }
 
}


init_hpf_server_(char *port,char *pName)
{
  char *p,tmpname[256];
  int i,index;
  void read_parse_tree();

  
  sprintf(tmpname,"output_%d",ME);
  fpout = fopen(tmpname,"w"); 
  
  fpout = stdout;  
  strcpy(projectName,pName);
  p = strchr(projectName,' ');
  if (p)  
    *p = 0;

  fread_parse_tree_(); 
  /*readParseTree("test.prj",&nfiles); 
  write_summary("EROL",nfiles);
  */
  
  if (DEBUG)
     fprintf(fpout,"after  inithpfLines \n"); 
  
  filesSent = (int *)calloc(nfiles,sizeof(int));
  for(i=0;i<nfiles;i++) filesSent[i] = 0;
  
  /* find the file which includes main subroutine */
  for(i=0;i<nfiles;i++)
    if (files[i].isIncludeMain)
      indexOfMain = i;
  curFile = indexOfMain;       /* set current file to main program file */
  filesSent[indexOfMain] = 1;  /* We sent this main program */

  openNewProject(files[curFile].depFileName);

  max_push_id = 0;
  cstack.top  = 0; /* set top of contral stack information */
  cstack.sInfo[0].fileName =  files[curFile].fileName;
  index = files[curFile].mainFuncIndex;
  cstack.sInfo[0].funcName =  files[curFile].functab[index].funcName;
  
  p =  strchr(port,' ');
  *p = 0;
  strcpy(portnum,port);
   
  msock = 0;

  if (HOST)
     msock = passivesock(portnum, "tcp",5);
  distribute_oneitem_(&msock);
  
  nfds = getdtablesize();
  FD_ZERO(&afds);
  FD_SET(msock, &afds);
  /* set signal handler */

  /* DO NOT FORGET TO UNCOMMNET THE FOLLOWING LINE */
  set_signal_handler(interrupt_prog); 

  if (DEBUG)
     fprintf(fpout,"MSOCK = %d sizeof(afds) =%d \n",msock,sizeof(afds));
  nextModule = 0;  
  receivedHPFList = (char *)malloc(10240);
}


void c_distribute_string_()
{
  #include "pglocal.h"      
  int me = __hpf_myprocnum();
  int nprocs = __hpf_nprocs();
  int pid,nbytes ;

  if (me == 0){
    nbytes = strlen(receivedHPFList);
    for(pid=1;pid<nprocs;pid++){
      __hpf_csend(pid,&nbytes,1,1,PGLCL_INT4);
      __hpf_csend(pid,receivedHPFList,nbytes,1,PGLCL_INT1);
    } 
  }
  else{
    __hpf_crecv(pid,&nbytes,1,1,PGLCL_INT4);
    __hpf_crecv(0,receivedHPFList,nbytes,1,PGLCL_INT1); 
  }
  receivedHPFList[nbytes] = 0; /* Append null character */
  
}

        
     

void read_parse_tree_()
{
  #include "pglocal.h"      
  int me = __hpf_myprocnum();
  int nprocs = __hpf_nprocs();
  int fsize,fnfuncs,f,pid;
  
  if (me == 0){
     readParseTree(projectName,&nfiles);
     for(pid=1;pid<nprocs;pid++){
       __hpf_csend(pid,&nfiles,1,1,PGLCL_INT4);
       for(f = 0;f<nfiles;f++){
	 __hpf_csend(pid,&files[f],sizeof(FILES),1,PGLCL_INT1);
         fsize   = files[f].fileSize;
         fnfuncs = files[f].nfuncs;  
         
         __hpf_csend(pid,&fsize,1,1,PGLCL_INT4);
         __hpf_csend(pid,&fnfuncs,1,1,PGLCL_INT4);
         __hpf_csend(pid,files[f].functab,sizeof(FTAB)*fnfuncs,1,PGLCL_INT1); 
         __hpf_csend(pid,files[f].lineInfo,sizeof(SINFO)*fsize,1,PGLCL_INT1); 
       }
     }
  }
  else{
       pid = 0;
       __hpf_crecv(pid,&nfiles,1,1,PGLCL_INT4);
       files = (FILES *)calloc(nfiles,sizeof(FILES));
       for(f = 0;f<nfiles;f++){
         __hpf_crecv(pid,&files[f],sizeof(FILES),1,PGLCL_INT1);  
         __hpf_crecv(pid,&fsize,1,1,PGLCL_INT4);
         __hpf_crecv(pid,&fnfuncs,1,1,PGLCL_INT4);
         files[f].fileSize = fsize;
         files[f].nfuncs   = fnfuncs;
         files[f].lineInfo = (SINFO *)calloc(fsize,sizeof(SINFO));
         files[f].functab  = (FTAB *)calloc(fnfuncs,sizeof(FTAB));
         __hpf_crecv(pid,files[f].functab,sizeof(FTAB)*fnfuncs,1,PGLCL_INT1); 
         __hpf_crecv(pid,files[f].lineInfo,sizeof(SINFO)*fsize,1,PGLCL_INT1); 
       }
  }

}


void hpf_server_(int *myline,char *funcName,char *fileName)
{
  struct sockaddr_in fsin;        /* the from address of a client */
  fd_set  wfds;              /* read file descriptor set     */
  int     alen;                   /* from-address length          */
  int     fd;
  int     sresult;
  int     iter = 0,nready;
  struct timeval tval={0,0};
  int change;
     
  if (DEBUG)
    fprintf(fpout,"before hpf_server \n");    
  while (1) {
    /*
    if (DEBUG)
       fprintf(fpout,"ME = %d in server loop line=%d\n",ME,*myline);  
    */
    if (HOST){
        bcopy((char *)&afds, (char *)&rfds, sizeof(rfds));

        if (nready=select(nfds, &rfds,(fd_set *)0, (fd_set *)0,&tval)<0)
 	    err("select: error \n");  

        if (FD_ISSET(msock, &rfds)) {
            int     ssock;

            alen = sizeof(fsin);
            ssock = accept(msock, (struct sockaddr *)&fsin, &alen);
            if (ssock < 0)
	      err("accept error\n");
            FD_SET(ssock, &afds);
         }
     }
    else {
        FD_ZERO(&rfds);
        FD_ZERO(&afds);
     }  
    
    /* nfds = 64,we use only first two elemnets of rfds.fds_bits array */
    /* for each descriptor of 64, we check only one bit. two array items
       constitute 64 items, each 32 bit integer */

    distribute_oneitem_(&(rfds.fds_bits[0]));
    distribute_oneitem_(&(rfds.fds_bits[1])); 
    distribute_oneitem_(&(afds.fds_bits[0]));
    distribute_oneitem_(&(afds.fds_bits[1]));
    /*
    if (DEBUG)
        fprintf(fpout,"After distrbute in server loop ME=%d line=%d\n",ME,*myline);
    */
    for (fd=0; fd<32; ++fd){
      if ((fd != msock) && FD_ISSET(fd, &afds)){
    	 sresult = server(*myline,funcName,fileName,fd);
         if (sresult == EXITFROMSERVER){
            if (DEBUG)
               fprintf(fpout,"after hpf_server line = %d ME =%d\n",*myline,ME); 
            return;
	 }   
      }
    }
  } /*  while (1) */
 
  
}

distribute_sock_event(fd_set *rfds)
{
    long *fp;
    int i,len = howmany(FD_SETSIZE, NFDBITS);

    /* distribute the select events P_0 found to others */          
    fp = (long *)(stack[SOCK_RECV].buf);

    for(i=0;i<len;i++) fp[i] = rfds->fds_bits[i];
    distribute_item_(stack[SOCK_RECV].buf,stack[SOCK_RECV].desc);
    for(i=0;i<len;i++) rfds->fds_bits[i] = fp[i];
}

void recv_int(int sockfd,int *command)
{
  char cmnd[4];
  XDR xdrs;
 
  recv_raw_data(sockfd,cmnd,sizeof(int));
  xdrmem_create(&xdrs,cmnd,sizeof(int),XDR_DECODE); 
  xdr_int(&xdrs,command);

  xdr_destroy(&xdrs);
 
}
     
void send_int(int sockfd,int command)
{
  char cmnd[4];
  XDR xdrs;
 
  xdrmem_create(&xdrs,cmnd,sizeof(int),XDR_ENCODE); 
  xdr_int(&xdrs,&command);
  send_raw_data(sockfd,cmnd,sizeof(int));

  xdr_destroy(&xdrs);
  if (DEBUG)
     fprintf(fpout,"After send INTEGER : %d\n",command);
}

void recv_String (int sockfd,char *variableName)
{
   bool_t ret;

   char buffer[REGBUFSIZE],intbuf[4];
   int strLen,totalLen;
   XDR xdrs;   
   int i;

   recv_raw_data(sockfd,buffer,sizeof(int));
   strncpy(intbuf,buffer,4);
   xdrmem_create(&xdrs,buffer,sizeof(int),XDR_DECODE); 
   if ((&xdrs) == NULL)
     printf("1:xdrmem_create error in recv_string \n");
   ret=xdr_int(&xdrs,&strLen);
   if (ret == FALSE)
     printf("xdr_int error in recv_string \n");
   xdr_destroy(&xdrs);

   totalLen = strLen;
   if ((strLen%4) != 0)
     totalLen = strLen+4-strLen%4;

   recv_raw_data(sockfd,&buffer[sizeof(int)],totalLen);
   /* strncpy(buffer,intbuf,4); */
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_DECODE);
   if ((&xdrs) == NULL)
     printf("2:xdrmem_create error in recv_string \n");
   ret = xdr_string(&xdrs,&variableName,totalLen);
   if (ret == FALSE)
     printf("xdr_string error in recv_string \n");
   variableName[strLen] = 0; /* Append terminating character  */ 
   if (DEBUG)
      fprintf(fpout,"I received string : %s strlen = %d totlen=%d\n",
         variableName,strLen,totalLen);
      
   xdr_destroy(&xdrs);
}

void send_String (int sockfd,char *variableName)
{
   char buffer[REGBUFSIZE];
   int totalLen,ret;
   XDR xdrs;
       
   xdrmem_create(&xdrs,buffer,REGBUFSIZE,XDR_ENCODE); 
   ret = xdr_string(&xdrs,&variableName,strlen(variableName)); 
   
   totalLen = xdr_getpos(&xdrs);
   send_raw_data(sockfd,buffer,totalLen);
   
   xdr_destroy(&xdrs);
   free(buffer);
   if (DEBUG)
      fprintf(fpout,"I  send string = %s strlen =%d\n",
          variableName,strlen(variableName));
}

set_ParallelVar(int sockfd,int id)
{

   if (HOST)
     recv_data_(stack[id].localIndex, sockfd);

   copy_from_serial_to_parallel(id);

}
  
copy_from_parallel_to_serial(id)
{
   int li = stack[id].localIndex;
  
   if (DEBUG) 
      fprintf(fpout,"li = %d-%s type = %d ndims=%d ME = %d\n",
	      stack[id].localIndex,stack[stack[id].localIndex].name,
	  stack[id].type, stack[id].ndims,ME);
      
   switch(stack[id].type){
   case T_INT:
     switch(stack[id].ndims)
     {
       case 1: 
        copy1dint_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
        break;
       case 2:
        copy2dint_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
        break;
       case 3:
        copy3dint_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
        break;
     }
     break;
     
   case T_FLOAT: 
     switch(stack[id].ndims)
     {
       case 1:
         copy1dfloat_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         copy2dfloat_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         copy3dfloat_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
     break;

   case T_LONG:
     switch(stack[id].ndims)
     {
       case 1:
         copy1dlong_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         copy2dlong_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         copy3dlong_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
      }
      break;

   case T_DOUBLE: 
     switch(stack[id].ndims)
     {
       case 1:
	 printf("OK fro Double 1D\n");
         copy1ddouble_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         copy2ddouble_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         copy3ddouble_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
     break;

   case T_BOOL: 
     switch(stack[id].ndims)
     {
       case 1:
         copy1dboolean_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         copy2dboolean_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         copy3dboolean_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
     break;

   case T_BYTE:  
    switch(stack[id].ndims)
     {
       case 1:
         copy1dbyte_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         copy2dbyte_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         copy3dbyte_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
     break;  

   case T_SHORT:  
     switch(stack[id].ndims)
     {
       case 1:
         copy1dshort_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         copy2dshort_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         copy3dshort_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
    break;

   }
   
}

copy_from_serial_to_parallel(id)
{
   int li = stack[id].localIndex;/* localIndex = id-1 */
   if (DEBUG)
      fprintf(fpout,"li = %d-%s- type = %d ndims=%d ME = %d\n",
	      stack[id].localIndex, stack[stack[id].localIndex].name,
	      stack[id].type, stack[id].ndims,ME);
   
   switch(stack[id].type){
   case T_INT:
     switch(stack[id].ndims)
     {
       case 1: 
        pscopy1dint_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
        break;
       case 2:
        pscopy2dint_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
        break;
       case 3:
        pscopy3dint_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
        break;
     }
     break;
     
   case T_FLOAT: 
     switch(stack[id].ndims)
     {
       case 1:
         pscopy1dfloat_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         pscopy2dfloat_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         pscopy3dfloat_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
     break;

   case T_LONG:
     switch(stack[id].ndims)
     {
       case 1:
         pscopy1dlong_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         pscopy2dlong_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         pscopy3dlong_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
      }
      break;

   case T_DOUBLE: 
     switch(stack[id].ndims)
     {
       case 1:
         pscopy1ddouble_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         pscopy2ddouble_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         pscopy3ddouble_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
     break;

   case T_BOOL: 
     switch(stack[id].ndims)
     {
       case 1:
         pscopy1dboolean_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         pscopy2dboolean_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         pscopy3dboolean_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
     break;

   case T_BYTE:  
    switch(stack[id].ndims)
     {
       case 1:
         pscopy1dbyte_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         pscopy2dbyte_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         pscopy3dbyte_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
     break;  

   case T_SHORT:  
     switch(stack[id].ndims)
     {
       case 1:
         pscopy1dshort_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 2:
         pscopy2dshort_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
       case 3:
         pscopy3dshort_(stack[id].buf,stack[li].buf,
           stack[id].desc,stack[li].desc);
         break;
     }
    break;

   }
       
}
 
void err(char *string) {
  perror(string);
  printf("Error no :%d\n",errno);
  exit(0);
}


write_summary(char *outFile,int nfiles)
{

    char fname[256];
    FILE *fp ;
    int i,j,k; 

    sprintf(fname,"%s_%d",outFile,ME);
    fp = fopen(fname,"w");
  
    fprintf(fp,"//Number of Files \n");
    fprintf(fp,"%d\n",nfiles);
    fprintf(fp,"// LineNumber  stmtID parent isExecutable isInLoop isReturnPoint\n");

    for( i=0;i<nfiles;i++){
      fprintf(fp,"// number of functions \n");
      fprintf(fp,"%d\n",files[i].nfuncs); 
      fprintf(fp,"//LineNumber  FunctionName FileName \n");
      for(j=0;j<files[i].nfuncs;j++)
        fprintf(fp,"%d   %s  %s\n", 
          files[i].functab[j].lineNum,
          files[i].functab[j].funcName,
          files[i].functab[j].fileName);
 

      fprintf(fp,"//File name \n");
      fprintf(fp,"%s\n",files[i].fileName);
      fprintf(fp,"//Length of File \n");
      fprintf(fp,"%d\n",files[i].fileSize);
      for(k=0;k<files[i].fileSize;k++)
        fprintf(fp,"%5d    %5d   %5d   %5d   %5d  %5d\n",
	  files[i].lineInfo[k].lineNum,
          files[i].lineInfo[k].stmtID  ,
          files[i].lineInfo[k].parent  ,
          files[i].lineInfo[k].isExecutable,
          files[i].lineInfo[k].isInLoop ,
          files[i].lineInfo[k].isReturnPoint);
    }
 
    fclose(fp);

}


/* fcallString : plot(java_serXXX,....) */
executeFunctionCall(char *fcallString,char *extFuncName)
{
   #define PI(i) ((int *)(stack[ind[i]].buf))
   #define PD(i) ((double *)(stack[ind[i]].buf))
   char *funcName,*sp,windowName[256];
   int  ind[48],i_counter;
   int index;

   i_counter = 0;
   sp = strtok(fcallString,"\n\r\t&(), ");
   funcName = strtok(NULL,"\n\r\t&(), ");

   if (DEBUG)
     printf("I am calling the function : %s\n",funcName);
   while((sp = strtok(NULL,"\n\r\t&(), "))){
     if (isalpha(sp[0])){ /* variable */
       index = find_var(extFuncName,sp);
       if (DEBUG)
         printf("-%s- is a variable \n",sp);
       if (index < 0)
	 printf("I could not find the variable : -%s-\n",sp);
       if (stack[index].isDistributed){
	 if (DEBUG)
	   printf("-%s- is distributed \n",sp);
	 copy_from_parallel_to_serial(index);
	 index = stack[index].localIndex;
       }
       if (i_counter == 0) /* Store Window name */
	 strcpy(windowName,sp);
       ind[i_counter++] = index;
     }
     else if (sp[0] == '\"'){ /* Constant string */
        strcpy(windowName,&sp[1]);
	if (!strchr(windowName,'\"')){
	   do{
	      sp = strtok(NULL,"\n\r\t&(), ");
	      strcat(windowName," ");
	      strcat(windowName,sp);
	   }while(!strchr(sp,'\"'));
        }
	*strchr(windowName,'\"') = 0;
	
	if (DEBUG)
	  printf("-%s- is windowName : -%s- \n",windowName,sp);
	i_counter++;
     }
   } 
   if (!HOST)
     return;  

   printf("I am ready to call the function : -%s- %d \n",
	  funcName,strlen(funcName));
   if (!strcasecmp(funcName,"java_ser_")){
     printf("Before Function call of java_ser_ \n");
     java_ser_(windowName,PD(1),PD(2),PD(3),PI(4));
     printf("After Function call of java_ser_ \n");
   }
   else  if (!strcasecmp(funcName,"java_mser_")){
     printf("Before Function call of java_mser_ \n");
     java_mser_(windowName,PI(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"java_ser2d_")){
     printf("Before Function call of java_ser2d_ \n");
     java_ser2d_(windowName,PD(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"java_mser2d_")){
     printf("Before Function call of java_mser2d_ \n");
     java_mser2d_(windowName,PI(1),PD(2),PD(3),PD(4),PD(5),PI(6));
   }
   else  if (!strcasecmp(funcName,"java_bser2d_")){
     printf("Before Function call of java_bser2d_ \n");
     java_bser2d_(windowName,PD(1),PD(2),PI(3),PD(4),PI(5),PD(6));
   }
   else  if (!strcasecmp(funcName,"java_bmser2d_")){
     printf("Before Function call of java_bmser2d_ \n");
     java_bmser2d_(windowName,PI(1),PD(2),PD(3),PI(4),PD(5),PI(6),PD(7));
   }
   else  if (!strcasecmp(funcName,"java_bbser2d_")){
     printf("Before Function call of java_bbser2s_ \n");
     java_bbser2d_(windowName,PD(1),PD(2),PI(3),PI(4),PD(5));
   }
   else  if (!strcasecmp(funcName,"java_bbmser2d_")){
     printf("Before Function call of java_bbmser2d_ \n");
     java_bbmser2d_(windowName,PI(1),PD(2),PD(3),PI(4),PI(5),PD(6));
   }
   else  if (!strcasecmp(funcName,"java_vser_")){
     printf("Before Function call of java_vser_ \n");
     java_vser_(windowName,PD(1),PD(2),PD(3),PD(4),PD(5),PI(6));
   }
   else  if (!strcasecmp(funcName,"java_vmser_")){
     printf("Before Function call of java_vmser_ \n");
     java_vmser_(windowName,PI(1),PD(2),PD(3),PD(4),PD(5),PD(6), PI(7));
   }
   else  if (!strcasecmp(funcName,"java_bbser_")){
     printf("Before Function call of java_bbser_ \n");
     java_bbser_(windowName,PD(1),PD(2),PI(3),PD(4));
   }
   else  if (!strcasecmp(funcName,"java_bbmser_")){
     printf("Before Function call of java_bbmser_ \n");
     java_bbmser_(windowName,PI(1),PD(2),PD(3),PI(4),PD(5));
   }
   

}
