#include "debugger.h"

inithpfLines(int sourceLen)
{
   int i;

   read_summary_dep_file("summary_dep_file");
   curFile = 0;
}

int server (int myline,int sockfd)
{
   int Stop = 0; 
   char variableName[256];
   static int curScope,curCmnd;
   static int nIterStartLine,curCounter;
   int    is_staying_in_server = 0,lineNumber,i;
   int scope, status;
   char msg[256],errcode=0;


   scope = files[curFile].lineInfo[myline].scope;

   if (curCmnd == RUN)
        Stop = 0;
   else if (((curCmnd == STEPOVER)||(curCmnd == NSTEPOVER))&&
       (curScope == scope))
   { 
       if (curCounter > 0)
          curCounter --;
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == STEPINTO)||(curCmnd == NSTEPINTO))
   {
       if (curCounter > 0)
          curCounter --;  
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == CONTINUE)&&(files[curFile].lineInfo[myline].onbreak))
       Stop = 1;
   else if ((curCmnd == NITERATION)&&(myline ==  nIterStartLine))
     {
       if (curCounter > 0)
	   curCounter--;
       if (curCounter == 0) 
	   Stop = 1;
     }
   
   if (!Stop)
      return EXITFROMSERVER;

   /* Send myline to Java Applet which updates current line number */
   send_int(myline);
   
   curScope = scope;
   if (HOST)
      recv_int( sockfd,&curCmnd);
   distribute_oneitem_(&curCmnd);
   
   switch(curCmnd){

   case PUTBREAKON : 
     if (HOST)
        recv_int( sockfd,&lineNumber );  
     distribute_oneitem_(&lineNumber);
     if (!(files[curFile].lineInfo[lineNumber].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd);
        errcode = -1;
     }
     else  
        files[curFile].lineInfo[lineNumber].onbreak = BREAKON;
     is_staying_in_server = 1;
     break;

   case PUTBREAKOFF:
     if (HOST) 
        recv_int( sockfd,&lineNumber);  
     distribute_oneitem_(&lineNumber);
     if (files[curFile].lineInfo[lineNumber].onbreak != BREAKON){
        send_errmsg(-2,"You have not put break point into this line",
                myline,sockfd);
        errcode = -2;
     }
     else
        files[curFile].lineInfo[lineNumber].onbreak = BREAKOFF;
     is_staying_in_server = 1;
     break;

   case STEPOVER:case STEPINTO:
     curCounter = 1;
     break;
   case NSTEPOVER:case NSTEPINTO: 
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     break;
   case CONTINUE:
     break;
   case RUN: 
     break;
   case NITERATION:
     if (HOST)
        recv_int( sockfd,&curCounter);
     if (!(files[curFile].lineInfo[myline].isInLoop)){
        send_errmsg(-3,"You are not in one loop",myline,sockfd);
        errcode = -3;
     }
     else{
        distribute_oneitem_(&curCounter);
        nIterStartLine = myline;
     }
     break;
   case DISPLAY:
     if (HOST)
       recv_String(sockfd,variableName);
     status = send_registered_data(scope,variableName,sockfd);
     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-4,msg,myline,sockfd);
        errcode = -4;
     }
     is_staying_in_server = 1;
     break;
   case SETVARIABLE:
     if (HOST)
        recv_String(sockfd,variableName);
     status = set_variable(sockfd,variableName,scope); 
     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-5,msg,myline,sockfd);
        errcode = -6; 
     } 
     is_staying_in_server = 1;   
     break;
   case SETPARVAR:
     if (HOST)
        recv_String(sockfd,variableName); 
     set_ParallelVar(sockfd,variableName, scope);
     is_staying_in_server = 1;
     break;    

     }
   /* If therse is no error,send Ok message to Applet */
   if (errcode == 0)
      send_errmsg(0,"OK ",myline,sockfd);
   return is_staying_in_server;
}

send_errmsg(int errorcode,char *errormsg,int myline,int sockfd)
{
   char msg[256];

   if (HOST){
     sprintf(msg,"%s : %d\n",errormsg,myline);
     send_int(sockfd,errorcode);
     send_String(sockfd, msg);
   }
}


/*********************************************************/
/*********************************************************/
/*********************************************************/
/*********************************************************/
read_summary_dep_file(char *fileName)
{
  FILE *fp;
  char lines[256],*ptr,fname[64];
  int j,i,k,filelen,newfuncs;
  int nextfunc=0,nextfile=0;
 
  if (!(fp = fopen(fileName,"r"))){
    printf("I can not open the file : %s\n",fileName);
    exit(0);
  }
  nfiles = 0;
  nfuncs = 0;
  while(!feof(fp))
  {
     fgets(lines,256,fp);
     if ((strstr(lines,"//"))&&(strstr(lines,"number of functions"))){
        fgets(lines,256,fp);
        nfuncs += atoi(lines);
     }
     else if ((strstr(lines,"//"))&&(strstr(lines,"File name" )))
        nfiles++;
     else if((strstr(lines,"//"))&&(strstr(lines,"Length" ))){
        fgets(lines,256,fp);
        filesizes[nfiles-1] = atoi(lines);
     }
  }

  functab = (FTAB *)calloc(nfuncs,sizeof(FTAB));  
  files  = (FILES *)calloc(nfiles,sizeof(FILES)); 
  for(i=0;i<nfiles;i++)
    files[i].lineInfo = (SINFO *)calloc(filesizes[i],sizeof(SINFO));  

  rewind(fp);
  /* read comment "File Name" */
  fgets(lines,256,fp);
  while(!feof(fp))
  {
   
     /* read file name */
     fgets(lines,256,fp);
     strcpy(fname,strtok(lines,"\n\r\t "));
    
     /*read comment "Length of File " */
     fgets(lines,256,fp);
     /* read file length */
     fgets(lines,256,fp);
     filelen = atoi(lines);
    
     /* read comment "number of functions" */
     fgets(lines,256,fp);
     /* read number of functions */
     fgets(lines,256,fp);
     newfuncs = atoi(lines);
    
     /* read comment "LineNumber  FunctionName FileName" */
     fgets(lines,256,fp);

     for(i = nextfunc;i<nextfunc+newfuncs;i++){
       /* read one line of function info */
       fgets(lines,256,fp);
       ptr = strtok(lines,"\n\r\t ");
       functab[i].lineNum = atoi(ptr);
       strcpy(functab[i].funName, strtok(NULL,"\n\r\t "));
       strcpy(functab[i].fileName, fname);
      
     }

     /* accumulate total number of functions */
     nextfunc += newfuncs ; 

     /* read comment "LineNumber Scope stmtID parent isExecutable" */
     fgets(lines,256,fp);

     i = nextfile;
     for(j=0;j <filelen;j++){
       /* read line number */
       fgets(lines,256,fp);
       k = atoi(strtok(lines,"\n\r\t "));
       files[i].lineInfo[k].lineNum = k;
       files[i].lineInfo[k].scope = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].stmtID = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].parent = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isExecutable = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isInLoop = atoi(strtok(NULL,"\n\r\t "));
     }
     nextfile++;

     /* read comment "File Name" */
     fgets(lines,256,fp);
  }
  fclose(fp);
}
