/* TCPmechod.c - main, echo */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>

#include <stdio.h>

#define QLEN               5    /* maximum connection queue length      */
#define BUFSIZE         4096

extern int      errno;
extern char     *sys_errlist[];

/*------------------------------------------------------------------------
 * main - Concurrent TCP server for ECHO service
 *------------------------------------------------------------------------
 */
int
main(argc, argv)
int     argc;
char    *argv[];
{
        char    *service = "echo";      /* service name or port number  */
        struct sockaddr_in fsin;        /* the from address of a client */
        int     msock;                  /* master server socket         */
        fd_set  rfds;                   /* read file descriptor set     */
        fd_set  afds;                   /* active file descriptor set   */
        int     alen;                   /* from-address length          */
        int     fd, nfds;
        int ndesc,i;
	
        
        switch (argc) {
        case    1:
                break;
        case    2:
                service = argv[1];
                break;
        default:
                errexit("usage: TCPmechod [port]\n");
        }

        /*msock = passiveTCP(service, QLEN); */
        msock = passivesock(service, "tcp",QLEN);

        nfds = getdtablesize();
        FD_ZERO(&afds);
        FD_SET(msock, &afds);

        while (1) {
                bcopy((char *)&afds, (char *)&rfds, sizeof(rfds));

                for (fd=0; fd<nfds; ++fd)
                  if(FD_ISSET(fd, &rfds))
	             printf("Are you selected fd = %d \n",fd);

                if ((ndesc=select(nfds, &rfds, (fd_set *)0, (fd_set *)0,
                                (struct timeval *)0)) < 0)
                         errexit("select: %s\n", sys_errlist[errno]);
 
               for (fd=0; fd<nfds; ++fd){
                  /* printf("rfds[%d] = %d\n",fd,rfds.fds_bits[fd]); */
                  if(FD_ISSET(fd, &rfds))
 	                printf("YOu selected ....fd = %d  \n",fd); 
               }
        
	       printf("OK....ND = %d  \n",ndesc);
	       
                if (FD_ISSET(msock, &rfds)) {
                        int     ssock;

                        alen = sizeof(fsin);
                        ssock = accept(msock, (struct sockaddr *)&fsin,
                                &alen);
                        if (ssock < 0)
                                errexit("accept: %s\n",
                                        sys_errlist[errno]);
                        FD_SET(ssock, &afds);
                }
                for (fd=0; fd<nfds; ++fd)
                        if (fd != msock && FD_ISSET(fd, &rfds))
                                if (echo(fd) == 0) {
				  printf("I am clearing %d\n",fd);
				  
                                        (void) close(fd);
                                        FD_CLR(fd, &afds);
                                }
        }
}

/*------------------------------------------------------------------------
 * echo - echo one buffer of data, returning byte count
 *------------------------------------------------------------------------
 */
int
echo(fd)
int     fd;
{
        char    buf[BUFSIZ];
        int     cc;


        printf("File num = %d\n",fd);

        cc = read(fd, buf, sizeof buf);
        if (cc < 0)
                errexit("echo read: %s\n", sys_errlist[errno]);
        if (cc && write(fd, buf, cc) < 0)
                errexit("echo write: %s\n", sys_errlist[errno]); 
        return cc;
}
