#include <stdio.h>
#include "compilerApi.h"
#include "deftypes.h"
#include <malloc.h>
#include <string.h>

#define TIMER_CLEAR    0
#define TIMER_START    1
#define TIMER_STOP     2
#define TIMER_ELAPSED  3
#define REGISTER       4
#define HPF_SERVER     5
#define INIT           6
#define SLOCAL       1
#define DISTRIBUTED 2

#define BEFORE  0
#define AFTER   1
#define MAX_FUNC_NUM 300
#define MAX_PAIR     300

enum FLAG {off, on};
FLAG in_main_program;
FLAG in_procedure;
int tabnumber=0;
void doFullType(SgType *t);
void doSymbAttribs(SgSymbol *s);
void doRoutineHeader(SgStatement *s);
void doSymb(SgSymbol *s);
void register_var();
void timer_start(),timer_clear(),timer_stop(),timer_elapsed();
void configure();
void insert_register_and_config_params(SgStatement *);
int give_type_symbol();
SgStatement *find_first_exec_stmt(SgStatement *);
void hpf_server();
void find_exec_next_stmt(SgStatement *,int *,int *);
SgStatement *find_outermost_scope(SgStatement *);
void create_one_func(SgStatement *);
SgVariableSymb *DeclareTemporaryLike(SgSymbol * ,int );
void insert_decls(SgStatement *moduleDecls);
void build_function(int ,SgStatement *);
int isInLoop(SgStatement *);
int isTemplate(SgSymbol *symb);

create_functionTable_file(SgProject * project, int *nfiles,
			  FILES **files);
int isInLoop(SgStatement *s);
SgStatement *find_outermost_scope(SgStatement *s);
void action(SgStatement * s,int find);
void transform_registration(SgStatement * s,int find,FILES *files) ;
write_summary(char *outFile,int nfiles);
SgStatement *find_first_exec_stmt(SgStatement *s);
char *insert_register_defined_vars(SgStatement *procHedr);
			
//extern "C" void readParseTree(char *projectFileName ,int *nfiles,
//		       FILES **files);
void readParseTree(char *projectFileName ,int *nfiles,FILES **files);
void addcontains(char *s);
int isDecl(SgStatement *chld);
int isHpfLocal(SgStatement *s);
SgVariableSymb *register_var_symb;
//char projectName[256];
typedef struct festmts
{
  char *fname;
  int  feline;
  SgStatement *s;
}FUNCS;

typedef struct parsymbs{
  char     name[256];
  SgSymbol *parsymb;
}SYMBTAB;
SYMBTAB symbtable[256];
int nextsymb=0;


SgStatement *first;
int nextp;
FUNCS funcs[MAX_FUNC_NUM];
int nextf ;
FILES *parsefiles;
int   *lengthOfFiles;
FTAB  *parfunctab;
int fileIndex;
SgVariableSymb *hpf_server_symb,*jmp_symb;
char *parcurFileName,*parcurFuncName;


SgStatement *whereDeclared(SgSymbol *x,SgStatement *start);


// Insert a C function call statement
void 
InsertFCallNode(SgStatement *s,int wfunction,int how)
{
  int myline = s->lineNumber();
  SgSymbol *symb;
  char *fsymb ;
  SgStatement *f;

  switch (wfunction) {
    case TIMER_CLEAR: symb = new SgVariableSymb("timer_clear");
                        break;
    case TIMER_START: symb = new SgVariableSymb("timer_start");
                        break;
    case TIMER_STOP:  symb = new SgVariableSymb("timer_stop");
                        break;
    case TIMER_ELAPSED:symb = new SgVariableSymb("timer_elapsed"); 
                         break;
    case REGISTER : symb = new SgVariableSymb("REGISTER");
      break;
    case HPF_SERVER: symb = hpf_server_symb;
      break;
    case INIT: symb = new SgVariableSymb("init_hpf_server");
      break;
    
 }

 

  // you can put break only at points before which HPF_Server 
  // call is inserted   
  parsefiles[fileIndex].lineInfo[myline].isExecutable = 1;
  parsefiles[fileIndex].lineInfo[myline].isInLoop = isInLoop(s);
  SgCallStmt *func = new SgCallStmt(*symb);

  /* add myline parameter */  
  SgValueExp *ev = new SgValueExp(myline);
  func->addArg(*ev);

  f = find_outermost_scope(s);
  SgProgHedrStmt *fph = (SgProgHedrStmt *)f;
  fsymb = (fph->name()).identifier();

  // add current function name  
  char *ts  = new char[strlen(fsymb)+5]; //(char *)malloc(strlen(fsymb)+5);
  strcpy(&ts[1], fsymb );
  ts[0] = '\"';
  ts[strlen(fsymb)+1] = '\\';
  ts[strlen(fsymb)+2] = '0';
  ts[strlen(fsymb)+3] = '\"';
  ts[strlen(fsymb)+4] = 0;    

  SgVariableSymb *dummy = new SgVariableSymb(ts,*f);
  SgValueExp *varName = new SgValueExp(dummy->identifier());
  func->addArg(*varName);

  // add current file name
  ts  = new char[strlen(parcurFileName)+5];
  //(char *)malloc(strlen(parcurFileName)+5);
  strcpy(&ts[1], parcurFileName);
  ts[0] = '\"';
  ts[strlen(parcurFileName)+1] = '\\';
  ts[strlen(parcurFileName)+2] = '0';
  ts[strlen(parcurFileName)+3] = '\"';
  ts[strlen(parcurFileName)+4] = 0;    

  dummy = new SgVariableSymb(ts,*f);
  varName = new SgValueExp(dummy->identifier());
  func->addArg(*varName);

  switch (how) {
    case BEFORE:
         s->insertStmtBefore(*func,*(s->controlParent()));
         break;
    case AFTER:
         s->insertStmtAfter(*func,*(s->controlParent()));
         break;
  }
 
  /***********************************************************/
  /* Add setjump function call to store stack information */
   SgCallStmt *jmp_func = new SgCallStmt(*jmp_symb);
   SgValueExp *jmp_ev = new SgValueExp(myline);
   jmp_func->addArg(*jmp_ev);
   func->insertStmtBefore(*jmp_func,*(s->controlParent()));
  /***********************************************************/

}

void action(SgStatement * s)
{
  SgDeclarationStatement *decl;
  SgProgHedrStmt *spg;
  SgCallStmt *cs;
  SgForStmt *fs;
  int flag = 0;
  SgAssignStmt *ass ;
  SgForStmt *sfo ; 
  SgCallStmt *call;
  
  if (call = isSgCallStmt(s))
     parcurFuncName = call->name()->identifier();
      
  if (cs=isSgCallStmt(s)){
      if ((!strcmp(cs->name()->identifier(),"register_var"))||
          (!strcmp(cs->name()->identifier(),"setjmp"))||
          (!strcmp(cs->name()->identifier(),"hpf_server")))
	   
        return;
  }
  
  SgStatement *cp = s->controlParent();
  if ((isSgExecutableStatement(s))&&
      (s->variant() != CONTROL_END)&&
      (s->variant() != MODULE_STMT)&&
      (s->variant() != USE_STMT)&&
      (s->variant() != INCLUDE_STAT)&&
      ((!cp)||(!(cp->lineNumber()==s->lineNumber()))) )
          InsertFCallNode(s , HPF_SERVER,BEFORE);
 

  // put server function call before end of function unit
    
}


 SgStatement *find_outermost_scope(SgStatement *s)
{
   SgProgHedrStmt *    prog,*curs;    
   SgProcHedrStmt *    subr;  
   SgProsHedrStmt *    pros;
   SgFuncHedrStmt *    func;  
   SgStatement *cp;


   cp = s;
   curs = NULL;
   do{
      if(subr = isSgProcHedrStmt (cp))
        curs = (SgProgHedrStmt *)subr;
      else if (pros = isSgProsHedrStmt(cp))
        curs = (SgProgHedrStmt *)pros;
      else if(func = isSgFuncHedrStmt(cp))
        curs = (SgProgHedrStmt *)func;
      else if(prog = isSgProgHedrStmt(cp))
        curs = prog;
      
      if (curs == NULL){
      
	cp = cp->controlParent();
      
      }
   }while(!curs);
   return (curs);
   
}

//find whether or not current stmt s is in one loop ,
// if so return line number of the header of innermost loop  
// otherwise return 0
int isInLoop(SgStatement *s)
{

   SgStatement *cp,*curs;
   SgForStmt      *fstmt;
   SgDoWhileStmt  *dwstmt;

   cp   = s;
   curs = NULL;
   do{
     if ((fstmt = isSgForStmt(cp))||(dwstmt = isSgDoWhileStmt(cp)))
       curs =  cp;
     else if(cp != NULL)
   	cp = cp->controlParent();
   }while((cp)&&(!curs));
   if (curs )
     return (curs->lineNumber());
   else 
     return 0;
         
}



void find_exec_next_stmt(SgStatement *s,int *lexnext,int *callnext)
{
  SgStatement *cp;
  SgCallStmt  *cs;
  int i;
  
  if (s->lexNext()->variant() != CONTROL_END){
    if (s->lineNumber() == s->lexNext()->lineNumber()){
       cp = s;
       while((cp->nextInChildList())&& 
          (cp->nextInChildList()->variant() == CONTROL_END))
       cp = cp->controlParent();
       if (cp->nextInChildList())
         *lexnext  = cp->nextInChildList()->lineNumber();
       else
         *lexnext  = -3;     
    }
    
    else
      *lexnext  = s->lexNext()->lineNumber();
  }
      
  else{
    cp = s;
    while((cp->nextInChildList())&& 
         (cp->nextInChildList()->variant() == CONTROL_END))
      cp = cp->controlParent();
    if (cp->nextInChildList())
      *lexnext  = cp->nextInChildList()->lineNumber();
    else
      *lexnext  = -2;
    
  }
  
  if (cs = isSgCallStmt(s)){
    for(i=0;i<nextf;i++)
      if(!strcmp(funcs[i].fname,cs->name()->identifier()))
        break;
    if (i == nextf) 
      *callnext = -1;
    else
      *callnext = funcs[i].feline;
  }
  else
    *callnext  = -2;
  
}

SgStatement *part_find_first_exec_stmt(SgStatement *interface,
				       SgStatement *last)
{
  SgStatement *s;

  for(s = interface;( s!= last);s = s->nextInChildList())
    if ((isSgExecutableStatement(s))&&
        (s->variant() != CONTROL_END)&&
        (s->variant() != USE_STMT)&&
        (s->variant() != INCLUDE_STAT)&&
	(s->variant() != PROCESSORS_STMT)&&
        (s->variant() != TEMPLATE_STMT)  )
	  return (s);

  return last;


}
  
SgStatement *find_first_exec_stmt(SgStatement *s)
{
    
   int nlchilds = s->numberOfChildrenList1();
   SgStatement *lasts = s-> childList1(nlchilds-1) ; 

   for(int i=0;i<nlchilds;i++)
     if ((isSgExecutableStatement(s->childList1(i)))&&
        (s->childList1(i)->variant() != CONTROL_END)&&
        (s->childList1(i)->variant() != USE_STMT)&&
        (s->childList1(i)->variant() != INCLUDE_STAT)&&
	(s->childList1(i)->variant() != PROCESSORS_STMT)&&
        (s->childList1(i)->variant() != TEMPLATE_STMT)  )
	 return (s->childList1(i));
   
   return lasts;
   
}

int give_type_symbol(SgType *vtype)
{
  int variant_type = vtype->variant();
  int var_type;

  switch(variant_type){
           
     case T_CHAR: var_type = T_CHAR; break;
     case T_INT: var_type = T_INT; break;
     case T_FLOAT: var_type = T_FLOAT; break;
     case T_DOUBLE : var_type = T_DOUBLE; break;
     case T_BOOL: var_type = T_BOOL; break;
     case T_ARRAY: var_type = give_type_symbol(vtype->baseType());break;
     case T_KIND:
	int base_type = 
            vtype->thetype->entry.kind_decl.base_type->variant;
        int kind_val = (vtype->thetype->entry.kind_decl.kindexp)->entry.                   list_s.item->entry.literal.value->entry.ival; 
	
        switch(base_type){
	case T_INT:
	  switch(kind_val){
	  case 1:var_type = T_BYTE;break; /* Byte */
	  case 2:var_type = T_SHORT;break; /* Short */
	  case 4:var_type = T_INT;break; /* Integer */
	  case 8:var_type = T_LONG;break; /* Long */
	  }
	  	  
	  break;
	case T_FLOAT:  
	  switch(kind_val){
	  case 4:var_type = T_FLOAT;break; /* Float */
	  case 8:var_type = T_DOUBLE;break; /* Double */
	  }
	  
	  break;
	}
		
	break;
  }

  return (var_type);
 
}


int symb_ndims(SgSymbol *symb)

{
  int vtype =  symb->type()->variant();
  SgArrayType *atype;
  int ndims;
    
  switch(vtype){
  case T_ARRAY: if (atype = isSgArrayType(symb->type()))
                   ndims = atype->dimension();
  break;
  
  default:ndims = 0;break;
  }
  return ndims;
  
}

int findNdimsForLocal(SgSymbol *localsymb)
{ 
   int found=-1;
   char *sp = (localsymb->identifier())+strlen("LOCAL_");
   for(int i=0;i<nextsymb;i++)
     if (!strcasecmp(sp,symbtable[i].name)){
       found = i;
       break;
     }
   if (found<0){
     printf("Instrumentation:I cound not found parallel version of %s\n",
	    localsymb->identifier());
     return -1;
   }
   int ndims = symb_ndims(symbtable[found].parsymb);
   return ndims;
}

//////////////////////////////////////////////////
//////////////////////////////////////////////////
//Register variables
void insert_register_and_config_params(SgStatement *s)
{

    SgProgHedrStmt *    prog,*curs;    
    SgProcHedrStmt *    subr;  
    SgProsHedrStmt *    pros;
    SgFuncHedrStmt *    func;       
    SgSymbol *symb;
    SgVariableSymb *fsymb,*shape_symb;
    SgStatement    *    festmt;
    int var_type;
    int ndims,scope,var_id;
    char *name,indexName[256] ;
    SgValueExp *varType,*varName,*varNdims,*varShape,*varScope;
    SgValueExp *symbattributes;
    SgCallStmt *scstmt;
    SgVarRefExp *e1;
    SgVariableSymb *ptsymb;
    SgFunctionCallExp *fce;
    int distFlag;
    SgStatement *decls;
    int nextTemp=0;
    char *ts ;
    SgVarDeclStmt *svar;
    SgParameterStmt *parvar;
    int ns;
     
    curs = NULL;
    if(subr = isSgProcHedrStmt (s))
       curs = (SgProgHedrStmt *)subr;
    else if (pros = isSgProsHedrStmt(s))
      curs = (SgProgHedrStmt *)pros;
    else if(func = isSgFuncHedrStmt(s))
      curs = (SgProgHedrStmt *)func;
    else if(prog = isSgProgHedrStmt(s))
      curs = prog;
    
    if (curs == NULL) return;
    
    //printf("symbol:%s", (curs->name()).identifier());
    //printf(" which is a subroutine.\n");
    if (isHpfLocal(curs))
      return;

        /* find first executable stmt in current scope */
        festmt = find_first_exec_stmt(curs);
	
         /* add the first executable stmt of this func./subr. to funcs
           record array */
        funcs[nextf].feline = festmt->lineNumber();
	funcs[nextf].fname   = (curs->name()).identifier();
        funcs[nextf++].s = curs;
	
        register_var_symb = new SgVariableSymb("register_var",*curs);
        hpf_server_symb = new SgVariableSymb("hpf_server",*curs);
        jmp_symb =  new SgVariableSymb("setjmp",*curs);        

        // create SgSymbol for function name     
	char *funcName = (curs->name()).identifier();
        char *funcNameSymb  = new char[strlen(funcName)+5];
        //(char *)malloc(strlen(funcName)+5);
        strcpy(&funcNameSymb[1], funcName);
        funcNameSymb[0] = '\"';
        funcNameSymb[strlen(funcName)+1] = '\\';
        funcNameSymb[strlen(funcName)+2] = '0';
        funcNameSymb[strlen(funcName)+3] = '\"';
        funcNameSymb[strlen(funcName)+4] = 0;    
        SgVariableSymb *fSymb = new SgVariableSymb(funcNameSymb,*curs);
        SgValueExp *funcVarName = new SgValueExp(fSymb->identifier());

        // new addition
        // get the expression list of variables delcared
        for(decls=curs->lexNext();decls!=festmt;
	    decls = decls->nextInChildList())
	{

           if (decls->variant() == INTERFACE_STMT  )
	     continue;
	   if (isSgVarDeclStmt(decls)){
	     svar = (SgVarDeclStmt *)decls;
             ns = svar->numberOfSymbols();
	   }
           else if (isSgParameterStmt(decls)){
	     parvar = (SgParameterStmt *)decls;
	     ns = parvar->numberOfConstants();
	   }
           else
             continue;
           
           for(int i=0;i<ns;i++)
	   {
	      if (isSgVarDeclStmt(decls))
                 symb = svar->symbol(i);
              else
		 symb = parvar->constant(i);
 
              /* Dont register variables other than variable names 
		 or constants */ 
              if ((symb->variant() != VARIABLE_NAME)&&
		  (symb->variant() != CONST_NAME))
                continue;
    
	      // Do not register the complex variables I won't use at all
	      var_type = give_type_symbol(symb->type()->internalBaseType());
	      if (var_type == T_COMPLEX)
		continue;

	      //printf("I am registring : %s variant = %d in fun=%s\n",
	      //     symb->identifier(),symb->variant(),
	      //     (curs->name()).identifier() );
	      //doSymbAttribs(symb);
                           
              fsymb = register_var_symb;
	      scstmt = new SgCallStmt(*fsymb);
	      
              /* add var_type parameters to register_var subroutine */
	      var_type = give_type_symbol(symb->type()->internalBaseType());
              varType = new SgValueExp(var_type);
	      scstmt->addArg(*varType);

              /* add variable id = parameter var_id */	
              sprintf(indexName, "ind_%d", nextTemp++);
              ptsymb = new SgVariableSymb(indexName,*curs);
	      e1 = new SgVarRefExp(*ptsymb);
	      scstmt->addArg(*e1);
              // make declaration this new created temporary variable
	      // in this function/subroutine. Fotget if for now
              // ptsymb->declareTheSymbol(*curs);
	        

              /* add variable itself = var parameter */
              e1 = new SgVarRefExp(*symb);
	      scstmt->addArg(*e1);
                 
              /* add variable literal name = name parameter */
              ts  = new char[strlen(symb->identifier())+5];
	      //(char *)malloc(strlen(symb->identifier())+5);
              strcpy(&ts[1], symb->identifier() );
              ts[0] = '\"';
              ts[strlen(symb->identifier())+1] = '\\';
              ts[strlen(symb->identifier())+2] = '0';
              ts[strlen(symb->identifier())+3] = '\"';
              ts[strlen(symb->identifier())+4] = 0;                   
   


              SgVariableSymb *dummy = new SgVariableSymb(ts,*curs);

	      varName = new SgValueExp(dummy->identifier());
              //SgExpression *varName = new SgExpression(STRING_VAL,ts);
	      scstmt->addArg(*varName);
	      //printf("ts = %s arg = %s\n",ts,varName->stringValue());
 
              /* add var_ndims parameter */
	      if (strstr(symb->identifier(),"LOCAL_"))
		ndims = findNdimsForLocal(symb);
              else
		ndims = symb_ndims(symb);
              varNdims = new SgValueExp(ndims);
	      scstmt->addArg(*varNdims);
              // add current function name  
              scstmt->addArg(*funcVarName);

	      //add attributes of symbol
	      symbattributes = new SgValueExp(symb->attributes());
	      scstmt->addArg(*symbattributes);

              /* Add distributed flag:is distributed or not */      
              if ((symb->attributes() & ALIGN_BIT)||
                    (symb->attributes() & DISTRIBUTE_BIT ))
		  distFlag = 1;
	      else
		  distFlag = 0;
              SgValueExp *dflag = new SgValueExp(distFlag);       
              scstmt->addArg(*dflag);
   
              /****************************************************/
              /* if its is array ,adds its ubounds and lbounds as argument */
              if ((symb->attributes()& DIMENSION_BIT)||
		  strstr(symb->identifier(),"LOCAL_")){
	
		 if (strstr(symb->identifier(),"LOCAL_")){
		   char *tempSymbVal=new char[256]; //(char *)malloc(256);
		   strcpy(tempSymbVal,(symb->identifier())+strlen("LOCAL_"));
		   varShape = new SgValueExp(tempSymbVal);
		 }
		 else
		   varShape = new SgValueExp(symb->identifier());

                 /*prepare LBOUND(A) call function for dim_info parameter*/
                 /* Here we are trying to calculate the LBOUND of var */
                 shape_symb = new SgVariableSymb("lbound",*curs);
	         fce   = new SgFunctionCallExp(*shape_symb );
                 fce -> addArg(*varShape);
                 /* Add dim_info parameter  */
                 scstmt->addArg(*fce);


                 /*prepare UBOUND(A) call function for dim_info parameter*/
                 /* Here we are trying to calculate the UBOUND of var */
                 shape_symb = new SgVariableSymb("ubound",*curs);
	         fce   = new SgFunctionCallExp(*shape_symb );
                 fce -> addArg(*varShape);
                 /* Add dim_info parameter  */
                 scstmt->addArg(*fce);
	      } 
              /****************************************************/

              /* finally add register call stmt */
              festmt->insertStmtBefore(*scstmt,*(festmt->controlParent()));

              //scstmt->unparsestdout();

	   }
	}
       	
        // put server function call before end of function unit
        SgStatement *lastStmt = curs->lastExecutable()->lexNext();
        if (curs->lastExecutable()->variant() != RETURN_STAT)
	  InsertFCallNode(lastStmt , HPF_SERVER,BEFORE);
	free(ts);
}



insertAllocateStmt(SgSymbol *symb,SgStatement *curs)
{
    SgCallStmt *callStmt;
    SgVariableSymb *parSymb;//,*callSymb;
    SgFunctionSymb *callSymb;
    SgStatement *sline;
    char varName[1024],tmpName[1024],*p;

    sline = find_first_exec_stmt(curs);
    //callSymb = new SgVariableSymb("ALLOCATE", *(sline->controlParent()));
    callSymb = new SgFunctionSymb(FUNCTION_NAME,"ALLOCATE",
		     *(new SgType(T_VOID)),*(sline->controlParent()));
    callStmt = new SgCallStmt(*callSymb);

    p = symb->identifier();
    strcpy(tmpName,p+strlen("LOCAL_"));
    parSymb = new SgVariableSymb(tmpName);

    SgArrayRefExp *arefexp = new  SgArrayRefExp(*symb);
    for(int i=1;i<= findNdimsForLocal(symb);i++){
      SgVariableSymb *shape_symb = new SgVariableSymb("size");
      SgFunctionCallExp *fce   = new SgFunctionCallExp(*shape_symb );
      SgVarRefExp   *sv = new SgVarRefExp(parSymb);
      fce -> addArg(*sv);
      SgValueExp *sve = new SgValueExp(i);
      fce -> addArg(*sve); 
      arefexp->addSubscript(*fce);
    }
    callStmt->addArg(*arefexp);
    p = callStmt->unparseToBuf();
    p = strstr(p,"call ")+strlen("call ");
    sprintf(tmpName,"      %s",p);
    sline->addComment(tmpName);  

    //Insert ALLOCATE function call just before registration of this local
    //sline->insertStmtBefore(*callStmt,*(sline->controlParent()));
    //sline->insertStmtBefore(*ass,*(sline->controlParent()));
}

int isHpfLocal(SgStatement *s)
{
  SgProcHedrStmt  *sg;
  if (!(sg=isSgProcHedrStmt(s))){
    return 0;
  }
  else{
    SgExpression *sexpr = sg->expr(1);
    int found = 0;
    for(;sexpr;sexpr = sexpr->nextInExprTable())
      if (sexpr->variant() == PREFIX_EXTRINSIC){
	found = 1;
	break;
      }
    return found;
  }
	

}

/*************************************************************************/
/*************************************************************************/
/*************************************************************************/
/* Here we are rewriting to insert the registration of only the variables*/
/* we are interedted inone variable I know this is extra but later I will*/
/* reorganise  my coding to make it more structured                      */
/*************************************************************************/
char *insert_register_defined_vars(SgStatement *procHedr)
				 
{
    
    SgProgHedrStmt *    prog,*curs;
    SgProcHedrStmt *    subr;  
    SgProsHedrStmt *    pros;
    SgFuncHedrStmt *    func;       
    SgSymbol *symb;
    SgVariableSymb *fsymb,*shape_symb;
    SgStatement    *    festmt;
    int var_type;
    int ndims,scope,var_id;
    char *name,indexName[256] ;
    SgValueExp *varType,*varName,*varNdims,*varScope;
    SgValueExp *symbattributes;
    SgCallStmt *scstmt;
    SgVarRefExp *e1,*varShape; 
    SgVariableSymb *ptsymb;
    SgFunctionCallExp *fce;
    int distFlag;
    SgStatement *decls;
    int nextTemp=0,found,k;
    char *ts ,useStmt[512];
    char hpfDynamic[1024],*newfunction_vars;
    int dynCnt=0;
    SgVariableSymb *register_var_symb;
    SgVarDeclStmt *svar;
    SgParameterStmt *parvar;
    int ns;

    curs = (SgProgHedrStmt *)(procHedr->controlParent());
    if ((curs == NULL) || (isHpfLocal(curs)))
      return NULL;
    //printf("symbol:%s", (curs->name()).identifier());
    //printf(" which is a subroutine.\n"); 

   /* find first executable stmt in current scope */
    festmt = find_first_exec_stmt(curs);
 
    register_var_symb=new SgVariableSymb("register_var",*curs);

    //create SgSymbol for function name   
    char *funcName = (curs->name()).identifier();
    char *funcNameSymb  = new char[strlen(funcName)+5];//(char *)malloc(strlen(funcName)+5);
    strcpy(&funcNameSymb[1], funcName);
    funcNameSymb[0] = '\"';
    funcNameSymb[strlen(funcName)+1] = '\\';
    funcNameSymb[strlen(funcName)+2] = '0';
    funcNameSymb[strlen(funcName)+3] = '\"';
    funcNameSymb[strlen(funcName)+4] = 0;    
    SgVariableSymb *fSymb = new SgVariableSymb(funcNameSymb,*curs);
    SgVarRefExp *funcVarName = new SgVarRefExp(fSymb);

    for(decls=procHedr;decls!=festmt;decls = decls->nextInChildList())
    {

       if (decls->variant() == INTERFACE_STMT  )
	     continue;

       if (isSgVarDeclStmt(decls)){
	   svar = (SgVarDeclStmt *)decls;
           ns = svar->numberOfSymbols();
	}
        else if (isSgParameterStmt(decls)){
	   parvar = (SgParameterStmt *)decls;
	   ns = parvar->numberOfConstants();
	}
        else
           continue;
	   
       for(int i=0;i<ns;i++)
       {
              if (isSgVarDeclStmt(decls))
                 symb = svar->symbol(i);
              else
		 symb = parvar->constant(i);
 
              /* Dont register variables other than variable names 
		 or constants */ 
              if ((symb->variant() != VARIABLE_NAME)&&
		  (symb->variant() != CONST_NAME))
                continue;

              // Do not register the complex variables I won't use at all
	      var_type = give_type_symbol(symb->type()->internalBaseType());
	      if (var_type == T_COMPLEX)
		continue;

	      //printf("I am registring : %s variant = %d in fun=%s\n",
	      //     symb->identifier(),symb->variant(),
	      //     (curs->name()).identifier() );



              fsymb = register_var_symb;
	      scstmt = new SgCallStmt(*fsymb);

              /* add var_type parameters to register_var subroutine */
              varType = new SgValueExp(var_type);
	      scstmt->addArg(*varType);

              /* add variable id = parameter var_id */	
              sprintf(indexName, "ind_%d", nextTemp++);
              ptsymb = new SgVariableSymb(indexName,*curs);
	      e1 = new SgVarRefExp(*ptsymb);
	      scstmt->addArg(*e1);
           	        
  
              /* add variable itself = var parameter */
              e1 = new SgVarRefExp(*symb);
	      scstmt->addArg(*e1);
                 
              /* add variable literal name = name parameter */
              ts  = new char[strlen(symb->identifier())+5];
	      //(char *)malloc(strlen(symb->identifier())+5);
              strcpy(&ts[1], symb->identifier() );
              ts[0] = '\"';
              ts[strlen(symb->identifier())+1] = '\\';
              ts[strlen(symb->identifier())+2] = '0';
              ts[strlen(symb->identifier())+3] = '\"';
              ts[strlen(symb->identifier())+4] = 0;                   
              SgVariableSymb *dummy = new SgVariableSymb(ts,*curs);
              SgVarRefExp *tvarName = new SgVarRefExp(dummy);
 	      scstmt->addArg(*tvarName);
	 
              /* add var_ndims parameter */
	      if (strstr(symb->identifier(),"LOCAL_"))
		ndims = findNdimsForLocal(symb);
              else
		ndims = symb_ndims(symb);
              varNdims = new SgValueExp(ndims);
	      scstmt->addArg(*varNdims);

              // add current function name  
              scstmt->addArg(*funcVarName);

              //add attributes of symbol
	      symbattributes = new SgValueExp(symb->attributes());
	      scstmt->addArg(*symbattributes);
             
              /* Add distributed flag:is distributed or not */      
              if ((symb->attributes() & ALIGN_BIT)||
		  (symb->attributes() & DISTRIBUTE_BIT )){
		  distFlag = 1;
                  sprintf(hpfDynamic,
               "      !hpf$ DYNAMIC :: %s\n",symb->identifier());
                  curs->lexNext()->addComment(hpfDynamic);
	      }
	      else
		  distFlag = 0;
              SgValueExp *dflag = new SgValueExp(distFlag);       
              scstmt->addArg(*dflag);
   
              /****************************************************/
              /* if its is array ,adds its ubounds and lbounds as argument */
              if ((symb->attributes()& DIMENSION_BIT)||
		  strstr(symb->identifier(),"LOCAL_")){

  	         if (strstr(symb->identifier(),"LOCAL_")){
		   char *tempSymbVal=new char[256];//(char *)malloc(256);
		   strcpy(tempSymbVal,(symb->identifier())+strlen("LOCAL_"));
		   varShape = new SgVarRefExp(new SgVariableSymb(tempSymbVal));
		 }
		 else
		   varShape = new SgVarRefExp(symb);


                 for(k=0;k<ndims;k++){
                    /*prepare LBOUND(A) call function for dim_info parameter*/
                    /* Here we are trying to calculate the LBOUND of var */
                    shape_symb = new SgVariableSymb("lbound",*curs);
	            fce   = new SgFunctionCallExp(*shape_symb );
                    fce -> addArg(*varShape);

		    SgValueExp *vardim = new SgValueExp(k+1);
	            fce->addArg(*vardim);
                    /* Add dim_info parameter  */
                    scstmt->addArg(*fce);


                    /*prepare UBOUND(A) call function for dim_info parameter*/
                    /* Here we are trying to calculate the UBOUND of var */
                    shape_symb = new SgVariableSymb("ubound",*curs);
	            fce   = new SgFunctionCallExp(*shape_symb );
		    fce -> addArg(*varShape);

		    vardim = new SgValueExp(k+1);
	            fce->addArg(*vardim);
                    /* Add dim_info parameter  */
                    scstmt->addArg(*fce);
		 }
                 
	      }
              if (strstr(symb->identifier(),"LOCAL_"))
                 insertAllocateStmt(symb,curs);
              /****************************************************/
              /* finally add register call stmt */
              festmt->insertStmtBefore(*scstmt,*(festmt->controlParent()));
	    	    	    
       }
    }
    free(ts);
    return newfunction_vars;
 
}

SgStatement *whereDeclared(SgSymbol *x,SgStatement *start)
{ 
   SgStatement  *old_decl;
   SgExpression *exp;
   SgExprListExp *elist;

   for(old_decl = start;old_decl ;old_decl=old_decl->lexNext()){
       
       if (old_decl -> variant() == SAVE_DECL)
          continue; 
       
       // get the expression list of variables delcared
       exp = old_decl->expr(0);
       // look for the reference to our symbol x.
       while(elist = isSgExprListExp(exp)){
       	 if((elist->value())->IsSymbolInExpression(*x) )
               break;       
         exp = elist->next();
       }    
       if ( exp ) 
          break;
   }
   return old_decl;
}

SgVariableSymb *DeclareTemporaryLike(SgSymbol * x,int sd)
{
       SgStatement  *old_decl_stmt;
       SgVariableSymb *tmp;
       SgVarDeclStmt *decl_stmt;
       SgExpression *exp;
       char *name;
       SgExprListExp *elist;
       SgType *old_type;
       SgVarDeclStmt *decl;
       SgProgHedrStmt *ispg;
              
       // now find the declaration statement for x and get
       // the correct initializing expression.
       
       old_decl_stmt = x ->declaredInStmt();
       // get the expression list of variables declared
       exp = old_decl_stmt->expr(0);
       // look for the reference to our symbol x.
       while(elist = isSgExprListExp(exp)){
       	 if((elist->value())->IsSymbolInExpression(*x) )
               break;       
            exp = elist->next();
            }    
       if(exp == NULL) return NULL;

       // get symbol type
       int symbTypeInt = give_type_symbol(x->type()->internalBaseType()); 
       SgType *symbType = new SgType(symbTypeInt);
 
       // create a new variable of the same class
       // generate the name as "_Ti" where i is counter.
       name = new char[256];//(char *)malloc(256);
       if (sd == SLOCAL)     
	 sprintf(name, "LOCAL_%s", x->identifier());
       else
	 sprintf(name, "DISTR_%s", x->identifier());

       tmp = new SgVariableSymb(name, *symbType, *(x->scope()));
       //Test if new declaration can be added
       SgArrayRefExp *arefexp = new  SgArrayRefExp(*(&tmp->copy())); 
       //prepare size(A) call fucntion for dim_info parameter
       //Here we are trying to calculate the shape of var 
       for(int i=1;i<=symb_ndims(x);i++){
	    //SgVariableSymb *shape_symb = new SgVariableSymb("size");
	    //SgFunctionCallExp *fce   = new SgFunctionCallExp(*shape_symb );
	    //SgValueExp *sve = new SgValueExp(x->identifier());
	    //SgValueExp *sve;
	    //SgVarRefExp   *sv = new SgVarRefExp(x);
            //printf("LOCAL : %s\n",x->identifier()); 
	    //fce -> addArg(*sve);
	    //fce -> addArg(*sv);
	    //sve = new SgValueExp(i);
	    //fce -> addArg(*sve); 
            arefexp->addSubscript(*(new SgExpression(COLON_OP))); //*fce);
	}
	SgVarDeclStmt *ndecl = new SgVarDeclStmt(*arefexp, *symbType);
	old_decl_stmt->insertStmtAfter(*ndecl, 
				       *(old_decl_stmt->controlParent()));

        char *b = old_decl_stmt->unparseToBuf();
        char *bp = old_decl_stmt->controlParent()->unparseToBuf();
        //printf("defined at-%s- and parent=%s- \n",b,bp);

        //store parallel SgSymbol in table to use its ndims during 
	//declaration of its local copy
        strcpy(symbtable[nextsymb].name,x->identifier());
	symbtable[nextsymb++].parsymb = x;


        return tmp;
    }

void insert_decls(SgStatement *moduleDecls)
{
   SgStatement *prev,*s1;
   SgSymbol *symb;
   SgVarDeclStmt *decl;
   SgProgHedrStmt *p;
   int found ,k;

   int nchilds = moduleDecls->numberOfChildrenList1();
   SgStatement *last = moduleDecls->childList1(nchilds-1);
   //printf("nchilds = %d\n",nchilds);
   for(prev = moduleDecls;(prev != last);prev = prev->lexNext()){  
     if  ((prev->variant() == ALIGN_DECL)||   
	  (prev->variant() == DISTRIBUTE_DECL)||
          (prev->variant() == COMBINED_DIRECTIVE_DECL)||
	  (prev->variant() == ALIGN_DECL)||
          (prev->variant() == TEMPLATE_STMT) )
       {
         decl = (SgVarDeclStmt *)prev;
       	 for(int i=0;i<decl->numberOfSymbols();i++){
            if (isTemplate(decl->symbol(i)))
              continue;
            DeclareTemporaryLike(decl->symbol(i),SLOCAL);
	 }
       }
   }

  
}

int isTemplate(SgSymbol *symb)
{
   SgStatement *prev = symb->declaredInStmt();

   if  ((prev->variant() == ALIGN_DECL)||   
	(prev->variant() == DISTRIBUTE_DECL)||
        (prev->variant() == COMBINED_DIRECTIVE_DECL)||
	(prev->variant() == ALIGN_DECL)||
        (prev->variant() == TEMPLATE_STMT) )
     return 1;
   else
     return 0;
}
   


int fileLength(SgFile *f,int num_of_routines)
{
  SgStatement *fs,*ls,*lc;
  int nchilds,line;  
  fs      = f->firstStatement();

  nchilds = fs->numberOfChildrenList1();
  lc      = fs->childList1(nchilds-1);
  nchilds = lc->numberOfChildrenList1();

  if (nchilds > 0){
    ls      = lc->childList1(nchilds-1);
    line = ls->lineNumber()+1;
    return (line);
  }
  else{
    line = lc->lineNumber()+1;
    return line;
  }
}
 
void readParseTree(char *projectFileName,int *nfiles,FILES **files)
{
   SgProject * project = new SgProject(projectFileName);

   create_functionTable_file(project,nfiles,files);
 
}



create_functionTable_file(SgProject * project, int *nfiles, FILES **t_files)
{
  int numOfFiles;
  int num_of_routines;
  int filelen;
  SgStatement *child;
  int rem,k;
  FILES *files;
    
  /* files = (FILES *)calloc(numOfFiles,sizeof(FILES)); */

  numOfFiles = project->numberOfFiles();
  *t_files = (FILES *)calloc(numOfFiles,sizeof(FILES)); 
  *nfiles = numOfFiles;
  files = *t_files;

  /* Go trough all the project files */
  for(int i=0;i< numOfFiles;i++){
    SgFile *f;
    SgStatement *mp;
    int nf;

    nf = 0;

    f = &(project->file(i));
    if (f -> mainProgram())   
      files[i].isIncludeMain = 1;
    else
      files[i].isIncludeMain = 0;   

    num_of_routines = f->numberOfFunctions();

    // calculate filelen and structures    
    filelen = fileLength(f, num_of_routines);
    files[i].lineInfo = (SINFO *)calloc(filelen,sizeof(SINFO));
    files[i].functab  = (FTAB *)calloc(num_of_routines,sizeof(FTAB));

    strcpy(files[i].fileName,project->fileName(i));
    files[i].fileSize = filelen;

    char *sptr = strrchr(files[i].fileName,'.');
    strncpy(files[i].depFileName,files[i].fileName,
	 sptr - (files[i].fileName));
    strcat(files[i].depFileName,".dep");

    //printf("filename : %s noffunc: %d filelen = %d\n",
    //	   files[i].fileName,num_of_routines,filelen);

    for(int j=0;j < num_of_routines;j++){
      SgStatement *sub;
      SgSymbol    *subsymb;

      sub     = f->functions(j);
      subsymb = sub->symbol();
      files[i].functab[nf].fExecStmt = find_first_exec_stmt(sub)->lineNumber();
      files[i].functab[nf].isVisited = 0;
      if (sub -> variant() == PROG_HEDR)
         files[i].mainFuncIndex = j;

      if ((sub->controlParent()->variant() !=  INTERFACE_STMT)){
         files[i].functab[nf].lineNum = sub->lineNumber();
         strcpy(files[i].functab[nf].funcName,subsymb->identifier());
         
         strcpy(files[i].functab[nf++].fileName,project->fileName(i));
      }
      if ((isHpfLocal(sub))||
	  (sub->controlParent()->variant() == INTERFACE_STMT))
	continue;


      SgStatement *ls = sub->childList1(sub->numberOfChildrenList1()-1);
      ls = ls->lexNext();
   
      SgStatement *ts = sub;
      for (; ts != ls; ts=ts->lexNext()){
	 if (ts->variant() == INTERFACE_STMT ){
	   ts = ts->nextInChildList();
	   ts = ts->lexPrev();
	   continue;
	 }
         child = ts;
         k = child->lineNumber();

         if ( child->lexNext())
	   files[i].lineInfo[k].next = child->lexNext()->lineNumber();
	 else
	   files[i].lineInfo[k].next = -1;
	 if (child->lexPrev())
	   files[i].lineInfo[k].prev = child->lexPrev()->lineNumber();
	 else
	   files[i].lineInfo[k].prev = -1;
	 
         files[i].lineInfo[k].onbreak = BREAKOFF;
	 /* Initialize that there is no function calls attached to this line */
         files[i].lineInfo[k].numOfAttachedFcalls = 0;
           
         files[i].lineInfo[k].lineNum = child->lineNumber();
         files[i].lineInfo[k].stmtID  = child->variant();
         files[i].lineInfo[k].parent  = child->controlParent()->lineNumber();
         files[i].lineInfo[k].isExecutable = 0; 
	 files[i].lineInfo[k].nexecution   = 0;
	 files[i].lineInfo[k].elapsed_time = 0; 
	 files[i].lineInfo[k].funcIndex    = nf-1;
 
         files[i].lineInfo[k].isInLoop = isInLoop(child);
         if ((child->variant() == RETURN_STAT)||
	     (child->variant() == STOP_STAT)||
	     (ts->lexNext() == ls))
	   files[i].lineInfo[k].isReturnPoint = 1;
	 else
           files[i].lineInfo[k].isReturnPoint = 0;

       } 
    }
    files[i].nfuncs = nf;
    transform_registration(f->firstStatement(),i,files);       
  }
}



void action(SgStatement * s,int find,FILES *files)
{
  SgDeclarationStatement *decl;
  SgProgHedrStmt *spg;
  SgCallStmt *cs;
  SgForStmt *fs;
  int flag = 0;
  SgAssignStmt *ass ;
  SgForStmt *sfo ; 
  SgCallStmt *call;
  
  SgStatement *cp = s->controlParent();
  
  if (isSgProgHedrStmt(cp)&&(s->nextInChildList() == NULL))
    {
          files[find].lineInfo[s->lineNumber()].isExecutable = 1; 
   }
  else if ((isSgExecutableStatement(s))&&
      (s->variant() != ELSEIF_NODE)&&
      (s->variant() != CONTROL_END)&&
      (s->variant() != MODULE_STMT)&&
      (s->variant() != USE_STMT)&&
      (s->variant() != INCLUDE_STAT)&&
      (s->variant() != WHERE_BLOCK_STMT)&&
      ((!cp)||(!(cp->lineNumber()==s->lineNumber()))) ){
          files[find].lineInfo[s->lineNumber()].isExecutable = 1; 
  }
     
}
  
void transform_registration(SgStatement * s,int find,FILES *files) 
{
  int i=0;

  int org_numberOfChildren1=s->numberOfChildrenList1();
  int org_numberOfChildren2= s->numberOfChildrenList2();
  int org_numberOfChildren = org_numberOfChildren1 + org_numberOfChildren2;
  SgStatement * * children = new SgStatement * [org_numberOfChildren];
  SgStatement *st;
  SgStatement *line;
   
  if (isHpfLocal(s))
       return;

  for (i=0; i<org_numberOfChildren1; i++)
	children[i]=s->childList1(i);
   
  for (; i<org_numberOfChildren; i++)
     children[i]=s->childList2(i-org_numberOfChildren1);

   for (i=0; i<org_numberOfChildren; i++){

     st =  children[i];
     if ((st -> variant() == FORALL_CONSTRUCT_STMT)||
         (st -> variant() == INTERFACE_STMT)||
         (st -> variant() == FORALL_STMT)||
	 (st->  variant() == WHERE_BLOCK_STMT))
         
     {
         action(st,find,files);
	 continue;
     }
     	 /* pass on INDEPENDENT DO LOOP */
     else if  (st -> variant() == INDEPENDENT_STMT)
     {
           action(st,find,files);
	   i++;
	   continue;
     }
     else{
         action(st,find,files);
         transform_registration(st,find,files);
     }
   }
   delete [] children;
   return;
   
}

int isDecl(SgStatement *chld)
{       if ((chld->variant() == VAR_DECL)||
	    (chld->variant() == DIM_STAT)||
            (chld->variant() == COMBINED_DIRECTIVE_DECL)||
	    (chld->variant() == DISTRIBUTE_DECL)||
            (chld->variant() == ALIGN_DECL)||
            (chld->variant() == PARAM_DECL)||
            (chld->variant() == PROCESSORS_STMT)||
            (chld->variant() == TEMPLATE_STMT)||
	    (chld->variant() == INHERIT_DECL))
         return 1;
     else
        return 0;

}

char *InstrumentModule(SgFile *file,int nextModule,int interface_num)
{
    SgStatement *firstExecStmt;
    SgFunctionSymb *functionSymb,*moduleSymb ;
    SgStatement *s,*interface,*last;
    char funcName[1024], moduleName[1024],*tempbuf,line[1024];
    char *p,useStmt[1024],*new_vars;
    SgType *type = new SgType(T_VOID);

    SgStatement *firstFunction  = file->functions(0);

    int len   = firstFunction->numberOfChildrenList1();
    interface = firstFunction->childList1(interface_num);
    last =    firstFunction->childList1(len-1);

    //start instrumentation
    //First add local declarations for distributed variables
    //and then register the variables user defined in interpreter mode
    ///////////////////////////////////////////////////////////////////
    firstFunction->lexNext()->setComments("");
    insert_decls(interface);
    new_vars = insert_register_defined_vars(interface);
    firstExecStmt = part_find_first_exec_stmt(interface,last);

    if (DEBUG)
      printf("I instrumented interpreter module  \n");

    sprintf(moduleName,"newmodule_%d",nextModule);
    char *output = new char [10240];
    //(char *)malloc(10240); // say maximum program is 10K
    sprintf(line,"      MODULE  %s\n",moduleName);
    strcpy(output,line);
    //copy the !hpf$ dynamic statements of parallel variables
    strcat(output,firstFunction->lexNext()->comments());

    firstFunction->lexNext()->setComments("");
    //And Eventually ,Add USE stmts for generated modules upto now

    if (nextModule >0){
       sprintf(useStmt,"      USE newmodule_%d\n",nextModule-1);
       firstFunction->lexNext()->addComment(useStmt);
    }
    
    // add PARAMETER Constant variabels at the top of module
    // These constants are coming from main subroutine in which
    // user request interpreter HPF commands
    //Because each consecutive module includes previous one (that is
    // module_i has this statement "USE module_(i-1) )
    // only first module includes all the constant declarations
    if (nextModule == 1){
      for(s = firstFunction->lexNext(); (s != interface);s=s->lexNext()){
	if (s->variant() == PARAM_DECL){
	  tempbuf = s->unparseToBuf();
	  strcat(output,tempbuf);
	}
      }
    }
    else
      if (firstFunction->lexNext()->variant() == PARAM_DECL){
      tempbuf = firstFunction->lexNext()->comments();
      strcat(output,tempbuf);
    }
	
    // Add local definitions for new module
    for(s=interface; (s!=firstExecStmt);s=s->lexNext()){
        tempbuf = s->unparseToBuf();
        strcat(output,tempbuf);
      }  

    //Add CONTAINS stmt
    strcat(output,"      CONTAINS\n");

    // add Declarations coming from main program unit
    // take only subroutine header and put into output buffer
    tempbuf = firstFunction -> unparseToBuf();
    p       = firstFunction -> lexNext()->unparseToBuf();
    *strstr(tempbuf,p) = 0;
    strcat(output,tempbuf);
   
    // And then the rest of subroutine
    // Excluding Constant PARAMETER variables
    for(s = firstFunction->lexNext();(s != interface) ;
	s=s->nextInChildList()){
	if (s->variant() != PARAM_DECL){
	  tempbuf = s -> unparseToBuf();
	  strcat(output,tempbuf);
	}
    }
    
    
    // add the actual executables
    for(s = firstExecStmt;s;s=s->nextInChildList()){
      tempbuf = s -> unparseToBuf();
      strcat(output,tempbuf);
    }

   //Add module END stmt
   strcat(output,"      END\n");
     
   //modify to free format
   char *loutput = new char[10240];//(char *)malloc(10240);
   strcpy(loutput,"");

   for(p=output;p;){
     char *pe;
     pe = strstr(p,"\n     +");
     if (pe == NULL)
       break;
     strncat(loutput,p,pe-p);
     strncat(loutput,"&\n     &",8);
     p = pe+7;
   }
   strcat(loutput,p);
   free(output);
   if (DEBUG)
     printf("Generated module ; %s\n",loutput);
   
   return loutput;
}

