#include "debugger.h"

int server (int myline,char *funcName,char *fileName,int sockfd)
{
   int Stop = 0,lineNumber,i; 
   char variableName[256];
   static int curCmnd=0,goToCursorLine;
   static int nIterStartLine,loopHeaderLine,curCounter;
   static int is_staying_in_server = STAYINSERVER;
   static char *curFileName=NULL ,*prevFileName;
   static char *curFuncName=NULL ,*prevFuncName;
   static int  prevStackTop;
   int status,temp;
   char msg[256];
   int errcode=0;
 
   prevFileName = curFileName;
   curFileName  = fileName;
   prevFuncName = curFuncName;
   curFuncName  = funcName;
   if (prevFileName == NULL)
     prevFuncName = fileName;
   if (prevFileName == NULL )
     prevFuncName = funcName;

   updateControlStack(myline,prevFuncName,curFuncName,prevFileName);

   if (DEBUG){
     printf("inside server myline = %d  sock=%d ME=%d cmnd=%d -%d stop=%d prevtop=%d\n",
         myline,sockfd,ME,curCmnd,cstack.top,prevStackTop);
      printf("File name : %s\n",fileName);
   }

   if (curCmnd == GOTOCURSOR){
        if (myline == goToCursorLine)
	   Stop = 1;
   } 
     
   else if (((curCmnd == STEPOVER)||(curCmnd == NSTEPOVER)) &&
         (cstack.top <= prevStackTop ))
   { 
       if (DEBUG)
          printf("Previos Command STEP cnt = %d\n",curCounter);
       if (curCounter > 0)
          curCounter --;
       if (curCounter == 0) 
	  Stop = 1;

   }
   else if ((curCmnd == STEPINTO)||(curCmnd == NSTEPINTO))
   {
       if (curCounter > 0)
          curCounter --;  
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == CONTINUE)&&(files[curFile].lineInfo[myline].onbreak))
       Stop = 1;
   else if ((curCmnd == NITERATION)&&(cstack.top <= prevStackTop ))
     {
       if (files[curFile].lineInfo[myline].isInLoop != loopHeaderLine)
          Stop = 1;    
       else if ((curCounter > 0)&&(myline ==  nIterStartLine))
	   curCounter--;
       if (curCounter == 0) 
	   Stop = 1;
     }
   if (is_staying_in_server == STAYINSERVER)
      Stop = 1; 
  
   if ((!Stop)&&(!FD_ISSET(sockfd, &rfds))){
      if (DEBUG)
         printf("I am exiting now \n");
      is_staying_in_server = EXITFROMSERVER; 
      return EXITFROMSERVER;
   }
    
   /* Send myline to Java Applet which updates current line number */
   /* for beginning, wait for connection request */
   /* do not send the myline number to Applet */
   if ((is_staying_in_server == EXITFROMSERVER) && HOST){
       /*If we moved to one function code which is in another file 
       other than current one, Applet will request new file source 
       code from HTTP server if it doesnt have */

       if (strcmp(curFileName,prevFileName)){
           int index;
	   index = findFileIndex(curFileName);

           send_int(sockfd,GETNEWFILE);
           send_String(sockfd, curFileName);
           curFile = index;
           openNewProject(curFile);
           if (DEBUG)
             printf("I am sending the file : %s\n",curFileName);

       }
       send_int(sockfd,myline); 
       if (DEBUG)
          printf("We ME = %d send current line = %d toApplet \n",ME,myline);   
   }

   curCmnd = 0;
   if (HOST)    
      recv_int( sockfd,&curCmnd );
   distribute_oneitem_(&curCmnd);
   if (DEBUG)
      printf("read new command = %d\n",curCmnd);

   switch(curCmnd){
   case GOTOCURSOR:
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     if (!(files[curFile].lineInfo[curCounter].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd,
		    prevFileName,curFileName);
        errcode = -1;
        is_staying_in_server = STAYINSERVER;  
     }
     else{
        goToCursorLine = curCounter;
        is_staying_in_server = EXITFROMSERVER;
     }
     break; 

   case CONNECT :
     if (HOST)
        send_int(sockfd,myline);
     is_staying_in_server = STAYINSERVER; 
     if (DEBUG) 
        printf("We processed connect request ME = %d\n",ME);
     break;

   case PUTBREAKONOFF :
     lineNumber = 0; 
     if (HOST)
        recv_int( sockfd,&lineNumber );  
     distribute_oneitem_(&lineNumber);
     if (DEBUG)
        printf("line number = %d\n",lineNumber);
     if (!(files[curFile].lineInfo[lineNumber].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd,
		    prevFileName,curFileName);
        errcode = -1;
     }
     else{
        if (files[curFile].lineInfo[lineNumber].onbreak == BREAKON)  
          files[curFile].lineInfo[lineNumber].onbreak = BREAKOFF;
        else
          files[curFile].lineInfo[lineNumber].onbreak = BREAKON;
     }
     is_staying_in_server = STAYINSERVER;
     break;

   case STEPOVER:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     prevStackTop = cstack.top;
     break;
   case STEPINTO:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NSTEPOVER:
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     is_staying_in_server = EXITFROMSERVER;
     prevStackTop = cstack.top;
     break;

   case NSTEPINTO: 
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     is_staying_in_server = EXITFROMSERVER;
     break;

   case CONTINUE:
     is_staying_in_server = EXITFROMSERVER;
     break;

   case RUN: 
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NITERATION:
     curCounter = 0;
     if (HOST)
        recv_int( sockfd,&curCounter);
     if (!(files[curFile].lineInfo[myline].isInLoop)){
        send_errmsg(-3,"You are not in one loop",myline,sockfd,
		    prevFileName,curFileName);
        is_staying_in_server = STAYINSERVER;
        errcode = -3;
     }
     else{
        distribute_oneitem_(&curCounter);
        nIterStartLine = myline;
        loopHeaderLine = files[curFile].lineInfo[myline].isInLoop;
        is_staying_in_server = EXITFROMSERVER;
     }
     prevStackTop = cstack.top;
     break;

   case DISPLAY:
     if (HOST)
        recv_String(sockfd,variableName);
     status = find_var(funcName,variableName);
     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-4,msg,myline,sockfd,prevFileName,curFileName);
        errcode = -4;
     }
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName); 
       status = send_registered_data(funcName,variableName,sockfd);   
     } 
     is_staying_in_server = STAYINSERVER;
     break;

   case SETVARIABLE:
     if (HOST)
        recv_String(sockfd,variableName);
     status = find_var(funcName,variableName);
     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-5,msg,myline,sockfd,prevFileName,curFileName);
        errcode = -5; 
     } 
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);  
       status = set_variable(sockfd,status);
     }
     is_staying_in_server = STAYINSERVER;   
     break;

   case SETPARVAR:
     if (HOST)
        recv_String(sockfd,variableName); 
     set_ParallelVar(sockfd,variableName, funcName);
     is_staying_in_server = STAYINSERVER;
     break;    

   case INTERPRET:
     if (HOST)
       interpretHPFStmt(sockfd,funcName);
     is_staying_in_server = STAYINSERVER;
     break;

   } /* switch */

   /* If there is no error,send Ok message to Applet */
   if ((errcode == 0)&&(curCmnd != DISPLAY)&&(curCmnd != SETVARIABLE))
      send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);
    
   return is_staying_in_server;
}

send_errmsg(int errorcode,char *errormsg,int myline,int sockfd,
	    char *prevFileName,char *curFileName)
{
   char msg[256];

   if (HOST){
     sprintf(msg,"%s : %d\n",errormsg,myline);
     if (DEBUG)
        printf("I will send errmsg =%s code=%d\n",msg,errorcode);

     send_int(sockfd,errorcode);
     send_String(sockfd, msg);
   }
}

int findFileIndex(char *curFileName)
{
   int i,index;

   for(i=0;i<nfiles;i++)
     if (!strcmp(files[i].fileName,curFileName))
       index = i;
   if(DEBUG)
      printf("I found index = %d sfile = %s\n",index,curFileName);
   return index;
}

int findFuncIndex(char *curFuncName)
{
   int i,index=-1;

   for(i=0;i<nfuncs;i++){
     if (!strcmp(functab[i].funcName,curFuncName)){
       index = i;
       break;
     }
   }
   if (index < 0){
     printf("I could not find the function : %s\n",curFuncName);
     exit(0);
   }
   return index;
}


updateControlStack(int myline,char *prevFuncName,
     char *curFuncName,char *prevFileName)
{
  int i,fexec,findex;

  findex = findFuncIndex(curFuncName);
  fexec =  functab[findex].fExecStmt;  /* First executable stmt */

  /* Subroutine called */
  if (strcmp(prevFuncName,curFuncName)&&(myline == fexec)){
      i = ++(cstack.top);
      cstack.sInfo[i].lineNum  = myline;
      cstack.sInfo[i].funcName = prevFuncName;
      cstack.sInfo[i].fileName = prevFileName;
      if (DEBUG)
         printf("Subroutine called  TOP =%d\n",i);
  }
  /* Return from function */
  else if (strcmp(prevFuncName,curFuncName)&&(myline != fexec)){
      (cstack.top)--;
       if (DEBUG)
          printf("Subroutine returned   TOP =%d\n",cstack.top);
  }

}

void interpretHPFStmt(int sockfd,char *funcName)
{
   int findex,i;
   char hpfStmtList[10240];

   findex = findFuncIndex(funcName);

   recv_String(sockfd,hpfStmtList);

   callFuncDynamic(hpfStmtList,funcName);

  
}

