#include "debugger.h"

#define P(i) (stack[ind[i]].buf)
#define D(i) (stack[ind[i]].desc)
char *toLowerCase(char *exfuncName);

int callFuncDynamic(char *hpfStmtList, char *curHpfFunc)
{
    char *funcInBuf;  
    FILE *fp;
    int pid,status,numOfusedVars;
    char funcName[128];
    char *usedVars[128];
    void *handle;
    int *iptr;
    char (*fptr)();
    int  ind[256];
    char *exfuncName ;

    funcInBuf = generateNewFunction(hpfStmtList,curHpfFunc,
           funcName,usedVars,&numOfusedVars);

    if (DEBUG){
      printf("I got the string : %s\n",hpfStmtList);
      printf("its function is : %s\n",funcInBuf);
    }

    exfuncName = (char *)malloc(sizeof(funcName)+2);
    strcpy(exfuncName,funcName);
    strcat(exfuncName,"_");

    fp = fopen("foos.hpf","w");
    fprintf(fp,"%s", funcInBuf);
    fclose(fp);

    /* Build shared object fron the on-the-fly generated function */
    system ("pghpf -Mfree -G -dy foos.hpf -o libfoo.so");
    
    if ((handle = dlopen("libfoo.so",RTLD_LAZY)) == 0)
       fatal("%s\n",dlerror());

    
    if ((fptr = (char (*)())dlsym(handle,toLowerCase(exfuncName))) == 0)
       fatal("%s\n",dlerror());

  	/* call hpf function */
    makeFuncCall(curHpfFunc, usedVars, numOfusedVars,fptr);
    dlclose(handle);
      
}
   
char *toLowerCase(char *s)
{
  int i;

  for(i=0;i<strlen(s);i++){
     if ((s[i]>=65)&&(s[i]<=90))
       s[i] += 32;
  }
  return s;
}



makeFuncCall(char *curHpfFunc,char *usedVars[],
	     int numOfusedVars,char (*fptr)() )
{
  int ind[32];

 
  /* Here we making some pessimistic prediction */
  calcIndices(curHpfFunc,usedVars,numOfusedVars,ind);
  switch(numOfusedVars)
    {
    case 0: (*fptr)();
      break;
    case 1:(*fptr)(P(0),D(0));
      break;
    case 2:(*fptr)(P(0),P(1),D(0),D(1));
     break;
    case 3:(*fptr)(P(0),P(1),P(2),D(0),D(1),D(2));
     break;
    case 4:(*fptr)(P(0),P(1),P(2),P(3),D(0),D(1),D(2),D(3));
     break;
    case 5:(*fptr)(P(0),P(1),P(2),P(3),P(4),D(0),D(1),D(2),D(3),D(4));
     break;
    case 6:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),
           D(0),D(1),D(2),D(3),D(4),D(5));
    break;
    case 7:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6));
    break;
    case 8:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7));
    break;
    case 9:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8));
    break;
    case 10:(*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8),D(9));
    break;
    case 11:
       (*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),P(10),
           D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8),D(9),D(10));
    break;
    case 12:
    (*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),P(10),P(11),
       D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8),D(9),D(10),D(11));
    break;
 
    case 13:
    (*fptr)(P(0),P(1),P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),P(10),P(11),
        P(12),D(0),D(1),D(2),D(3),D(4),D(5),D(6),D(7),D(8),D(9),D(10),D(11),
	    D(12));
 
    break;
 
    }
 
}
 
void calcIndices(char *curHpfFunc,char *usedVars[],int numOfusedVars,int *ind)
{
   int i,r,*ptr;

   for (i=0,ptr=ind;i<numOfusedVars;i++)
   {
     if ((r = find_var(curHpfFunc,usedVars[i])) < 0)
        printf("I couldn't find the var : %s in function :%s\n",
		usedVars[i], curHpfFunc);
     else
        *ptr++ = r;
   }
}
    

void fatal(char *s1, char *s2)
{
  
  printf(s1,s2);
  exit(0);
}

