#include "compilerApi.h"
#include "debugger.h"

int fileLength(SgFile *f,int num_of_routines);
create_functionTable_file(SgProject * project, int *nfiles);
int isInLoop(SgStatement *s);
SgStatement *find_outermost_scope(SgStatement *s);
void action(SgStatement * s,int find);
void transform_registration(SgStatement * s,int find) ;
write_summary(char *outFile,int nfiles);
SgStatement *find_first_exec_stmt(SgStatement *s);

extern "C" void readParseTree(char *projectFileName ,int *nfiles);

/*main(int argc,char **argv){
  int n,m;
  printf("before dflkgsdfg\n");
  SgProject * project = new SgProject("test.prj");
  create_functionTable_file(project,&n,&m);
  printf("after readParse \n");
  write_summary("EROL",n,m);
}*/


void readParseTree(char *projectFileName,int *nfiles)
{
 
   SgProject * project = new SgProject(projectFileName);

   create_functionTable_file(project,nfiles);

   /*write_summary("EROL", nfuncs, nfiles);  */
}


int fileLength(SgFile *f,int num_of_routines)
{
  SgStatement *s = f->functions(num_of_routines-1);
  s = s->childList1(s->numberOfChildrenList1()-1);
  return (s->lineNumber()+1);

}


create_functionTable_file(SgProject * project, int *nfiles)
{
  int numOfFiles = project->numberOfFiles();
  int num_of_routines;
  int filelen;
  SgStatement *child;
  int rem,k;
  
  files = (FILES *)calloc(numOfFiles,sizeof(FILES));
  *nfiles = numOfFiles;

  for(int i=0;i< numOfFiles;i++){
    SgFile *f;
    SgStatement *mp;
    int nf;

    nf = 0;

    f = &(project->file(i));
    if (f -> mainProgram())
      files[i].isIncludeMain = 1;
    else
      files[i].isIncludeMain = 0;   

    num_of_routines = f->numberOfFunctions();

    // calculate filelen and structures    
    filelen = fileLength(f, num_of_routines);
    files[i].lineInfo = (SINFO *)calloc(filelen,sizeof(SINFO));
    files[i].functab  = (FTAB *)calloc(num_of_routines,sizeof(FTAB));

    strcpy(files[i].fileName,project->fileName(i));
    files[i].fileSize = filelen;

    char *sptr = strrchr(files[i].fileName,'.');
    strncpy(files[i].depFileName,files[i].fileName,
	 sptr - (files[i].fileName));
    strcat(files[i].depFileName,".dep");

    for(int j=0;j < num_of_routines;j++){
      SgStatement *sub;
      SgSymbol    *subsymb;

      sub     = f->functions(j);
      subsymb = sub->symbol();
      files[i].functab[nf].fExecStmt = find_first_exec_stmt(sub)->lineNumber();
      if (sub -> variant() == PROG_HEDR)
         files[i].mainFuncIndex = j;

      if (sub->controlParent()->variant() !=  INTERFACE_STMT){
         files[i].functab[nf].lineNum = sub->lineNumber();
         files[i].functab[nf].ParseTreeStmt = NULL;
         strcpy(files[i].functab[nf].funcName,subsymb->identifier());
         
         strcpy(files[i].functab[nf++].fileName,project->fileName(i));
        
      }

      SgStatement *ls = sub->childList1(sub->numberOfChildrenList1()-1);
      ls = ls->lexNext();

      SgStatement *ts = sub;
      for (; ts != ls; ts=ts->lexNext()){
         child = ts;
         k = child->lineNumber();
        
         files[i].lineInfo[k].lineNum = child->lineNumber();
         files[i].lineInfo[k].stmtID  = child->variant();
         files[i].lineInfo[k].parent  = child->controlParent()->lineNumber();
         files[i].lineInfo[k].isExecutable = 0; 
         files[i].lineInfo[k].isInLoop = isInLoop(child);
         if ((child->variant() == RETURN_STAT)
	     ||(ts->lexNext() == ls))
	   files[i].lineInfo[k].isReturnPoint = 1;
	 else
           files[i].lineInfo[k].isReturnPoint = 0;
       }
    }
    files[i].nfuncs = nf;
    transform_registration(f->firstStatement(),i);       
  }
}

int isInLoop(SgStatement *s)
{

   SgStatement *cp,*curs;
   SgForStmt      *fstmt;
   SgDoWhileStmt  *dwstmt;

   cp   = s;
   curs = NULL;
   do{
     if ((fstmt = isSgForStmt(cp))||(dwstmt = isSgDoWhileStmt(cp)))
       curs =  cp;
     else if(cp != NULL)
   	cp = cp->controlParent();
   }while((cp)&&(!curs));
   if (curs )
     return (curs->lineNumber());
   else 
     return 0;
         
}


void action(SgStatement * s,int find)
{
  SgDeclarationStatement *decl;
  SgProgHedrStmt *spg;
  SgCallStmt *cs;
  SgForStmt *fs;
  int flag = 0;
  SgAssignStmt *ass ;
  SgForStmt *sfo ; 
  SgCallStmt *call;
  
  SgStatement *cp = s->controlParent();
  if ((isSgExecutableStatement(s))&&
      (s->variant() != CONTROL_END)&&
      (s->variant() != MODULE_STMT)&&
      (s->variant() != USE_STMT)&&
      (s->variant() != INCLUDE_STAT)&&
      ((!cp)||(!(cp->lineNumber()==s->lineNumber()))) )
          files[find].lineInfo[s->lineNumber()].isExecutable = 1; 
     
}

void transform_registration(SgStatement * s,int find) 
{
  int i=0;

  int org_numberOfChildren1=s->numberOfChildrenList1();
  int org_numberOfChildren2= s->numberOfChildrenList2();
  int org_numberOfChildren = org_numberOfChildren1 + org_numberOfChildren2;
  SgStatement * * children = new SgStatement * [org_numberOfChildren];
  SgStatement *st;
  SgStatement *line;
   
  for (i=0; i<org_numberOfChildren1; i++)
	children[i]=s->childList1(i);

  for (; i<org_numberOfChildren; i++)
     children[i]=s->childList2(i-org_numberOfChildren1);

   for (i=0; i<org_numberOfChildren; i++){

     st =  children[i];
     if ((st -> variant() == FORALL_CONSTRUCT_STMT)||
         (st -> variant() == INTERFACE_STMT)||
         (st -> variant() == FORALL_STMT))
         
     {
         action(st,find);
	 continue;
     }
     	 /* pass on INDEPENDENT DO LOOP */
     else if  (st -> variant() == INDEPENDENT_STMT)
     {
           action(st,find);
	   i++;
	   continue;
     }
     else{
         action(st,find);
         transform_registration(st,find);
     }
   }
   delete [] children;
   return;
   
}


SgStatement *find_first_exec_stmt(SgStatement *s)
{
  int i;
  
   int nlchilds = s->numberOfChildrenList1();
   
   for(i=0;i<nlchilds;i++)
     if ((isSgExecutableStatement(s->childList1(i)))&&
        (s->childList1(i)->variant() != CONTROL_END)&&
        (s->childList1(i)->variant() != USE_STMT)&&
        (s->childList1(i)->variant() != INCLUDE_STAT))
	 return (s->childList1(i));
   
   return NULL;
   
}

/*char *giveFileName(int curFile)
{
    return (files[curFile].depFileName);
} */
