#include "debugger.h"

void stop_program(int sockfd)
{
    int cmnd,fd;

    cmnd = -1;
    if (HOST){
       send_int(sockfd, STOPPROGRAM);
       recv_int(sockfd,&cmnd);
    }
    distribute_oneitem_(&cmnd);
    for (fd=0; fd<32; ++fd)
      if (FD_ISSET(fd, &afds))
	  close(fd);
    if (DEBUG)
       fprintf(fpout,"ME = %d I stopped command \n",ME);
    exit(0);
}

int setjmp_(int *myline)
{
  return setjmp(files[curFile].lineInfo[*myline].jmpbuffer); 
}

int server (int myline,char *funcName,char *fileName,int sockfd)
{
   int Stop = 0,lineNumber,i; 
   char variableName[256];
   static int curCmnd=0,goToCursorLine;
   
   static int nIterStartLine,loopHeaderLine,curCounter;
   static int is_staying_in_server = STAYINSERVER;
   static char *curFileName=NULL ,*prevFileName;
   static char *curFuncName=NULL ,*prevFuncName;
   static int  prevStackTop;
   
   int status,temp;
   char msg[256];
   int errcode=0,fd;

   prevFileName = curFileName;
   curFileName  = fileName;
   prevFuncName = curFuncName;
   curFuncName  = funcName;
   if (prevFileName == NULL)
     prevFuncName = fileName;
   if (prevFileName == NULL )
     prevFuncName = funcName;

   updateControlStack(myline,prevFuncName,curFuncName,prevFileName,curFileName);

   if (DEBUG)
     fprintf(fpout,"inside server myline = %d  sock=%d ME=%d cmnd=%d stacktop=%d fn=%s\n",
         myline,sockfd,ME,curCmnd,cstack.top,fileName);
   
   if (curCmnd == GOTOCURSOR){
        if (myline == goToCursorLine)
	   Stop = 1;
   } 
     
   else if (((curCmnd == STEPOVER)||(curCmnd == NSTEPOVER)) &&
         (cstack.top <= prevStackTop ))
   { 
       if (DEBUG)
          fprintf(fpout,"Previos Command STEP cnt = %d\n",curCounter);
       if (curCounter > 0)
          curCounter --;
       if (curCounter == 0) 
	  Stop = 1;

   }
   else if ((curCmnd == STEPINTO)||(curCmnd == NSTEPINTO))
   {
       if (curCounter > 0)
          curCounter --;  
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == CONTINUE)&&(files[curFile].lineInfo[myline].onbreak))
       Stop = 1;
   else if ((curCmnd == NITERATION)&&(cstack.top <= prevStackTop ))
     {
       if (files[curFile].lineInfo[myline].isInLoop != loopHeaderLine){
          Stop = 1;    
          if (DEBUG)
	  fprintf(fpout,"Ok ME = %d I went oout of loop before indicated times:%d - %d\n",
              ME,files[curFile].lineInfo[myline].isInLoop,loopHeaderLine);
       }
       else if ((curCounter > 0)&&(myline ==  nIterStartLine))
	   curCounter--;
       if (curCounter == 0) 
	   Stop = 1;
     }
   if (is_staying_in_server == STAYINSERVER)
      Stop = 1; 
  
   /* check the program termination */
   if ((files[curFile].lineInfo[myline].isReturnPoint)
           &&(cstack.top == 0)&&(!Stop))
      stop_program(sockfd);

   if ((!Stop)&&(!FD_ISSET(sockfd, &rfds))){
      if (DEBUG)
         fprintf(fpout,"I am exiting now \n");
      is_staying_in_server = EXITFROMSERVER; 
      return EXITFROMSERVER;
   }

   /* Send myline to Java Applet which updates current line number */
   /* for beginning, wait for connection request */
   /* do not send the myline number to Applet */
   if (is_staying_in_server == EXITFROMSERVER){
       /*If we moved to one function code which is in another file 
       other than current one, Applet will request new file source 
       code from HTTP server if it doesnt have */

       if (strcmp(curFileName,prevFileName)){
           int index;

           if (DEBUG)
             fprintf(fpout,"I(%d) am sending the file : %s\n",ME,curFileName);
	   index = findFileIndex(curFileName);

           if (HOST){
             send_int(sockfd,GETNEWFILE);
             send_String(sockfd, curFileName);
	   }
           curFile = index;
           openNewProject(files[curFile].depFileName);
           if (DEBUG)
             fprintf(fpout,"I(%d) sent the file : %s\n",ME,curFileName);

       }
       /* check the program termination */
       if ((files[curFile].lineInfo[myline].isReturnPoint)
	   &&(cstack.top == 0)){
          fprintf(fpout,"ME=%d I stop program now \n",ME);
          stop_program(sockfd);
       }
       else if (HOST)
          send_int(sockfd,myline); 
       if (DEBUG)
          fprintf(fpout,"We ME = %d send current line = %d toApplet \n",ME,myline);   
   }  
   
   curCmnd = 0;
   if (HOST)    
      recv_int( sockfd,&curCmnd );
   distribute_oneitem_(&curCmnd);
   if (DEBUG)
      fprintf(fpout,"read new command = %d\n",curCmnd);
   
   switch(curCmnd){
   case GOTOCURSOR:
     curCounter = 0;
     if (HOST)     
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     if (!(files[curFile].lineInfo[curCounter].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd,
		    prevFileName,curFileName);
        errcode = -1;
        is_staying_in_server = STAYINSERVER; 
        return is_staying_in_server; 
     }
     else{
        goToCursorLine = curCounter;
        is_staying_in_server = EXITFROMSERVER;
     }
     fprintf(fpout,"Current counter = %d myline : %d\n",curCounter,myline);
     if (curCounter < myline){
        fprintf(fpout,"I am going back to line : %d\n",goToCursorLine);
        send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);  
        longjmp(files[curFile].lineInfo[curCounter].jmpbuffer,1);
     } 

     break; 

   case CONNECT :
     if (HOST)
        send_int(sockfd,myline);
     is_staying_in_server = STAYINSERVER; 
     if (DEBUG) 
        fprintf(fpout,"We processed connect request ME = %d\n",ME);
     break;

   case PUTBREAKONOFF :
     lineNumber = 0; 
     if (HOST)
        recv_int( sockfd,&lineNumber );  
     distribute_oneitem_(&lineNumber);
     if (DEBUG)
        fprintf(fpout,"line number = %d\n",lineNumber);
     if (!(files[curFile].lineInfo[lineNumber].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd,
		    prevFileName,curFileName);
        errcode = -1;
     }
     else{
        if (files[curFile].lineInfo[lineNumber].onbreak == BREAKON)  
          files[curFile].lineInfo[lineNumber].onbreak = BREAKOFF;
        else
          files[curFile].lineInfo[lineNumber].onbreak = BREAKON;
     }
     is_staying_in_server = STAYINSERVER;
     break;

   case STEPOVER:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     prevStackTop = cstack.top;
     break;
   case STEPINTO:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NSTEPOVER:
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     is_staying_in_server = EXITFROMSERVER;
     prevStackTop = cstack.top;
     break;

   case NSTEPINTO: 
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     is_staying_in_server = EXITFROMSERVER;
     break;

   case CONTINUE:
     is_staying_in_server = EXITFROMSERVER;
     break;

   case RUN: 
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NITERATION:
     curCounter = 0;
     if (HOST)
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);

     if (!(files[curFile].lineInfo[myline].isInLoop)){
        send_errmsg(-3,"You are not in one loop",myline,sockfd,
		    prevFileName,curFileName);
        is_staying_in_server = STAYINSERVER;
        errcode = -3;
     }
     else{
        nIterStartLine = myline;
        loopHeaderLine = files[curFile].lineInfo[myline].isInLoop;
        is_staying_in_server = EXITFROMSERVER;
     }
     prevStackTop = cstack.top;
     break;

   case DISPLAY:
     status = 0;
     if (HOST){
        recv_String(sockfd,variableName);
        status = find_var(funcName,variableName);
     }
     distribute_oneitem_(&status);

     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-4,msg,myline,sockfd,prevFileName,curFileName);
        errcode = -4;
     }
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName); 
       status = send_registered_data(variableName,status,sockfd);   
     } 
     is_staying_in_server = STAYINSERVER;
     break;

   case DISARRAYSECTION:
     sendArraySection(myline,sockfd,prevFileName,curFileName,funcName);
     is_staying_in_server = STAYINSERVER;
     break;

   case SETVARIABLE:
     status = 0;
     if (HOST){
        recv_String(sockfd,variableName);
        status = find_var(funcName,variableName);
     }
     distribute_oneitem_(&status);

     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-5,msg,myline,sockfd,prevFileName,curFileName);
        errcode = -5; 
     } 
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);  
       status = set_variable(sockfd,status);
     }
     is_staying_in_server = STAYINSERVER;   
     break;

   case SETPARVAR:
     status = 0;
     if (HOST){
        recv_String(sockfd,variableName);
	status = find_var(funcName,variableName);
     }
     distribute_oneitem_(&status);
     
     if (status < 0){
        sprintf(msg,"We could not find parallel  variable : %s",variableName);
        send_errmsg(-6,msg,myline,sockfd,prevFileName,curFileName);
        errcode = -5; 
     } 
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);  
       set_ParallelVar(sockfd,status);
     }

     is_staying_in_server = STAYINSERVER;
     break;    

   case INTERPRET:
     if (HOST)
       interpretHPFStmt(sockfd,funcName);
     is_staying_in_server = STAYINSERVER;
     break;

   case STOP:
     for (fd=0; fd<32; ++fd)
       if (FD_ISSET(fd, &afds))
	  close(fd);
     exit(0);
     break;


   } /* switch */


   /* If there is no error,send Ok message to Applet */
   if ((errcode == 0)&&(curCmnd != DISPLAY)
       &&(curCmnd != SETVARIABLE)&&(curCmnd != DISARRAYSECTION))
      send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);
    
   return is_staying_in_server;
}

send_errmsg(int errorcode,char *errormsg,int myline,int sockfd,
	    char *prevFileName,char *curFileName)
{
   char msg[256];

   if (HOST){
     sprintf(msg,"%s : %d\n",errormsg,myline);
     if (DEBUG)
        fprintf(fpout,"I will send errmsg =%s code=%d\n",msg,errorcode);

     send_int(sockfd,errorcode);
     send_String(sockfd, msg);
   }
}

int findFileIndex(char *curFileName)
{
   int i,index;

   for(i=0;i<nfiles;i++)
     if (!strcmp(files[i].fileName,curFileName))
       index = i;
   /*if(DEBUG)
      fprintf(fpout,"I found index = %d sfile = %s\n",index,curFileName); */
   return index;
}
  
int findFuncIndex(char *curFuncName,char *curFileName)
{
   int i,fileInd,index=-1;

   fileInd = findFileIndex(curFileName);
   for(i=0;i<files[fileInd].nfuncs;i++){
     if (!strcmp(files[fileInd].functab[i].funcName,curFuncName)){
       index = i;
       break;
     }
   }
   if (index < 0){
     fprintf(fpout,"I could not find the function : %s\n",curFuncName);
     exit(0);
   }
   return index;
}


updateControlStack(int myline,char *prevFuncName,
     char *curFuncName,char *prevFileName,char *curFileName)
{
  int i,fexec,findex,fileInd;

  fileInd = findFileIndex(curFileName);
  findex = findFuncIndex(curFuncName,curFileName);
  fexec =  files[fileInd].functab[findex].fExecStmt;  /* First executable stmt */

  /* Subroutine called */
  if (strcmp(prevFuncName,curFuncName)&&(myline == fexec)){
      i = ++(cstack.top);
      cstack.sInfo[i].lineNum  = myline;
      cstack.sInfo[i].funcName = prevFuncName;
      cstack.sInfo[i].fileName = prevFileName;
      if (DEBUG)
         fprintf(fpout,"Subroutine called  TOP =%d\n",i);
  }
  /* Return from function */
  else if (strcmp(prevFuncName,curFuncName)&&(myline != fexec)){
      (cstack.top)--;
       if (DEBUG)
          fprintf(fpout,"Subroutine returned   TOP =%d\n",cstack.top);
  }

}

void interpretHPFStmt(int sockfd,char *funcName)
{
   char hpfStmtList[10240];

   recv_String(sockfd,hpfStmtList);

   callFuncDynamic(hpfStmtList,funcName);

  
}

int itemAddr(int ndims,int *coor,int *dims,int *lb)
{
   int i,j,k,m;
   int a ;

   for(j=1,a=coor[0]-lb[0];j<ndims;j++){
     for(k=0,m=coor[j]-lb[j];k<j;k++)
       m *= dims[k];
     a += m;
   }
   return a;
}

int sendArraySection(myline,sockfd,prevFileName,curFileName,funcName)
int myline,sockfd;
char *prevFileName,*curFileName,*funcName;
{
     char variableName[256],msg[256];
     int nums,nbytes,i,j,k,vindex,*subs;
     int *lb,*ub,*slb,*sub,*sst,elsize;
     int *coor,cnt,id,totelems,ndims,index,type;
     char *sendbuf;
     char *buf;
     XDR xdrs;
     bool_t ret;

     if (HOST){
        recv_String(sockfd,variableName);
        recv_int(sockfd,&nums);
        nbytes = nums*sizeof(int);
        buf  = (char *)malloc(nbytes);
	subs = (int *)malloc(nbytes);
        recv_raw_data(sockfd, buf, nbytes);
        xdrmem_create(&xdrs,buf,nbytes,XDR_DECODE); 
        ret = xdr_vector(&xdrs,(char *)subs,nums,sizeof(int),xdr_int);
        xdr_destroy(&xdrs);
        if (ret == FALSE)
          printf("There is encoding error \n");
        /*for(i=0;i<nums;i++)
          printf("nums[%d] = %d\n",i,subs[i]); */

        vindex = find_var(funcName,variableName);
        if (vindex < 0){
           sprintf(msg,"We could not find the variable : %s",variableName);
           send_errmsg(-5,msg,myline,sockfd,prevFileName,curFileName);
        }
        
     }
     distribute_oneitem_(&vindex);
     if (vindex < 0)
        return;
     
     if (!(stack[vindex].isDistributed ))
       id = vindex;
     else{
       copy_from_parallel_to_serial(vindex);
       id = stack[vindex].localIndex;
     }
     if (!HOST )
       return;

     type = stack[vindex].type;     
     ndims = stack[vindex].ndims;
     lb = stack[vindex].lbounds;
     ub = stack[vindex].ubounds;
     
     slb = (int *)malloc(sizeof(int)*ndims);
     sub = (int *)malloc(sizeof(int)*ndims);
     sst = (int *)malloc(sizeof(int)*ndims);

     for(i=0,k=0;k<ndims;k++)
     {       
       if (subs[i] == 1){ /* one element*/
	 slb[k] = subs[i+1];
         sub[k] = slb[k];
         sst[k] = 1;
         i+=2;
       }
       else if (subs[i] == 2){ /* section with no stride*/
         slb[k] = subs[i+1];
         sub[k] = subs[i+2];
	 sst[k] = 1;
         if (subs[i+1] == NUSEDDIM )
	   slb[k] = lb[k];
         if (subs[i+2] == NUSEDDIM )
	   sub[k] = ub[k];
         i+=3;
       }

       else if (subs[i] == 3){ /* section with  stride*/
	 slb[k] = subs[i+1];
         sub[k] = subs[i+2];
	 sst[k] = subs[i+3];
         if (subs[i+1] == NUSEDDIM )
	   slb[k] = lb[k];
         if (subs[i+2] == NUSEDDIM )
	   sub[k] = ub[k];
	 if (subs[i+3] == NUSEDDIM )
	   sst[k] = 1;
	 i+=4;
       }
     }

 
     elsize = stack[vindex].elsize;
     for(k=0,totelems=1;k<ndims;k++)
       totelems *= ((sub[k]-slb[k])/sst[k]+1);
     sendbuf = (char *)malloc(elsize*totelems);

     
     coor = (int *)malloc(sizeof(int)*ndims);
     for(k=0;k<ndims;k++) 
       coor[k] = slb[k];

     
     for(k=0;k<totelems;k++){
       index = itemAddr(ndims,coor,stack[vindex].dim_info,lb);
       
       memcpy(&sendbuf[k*elsize],((char *)(stack[id].buf)+index*elsize),elsize);
      
       coor[0] += sst[0];
       if (coor[0] > sub[0])
	 coor[0] = slb[0];
       for(j=1;j<ndims;j++){
	 if (coor[j-1] == slb[j-1]){
	   coor[j] += sst[j];
	   if (coor[j] > sub[j])
	     coor[j] = slb[j];
	 }
       }
     }
     
     
      /* send the ack. to Applet*/
     send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);   

     /* send the distribution info */
     send_int(sockfd,stack[vindex].isDistributed);

     /* send the registration info */
     /* tag = 0, ndims=1(because we are sending array section as 1D array */
     send_registration_info_(0,variableName, type, 1,
		        totelems,&totelems,sockfd);

     

     free(buf);
     nbytes = totelems*elsize;
     buf = (char *)malloc(nbytes);
     xdrmem_create(&xdrs,buf,nbytes,XDR_ENCODE);
     
     putArraySection(&xdrs,sendbuf,totelems,elsize,type);
     /* send the actual data */
     send_raw_data(sockfd,buf,nbytes);

     
     xdr_destroy(&xdrs);
     free(slb);
     free(sub);
     free(sst);
     free(coor);
     free(subs);
     free(sendbuf);
     free(buf);
}      

putArraySection(XDR xdrs,char *sendbuf,int nelems,int elsize,int type)
{

  bool_t ret;

  switch(type){
    case T_CHAR  : 
      ret = xdr_vector(&xdrs,sendbuf,nelems,elsize,xdr_char);
      break;
    case T_INT   : 
      ret = xdr_vector(&xdrs,sendbuf,nelems,elsize,xdr_int);
      break;
    case T_FLOAT : 
      ret = xdr_vector(&xdrs,sendbuf,nelems,elsize,xdr_float);
      break;
    case T_LONG  :
      ret = xdr_vector(&xdrs,sendbuf,nelems,elsize,xdr_long);
      break;
    case T_DOUBLE:
      ret = xdr_vector(&xdrs,sendbuf,nelems,elsize,xdr_double);
      break;
  }
  if (ret == FALSE)
     printf("there is error during encoding (in putArraySection) \n");

}
