#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define  MAXFILES 128

typedef struct functable{
 int lineNum;
 char funName[64];
 char fileName[64];
}FTAB;

typedef struct sourceinfo{
 int lineNum;
 int scope;
 int stmtID;
 int parent;
 int isExecutable;
 int isInLoop;
}SINFO;

typedef struct intermediateFiles{
  char   fileName[64];
  SINFO  *lineInfo;
}FILES ;
int filesizes[MAXFILES];

FILES *files=NULL;
FTAB  *functab=NULL;
int   nfuncs,nfiles;

main(int argc, char *argv[])
{
  FILE *fp;
  char lines[256],*ptr,fname[64];
  int j,i,k,filelen,newfuncs;
  int nextfunc=0,nextfile=0;
 
  if (argc < 2){
    printf("Unknown file name \n");
    return;
  }

  fp = fopen(argv[1],"r");
  nfiles = 0;
  nfuncs = 0;
  while(!feof(fp))
  {
     fgets(lines,256,fp);
     if ((strstr(lines,"//"))&&(strstr(lines,"number of functions"))){
        fgets(lines,256,fp);
        nfuncs += atoi(lines);
     }
     else if ((strstr(lines,"//"))&&(strstr(lines,"File name" )))
        nfiles++;
     else if((strstr(lines,"//"))&&(strstr(lines,"Length" ))){
        fgets(lines,256,fp);
        filesizes[nfiles-1] = atoi(lines);
     }
  }

  printf("nfiles = %d nfuncs = %d\n",nfiles,nfuncs);
  functab = (FTAB *)calloc(nfuncs,sizeof(FTAB));  
  files  = (FILES *)calloc(nfiles,sizeof(FILES)); 
  for(i=0;i<nfiles;i++)
    files[i].lineInfo = (SINFO *)calloc(filesizes[i],sizeof(SINFO));  

  rewind(fp);
  /* read comment "File Name" */
  fgets(lines,256,fp);
  while(!feof(fp))
  {
   
     /* read file name */
     fgets(lines,256,fp);
     strcpy(fname,strtok(lines,"\n\r\t "));
     printf("file name = %s\n",fname);

     /*read comment "Length of File " */
     fgets(lines,256,fp);
     /* read file length */
     fgets(lines,256,fp);
     filelen = atoi(lines);
     printf("length of file = %d\n",filelen);

     /* read comment "number of functions" */
     fgets(lines,256,fp);
     /* read number of functions */
     fgets(lines,256,fp);
     newfuncs = atoi(lines);
     printf("newfuncs = %d\n",newfuncs);

     /* read comment "LineNumber  FunctionName FileName" */
     fgets(lines,256,fp);

     for(i = nextfunc;i<nextfunc+newfuncs;i++){
       /* read one line of function info */
       fgets(lines,256,fp);
       ptr = strtok(lines,"\n\r\t ");
       functab[i].lineNum = atoi(ptr);
       strcpy(functab[i].funName, strtok(NULL,"\n\r\t "));
       strcpy(functab[i].fileName, fname);
       printf("%d   %s  %s\n", functab[i].lineNum,functab[i].funName,
          functab[i].fileName);
     }

     /* accumulate total number of functions */
     nextfunc += newfuncs ; 

     /* read comment "LineNumber Scope stmtID parent isExecutable" */
     fgets(lines,256,fp);

     i = nextfile;
     for(j=0;j <filelen;j++){
       /* read line number */
       fgets(lines,256,fp);
       k = atoi(strtok(lines,"\n\r\t "));
       files[i].lineInfo[k].lineNum = k;
       files[i].lineInfo[k].scope = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].stmtID = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].parent = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isExecutable = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isInLoop = atoi(strtok(NULL,"\n\r\t "));
       printf("%d  %d  %d  %d  %d  %d\n",
          files[i].lineInfo[k].lineNum, 
          files[i].lineInfo[k].scope   ,
          files[i].lineInfo[k].stmtID  ,
          files[i].lineInfo[k].parent  ,
          files[i].lineInfo[k].isExecutable,
          files[i].lineInfo[k].isInLoop  );
     }
     nextfile++;

     /* read comment "File Name" */
     fgets(lines,256,fp);
  }
  fclose(fp);
  
}




