#include "debugger.h"

inithpfLines()
{

   read_summary_dep_file("summary_dep_files");
   curFile = indexOfMain;
}    

int server (int myline,int sockfd)
{
   int Stop = 0,lineNumber,i; 
   char variableName[256];
   static int curScope,curCmnd=0;
   static int nIterStartLine,curCounter;
   static int is_staying_in_server = STAYINSERVER;
   int scope, status,temp;
   char msg[256];
   int errcode=0;

   scope = files[curFile].lineInfo[myline].scope;
   if (DEBUG)
     printf("inside server myline = %d myscope=%d sock=%d ME=%d\n",
         myline,scope,sockfd,ME);

   if (curCmnd == GOTOCURSOR){
        if (myline == curCounter)
	   Stop = 1;
   } 
  
   else if (((curCmnd == STEPOVER)||(curCmnd == NSTEPOVER))&&
       (curScope == scope))
   { 
       if (DEBUG)
          printf("Previos Command STEP cnt = %d\n",curCounter);
       if (curCounter > 0)
          curCounter --;
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == STEPINTO)||(curCmnd == NSTEPINTO))
   {
       if (curCounter > 0)
          curCounter --;  
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == CONTINUE)&&(files[curFile].lineInfo[myline].onbreak))
       Stop = 1;
   else if ((curCmnd == NITERATION)&&(myline ==  nIterStartLine))
     {
       if (curCounter > 0)
	   curCounter--;
       if (curCounter == 0) 
	   Stop = 1;
     }
   if (is_staying_in_server == STAYINSERVER)
      Stop = 1; 
  
   if ((!Stop)&&(!FD_ISSET(sockfd, &rfds))){
      if (DEBUG)
         printf("I am exiting now \n");
      is_staying_in_server = EXITFROMSERVER; 
      return EXITFROMSERVER;
   }
    
   /* Send myline to Java Applet which updates current line number */
   /* for beginning, wait for connection request */
   /* do not send the myline number to Applet */
   if ((is_staying_in_server == EXITFROMSERVER) && HOST){
      if (curCmnd != GOTOCURSOR)
        send_int(sockfd,myline); 
      if (DEBUG)
         printf("We ME = %d send current line = %d toApplet \n",ME,myline);   
   }

   curScope = scope;
   curCmnd = 0;
   if (HOST)    
      recv_int( sockfd,&curCmnd );
   distribute_oneitem_(&curCmnd);
   if (DEBUG)
      printf("read new command = %d\n",curCmnd);

   switch(curCmnd){

   case GOTOCURSOR:
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     if (!(files[curFile].lineInfo[curCounter].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd);
        errcode = -1;
        is_staying_in_server = STAYINSERVER;  
     }
     else
        is_staying_in_server = EXITFROMSERVER;
     break; 

   case CONNECT :
     if (HOST)
        send_int(sockfd,myline);
     is_staying_in_server = STAYINSERVER; 
     if (DEBUG) 
        printf("We processed connect request ME = %d\n",ME);
     break;

   case PUTBREAKONOFF :
     lineNumber = 0; 
     if (HOST)
        recv_int( sockfd,&lineNumber );  
     distribute_oneitem_(&lineNumber);
     if (DEBUG)
        printf("line number = %d\n",lineNumber);
     if (!(files[curFile].lineInfo[lineNumber].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd);
        errcode = -1;
     }
     else{
        if (files[curFile].lineInfo[lineNumber].onbreak == BREAKON)  
          files[curFile].lineInfo[lineNumber].onbreak = BREAKOFF;
        else
          files[curFile].lineInfo[lineNumber].onbreak = BREAKON;
     }
     is_staying_in_server = STAYINSERVER;
     break;

   case STEPOVER:case STEPINTO:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NSTEPOVER:case NSTEPINTO: 
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     is_staying_in_server = EXITFROMSERVER;
     break;

   case CONTINUE:
     is_staying_in_server = EXITFROMSERVER;
     break;

   case RUN: 
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NITERATION:
     if (HOST)
        recv_int( sockfd,&curCounter);
     if (!(files[curFile].lineInfo[myline].isInLoop)){
        send_errmsg(-3,"You are not in one loop",myline,sockfd);
        errcode = -3;
     }
     else{
        curCounter = 0;
        distribute_oneitem_(&curCounter);
        nIterStartLine = myline;
     }
     is_staying_in_server = EXITFROMSERVER;
     break;

   case DISPLAY:
     if (HOST)
       recv_String(sockfd,variableName);
     status = send_registered_data(scope,variableName,sockfd);
     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-4,msg,myline,sockfd);
        errcode = -4;
     }
     is_staying_in_server = STAYINSERVER;
     break;

   case SETVARIABLE:
     if (HOST)
        recv_String(sockfd,variableName);
     status = set_variable(sockfd,variableName,scope); 
     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-5,msg,myline,sockfd);
        errcode = -5; 
     } 
     is_staying_in_server = STAYINSERVER;   
     break;

   case SETPARVAR:
     if (HOST)
        recv_String(sockfd,variableName); 
     set_ParallelVar(sockfd,variableName, scope);
     is_staying_in_server = STAYINSERVER;
     break;    

     }
   /* If there is no error,send Ok message to Applet */
   if (errcode == 0)
      send_errmsg(0,"OK ",myline,sockfd);
   return is_staying_in_server;
}

send_errmsg(int errorcode,char *errormsg,int myline,int sockfd)
{
   char msg[256];

   if (HOST){
     sprintf(msg,"%s : %d\n",errormsg,myline);
     if (DEBUG)
        printf("I will send errmsg =%s code=%d\n",msg,errorcode);
     send_int(sockfd,errorcode);
     send_String(sockfd, msg);
   }
}


/*********************************************************/
/*********************************************************/
/*********************************************************/
/*********************************************************/
read_summary_dep_file(char *fileName)
{
  FILE *fp;
  char lines[256],*ptr,fname[64];
  int j,i,k,filelen,newfuncs;
  int nextfunc=0,nextfile=0;
 
  if (!(fp = fopen(fileName,"r"))){
    printf("I can not open the file : %s\n",fileName);
    exit(0);
  }
  nfiles = 0;
  nfuncs = 0;
  while(!feof(fp))
  {
     fgets(lines,256,fp);
     if ((strstr(lines,"//"))&&(strstr(lines,"number of functions"))){
        fgets(lines,256,fp);
        nfuncs += atoi(lines);
     }
     else if ((strstr(lines,"//"))&&(strstr(lines,"File name" )))
        nfiles++;
     else if((strstr(lines,"//"))&&(strstr(lines,"Length" ))){
        fgets(lines,256,fp);
        filesizes[nfiles-1] = atoi(strtok(lines,"\n\r\t "));
        if (atoi(strtok(NULL,"\n\r\t ")))
          indexOfMain = nfiles-1;
     }
  }

  functab = (FTAB *)calloc(nfuncs,sizeof(FTAB));  
  files  = (FILES *)calloc(nfiles,sizeof(FILES)); 
  for(i=0;i<nfiles;i++)
    files[i].lineInfo = (SINFO *)calloc(filesizes[i],sizeof(SINFO));  

  rewind(fp);
  /* read comment "File Name" */
  fgets(lines,256,fp);
  while(!feof(fp))
  {
   
     /* read file name */
     fgets(lines,256,fp);
     strcpy(fname,strtok(lines,"\n\r\t "));
    
     /*read comment "Length of File " */
     fgets(lines,256,fp);
     /* read file length */
     fgets(lines,256,fp);
     filelen = atoi(lines);
    
     /* read comment "number of functions" */
     fgets(lines,256,fp);
     /* read number of functions */
     fgets(lines,256,fp);
     newfuncs = atoi(lines);
    
     /* read comment "LineNumber  FunctionName FileName" */
     fgets(lines,256,fp);

     for(i = nextfunc;i<nextfunc+newfuncs;i++){
       /* read one line of function info */
       fgets(lines,256,fp);
       ptr = strtok(lines,"\n\r\t ");
       functab[i].lineNum = atoi(ptr);
       strcpy(functab[i].funName, strtok(NULL,"\n\r\t "));
       strcpy(functab[i].fileName, fname);
      
     }

     /* accumulate total number of functions */
     nextfunc += newfuncs ; 

     /* read comment "LineNumber Scope stmtID parent isExecutable" */
     fgets(lines,256,fp);

     i = nextfile;
     for(j=0;j <filelen;j++){
       /* read line number */
       fgets(lines,256,fp);
       k = atoi(strtok(lines,"\n\r\t "));
       files[i].lineInfo[k].lineNum = k;
       files[i].lineInfo[k].scope = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].stmtID = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].parent = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isExecutable = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isInLoop = atoi(strtok(NULL,"\n\r\t "));
     }
     nextfile++;

     /* read comment "File Name" */
     fgets(lines,256,fp);
  }
  fclose(fp);
}
