c
c ----------------------------------------------------------------------
c                                                                       
          subroutine bcin
c
c SIMPLE ZEROTH ORDER EXTRAPOLATION
c                                                                       
c update qnew at inflow phantom cells
c
      include 'dimpar.inc'
      include 'common.inc'
	real start,end
c
	call timer(start,0.0)
      tgam1       = (gam  -1.)/gam
      tgam2       = .5*(gam  -1.)
      tan1        = tan(pi*beta1/180.)
c
      i           = 1
c
      if (ibcin .eq. 1) then
c
c subsonic inflow
c
	
      iloc1       = i  +1
      rav1        = .5*( r(2) + r(1) )
!!HPF$ INDEPENDENT
      do 10 j=2,my

c extrapolate pressure
      rho         = qnew(1,iloc1,j)
      u           = qnew(2,iloc1,j)/qnew(1,iloc1,j)
      v           = qnew(3,iloc1,j)/qnew(1,iloc1,j)
      et          = qnew(4,iloc1,j)
      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav1*omega)**2))
c compute primitive variable at cell i=1
      xm2_abs     = ((pstagn(j)/p)**tgam1  -1.)/tgam2
      temp        = tstagn(j)/(1.  +tgam2*xm2_abs)
      qtot_abs    = sqrt(gam*xm2_abs*temp) 
      v_abs       = vtheta1
      u_abs       = sqrt(qtot_abs**2 -v_abs**2)
      u           = u_abs
      v           = v_abs - r(i)*omega
      rho         = p/temp
      et          = p/(gam  -1.)  +.5*rho*(u*u  +v*v 
     &               -(r(i)*omega)**2)
c compute conservative variables at cell i=1
      qnew(1,i,j) = rho
      qnew(2,i,j) = rho*u
      qnew(3,i,j) = rho*v
   10 qnew(4,i,j) = et
c

	
      else
      endif
c
	call timer(end,start)

      return                                                            
      end                                                               
c
c ----------------------------------------------------------------------
c                                                                       
           subroutine bcout
c
c update qnew at outflow phantom cells
c
      include 'dimpar.inc'
      include 'common.inc'
c
      i           = mx  +1
      iloc1       = i  -1
      rav1        = .5*( r(iloc1) + r(iloc1 -1) )

c
      if (ibcout .eq. 1) then
	
c 
c subsonic outflow
c
	



!      do 10 j=2,my
	
c extrapolate {rho,u,v}
!      rho         = qnew(1,iloc1,j)
!      u           = qnew(2,iloc1,j)/qnew(1,iloc1,j)
!      v           = qnew(3,iloc1,j)/qnew(1,iloc1,j)
c compute primitive variables at cell i=mx+1
!      p           = pback
!      et          = p/(gam  -1.)  +.5*rho*(u*u  +v*v 
!     &               -(r(i-1)*omega)**2)
c compute conservative variables at cell i=mx+1
!      qnew(1,i,j) = rho
!      qnew(2,i,j) = rho*u
!      qnew(3,i,j) = rho*v
!   10 qnew(4,i,j) = et
	
	qnew(1,mx+1,2:my)=qnew(1,mx,2:my)
	qnew(2,mx+1,2:my)=qnew(2,mx,2:my)
	qnew(3,mx+1,2:my)=qnew(3,mx,2:my)
	qnew(4,mx+1,2:my)=pback/(gam-1.) +0.5*qnew(1,mx,2:my)
     $ * ((qnew(2,mx,2:my)/qnew(1,mx,2:my))**2 
     $  +(qnew(3,mx,2:my)/qnew(1,mx,2:my))**2-(r(mx)*omega)**2)

c
	
      else
      endif
c
      if (ibcout .eq. 2) then
c 
c supersonic outflow
c
      iloc1       = i  -1
      rav1        = .5*( r(iloc1) + r(iloc1 -1) )
      do 20 j=2,my
c extrapolate {rho,u,v,et}
      rho         = qnew(1,iloc1,j)
      u           = qnew(2,iloc1,j)/qnew(1,iloc1,j)
      v           = qnew(3,iloc1,j)/qnew(1,iloc1,j)
      et          = qnew(4,iloc1,j)
c compute conservative variables at cell i=mx+1
      qnew(1,i,j) = rho
      qnew(2,i,j) = rho*u
      qnew(3,i,j) = rho*v
   20 qnew(4,i,j) = et
c
      else
      endif
c
      if (ibcout .eq. 3) then
c
c unknown outflow condition
c
      iloc         = mx
      iloc1        = mx
      rav          = .5*( r(iloc) + r(iloc -1) )
      rav1         = .5*( r(iloc1) + r(iloc1 -1) )
      do 30 j=2,my
      rho          = qnew(1,iloc,j)
      u            = qnew(2,iloc,j)/qnew(1,iloc,j)
      v            = qnew(3,iloc,j)/qnew(1,iloc,j)
      v_abs        = v +rav*omega
      et           = qnew(4,iloc,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      xm2          = (u*u  +v*v)/(gam*p/rho)
      xm2_abs      = (u*u +v_abs*v_abs)/(gam*p/rho)
c
      if (xm2_abs .gt. 1.) then
c
c      if (xm2 .gt. 1) then
c extrapolate {rho,u,v,et}
      rho        = qnew(1,iloc1,j)
      u          = qnew(2,iloc1,j)/qnew(1,iloc1,j)
      v          = qnew(3,iloc1,j)/qnew(1,iloc1,j)
      et         = qnew(4,iloc1,j)
c
      else
c extrapolate {rho,u,v}
      rho        = qnew(1,iloc1,j)
      u          = qnew(2,iloc1,j)/qnew(1,iloc1,j)
      v          = qnew(3,iloc1,j)/qnew(1,iloc1,j)
c compute primitive variables at cell i=mx+1
      p           = pback
      et          = p/(gam  -1.)  +.5*rho*(u*u  +v*v 
     &               -(r(iloc)*omega)**2)
c      
      endif
c
      qnew(1,i,j) = rho
      qnew(2,i,j) = rho*u
      qnew(3,i,j) = rho*v
   30 qnew(4,i,j) = et
c
      else
      endif
c
c****************************
      if (ibcout .eq. 4) then
c 
c subsonic outflow *** with enforced MASS FLOW ***
c
      iloc1    = mx
c      rav     = r(iloc1)
      rav     = .5*(r(iloc1) +r(iloc1-1))
c      hav     = h(iloc1)
      hav     = .5*(h(iloc1) +h(iloc1-1))
      xmflow   = 0.
      pave     = 0.
      rhoave   = 0.
      uave     = 0.
      vave     = 0.
      etave    = 0.

      do j = 2,my
         rho         = qnew(1,iloc1,j)
         u           = qnew(2,iloc1,j)/qnew(1,iloc1,j)
         v           = qnew(3,iloc1,j)/qnew(1,iloc1,j)
         et          = qnew(4,iloc1,j)
         p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &        -(rav*omega)**2))
c         rdy         = rav*(y(iloc1,j) -y(iloc1,j-1))
         rdy          = .5*(y(iloc1,j) +y(iloc1-1,j) 
     &                     -y(iloc1,j-1) -y(iloc1-1,j-1))*rav
c         pave        = pave + p*rho*u*rdy*hav
         uave        = uave + u*rho*u*rdy*hav
         rhoave      = rhoave + rho*rho*u*rdy*hav
         vave        = vave + v*rho*u*rdy*hav
         etave       = etave + et*rho*u*rdy*hav
         xmflow      = xmflow + rho*u*rdy*hav
      enddo
c
c      pave           = pave/xmflow 
      rhoave         = rhoave/xmflow
      uave           = uave/xmflow
      vave           = vave/xmflow
      etave          = etave/xmflow
c
      pave           = (gam  -1.)*(etave  -.5*rhoave*(uave*uave  
     &	               +vave*vave -(rav*omega)**2))
c
c
      correction     = xmout / xmflow
      deltamomen     = uave*(xmout*correction -xmflow)
c
c	print*,correction,xmout,xmflow
c
      correction_p   = deltamomen/(rav*sc*hav)
c      correction_p   = xmflow*(correction -1.)/(rav*sc)
      pback_cor      = pave -correction_p*.2
c      pback_cor      = pave -correction_p*.7

c	print*,rhoave,uave,vave,etave,xmflow
c	print*,pave,correction_p,pback_cor

      do 40 j=2,my
c extrapolate {rho,u,v}
      rho         = qnew(1,iloc1,j)
      u           = qnew(2,iloc1,j)/qnew(1,iloc1,j)
      v           = qnew(3,iloc1,j)/qnew(1,iloc1,j)
c compute primitive variables at cell i=mx+1
      p           = pback_cor
      et          = p/(gam  -1.)  +.5*rho*(u*u  +v*v 
     &               -(r(i-1)*omega)**2)
c compute conservative variables at cell i=mx+1
      qnew(1,i,j) = rho
      qnew(2,i,j) = rho*u
      qnew(3,i,j) = rho*v
   40 qnew(4,i,j) = et
c
      else
      endif
c
      return                                                            
      end                                                               
c
c ----------------------------------------------------------------------
c                                                                       
      subroutine bcper
c                                                                       
c update qnew at periodic boundaries
c
      include 'dimpar.inc'
      include 'common.inc'
c
c upstream region
c
!HPF$ INDEPENDENT,NEW(n)
      do 10 i=1,ile
      do 10 n=1,4
      qnew(n,i,1)     = qnew(n,i,my)
   10 qnew(n,i,my+1)  = qnew(n,i,2)
c
c downstream region
c
!HPF$ INDEPENDENT,NEW(n)
      do 20 i=ite+1,mx
      do 20 n=1,4
      qnew(n,i,1)     = qnew(n,i,my)
   20 qnew(n,i,my+1)  = qnew(n,i,2)
c
c
c SPECIFYING DUMMY VALUES FOR qnew(..,1..) and qnew(..,my+1) WITHIN 
c THE BLADED REGION.  THESE ARE MEANT ONLY FOR EASE OF PROGRAMMING!!!
c
!HPF$ INDEPENDENT,NEW(n)
      do 30 i=ile+1,ite
      do 30 n=1,4
      qnew(n,i,1)     = qnew(n,i,my)
   30 qnew(n,i,my+1)  = qnew(n,i,2)
c
c SPECIFYING DUMMY VALUES FOR qnew(..,mx+1,1)
c      and      q(..,mx+1,1)    !!!!!!!!!!!!!!!
c THESE ARE MEANT ONLY FOR EASE OF PROGRAMMING!!!      
c


         qnew(1:4,mx+1,1) = qnew(1:4,mx,1)
         q(1:4,mx+1,1) = qnew(1:4,mx+1,1)
c 40      print*,mx+1,1, q(n,mx+1,1)
c

      return                                                            
      end                                                               














