c
      subroutine blayer
c
c Writes a file ' bltest.inp ' for checking SEPARARION
c
      include 'dimpar.inc'
      include 'common.inc'
c
      dimension sv(270),twal(270)
      character*60 titre
c
      open(30,file='bltest.inp')
c
      prefe        = 98896.       ! N/m^2
      trefe        = 293.66        ! K
      chord        = .1016         ! m
      rgas         = 287.          ! J/kg-k  
      gam          = 1.4
c
      i            = 2
      j            = 2
      rav          = .5*(r(i) +r(i-1))
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
c      v_abs        = v + rav*omega
c      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2.))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
c      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      xmach        = sqrt(u*u  +v*v)/c
c      term         = 1.  +.5*(gam  -1.)*xmach_abs*xmach_abs
      term         = 1.  +.5*(gam  -1.)*xmach*xmach
      ttz           = tem*term
      ptz           = p * ( term**(gam/(gam -1.)) )
      upmach        = xmach
c
c converting normalized values to real values in METRIC units
c
      ttz      = ttz * trefe    ! K
      ptz      = ptz * prefe    ! N/m^2
c
      gam      = gam            ! ratio of specific heats
      rgas     = rgas           ! gas constant  J/kg-k
      ptz      = ptz            ! upstream RELATIVE P0  N/m^2
      ttz      = ttz            ! upstream RELATIVE T0  K
      upmach   = upmach         ! upstream RELATIVE Mach No.
      szero    = 0.0            ! 
      omegabl  = omega*sqrt(rgas*trefe)/chord ! rot. speed : rad/sec       
      radin    = r(2) *chord     ! 
c      
      nst      = ite -ile +1    ! no. of input stations
      nvp      = 20             ! no. of points desired in Vel. profile
      nturb    = 1              ! turbulence starting statin no. 
      kpvm     = 1              ! integer from 1-5 : surface variable
                                ! 1 -- pressure
                                ! 2 -- free-stream velocity V
                                ! 3 -- free-stream Mach No.
                                ! 4 -- p / P0
                                ! 5 -- V / V critical
      kem      = 1              ! units: 0 - British, 1 - Metric
      ksmth    = 0              ! no. of times distribution of V is
                                ! to be smoothened prior to calculn.
      kspln    = 0              ! manner of calculn of surface gradn
                                ! 0 - weighted diff,  1 - spline 
      kle      = 1              ! type of initial condition
                                ! 0 - Stagnation pt,  1 - sharp LE
      katch    = 1              ! if laminar-bl sep. should reattach
                                ! as turb-bl    0 - sep. & stop
                                !               1 - reattach
      cthet    = 1.0            ! if katach=1, ratio of Momen thk
                                ! after reattachment to lamin.
      chsubi   = 2.0            ! incompress form factor after 
                                ! laminar reattachment
c
      dlam     = 0.             ! delta at station 1
      tlam     = 0.             ! momen thk at station 1
      dturb    = 0.0015         ! initial delta at statin NTURB
      tturb    = 0.0010         ! initial momen thk at statin NTURB
c
      kpre     = 1              ! o/p from PRECAL 0-suppress, 1-print
      kgrad    = 1              ! print surf grad of V & M: 0-NO, 1-Y
      ksde     = 0              ! print soln of lam & turb: 0-NO, 1-Y
      klam     = 1              ! print locatn of instabili:0-NO, 1-Y
      kmain    = 1              ! print bl parameters     : 0-NO, 1-Y
      kprof    = 0              ! print vel profiles      : 0-NO, 1-Y
c
c FOR THE UPPER SURFACE : J=1
c
      do j=1,my,my-1
         if (j .eq. 1)  then
            titre  = ' Upper Surface '
            jj     = j +1
         endif
         if (j .eq. my)  then 
            titre  = ' Lower Surface '
            jj     = j
         endif
         write(30,1050) titre
         write(30,1025) gam,rgas,ptz,ttz,upmach,szero,omegabl,radin
         write(30,1040) nst,nvp,nturb,kpvm,kem,ksmth,kspln,kle,katch,
     &        cthet,chsubi
         write(30,1020) dlam,tlam,dturb,tturb
         write(30,1010) kpre,kgrad,ksde,klam,kmain,kprof
c     
         if ( kpvm .eq. 1 ) then 
            do i=ile,ite
               r1   = r(i)
               rho1 = q(1,i,jj)
               u1   = q(2,i,jj)/q(1,i,jj) 
               v1   = q(3,i,jj)/q(1,i,jj)
               et1  = q(4,i,jj)
               p1   = (gam  -1.)*(et1  -.5*rho1*(u1*u1  +v1*v1 
     &              -(r1*omega)**2))
               t1   = p1/rho1
               r2   = r(i-1)
               rho2 = q(1,i-1,jj)
               u2   = q(2,i-1,jj)/q(1,i-1,jj) 
               v2   = q(3,i-1,jj)/q(1,i-1,jj)
               et2  = q(4,i-1,jj)
               p2   = (gam  -1.)*(et2  -.5*rho2*(u2*u2  +v2*v2 
     &              -(r2*omega)**2))
               t2   = p2/rho2
               twal(i) = .5* (t1 +t2) *trefe
               sv(i)= .5*(p1 +p2) *prefe
            enddo
         endif
c     
         if ( kpvm .eq. 2 ) then 
            do i=ile,ite
               r1   = r(i)
               rho1 = q(1,i,jj)
               u1   = q(2,i,jj)/q(1,i,jj) 
               v1   = q(3,i,jj)/q(1,i,jj)
               et1  = q(4,i,jj)
               q1   = sqrt(u1*u1 +v1*v1)
               q1   = sign(q1, v1/u1) 
               p1   = (gam  -1.)*(et1  -.5*rho1*(u1*u1  +v1*v1 
     &              -(r1*omega)**2))
               t1   = p1/rho1
               r2   = r(i-1)
               rho2 = q(1,i-1,jj)
               u2   = q(2,i-1,jj)/q(1,i-1,jj) 
               v2   = q(3,i-1,jj)/q(1,i-1,jj)
               et2  = q(4,i-1,jj)
               q2   = sqrt(u2*u2 +v2*v2)
               q2   = sign(q2, v2/u2) 
               p2   = (gam  -1.)*(et2  -.5*rho2*(u2*u2  +v2*v2 
     &              -(r2*omega)**2))
               t2   = p2/rho2
               twal(i) = .5* (t1 +t2) *trefe
               sv(i)= .5*(q1 +q2) * (sqrt(rgas*trefe))
            enddo
         endif
c     
         if ( kpvm .eq. 3 ) then 
            do i=ile,ite
               r1   = r(i)
               rho1 = q(1,i,jj)
               u1   = q(2,i,jj)/q(1,i,jj) 
               v1   = q(3,i,jj)/q(1,i,jj)
               q1   = sqrt(u1*u1 +v1*v1)
               et1  = q(4,i,jj)
               p1   = (gam  -1.)*(et1  -.5*rho1*(u1*u1  +v1*v1 
     &              -(r1*omega)**2))
               t1   = p1/rho1
               c1   = sqrt(p1/rho1)
               xm1  = q1/c1
               r2   = r(i-1)
               rho2 = q(1,i-1,jj)
               u2   = q(2,i-1,jj)/q(1,i-1,jj) 
               v2   = q(3,i-1,jj)/q(1,i-1,jj)
               q2   = sqrt(u2*u2 +v2*v2)
               et2  = q(4,i-1,jj)
               p2   = (gam  -1.)*(et2  -.5*rho2*(u2*u2  +v2*v2 
     &              -(r2*omega)**2))
               c2   = sqrt(p2/rho2)
               xm2  = q2/c2
               t2   = p2/rho2
               twal(i) = .5* (t1 +t2) *trefe
               sv(i)= .5*(xm1 +xm2)
            enddo
         endif
c     
         if ( kpvm .eq. 4 ) then 
            do i=ile,ite
               r1   = r(i)
               rho1 = q(1,i,jj)
               u1   = q(2,i,jj)/q(1,i,jj) 
               v1   = q(3,i,jj)/q(1,i,jj)
               et1  = q(4,i,jj)
               p1   = (gam  -1.)*(et1  -.5*rho1*(u1*u1  +v1*v1 
     &              -(r1*omega)**2))
               t1   = p1/rho1
               r2   = r(i-1)
               rho2 = q(1,i-1,jj)
               u2   = q(2,i-1,jj)/q(1,i-1,jj) 
               v2   = q(3,i-1,jj)/q(1,i-1,jj)
               et2  = q(4,i-1,jj)
               p2   = (gam  -1.)*(et2  -.5*rho2*(u2*u2  +v2*v2 
     &              -(r2*omega)**2))
               t2   = p2/rho2
               twal(i) = .5* (t1 +t2) *trefe
               sv(i)= .5*(p1 +p2)
            enddo
         endif
c     
         if ( kpvm .eq. 5 ) then 
            do i=ile,ite
               r1   = r(i)
               rho1 = q(1,i,jj)
               u1   = q(2,i,jj)/q(1,i,jj) 
               v1   = q(3,i,jj)/q(1,i,jj)
               et1  = q(4,i,jj)
               p1   = (gam  -1.)*(et1  -.5*rho1*(u1*u1  +v1*v1 
     &              -(r1*omega)**2))
               t1   = p1/rho1
               r2   = r(i-1)
               rho2 = q(1,i-1,jj)
               u2   = q(2,i-1,jj)/q(1,i-1,jj) 
               v2   = q(3,i-1,jj)/q(1,i-1,jj)
               et2  = q(4,i-1,jj)
               p2   = (gam  -1.)*(et2  -.5*rho2*(u2*u2  +v2*v2 
     &              -(r2*omega)**2))
               t2   = p2/rho2
               twal(i) = .5* (t1 +t2) *trefe
               sv(i)= .5*(p1 +p2)
            enddo
         endif     
c     
         write(30,1030) (x(i,j)*chord,y(i,j)*r(i)*chord,sv(i)
     &        ,twal(i),r(i)*chord, i=ile,ite)
      enddo
c     
 1010 format(16i5)
 1020 format(8f10.5)
 1025 format(f10.4,f10.3,f10.2,f9.3,2f10.4,1x,f10.4,f10.5)
 1030 format(2f10.5,f10.3,f10.4,f9.5)
 1040 format(9i5,2f10.5)
 1050 format(a60)
c
      return
      end











