c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine camber (imaxf,errf)
c                                                                       
c update camber line at node points
c                                                                       
      include 'dimpar.inc'
      include 'common.inc'
c
      imaxf        = -1
      errf         = 0.
c
      tan1         = tan(pi*beta1/180.)
c      tan1_rel         = tan(pi*beta1_rel/180.)
      jm           = my 
      jp           = 2
c
c update camber line 
c
      f1(ile)      = 0.
      do 10 i=ile+1,ite
      rav          = .5*( r(i) + r(i-1) )
      dx           = x(i,1)  -x(i-1,1)
      dtdx         = (t(i)  -t(i-1))/dx
      delu         = q(2,i,jp)/q(1,i,jp)  -q(2,i,jm)/q(1,i,jm)
      ubl          = q(2,i,jp)/q(1,i,jp)  +q(2,i,jm)/q(1,i,jm)
      vbl          = q(3,i,jp)/q(1,i,jp)  +q(3,i,jm)/q(1,i,jm)
c
c      term         = vbl  -.5*delu*dtdx
c
c NOTE : here we have to divide vbl by r(i)
c
      term         = vbl/rav  -.5*delu*dtdx
   10 f1(i)        = f1(i-1)  +(term/ubl)*dx
c
c
      stagger = (f1(ite)*r(ite)  -f1(ile)*r(ile))/
     &           (x(ite,1)  -x(ile,1))
c
c OPTION FOR ANGLE OF THE MESH AT INLET 
c 
      slope        = (f1(ite)*r(ite)  -f1(ite-1)*r(ite-1))/
     &               (x(ite,1)  -x(ite-1,1))
c
      slope   = 0.       ! comment out if Zero angle not desired
c
      slope   = stagger  ! comment out if stagger angle not desired
c
      do 11 i=ite+1,mx
 11      f1(i)        = (f1(i-1)*r(i-1)  +slope*(x(i,1)  -x(i-1,1)))/
     &               r(i)
c
      if (slope .eq. 0.) then
      do 31 i=ite+1,mx
 31      f1(i)        = f1(ite)

      endif
c
c OPTION FOR ANGLE OF THE MESH AT  OUTLET
c
      slope        = (f1(ile+1)*r(ile+1)  -f1(ile)*r(ile))/
     &                (x(ile+1,1)  -x(ile,1))
c
      slope   = 0.       ! comment out if Zero angle not desired
c
      slope   = stagger  ! comment out if stagger angle not desired
c
      do 12 i=ile-1,1,-1
 12      f1(i)  = (f1(i+1)*r(i+1)  -slope*(x(i+1,1)  -x(i,1)))/
     &               r(i)
c
      if (slope .eq. 0.) then
      do 32 i=ile-1,1,-1
 32      f1(i)        = f1(ile)
      endif
c
c check for convergence
c
      do 20 i=1,mx
      if (i.ge.ile .and. i.le.ite) then
      error        = abs(f(i)  -f1(i))
      if (error .gt. errf) then
      imaxf        = i
      errf         = error
      else
      endif
      else
      endif
   20 f(i)         = f(i)  +relaxf*(f1(i)  -f(i))
c
c update mesh
c
      do 70 i=1,mx
      do 70 j=1,my
      alpha        = .5*sc  +(1.  -t(i)/sc)*(sfy(j)  -.5*sc)
   70 y(i,j)       = alpha  +f(i)
c
      return                                                            
      end                                                               











