c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine chart(iwrit)                                        
c                                                                       
c generates output in ft02.dat
c
      include 'dimpar.inc'
      include 'common.inc'
c
      dimension     m(jcell)                                            
c      dimension     vyavg(inode)
      dimension     rvyavg(inode)  
c                                                                       
      jstep     = 1 + (ny - 1)/32                                       
      xpow      = gam/(gam  -1.)
      pi        = 4.*atan(1.)
c
c check (1) error in mass flow rate 
c       (2) error in mass-averaged swirl
c       (3) mass-averaged stagnation pressure loss
c
c      i         = 1
      i         = 2
      sum1      = 0.
      sum2      = 0.
      sum3      = 0.
      do 8 j=2,my
      rav       = r(i)
      hav       = h(i)
c      dy        = y(i,j)  -y(i,j-1)
      rdy       = r(i)*y(i,j)  -r(i)*y(i,j-1)
      rho       = .5*(q(1,i+1,j)  +q(1,i,j))
      u         = .5*(q(2,i+1,j)/q(1,i+1,j)  +q(2,i,j)/q(1,i,j))
      v         = .5*(q(3,i+1,j)/q(1,i+1,j)  +q(3,i,j)/q(1,i,j))
      v_abs     = .5*(q(3,i+1,j)/q(1,i+1,j) +r(i+1)*omega 
     &               +q(3,i,j)/q(1,i,j) +r(i)*omega  )
      rvy       = rav*v_abs
      et        = .5*(q(4,i+1,j)  +q(4,i,j))
      p         = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(rav*omega)**2))
      c         = sqrt(gam*p/rho)
      xmach     = sqrt(u*u  +v*v)/c
      xmach_abs = sqrt(u*u  +v_abs*v_abs)/c
      p0        = p*(1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)**xpow
      dmdot     = rho*u*rdy*hav
      sum1      = sum1  +dmdot
c      sum2      = sum2  + v*dmdot
      sum2      = sum2  + rvy*dmdot
    8 sum3      = sum3  + p0*dmdot
      xmass1    = sum1
      rvyavg1   = sum2/sum1
      p01       = sum3/sum1
      i         = mx  -1
      sum1      = 0.
      sum2      = 0.
      sum3      = 0.
      do 9 j=2,my
      hav       = h(i)
      rav       = r(i)
c      dy        = y(i,j)  -y(i,j-1)
      rdy       = r(i)*y(i,j)  -r(i)*y(i,j-1)
      rho       = .5*(q(1,i+1,j)  +q(1,i,j))
      u         = .5*(q(2,i+1,j)/q(1,i+1,j)  +q(2,i,j)/q(1,i,j))
      v         = .5*(q(3,i+1,j)/q(1,i+1,j)  +q(3,i,j)/q(1,i,j))
      v_abs     = .5*(q(3,i+1,j)/q(1,i+1,j) +r(i+1)*omega 
     &               +q(3,i,j)/q(1,i,j) +r(i)*omega  )
      rvy       = rav*v_abs
      et        = .5*(q(4,i+1,j)  +q(4,i,j))
      p         = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(rav*omega)**2))
      c         = sqrt(gam*p/rho)
      xmach     = sqrt(u*u  +v*v)/c
      xmach_abs = sqrt(u*u  +v_abs*v_abs)/c
      p0        = p*(1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)**xpow
      dmdot     = rho*u*rdy*hav
      sum1      = sum1  +dmdot
c      sum2      = sum2  +v*dmdot
      sum2      = sum2  + rvy*dmdot
    9 sum3      = sum3  + p0*(dmdot)
      xmass2    = sum1
      rvyavg2    = sum2/sum1
      p02       = sum3/sum1
      del_mass  = 100.*abs((xmass2  -xmass1)/xmass1)
c
      if (icycle .gt. 1) then
c      
      if (idesign .eq. 1)
     &   del_rvy   = 100.*abs(((rvyavg2  -rvyavg1)  -delrvy)/delrvy)
      del_p0    = 100.*abs((p02  -p01)/p01)
      write (iwrit,*) ' '
      write (iwrit,*) '    % error in mass flow rate = ',del_mass
      if (idesign .eq. 1)
     &write (iwrit,*) '         % error in DELTA(rVy) = ',del_rvy
      write (iwrit,*) '% loss in stagnation pressure = ',del_p0
c
      write (iwrit,600)
      write (iwrit,*) '     j        ry     Pstag     Tstag'
      do 1 j=2,my
      ryc        = .5*(r(1)*y(1,j)  +r(1)*y(1,j-1))
    1 write (iwrit,502) j,ryc,pstagn(j),tstagn(j)
c
      else
      endif
c
      write (iwrit,600)
      write (iwrit,*) '                             computed    input'
      write (iwrit,*) '         x        T     uavg    rvyavg    rvavg
     &     f      s/c'
      do 3 i=2,mx-1                                                  
      sum1      = 0.
      sum2      = 0.
      sum3      = 0.
      do 4 j=2,my
      rav       = r(i)
      hav       = h(i)
c      dy        = y(i,j)  -y(i,j-1)
      rdy       = r(i)*y(i,j)  -r(i)*y(i,j-1)
      rho       = .5*(q(1,i+1,j)  +q(1,i,j))
      v         = .5*(q(3,i+1,j)/q(1,i+1,j)  +q(3,i,j)/q(1,i,j))
      v_abs     = .5*(q(3,i+1,j)/q(1,i+1,j) +r(i+1)*omega 
     &               +q(3,i,j)/q(1,i,j) +r(i)*omega  )
      rvy       = rav*v_abs
      u         = .5*(q(2,i+1,j)/q(1,i+1,j)  +q(2,i,j)/q(1,i,j))
      sum1      = sum1  +rho*u*rdy*hav
      sum2      = sum2  +u*(rho*u*rdy*hav)
    4 sum3      = sum3  +rvy*(rho*u*rdy*hav)
      uavg      = sum2/sum1
      rvyavg(i)  = sum3/sum1
c      term      = y(i,my)  -y(i,1)
      rterm      = r(i)*y(i,my)  -r(i)*y(i,1)
    3 write (iwrit,503) x(i,1),t(i),uavg,rvyavg(i),rvavg(i),f(i),rterm
c
      write (iwrit,600)
      write (iwrit,*) '         computed     input'
      write (iwrit,*)
     & '        x   DEL(p)   DEL(p)     dfdx    df+dx    df-dx'
c ************
c
      if (idelp .eq. 1) then
c
      do i = ile+1,ite
         rav       = .5*(r(i) + r(i-1))
         hav       = .5*(h(i) + h(i-1))
         j = 2
         rho       = q(1,i,j)
         u         = q(2,i,j)/q(1,i,j)
         v         = q(3,i,j)/q(1,i,j)
         et        = q(4,i,j)
         pplus     = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
         j = my
         rho       = q(1,i,j)
         u         = q(2,i,j)/q(1,i,j)
         v         = q(3,i,j)/q(1,i,j)
         et        = q(4,i,j)
         pminus    = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
         delpc(i)  = pplus -pminus
c
         print*,.5*(x(i,2) +x(i-1,2)),pplus,pminus,pplus-pminus 
c
      enddo
c
      do i=ile+1,ite
         rav       = .5*(r(i) + r(i-1))
         hav       = .5*(h(i) + h(i-1))
         xc        = .5*(x(i,1)  +x(i-1,1))
         dx        = x(i,1)  -x(i-1,1)
         drfdx      = (r(i)*f(i)  -r(i-1)*f(i-1))/dx
         drtdx      = (r(i)*t(i)  -r(i-1)*t(i-1))/dx
         df        = (180./pi)*atan(drfdx)
         df_plus   = (180./pi)*atan(drfdx  +drtdx)
         df_minus  = (180./pi)*atan(drfdx  -drtdx)
         if (delrvy .eq. 0.) then
            xload1    = 0.
            xload2    = 0.
         else
c     tsign     = delrvy/abs(delrvy)
c     xload1    = tsign*(rvyavg(i)  -rvyavg(i-1))/dx
c     xload2    = tsign*(rvavg(i)  -rvavg(i-1))/dx
            xload1 = delpc(i)
            xload2 = delpin(i)
         endif
         write (41,504) xc,xload1
         write (iwrit,503) xc,xload1,xload2,df,df_plus,df_minus
      enddo
c
      else
c
      do 5 i=ile+1,ite
      rav       = .5*(r(i) + r(i-1))
      hav       = .5*(h(i) + h(i-1))
      xc        = .5*(x(i,1)  +x(i-1,1))
      dx        = x(i,1)  -x(i-1,1)
      drfdx      = (r(i)*f(i)  -r(i-1)*f(i-1))/dx
      drtdx      = (r(i)*t(i)  -r(i-1)*t(i-1))/dx
      df        = (180./pi)*atan(drfdx)
      df_plus   = (180./pi)*atan(drfdx  +drtdx)
      df_minus  = (180./pi)*atan(drfdx  -drtdx)
      if (delrvy .eq. 0.) then
      xload1    = 0.
      xload2    = 0.
      else
c      tsign     = delrvy/abs(delrvy)
c      xload1    = tsign*(rvyavg(i)  -rvyavg(i-1))/dx
c      xload2    = tsign*(rvavg(i)  -rvavg(i-1))/dx
      xload1    = (rvyavg(i)  -rvyavg(i-1))/dx
      xload2    = (rvavg(i)  -rvavg(i-1))/dx
      xload1    = xmdot*xload1/(rav*hav)
      xload2    = xmdot*xload2/(rav*hav)
      endif
      write (41,504) xc,xload1
    5 write (iwrit,503) xc,xload1,xload2,df,df_plus,df_minus
      endif
c
c ***********
c
      if (ipt1.eq.1) then
c
      write (iwrit,600)
      write (iwrit,*)   
     &'        x     Mdot   ERROR+   ERROR-  ERROR_f  ERROR_T'
      do 6 i=ile+1,ite                                                 
      xc        = .5*(x(i,1)  +x(i-1,1))
      xmdot     = 0.
      hav       = .5*(h(i) +h(i-1))
      do 7 j=2,my
      rdy        = r(i)*y(i,j)  -r(i)*y(i,j-1)
    7 xmdot     = xmdot  +q(2,i,j)*rdy*hav
      dx        = x(i,1)  -x(i-1,1)
      dfdx      = (f(i)  -f(i-1))/dx
      dtdx      = (t(i)  -t(i-1))/dx
      dthick    = t(i)  -t(i-1)
      u_plus    = q(2,i,2)/q(1,i,2)
      u_minus   = q(2,i,my)/q(1,i,my)
      v_plus    = q(3,i,2)/q(1,i,2)
      v_minus   = q(3,i,my)/q(1,i,my)
      ubl       = u_plus  +u_minus
      vbl       = v_plus  +v_minus
      delu      = u_plus  -u_minus
      delv      = v_plus  -v_minus
      err_plus  = u_plus*(dfdx  +.5*dtdx)  -v_plus
      err_minus = u_minus*(dfdx  -.5*dtdx)  -v_minus
      err_f     = ubl*dfdx  +.5*delu*dtdx  -vbl
      err_t     = delu*dfdx  +.5*ubl*dtdx  -delv
    6 write (iwrit,503) xc,xmdot,err_plus,err_minus,err_f,err_t
c
      else
      endif
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '     density chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)                         
      write (iwrit,*) ' '
      do 11 i=2,mx                                                  
      do 12 j=2,my                                                
      rho          = q(1,i,j)
   12 m(j)         = 100.*rho
   11 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '  u-velocity chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 15 i=2,mx                                                  
      do 16 j=2,my                                                
      u            = q(2,i,j)/q(1,i,j)                                  
   16 m(j)         = 100.*u
   15 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '  v_abs-velocity chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 17 i=2,mx                                                  
      do 18 j=2,my                                                
      v            = q(3,i,j)/q(1,i,j) +r(i)*omega
 18   m(j)         = 100.*v
 17   write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '  v-velocity chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 19 i=2,mx                                                  
      do 20 j=2,my                                                
      v            = q(3,i,j)/q(1,i,j)                                  
   20 m(j)         = 100.*v
   19 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '  total relative velocity chart'
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 21 i=2,mx                                                  
      do 22 j=2,my                                                
      u            = q(2,i,j)/q(1,i,j)                                  
      v            = q(3,i,j)/q(1,i,j)                                  
 22   m(j)         = 100.*sqrt(u*u  +v*v)
 21   write (iwrit,501) i,(m(j),j=2,my,jstep) 
c
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '  total absolute velocity chart'
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 23 i=2,mx                                                  
      do 24 j=2,my                                                
      u            = q(2,i,j)/q(1,i,j)                                  
      v_abs        = q(3,i,j)/q(1,i,j) +r(i)*omega
   24 m(j)         = 100.*sqrt(u*u  +v_abs*v_abs)
   23 write (iwrit,501) i,(m(j),j=2,my,jstep) 
c
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '    Relative Mach no. chart' 
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 25 i=2,mx                                                    
      do 26 j=2,my                                                  
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)                                  
      v            = q(3,i,j)/q(1,i,j)                                  
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)**2))                
      cc           = gam*p/rho                                          
 26   m(j)         = 100.*sqrt((u*u  +v*v)/cc)                          
 25   write (iwrit,501) i,(m(j),j=2,my,jstep)                           
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '   Absolute  Mach no. chart'
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 27 i=2,mx                                                    
      do 28 j=2,my                                                  
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)                                  
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = q(3,i,j)/q(1,i,j) + r(i)*omega
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)**2))                
      cc           = gam*p/rho                                          
   28 m(j)         = 100.*sqrt((u*u  +v_abs*v_abs)/cc)  
   27 write (iwrit,501) i,(m(j),j=2,my,jstep)                           
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '    pressure chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 31 i=2,mx
      do 32 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)                                  
      v            = q(3,i,j)/q(1,i,j)                                  
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)**2))
   32 m(j)         = 100.*p
   31 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-------------------------'                          
      write (iwrit,*) 'stagnation pressure (absolute) chart'        
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 33 i=2,mx                                                  
      do 34 j=2,my                                                  
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)                                  
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = q(3,i,j)/q(1,i,j) + r(i)*omega
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)**2))
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term         = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)**xpow
   34 m(j)         = 100.*p*term
   33 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '    temperature chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 35 i=2,mx                                                  
      do 36 j=2,my                                                
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)                                  
      v            = q(3,i,j)/q(1,i,j)                                  
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)**2))
      temp         = p/rho
   36 m(j)         = 100.*temp
   35 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '----------------------------'                          
      write (iwrit,*) 'stagnation temperature chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 37 i=2,mx                                                  
      do 38 j=2,my                                                  
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)                                  
      v            = q(3,i,j)/q(1,i,j)                                  
      v_abs        = q(3,i,j)/q(1,i,j) + r(i)*omega
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)**2))
      temp         = p/rho
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term         = 1.  +.5*(gam  -1.)*xmach_abs*xmach_abs
   38 m(j)         = 100.*temp*term
   37 write (iwrit,501) i,(m(j),j=2,my+1,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-------------------------'                          
      write (iwrit,*) 'entropy chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 39 i=2,mx                                                  
      do 40 j=2,my                                                  
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)                                  
      v            = q(3,i,j)/q(1,i,j)                                  
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)**2))
   40 m(j)         = 100.*(gam*alog(p/rho)/(gam  -1.)  -alog(p))
   39 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c
      write (iwrit,600)
      write (iwrit,*) '-------------------------'                          
      write (iwrit,*) 'Prandtl length-i  chart'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 42 i=2,mx                                                  
      do 43 j=2,my                                                  
 43      m(j)         = int(1000.*prlni(i,j))
 42      write (iwrit,501) i,(m(j),j=2,my,jstep)
c
      write (iwrit,600)
      write (iwrit,*) '-------------------------'                          
      write (iwrit,*) 'Prandtl length-j  chart' 
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 45 i=2,mx                      
      do 46 j=2,my                                                  
 46      m(j)         = int(1000.*prlnj(i,j))
 45      write (iwrit,501) i,(m(j),j=2,my,jstep)
c
      write (iwrit,600)
      write (iwrit,*) '-------------------------'                          
      write (iwrit,*) 'Shear stress taumt-i  chart' 
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 48 i=2,mx                                                  
      do 49 j=1,my                                                  
 49      m(j)         = int(10000.*taumti(i,j))
 48      write (iwrit,501) i,(m(j),j=2,my,jstep)
c                                           
      write (iwrit,600)
      write (iwrit,*) '-------------------------'                          
      write (iwrit,*) 'Shear stress taumt-j  chart' 
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=1,my,jstep)
      write (iwrit,*) ' '
      do 51 i=2,mx                                                  
      do 52 j=1,my                                                  
 52      m(j)         = int(10000.*taumtj(i,j))
 51      write (iwrit,501) i,(m(j),j=1,my,jstep)
c
      if (ipt1.eq.1) then
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '     q vector q(1) '                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 91 i=2,mx                                                    
      do 92 j=2,my                                                    
   92 m(j)         = 100.*q(1,i,j)                                    
   91 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '     q vector q(2) '                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 93 i=2,mx                                                    
      do 94 j=2,my                                                    
   94 m(j)         = 100.*q(2,i,j)                                    
   93 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '     q vector q(3) '                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 95 i=2,mx                                                    
      do 96 j=2,my                                                    
   96 m(j)         = 100.*q(3,i,j)                                    
   95 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '     q vector q(4) '                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 97 i=2,mx                                                    
      do 98 j=2,my                                                    
   98 m(j)         = 100.*q(4,i,j)                                    
   97 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c
      do 200 i=1,mx+1
      do 200 j=1,my+1
      do 200 n=1,4
  200 qnew(n,i,j)   = q(n,i,j)
      call flux
      call residual
c
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '   residual res(1) '
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 221 i=2,mx                                                    
      do 222 j=2,my                                                    
  222 m(j)         = 100.*res(1,i,j)                                    
  221 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '   residual res(2) '
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 223 i=2,mx                                                    
      do 224 j=2,my                                                    
  224 m(j)         = 100.*res(2,i,j)                                    
  223 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '   residual res(3) '
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 225 i=2,mx                                                    
      do 226 j=2,my                                                    
  226 m(j)         = 100.*res(3,i,j)                                    
  225 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '   residual res(4) '
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 227 i=2,mx                                                    
      do 228 j=2,my                                                    
  228 m(j)         = 100.*res(2,i,j)                                    
  227 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) ' dissipation dwx(1) '                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      do 101 i=1,mx                                                    
      do 102 j=2,my                                                    
  102 m(j)         = 100000.*dwx(1,i,j)                                   
  101 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) ' dissipation dwy(1) '                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=1,my,jstep)
      write (iwrit,*) ' '
      do 105 i=2,mx                                                    
      do 106 j=1,my                                                    
  106 m(j)         = 100000.*dwy(1,i,j)                                   
  105 write (iwrit,501) i,(m(j),j=1,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '    local time step'                               
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=2,my,jstep)
      write (iwrit,*) ' '
      if (dtime .eq. 0.) dtime = 1.
      do 111 i=2,mx                                                  
      do 112 j=2,my                                                  
  112 m(j)         = 1000.*dt(i,j)/dtime                             
  111 write (iwrit,501) i,(m(j),j=2,my,jstep)                         
      write (iwrit,*) 'dtime = ',dtime                               
c
      else
      endif
c
      if (ipt2.eq.1) then
c
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '  mesh distribution x'                            
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=1,my,jstep)
      write (iwrit,*) ' '
      do 114 i=1,mx                                                    
      do 115 j=1,my                                                    
 115     m(j)         = 100.*x(i,j)                                     
 114     write (iwrit,501) i,(m(j),j=1,my,jstep)                         
c                                                                       
      write (iwrit,600)
      write (iwrit,*) '-----------------------'                          
      write (iwrit,*) '  mesh distribution y'                            
      write (iwrit,*) ' '
      write (iwrit,500) (j,j=1,my,jstep)
      write (iwrit,*) ' '
      do 117 i=1,mx                                                    
      do 118 j=1,my                                                    
 118     m(j)         = 100.*y(i,j)                                     
 117     write (iwrit,501) i,(m(j),j=1,my,jstep)                         
c
      else
      endif
c
c Writing USEFUL information
c
c      open(15,file='useful.dat')
      xmdoti      = 0.
      xmdoto      = 0.
      poi_abs     = 0.
      poo_abs     = 0.
      toi_abs     = 0.
      too_abs     = 0.
      poi_rel     = 0.
      poo_rel     = 0.
      toi_rel     = 0.
      too_rel     = 0.
      ui          = 0.
      vi          = 0.
      v_absi      = 0.
      uo          = 0.
      vo          = 0.
      v_abso      = 0.
c      
      do 61 j=2,my
         i=ile -3
      rav          = .5*(r(i) +r(i-1))
      hav          = .5*(h(i) +h(i-1))
      rdy          = .5*(y(i,j) +y(i-1,j) -y(i,j-1) -y(i-1,j-1))*rav
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v +rav*omega
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem          = p/rho
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term_abs     = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)
      term_rel     = (1.  +.5*(gam  -1.)*xmach*xmach)
      po_abs       = p*(term_abs**(gam/(gam -1.)))
      to_abs       = tem *term_abs
      po_rel       = p*(term_rel**(gam/(gam -1.)))
      to_rel       = tem *term_rel
      toi_abs      = toi_abs + to_abs*u*rdy*rho*hav
      poi_abs      = poi_abs + po_abs*u*rdy*rho*hav
      toi_rel      = toi_rel + to_rel*u*rdy*rho*hav
      poi_rel      = poi_rel + po_rel*u*rdy*rho*hav
      ui           = ui + u*u*rdy*rho*hav
      vi           = vi + v*u*rdy*rho*hav
      v_absi       = v_absi + v_abs*u*rdy*rho*hav
      xmdoti       = xmdoti + u*rdy*rho*hav
c
c
         i=ite +3
      rav          = .5*(r(i) +r(i-1))
      hav          = .5*(h(i) +h(i-1))
      rdy          = .5*(y(i,j) +y(i-1,j) -y(i,j-1) -y(i-1,j-1))*rav
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v +rav*omega
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem          = p/rho
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term_abs     = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)
      term_rel     = (1.  +.5*(gam  -1.)*xmach*xmach)
      po_abs       = p*(term_abs**(gam/(gam -1.)))
      to_abs       = tem *term_abs
      po_rel       = p*(term_rel**(gam/(gam -1.)))
      to_rel       = tem *term_rel
      too_abs      = too_abs + to_abs*u*rdy*rho*hav
      poo_abs      = poo_abs + po_abs*u*rdy*rho*hav
      too_rel      = too_rel + to_rel*u*rdy*rho*hav
      poo_rel      = poo_rel + po_rel*u*rdy*rho*hav
      uo           = uo + u*u*rdy*rho*hav
      vo           = vo + v*u*rdy*rho*hav
      v_abso       = v_abso + v_abs*u*rdy*rho*hav
 61   xmdoto       = xmdoto + u*rdy*rho*hav

      poi_abs       = poi_abs/xmdoti
      poo_abs       = poo_abs/xmdoto
      toi_abs       = toi_abs/xmdoti
      too_abs       = too_abs/xmdoto
      poi_rel       = poi_rel/xmdoti
      poo_rel       = poo_rel/xmdoto
      toi_rel       = toi_rel/xmdoti
      too_rel       = too_rel/xmdoto
      v_absi        = v_absi/xmdoti     
      v_abso        = v_abso/xmdoto
      ui            = ui/xmdoti
      uo            = uo/xmdoto
      vi            = vi/xmdoti
      vo            = vo/xmdoto
      ang_absi      = 180./pi*atan(v_absi/ui)
      ang_abso      = 180./pi*atan(v_abso/uo)
      angi          = 180./pi*atan(vi/ui)
      ango          = 180./pi*atan(vo/uo)
c
c overall adiabatic effifiency for the FAN /COMPRESSOR
c
      efffan    = ((poo_abs/poi_abs)**(1./xpow)  -1.)
     &             /(too_abs/toi_abs -1.)
c
c overall adiabatic effifiency for the TURBINE
c
      efftur    = (1.-too_abs/toi_abs)/(1. -(poo_abs/poi_abs)
     &             **(1./xpow) )
c
      write(15,605) 'quantity','inlet-abs','outlet-abs','inler-rel',
     &                'outlet-rel'
      write(15,*) 'mdot    ',xmdoti,xmdoto
      write(15,*) 'u       ',ui,uo
      write(15,*) 'v       ',v_absi,v_abso,vi,vo
      write(15,*) 'Alpha    ',ang_absi,ang_abso,angi,ango
      write(15,*) 'Po      ',poi_abs,poo_abs,poi_rel,poo_rel
      write(15,*) 'To      ',toi_abs,too_abs,toi_rel,too_rel
c

c
      write(15,*) '          % error           '
      write(15,*) 'mass    ',100.*(xmdoti -xmdoto)/xmdoti
      write(15,*) 'Po      ', 100.*(poi_abs -poo_abs)/poi_abs
      write(15,*) 'To      ', 100.*(toi_abs -too_abs)/toi_abs
      write(15,*)
      write(15,*) '        efficiency      '
      write(15,*) 'fan     ',efffan
      write(15,*) 'tur     ',efftur
c
c
c writing the same quantities in DR ROD CHIMA'S style
c
      xmdoti      = 0.
      xmdoto      = 0.
      rhoi        = 0.
      rhoo        = 0.
      ui          = 0.
      vi          = 0.
      uo          = 0.
      vo          = 0.
      eti          = 0.
      eto          = 0.
c      
      do 71 j=2,my
         i=ile -3
      rav          = .5*(r(i) +r(i-1))
      hav          = .5*(h(i) +h(i-1))
      rdy          = .5*(y(i,j) +y(i-1,j) -y(i,j-1) -y(i-1,j-1))*rav
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      rhoi         = rhoi + rho*u*rdy*rho*hav
      ui           = ui + u*u*rdy*rho*hav
      vi           = vi + v*u*rdy*rho*hav
      eti          = eti + et*u*rdy*rho*hav
      xmdoti       = xmdoti + u*rdy*rho*hav
c
c
         i=ite +3
      rav          = .5*(r(i) +r(i-1))
      hav          = .5*(h(i) +h(i-1))
      rdy          = .5*(y(i,j) +y(i-1,j) -y(i,j-1) -y(i-1,j-1))*rav
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      rhoo         = rhoo + rho*u*rdy*rho*hav
      uo           = uo + u*u*rdy*rho*hav
      vo           = vo + v*u*rdy*rho*hav
      eto          = eto + et*u*rdy*rho*hav
 71   xmdoto       = xmdoto + u*rdy*rho*hav

      rhoi          = rhoi/xmdoti
      rhoo          = rhoo/xmdoto
      eti           = eti/xmdoti
      eto           = eto/xmdoto
      ui            = ui/xmdoti
      uo            = uo/xmdoto
      vi            = vi/xmdoti
      vo            = vo/xmdoto
c
      ravi          = .5*(r(2) +r(1))
      ravo          = .5*(r(mx) +r(mx-1))
c
      v_absi        = vi +ravi*omega
      v_abso        = vo +ravo*omega
c      if (psi .le. 0.) pso = 0.12
      psi           = (gam  -1.)*(eti  -.5*rhoi*(ui*ui  +vi*vi 
     &               -(ravi*omega)**2))
      temi          = psi/rhoi
      ci            = sqrt(gam*psi/rhoi)
      xmachi        = sqrt(ui*ui  +vi*vi)/ci
      xmach_absi    = sqrt(ui*ui  +v_absi*v_absi)/ci
      term_absi     = (1.  +.5*(gam  -1.)*xmach_absi*xmach_absi)
      term_reli     = (1.  +.5*(gam  -1.)*xmachi*xmachi)
      po_absi       = psi*(term_absi**(gam/(gam -1.)))
      po_reli       = psi*(term_reli**(gam/(gam -1.)))
      to_absi       = temi *term_absi
      to_reli       = temi *term_reli

      pso           = (gam  -1.)*(eto  -.5*rhoo*(uo*uo  +vo*vo 
     &               -(ravo*omega)**2))
c      if (pso .le. 0.) pso = 0.08
      temo          = pso/rhoo
      co            = sqrt(gam*pso/rhoo)
      xmacho        = sqrt(uo*uo  +vo*vo)/co
      xmach_abso    = sqrt(uo*uo  +v_abso*v_abso)/co
      term_abso     = (1.  +.5*(gam  -1.)*xmach_abso*xmach_abso)
      term_relo     = (1.  +.5*(gam  -1.)*xmacho*xmacho)
      po_abso       = pso*(term_abso**(gam/(gam -1.)))
      to_abso       = temo *term_abso
      po_relo       = pso*(term_relo**(gam/(gam -1.)))
      to_relo       = temo *term_relo
      ang_absi      = 180./pi*atan(v_absi/ui)
      ang_abso      = 180./pi*atan(v_abso/uo)
      angi          = 180./pi*atan(vi/ui)
      ango          = 180./pi*atan(vo/uo)

c
c overall adiabatic effifiency for the FAN /COMPRESSOR
c
      efffan    = ((po_abso/po_abso)**(1./xpow)  -1.)
     &             /(to_abso/to_absi -1.)
c
c overall adiabatic effifiency for the TURBINE
c
      efftur    = (1.-to_abso/to_absi)/(1. -(po_abso/po_absi)
     &             **(1./xpow) )
c
      write(15,605) 'quantity','inlet-abs','outlet-abs','inler-rel',
     &                'outlet-rel'
      write(15,*) 'mdot     ',xmdoti,xmdoto
      write(15,*) 'density  ',rhoi,rhoo
      write(15,*) 'u        ',ui,uo
      write(15,*) 'v        ',v_absi,v_abso,vi,vo
      write(15,*) 'et       ',eti,eto
      write(15,*) 'Alpha    ',ang_absi,ang_abso,angi,ango
      write(15,*) 'ps       ',psi,pso
      write(15,*) 'Po       ',po_absi,po_abso,po_reli,po_relo
      write(15,*) 'To       ',to_absi,to_abso,to_reli,to_relo
      write(15,*) 'Mach     ',xmach_absi,xmach_abso,xmachi,xmacho
c
c
c Writing USEFUL information @ INLET AND OUTLET
c
c      open(15,file='useful.dat')
      xmdoti      = 0.
      xmdoto      = 0.
      poi_abs     = 0.
      poo_abs     = 0.
      toi_abs     = 0.
      too_abs     = 0.
      poi_rel     = 0.
      poo_rel     = 0.
      toi_rel     = 0.
      too_rel     = 0.
      ui          = 0.
      vi          = 0.
      v_absi      = 0.
      uo          = 0.
      vo          = 0.
      v_abso      = 0.
c      
      do 181 j=2,my
         i=2
      rav          = .5*(r(i) +r(i-1))
      hav          = .5*(h(i) +h(i-1))
      rdy          = .5*(y(i,j) +y(i-1,j) -y(i,j-1) -y(i-1,j-1))*rav
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v +rav*omega
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem          = p/rho
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term_abs     = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)
      term_rel     = (1.  +.5*(gam  -1.)*xmach*xmach)
      po_abs       = p*(term_abs**(gam/(gam -1.)))
      to_abs       = tem *term_abs
      po_rel       = p*(term_rel**(gam/(gam -1.)))
      to_rel       = tem *term_rel
      toi_abs      = toi_abs + to_abs*u*rdy*rho*hav
      poi_abs      = poi_abs + po_abs*u*rdy*rho*hav
      toi_rel      = toi_rel + to_rel*u*rdy*rho*hav
      poi_rel      = poi_rel + po_rel*u*rdy*rho*hav
      ui           = ui + u*u*rdy*rho*hav
      vi           = vi + v*u*rdy*rho*hav
      v_absi       = v_absi + v_abs*u*rdy*rho*hav
      xmdoti       = xmdoti + u*rdy*rho*hav
c
c
         i=mx
      rav          = .5*(r(i) +r(i-1))
      hav          = .5*(h(i) +h(i-1))
      rdy          = .5*(y(i,j) +y(i-1,j) -y(i,j-1) -y(i-1,j-1))*rav
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v +rav*omega
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem          = p/rho
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term_abs     = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)
      term_rel     = (1.  +.5*(gam  -1.)*xmach*xmach)
      po_abs       = p*(term_abs**(gam/(gam -1.)))
      to_abs       = tem *term_abs
      po_rel       = p*(term_rel**(gam/(gam -1.)))
      to_rel       = tem *term_rel
      too_abs      = too_abs + to_abs*u*rdy*rho*hav
      poo_abs      = poo_abs + po_abs*u*rdy*rho*hav
      too_rel      = too_rel + to_rel*u*rdy*rho*hav
      poo_rel      = poo_rel + po_rel*u*rdy*rho*hav
      uo           = uo + u*u*rdy*rho*hav
      vo           = vo + v*u*rdy*rho*hav
      v_abso       = v_abso + v_abs*u*rdy*rho*hav
 181  xmdoto       = xmdoto + u*rdy*rho*hav

      poi_abs       = poi_abs/xmdoti
      poo_abs       = poo_abs/xmdoto
      toi_abs       = toi_abs/xmdoti
      too_abs       = too_abs/xmdoto
      poi_rel       = poi_rel/xmdoti
      poo_rel       = poo_rel/xmdoto
      toi_rel       = toi_rel/xmdoti
      too_rel       = too_rel/xmdoto
      v_absi        = v_absi/xmdoti     
      v_abso        = v_abso/xmdoto
      ui            = ui/xmdoti
      uo            = uo/xmdoto
      vi            = vi/xmdoti
      vo            = vo/xmdoto
      ang_absi      = 180./pi*atan(v_absi/ui)
      ang_abso      = 180./pi*atan(v_abso/uo)
      angi          = 180./pi*atan(vi/ui)
      ango          = 180./pi*atan(vo/uo)
c
c overall adiabatic effifiency for the FAN /COMPRESSOR
c
      efffan    = ((poo_abs/poi_abs)**(1./xpow)  -1.)
     &             /(too_abs/toi_abs -1.)
c
c overall adiabatic effifiency for the TURBINE
c
      efftur    = (1.-too_abs/toi_abs)/(1. -(poo_abs/poi_abs)
     &             **(1./xpow) )
c
      write(15,605) 'quantity','inlet-abs','outlet-abs','inler-rel',
     &                'outlet-rel'
      write(15,*) 'mdot    ',xmdoti,xmdoto
      write(15,*) 'u       ',ui,uo
      write(15,*) 'v       ',v_absi,v_abso,vi,vo
      write(15,*) 'Alpha    ',ang_absi,ang_abso,angi,ango
      write(15,*) 'Po      ',poi_abs,poo_abs,poi_rel,poo_rel
      write(15,*) 'To      ',toi_abs,too_abs,toi_rel,too_rel
c

c
      write(15,*) '          % error           '
      write(15,*) 'mass    ',100.*(xmdoti -xmdoto)/xmdoti
      write(15,*) 'Po      ', 100.*(poi_abs -poo_abs)/poi_abs
      write(15,*) 'To      ', 100.*(toi_abs -too_abs)/toi_abs
      write(15,*)
      write(15,*) '        efficiency      '
      write(15,*) 'fan     ',efffan
      write(15,*) 'tur     ',efftur
c
c
c writing the same quantities in DR ROD CHIMA'S style
c
      xmdoti      = 0.
      xmdoto      = 0.
      rhoi        = 0.
      rhoo        = 0.
      ui          = 0.
      vi          = 0.
      uo          = 0.
      vo          = 0.
      eti          = 0.
      eto          = 0.
c      
      do 191 j=2,my
         i=2
      rav          = .5*(r(i) +r(i-1))
      hav          = .5*(h(i) +h(i-1))
      rdy          = .5*(y(i,j) +y(i-1,j) -y(i,j-1) -y(i-1,j-1))*rav
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      rhoi         = rhoi + rho*u*rdy*rho*hav
      ui           = ui + u*u*rdy*rho*hav
      vi           = vi + v*u*rdy*rho*hav
      eti          = eti + et*u*rdy*rho*hav
      xmdoti       = xmdoti + u*rdy*rho*hav
c
c
         i=mx
      rav          = .5*(r(i) +r(i-1))
      hav          = .5*(h(i) +h(i-1))
      rdy          = .5*(y(i,j) +y(i-1,j) -y(i,j-1) -y(i-1,j-1))*rav
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      rhoo         = rhoo + rho*u*rdy*rho*hav
      uo           = uo + u*u*rdy*rho*hav
      vo           = vo + v*u*rdy*rho*hav
      eto          = eto + et*u*rdy*rho*hav
 191  xmdoto       = xmdoto + u*rdy*rho*hav

      rhoi          = rhoi/xmdoti
      rhoo          = rhoo/xmdoto
      eti           = eti/xmdoti
      eto           = eto/xmdoto
      ui            = ui/xmdoti
      uo            = uo/xmdoto
      vi            = vi/xmdoti
      vo            = vo/xmdoto
c
      ravi          = .5*(r(2) +r(1))
      ravo          = .5*(r(mx) +r(mx-1))
c
      v_absi        = vi +ravi*omega
      v_abso        = vo +ravo*omega
c      if (psi .le. 0.) pso = 0.12
      psi           = (gam  -1.)*(eti  -.5*rhoi*(ui*ui  +vi*vi 
     &               -(ravi*omega)**2))
      temi          = psi/rhoi
      ci            = sqrt(gam*psi/rhoi)
      xmachi        = sqrt(ui*ui  +vi*vi)/ci
      xmach_absi    = sqrt(ui*ui  +v_absi*v_absi)/ci
      term_absi     = (1.  +.5*(gam  -1.)*xmach_absi*xmach_absi)
      term_reli     = (1.  +.5*(gam  -1.)*xmachi*xmachi)
      po_absi       = psi*(term_absi**(gam/(gam -1.)))
      po_reli       = psi*(term_reli**(gam/(gam -1.)))
      to_absi       = temi *term_absi
      to_reli       = temi *term_reli

      pso           = (gam  -1.)*(eto  -.5*rhoo*(uo*uo  +vo*vo 
     &               -(ravo*omega)**2))
c      if (pso .le. 0.) pso = 0.08
      temo          = pso/rhoo
      co            = sqrt(gam*pso/rhoo)
      xmacho        = sqrt(uo*uo  +vo*vo)/co
      xmach_abso    = sqrt(uo*uo  +v_abso*v_abso)/co
      term_abso     = (1.  +.5*(gam  -1.)*xmach_abso*xmach_abso)
      term_relo     = (1.  +.5*(gam  -1.)*xmacho*xmacho)
      po_abso       = pso*(term_abso**(gam/(gam -1.)))
      to_abso       = temo *term_abso
      po_relo       = pso*(term_relo**(gam/(gam -1.)))
      to_relo       = temo *term_relo
      ang_absi      = 180./pi*atan(v_absi/ui)
      ang_abso      = 180./pi*atan(v_abso/uo)
      angi          = 180./pi*atan(vi/ui)
      ango          = 180./pi*atan(vo/uo)

c
c overall adiabatic effifiency for the FAN /COMPRESSOR
c
      efffan    = ((po_abso/po_abso)**(1./xpow)  -1.)
     &             /(to_abso/to_absi -1.)
c
c overall adiabatic effifiency for the TURBINE
c
      efftur    = (1.-to_abso/to_absi)/(1. -(po_abso/po_absi)
     &             **(1./xpow) )
c
      write(15,605) 'quantity','inlet-abs','outlet-abs','inler-rel',
     &                'outlet-rel'
      write(15,*) 'mdot     ',xmdoti,xmdoto
      write(15,*) 'density  ',rhoi,rhoo
      write(15,*) 'u        ',ui,uo
      write(15,*) 'v        ',v_absi,v_abso,vi,vo
      write(15,*) 'et       ',eti,eto
      write(15,*) 'Alpha    ',ang_absi,ang_abso,angi,ango
      write(15,*) 'ps       ',psi,pso
      write(15,*) 'Po       ',po_absi,po_abso,po_reli,po_relo
      write(15,*) 'To       ',to_absi,to_abso,to_reli,to_relo
      write(15,*) 'Mach     ',xmach_absi,xmach_abso,xmachi,xmacho

c ___________________________________________________
c WRITING OUT THE  Y+  INFORMATION
c ___________________________________________________
c
      do i = ile+1,ite
      if ( (tauwp(i) .eq. 0.) .or. (tauwm(i) .eq. 0.) )then
      print*,i,'tauwp  =',tauwp(i),'tquwm  =',tauwm(i)
      goto 800
      endif
      enddo
c
      write(15,*) '...........................................'
      write(15,*) 'i     tauwp        tauwm'
      write(15,*) '...........................................'
 
      do i = ile+1,ite
      write(15,*) i,tauwp(i),tauwm(i)
      enddo
c      write(15,*)
c      write(15,*) .5*(r(ile+1) + r(ile)),xnugas
c      write(15,*)
c
      write(15,*) '****************************************************'
      write(15,*) 'j  =  2  (+) surface'
      write(15,*) 'i   yplus   uplus    uplus(log-law)   vstar   rho  v'
      write(15,*) '****************************************************'
c
      do i = ile+1,ite

      j      = 2
         dydx  = .5*(r(i) +r(i-1))*(y(i,1) -y(i-1,1))
     &             /(x(i,1) -x(i-1,1)) 
         cosang = 1./sqrt(1. + dydx**2)
      rhop   = q(1,i,j)
      up     = q(2,i,j)/q(1,i,j)
      vp     = q(3,i,j)/q(1,i,j)
      vabsp  = sqrt(up*up +vp*vp)
      vstarp = sqrt( abs(tauwp(i)/rhop) )
      rav    = .5*(r(i) + r(i-1))
      yav    = .25*( y(i,j) +y(i-1,j) +y(i,j-1) +y(i-1,j-1))
      dy     = abs(yav -.5*(y(i,j-1) +y(i-1,j-1)))
      dy     = dy*cosang
      ypp    = vstarp*rav*dy/xnugas    
      upp    = vabsp/vstarp
      upplaw = (alog(ypp)/0.41 +5.)

c      write(15,*) i,ypp,upp,upplaw,vstarp,rhop,vabsp,dy
      write(15,*) i,ypp,upp,upplaw,vstarp,rhop,vabsp

      enddo	
c
      write(15,*) 
      write(15,*) '****************************************************'
      write(15,*) 'j  =  my  (-) surface'
      write(15,*) 'i   yplus   uplus    uplus(log-law)   vstar   rho  v'
      write(15,*) '****************************************************'
c
      do i = ile+1,ite

      j      = my
         dydx  = .5*(r(i) +r(i-1))*(y(i,my) -y(i-1,my))
     &             /(x(i,my) -x(i-1,my)) 
         cosang = 1./sqrt(1. + dydx**2)
      rhom   = q(1,i,j)
      um     = q(2,i,j)/q(1,i,j)
      vm     = q(3,i,j)/q(1,i,j)
      vabsm  = sqrt(um*um +vm*vm)
      vstarm = sqrt( abs(tauwm(i)/rhom) )
      rav    = .5*(r(i) + r(i-1))
      yav    = .25*( y(i,j) +y(i-1,j) +y(i,j-1) +y(i-1,j-1))
      dy     = abs(yav -.5*(y(i,j) +y(i-1,j)))
      dy     = dy*cosang
      ymp    = vstarm*rav*dy/xnugas    
      ump    = vabsm/vstarm
      umplaw = (alog(ymp)/0.41 +5.)

c      write(15,*)  i,ymp,ump,umplaw,vstarm,rhom,vabsm,dy
      write(15,*)  i,ymp,ump,umplaw,vstarm,rhom,vabsm

      enddo	
c
 800  continue
c
c
c                                                                       
 500  format(9x,33i4)
 501  format(i4,5x,33i4)                                                
 502  format(1x,i5,7f10.5)                                              
 503  format(1x,8f9.4)
 504  format(10f10.5)
 600  format(1h1)
 605  format(15a,5x,4(9a,3x))
 610  format(15a,5x,4(f9.5,3x))
c                                                                       
      return                                                            
      end                                                               
