c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine contour1
c                                                                       
c generate data for contour plot
c                                                                       
      include 'dimpar.inc'
      include 'common.inc'
c
      icont        = 4
c
c      if (vflag .eq. 1.) then
cc         write (icont,*) 'VARIABLES = "x","y","u","v","Mach",
cc     &        "pressure","flow angle", "entropy","To","Po","prandtl",
cc     &        "tau"'
         write (icont,*) 'VARIABLES = "x","y","u","v","Mach",
     &        "pressure","flow angle", "entropy","To","Po","prandtl",
     &        "tau","vrm"'
c      else
c         write (icont,*) 'VARIABLES = "x","y","u","v","Mach",
c     &        "pressure","flow angle", "entropy","To","Po"'
c      endif
c
c      write (icont,*) 'VARIABLES = "x","y","u","v","Mach",
c     &   "pressure","flow angle", "entropy","To","temp",
c     &   "Po","rho","m","vr"'
c
c
c      write (icont,*) 'ZONE  I =',mx,'  J =',my,'   F=BLOCK'
      write (icont,*) 'ZONE  I =',mx,'  J =',my,'   F=BLOCK'
c
      write (icont,900) ((x(i,j),i=1,mx),j=1,my)
c      write (icont,900) ((y(i,j),i=1,mx),j=1,my)
      write (icont,900) ((y(i,j)*r(i),i=1,mx),j=1,my)
c      write (icont,900) (( (y(i,j) +sc) *r(i),i=1,mx),j=1,my)
c                                                                       
      do 110 i=2,mx
      do 110 j=2,my
  110 wcell(i,j)   = q(2,i,j)/q(1,i,j)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c    V velocity
c                                                                       
      do 120 i=2,mx
      do 120 j=2,my
  120 wcell(i,j)   = q(3,i,j)/q(1,i,j)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c   Relative Mach No.
c                                                                       
      do 130 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 130 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      c            = sqrt(gam*p/rho)
  130 wcell(i,j)   = sqrt(u*u  +v*v)/c
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c   Pressure
c                                              
      do 140 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 140 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
  140 wcell(i,j)   = p
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c  Relative Flow Angle
c                                              
      do 150 i=2,mx
      do 150 j=2,my
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
  150 wcell(i,j)   = (180./pi)*atan(v/u)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c  Entropy
c 
      do 160 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 160 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
  160 wcell(i,j)   = gam*alog(p/rho)/(gam  -1.)  -alog(p)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c  Absolute  Total Temperature
c
      do 170 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 170 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + rav*omega
      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      xmach        = sqrt(u*u  +v*v)/c
      term         = 1.  +.5*(gam  -1.)*xmach_abs*xmach_abs
  170 wcell(i,j)   = tem*term
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
cc
cc  Temperature
cc
c      do 180 i=2,mx
c         rav       = .5*( r(i) +r(i-1) )
c      do 180 j=2,my
c      rho          = q(1,i,j)
c      u            = q(2,i,j)/q(1,i,j)
c      v            = q(3,i,j)/q(1,i,j)
c      qq           = u*u +v*v
c      et           = q(4,i,j)
c      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
c     &               -(rav*omega)**2))
c      tem            = p/rho
cc      to           = tem + .5*qq
cc      c            = sqrt(gam*p/rho)
cc      xmach        = sqrt(u*u  +v*v)/c
cc      term         = 1.  +.5*(gam  -1.)*xmach*xmach
c  180 wcell(i,j)   = tem
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c  Absolute Total Pressure
c
      do 190 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 190 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + rav*omega
      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term         = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)
      term         = term**(gam/(gam -1.))
  190 wcell(i,j)   = p*term
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)      
cc
cc  Density
cc
c      do 200 i=2,mx
c      do 200 j=2,my
c      rho          = q(1,i,j)
c  200 wcell(i,j)   = rho
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my) 
cc
cc  Mass flow rate
cc
c      do 210 i=2,mx
c      hav          = .5*(h(i-1) +h(i))
c      rav          = .5*(r(i-1) +r(i))
c      do 210 j=2,my
c      rho          = q(1,i,j)
c      u            = q(2,i,j)/q(1,i,j)
c      rdy          = .5*(r(i)*( y(i,j) -y(i,j-1)) +
c     &                r(i-1)*( y(i-1,j) -y(i-1,j-1)) ) 
c 210  wcell(i,j)   =  rho*u*hav*rdy
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my) 
cc
cc  Radial Velocity 
cc
c      do 220 i=2,mx
c      do 220 j=2,my
c      drdm         = (r(i) - r(i-1))/(x(i,j) -x(i-1,j))
c      u            = q(2,i,j)/q(1,i,j)
c 220  wcell(i,j)   = drdm*u
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my) 
cc
      do 230 i=2,mx
      do 230 j=2,my
 230     wcell(i,j)   = .25*(prlni(i,j) +prlni(i-1,j) +
     &                       prlnj(i,j) +prlnj(i,j-1) )
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c writing taumt at nodal values
c
      do j=2,my-1
         do i = 2,mx-1
            wnode(i,j) = .25*( taumti(i,j) +taumti(i,j+1) +
     &                       taumtj(i,j) +taumtj(i+1,j) ) 
         enddo
      enddo
c
      do j=2,my-1
         i=1
         wnode(i,j) = ( taumti(i,j) +taumti(i,j+1) +taumtj(i+1,j) )/3.
         i=mx
         wnode(i,j) = ( taumti(i,j) +taumti(i,j+1) +taumtj(i,j) )/3. 
      enddo
c
      do i=ile+1,ite-1
         j=1
         wnode(i,j) = .5*(taumtj(i,j) +taumtj(i+1,j))
         j=my
         wnode(i,j) = .5*(taumtj(i,j) +taumtj(i+1,j))
      enddo
c
      do i=2,ile-1
         wnode(i,1) = .25*( taumti(i,2) +taumti(i,my) +
     &                       taumtj(i,1) +taumtj(i+1,1) ) 
         wnode(i,my)= wnode(i,1)
      enddo
      do i=ite+1,mx-1
         wnode(i,1) = .25*( taumti(i,2) +taumti(i,my) +
     &                       taumtj(i,1) +taumtj(i+1,1) ) 
         wnode(i,my)= wnode(i,1)
      enddo
c
      i=1
      wnode(i,1) = ( taumti(i,2) +taumti(i,my) +taumtj(i+1,1) )/3.
      wnode(i,my)= wnode(i,1)
      i=mx
      wnode(i,1) = ( taumti(i,2) +taumti(i,my) +taumtj(i,1) )/3. 
      wnode(i,my)= wnode(i,1)
c
      i=ile
      wnode(i,1) = ( taumti(i,2) +taumti(i,my) +taumtj(i+1,1) 
     &              +taumtj(i+1,my) +taumtj(i,1))/5.
      wnode(i,my)= wnode(i,1)
      i=ite
      wnode(i,1) = ( taumti(i,2) +taumti(i,my) +taumtj(i+1,1) 
     &              +taumtj(i,my) +taumtj(i,1))/5.
      wnode(i,my)= wnode(i,1)      
c
c      do 240 i=2,mx
c      do 240 j=2,my
c 240     wcell(i,j)   = .25*(taumti(i,j) +taumti(i-1,j) +
c     &                       taumtj(i,j) +taumtj(i,j-1) )
c      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c Magnitude of Relative  velocity
c
      do 250 i=2,mx
      do 250 j=2,my
         u   = q(2,i,j)/q(1,i,j)
         v   = q(3,i,j)/q(1,i,j)
         ss  = u/abs(u)
  250 wcell(i,j)   = ss*sqrt(u*u +v*v)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c ***********************************************************
c
c WRITING THE SECOND SET FOR THE QUASI3D DATA
c
      write (icont,*) 'ZONE  I =',mx,'  J =',my,'   F=BLOCK'
c
      write (icont,900) ((x(i,j),i=1,mx),j=1,my)
c      write (icont,900) ((y(i,j),i=1,mx),j=1,my)
c      write (icont,900) ((y(i,j)*r(i),i=1,mx),j=1,my)
      write (icont,900) (( (y(i,j) +sc) *r(i),i=1,mx),j=1,my)
c                                                                       
      do 310 i=2,mx
      do 310 j=2,my
  310 wcell(i,j)   = q(2,i,j)/q(1,i,j)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c    V velocity
c                                                                       
      do 320 i=2,mx
      do 320 j=2,my
  320 wcell(i,j)   = q(3,i,j)/q(1,i,j)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c   Relative Mach No.
c                                                                       
      do 330 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 330 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      c            = sqrt(gam*p/rho)
  330 wcell(i,j)   = sqrt(u*u  +v*v)/c
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c   Pressure
c                                              
      do 340 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 340 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
  340 wcell(i,j)   = p
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c  Relative Flow Angle
c                                              
      do 350 i=2,mx
      do 350 j=2,my
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
  350 wcell(i,j)   = (180./pi)*atan(v/u)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c  Entropy
c 
      do 360 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 360 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
  360 wcell(i,j)   = gam*alog(p/rho)/(gam  -1.)  -alog(p)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c  Absolute  Total Temperature
c
      do 370 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 370 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + rav*omega
      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      xmach        = sqrt(u*u  +v*v)/c
      term         = 1.  +.5*(gam  -1.)*xmach_abs*xmach_abs
  370 wcell(i,j)   = tem*term
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
cc
cc  Temperature
cc
c      do 380 i=2,mx
c         rav       = .5*( r(i) +r(i-1) )
c      do 380 j=2,my
c      rho          = q(1,i,j)
c      u            = q(2,i,j)/q(1,i,j)
c      v            = q(3,i,j)/q(1,i,j)
c      qq           = u*u +v*v
c      et           = q(4,i,j)
c      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
c     &               -(rav*omega)**2))
c      tem            = p/rho
cc      to           = tem + .5*qq
cc      c            = sqrt(gam*p/rho)
cc      xmach        = sqrt(u*u  +v*v)/c
cc      term         = 1.  +.5*(gam  -1.)*xmach*xmach
c  380 wcell(i,j)   = tem
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c  Absolute Total Pressure
c
      do 390 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 390 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + rav*omega
      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term         = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)
      term         = term**(gam/(gam -1.))
  390 wcell(i,j)   = p*term
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)      
cc
cc  Density
cc
c      do 400 i=2,mx
c      do 400 j=2,my
c      rho          = q(1,i,j)
c  400 wcell(i,j)   = rho
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my) 
cc
cc  Mass flow rate
cc
c      do 410 i=2,mx
c      hav          = .5*(h(i-1) +h(i))
c      rav          = .5*(r(i-1) +r(i))
c      do 410 j=2,my
c      rho          = q(1,i,j)
c      u            = q(2,i,j)/q(1,i,j)
c      rdy          = .5*(r(i)*( y(i,j) -y(i,j-1)) +
c     &                r(i-1)*( y(i-1,j) -y(i-1,j-1)) ) 
c 410  wcell(i,j)   =  rho*u*hav*rdy
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my) 
cc
cc  Radial Velocity 
cc
c      do 420 i=2,mx
c      do 420 j=2,my
c      drdm         = (r(i) - r(i-1))/(x(i,j) -x(i-1,j))
c      u            = q(2,i,j)/q(1,i,j)
c 420  wcell(i,j)   = drdm*u
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my) 
cc
      do 430 i=2,mx
      do 430 j=2,my
 430     wcell(i,j)   = .25*(prlni(i,j) +prlni(i-1,j) +
     &                       prlnj(i,j) +prlnj(i,j-1) )
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c writing taumt at nodal values
c
      do j=2,my-1
         do i = 2,mx-1
            wnode(i,j) = .25*( taumti(i,j) +taumti(i,j+1) +
     &                       taumtj(i,j) +taumtj(i+1,j) ) 
         enddo
      enddo
c
      do j=2,my-1
         i=1
         wnode(i,j) = ( taumti(i,j) +taumti(i,j+1) +taumtj(i+1,j) )/3.
         i=mx
         wnode(i,j) = ( taumti(i,j) +taumti(i,j+1) +taumtj(i,j) )/3. 
      enddo
c
      do i=ile+1,ite-1
         j=1
         wnode(i,j) = .5*(taumtj(i,j) +taumtj(i+1,j))
         j=my
         wnode(i,j) = .5*(taumtj(i,j) +taumtj(i+1,j))
      enddo
c
      do i=2,ile-1
         wnode(i,1) = .25*( taumti(i,2) +taumti(i,my) +
     &                       taumtj(i,1) +taumtj(i+1,1) ) 
         wnode(i,my)= wnode(i,1)
      enddo
      do i=ite+1,mx-1
         wnode(i,1) = .25*( taumti(i,2) +taumti(i,my) +
     &                       taumtj(i,1) +taumtj(i+1,1) ) 
         wnode(i,my)= wnode(i,1)
      enddo
c
      i=1
      wnode(i,1) = ( taumti(i,2) +taumti(i,my) +taumtj(i+1,1) )/3.
      wnode(i,my)= wnode(i,1)
      i=mx
      wnode(i,1) = ( taumti(i,2) +taumti(i,my) +taumtj(i,1) )/3. 
      wnode(i,my)= wnode(i,1)
c
      i=ile
      wnode(i,1) = ( taumti(i,2) +taumti(i,my) +taumtj(i+1,1) 
     &              +taumtj(i+1,my) +taumtj(i,1))/5.
      wnode(i,my)= wnode(i,1)
      i=ite
      wnode(i,1) = ( taumti(i,2) +taumti(i,my) +taumtj(i+1,1) 
     &              +taumtj(i,my) +taumtj(i,1))/5.
      wnode(i,my)= wnode(i,1)      
c
c      do 440 i=2,mx
c      do 440 j=2,my
c 440     wcell(i,j)   = .25*(taumti(i,j) +taumti(i-1,j) +
c     &                       taumtj(i,j) +taumtj(i,j-1) )
c      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c Magnitude of Relative  velocity
c
      do 450 i=2,mx
      do 450 j=2,my
         u   = q(2,i,j)/q(1,i,j)
         v   = q(3,i,j)/q(1,i,j)
         ss  = u/abs(u)
  450 wcell(i,j)   = ss*sqrt(u*u +v*v)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,my)
c
c ******************************************************
c
  900 format (10e13.5)
c                                                                       
      return                                                            
      end                                                               
c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine contour2
c                                                                       
c generate data for contour plot
c                                                                       
      include 'dimpar.inc'
      include 'common.inc'
c
      icont        = 4
      jmid         = (my  -1)/2  +1
      jmax         = (my  -1)/2  +1
c
c      if (vflag .eq. 1.) then
cc         write (icont,*) 'VARIABLES = "x","y","u","v","Mach",
cc     &        "pressure","flow angle", "entropy","To","Po","prandtl",
cc     &        "tau"'
         write (icont,*) 'VARIABLES = "x","y","u","v","Mach",
     &        "pressure","flow angle", "entropy","To","Po","prandtl",
     &        "tau","vrm"'
c      else
c         write (icont,*) 'VARIABLES = "x","y","u","v","Mach",
c     &        "pressure","flow angle", "entropy","To","Po"'
c      endif
cc
c      write (icont,*) 'VARIABLES = "x","y","u","v","Mach",
c     &   "pressure","flow angle", "entropy","To","temp",
c     &   "Po","rho","m","vr"'
c
      write (icont,*) 'ZONE  I =',mx,'  J =',jmax,'   F=BLOCK'
c
      write (icont,900) ((       x(i,j),i=1,mx),j=jmid,my)
c      write (icont,900) (((y(i,j)  -sc),i=1,mx),j=jmid,my)
      write (icont,900) (((y(i,j) -sc)*r(i),i=1,mx),j=jmid,my)
c                                                                       
      do 110 i=2,mx
      do 110 j=2,my
  110 wcell(i,j)   = q(2,i,j)/q(1,i,j)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
c    V velocity
c                                                                         
      do 120 i=2,mx
      do 120 j=2,my
  120 wcell(i,j)   = q(3,i,j)/q(1,i,j)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
c   Relative Mach No.
c                                                                       
      do 130 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 130 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      c            = sqrt(gam*p/rho)
  130 wcell(i,j)   = sqrt(u*u  +v*v)/c
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
c   Pressure
c                                                                       
      do 140 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 140 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v
     &                 -(rav*omega)**2))
  140 wcell(i,j)   = p
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
c  Relative Flow Angle
c                                                                       
      do 150 i=2,mx
      do 150 j=2,my
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
  150 wcell(i,j)   = (180./pi)*atan(v/u)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
c  Entropy
c                                                                       
      do 160 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 160 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
  160 wcell(i,j)   = gam*alog(p/rho)/(gam  -1.)  -alog(p)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
c  Absolute  Total Temperature
c
      do 165 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 165 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + rav*omega
      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      xmach        = sqrt(u*u  +v*v)/c
      term         = 1.  +.5*(gam  -1.)*xmach_abs*xmach_abs
 165  wcell(i,j)   = tem*term
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
cc
cc  Temperature
cc
c      do 170 i=2,mx
c         rav       = .5*( r(i) +r(i-1) )
c      do 170 j=2,my
c      rho          = q(1,i,j)
c      u            = q(2,i,j)/q(1,i,j)
c      v            = q(3,i,j)/q(1,i,j)
c      qq           = u*u +v*v
c      et           = q(4,i,j)
c      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
c     &               -(rav*omega)**2))
c      tem            = p/rho
cc      to           = tem + .5*qq
cc      c            = sqrt(gam*p/rho)
cc      xmach        = sqrt(u*u  +v*v)/c
cc      term         = 1.  +.5*(gam  -1.)*xmach*xmach
c  170 wcell(i,j)   = tem
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
c  Absolute Total Pressure
c
      do 175 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 175 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + rav*omega
      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term         = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)
      term         = term**(gam/(gam -1.))
 175  wcell(i,j)   = p*term
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)      
cc
cc  Density
cc
c      do 180 i=2,mx
c      do 180 j=2,my
c      rho          = q(1,i,j)
c  180 wcell(i,j)   = rho
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my) 
cc
cc  Mass flow rate
cc
c      do 185 i=2,mx
c      hav          = .5*(h(i-1) +h(i))
c      rav          = .5*(r(i-1) +r(i))
c      do 185 j=2,my
c      rho          = q(1,i,j)
c      u            = q(2,i,j)/q(1,i,j)
c      rdy          = .5*(r(i)*( y(i,j) -y(i,j-1)) +
c     &                r(i-1)*( y(i-1,j) -y(i-1,j-1)) ) 
c 185  wcell(i,j)   =  rho*u*hav*rdy
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my) 
cc
cc  Radial Velocity 
cc
c      do 190 i=2,mx
c      do 190 j=2,my
c      drdm         = (r(i) - r(i-1))/(x(i,j) -x(i-1,j))
c      u            = q(2,i,j)/q(1,i,j)
c 190  wcell(i,j)   = drdm*u
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my) 
c
c
c
      do 200 i=2,mx
      do 200 j=2,my
 200     wcell(i,j)   = .25*(prlni(i,j) +prlni(i-1,j) +
     &                       prlnj(i,j) +prlnj(i,j-1) )
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
      do 205 i=2,mx
      do 205 j=2,my
 205     wcell(i,j)   = .25*(taumti(i,j) +taumti(i-1,j) +
     &                       taumtj(i,j) +taumtj(i,j-1) )
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)
c
c Magnitude of Relative  velocity
c
      do 207 i=2,mx
      do 207 j=2,my
         u   = q(2,i,j)/q(1,i,j)
         v   = q(3,i,j)/q(1,i,j)
         ss  = u/abs(u)
 207     wcell(i,j)   = ss*sqrt(u*u +v*v)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=jmid,my)

c
      write (icont,*) 'ZONE  I =',mx,'  J =',jmax,'   F=BLOCK'
c
      write (icont,900) ((x(i,j),i=1,mx),j=1,jmid)
c      write (icont,900) ((y(i,j),i=1,mx),j=1,jmid)
      write (icont,900) (((y(i,j))*r(i),i=1,mx),j=1,jmid)
c                                                                       
      do 210 i=2,mx
      do 210 j=2,my
  210 wcell(i,j)   = q(2,i,j)/q(1,i,j)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c
c    V velocity
c                                                                       
      do 220 i=2,mx
      do 220 j=2,my
  220 wcell(i,j)   = q(3,i,j)/q(1,i,j)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c
c   Relative Mach No.
c                                                                       
      do 230 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 230 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      c            = sqrt(gam*p/rho)
  230 wcell(i,j)   = sqrt(u*u  +v*v)/c
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c                                                                       
      do 240 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 240 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
  240 wcell(i,j)   = p
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c                                                                       
      do 250 i=2,mx
      do 250 j=2,my
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
  250 wcell(i,j)   = (180./pi)*atan(v/u)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c                                                                       
      do 260 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 260 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
  260 wcell(i,j)   = gam*alog(p/rho)/(gam  -1.)  -alog(p)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c
c  Absolute  Total Temperature
c
      do 265 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 265 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + rav*omega
      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      xmach        = sqrt(u*u  +v*v)/c
      term         = 1.  +.5*(gam  -1.)*xmach_abs*xmach_abs
 265  wcell(i,j)   = tem*term
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
cc
cc  Temperature
cc
c      do 270 i=2,mx
c         rav       = .5*( r(i) +r(i-1) )
c      do 270 j=2,my
c      rho          = q(1,i,j)
c      u            = q(2,i,j)/q(1,i,j)
c      v            = q(3,i,j)/q(1,i,j)
c      qq           = u*u +v*v
c      et           = q(4,i,j)
c      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
c     &               -(rav*omega)**2))
c      tem            = p/rho
cc      to           = tem + .5*qq
cc      c            = sqrt(gam*p/rho)
cc      xmach        = sqrt(u*u  +v*v)/c
cc      term         = 1.  +.5*(gam  -1.)*xmach*xmach
c  270 wcell(i,j)   = tem
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c
c  Absolute Total Pressure
c
      do 275 i=2,mx
         rav       = .5*( r(i) +r(i-1) )
      do 275 j=2,my
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + rav*omega
      qq_abs       = u*u +v_abs*v_abs
      qq           = u*u +v*v
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      tem            = p/rho
c      to           = tem + .5*qq
      c            = sqrt(gam*p/rho)
      xmach        = sqrt(u*u  +v*v)/c
      xmach_abs    = sqrt(u*u  +v_abs*v_abs)/c
      term         = (1.  +.5*(gam  -1.)*xmach_abs*xmach_abs)
      term         = term**(gam/(gam -1.))
 275  wcell(i,j)   = p*term
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)      
cc
cc  Density
cc
c      do 280 i=2,mx
c      do 280 j=2,my
c      rho          = q(1,i,j)
c  280 wcell(i,j)   = rho
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid) 
cc
cc  Mass flow rate
cc
c      do 285 i=2,mx
c      hav          = .5*(h(i-1) +h(i))
c      rav          = .5*(r(i-1) +r(i))
c      do 285 j=2,my
c      rho          = q(1,i,j)
c      u            = q(2,i,j)/q(1,i,j)
c      rdy          = .5*(r(i)*( y(i,j) -y(i,j-1)) +
c     &                r(i-1)*( y(i-1,j) -y(i-1,j-1)) ) 
c 285  wcell(i,j)   =  rho*u*hav*rdy
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid) 
cc
cc  Radial Velocity 
cc
c      do 290 i=2,mx
c      do 290 j=2,my
c      drdm         = (r(i) - r(i-1))/(x(i,j) -x(i-1,j))
c      u            = q(2,i,j)/q(1,i,j)
c 290  wcell(i,j)   = drdm*u
c      call average
c      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid) 
c
      do 300 i=2,mx
      do 300 j=2,my
 300     wcell(i,j)   = .25*(prlni(i,j) +prlni(i-1,j) +
     &                       prlnj(i,j) +prlnj(i,j-1) )
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c
      do 310 i=2,mx
      do 310 j=2,my
 310     wcell(i,j)   = .25*(taumti(i,j) +taumti(i-1,j) +
     &                       taumtj(i,j) +taumtj(i,j-1) )
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c
c Magnitude of Relative  velocity
c
      do 320 i=2,mx
      do 320 j=2,my
         u   = q(2,i,j)/q(1,i,j)
         v   = q(3,i,j)/q(1,i,j)
         ss  = u/abs(u)
  320 wcell(i,j)   = ss*sqrt(u*u +v*v)
      call average
      write (icont,900) ((wnode(i,j),i=1,mx),j=1,jmid)
c
  900 format (10e13.5)
c                                                                       
      return                                                            
      end                                                               
c
c ----------------------------------------------------------------
c
      subroutine average
c     compute nodal value using cell-averaged value
      include 'dimpar.inc'
      include 'common.inc'
c
c inner points
c
      do 1 i=2,mx-1
      do 1 j=2,my-1
    1 wnode(i,j)    = .25*(wcell(i+1,j+1)  +wcell(i+1,j)
     .                    +wcell(i,j+1)  +wcell(i,j))
c
c boundary points
c
      j         = 1
      do 2 i=2,mx-1
    2 wnode(i,j)    = .5*(wcell(i+1,j+1)  +wcell(i,j+1))
      j         = my
      do 3 i=2,nx
    3 wnode(i,j)    = .5*(wcell(i+1,j)  +wcell(i,j))
      i         = 1
      do 4 j=2,my-1
    4 wnode(i,j)    = .5*(wcell(i+1,j+1)  +wcell(i+1,j))
      i         = mx
      do 5 j=2,my-1
    5 wnode(i,j)    = .5*(wcell(i,j+1)  +wcell(i,j))
c
c corner points
c
      wnode(1,1)      = wcell(2,2)
      wnode(1,my)     = wcell(2,my)
      wnode(mx,1)     = wcell(mx,2)
      wnode(mx,my)    = wcell(mx,my)
c
      return
      end


