c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine flux
c                                                                       
c compute flux-vectors at cell-centered locations
c
      include 'dimpar.inc'
      include 'common.inc'
	real start,end
c
c ***************************************************
c compute flux vectors e and f along constant i faces
c ***************************************************
c
	

!HPF$ INDEPENDENT, NEW(i)
      do 10 j=2,my
!HPF$ INDEPENDENT,NEW(rav,rho,u,v,et,p)
      do 10 i=1,mx
      rav         = r(i)
      rho         = .5*(qnew(1,i+1,j)  +qnew(1,i,j))
      u           = .5*(qnew(2,i+1,j)/qnew(1,i+1,j)
     &                 +qnew(2,i,j)/qnew(1,i,j))
      v           = .5*(qnew(3,i+1,j)/qnew(1,i+1,j)
     &                 +qnew(3,i,j)/qnew(1,i,j))
      et          = .5*(qnew(4,i+1,j)  +qnew(4,i,j))
c      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
c     &               -(rav*omega)**2))
      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)*(rav*omega)))
      ei(1,i,j)   = rho*u
      ei(2,i,j)   = rho*u*u  +p 
      ei(3,i,j)   = rho*u*v 
c
c ********* NOTE: THE FLUX TERM OF THE ENERGY EQN HAS ROTHALPY
c *********       INSTEAD OF STAGNATION ENTHALPY BECAUSE OF 
c *********       ROTATING FRAME
c *********       so = rho*u*I instead of rho*u*H
c
      ei(4,i,j)   = (et  +p)*u
      fi(1,i,j)   = rho*v
      fi(2,i,j)   = rho*u*v 
      fi(3,i,j)   = rho*v*v  +p 
   10 fi(4,i,j)   = (et  +p)*v

c
c ***************************************************
c compute flux vectors e and f along constant j faces
c ***************************************************
c
c upstream and downstream regions
c

	
!!HPF$ INDEPENDENT
      do 20 nreg=1,2
      if (nreg .eq. 1) then
      i1           = 2
      i2           = ile
      else
      i1           = ite  +1
      i2           = mx
      endif
!HPF$ INDEPENDENT
      do 20 j=1,my
!HPF$ INDEPENDENT,NEW(rav,rho,u,v,et,p)
      do 20 i=i1,i2
      rav         = .5*(r(i) +r(i-1))
      rho         = .5*(qnew(1,i,j+1)  +qnew(1,i,j))
      u           = .5*(qnew(2,i,j+1)/qnew(1,i,j+1)
     &                 +qnew(2,i,j)/qnew(1,i,j))
      v           = .5*(qnew(3,i,j+1)/qnew(1,i,j+1)
     &                 +qnew(3,i,j)/qnew(1,i,j))
      et          = .5*(qnew(4,i,j+1)  +qnew(4,i,j))
      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      ej(1,i,j)   = rho*u
      ej(2,i,j)   = rho*u*u  +p 
      ej(3,i,j)   = rho*u*v -taumtj(i,j)
      ej(4,i,j)   = (et  +p)*u
      fj(1,i,j)   = rho*v
      fj(2,i,j)   = rho*u*v -taumtj(i,j)
      fj(3,i,j)   = rho*v*v  +p 
   20 fj(4,i,j)   = (et  +p)*v
	
	
c
c bladed region
c
c inner faces
c
	
!HPF$ INDEPENDENT,NEW(i)
      do 30 j=2,my-1
!HPF$ INDEPENDENT,NEW(rav,rho,u,v,et,p)
      do 30 i=ile+1,ite
      rav         = .5*(r(i) +r(i-1))
      rho         = .5*(qnew(1,i,j+1)  +qnew(1,i,j))
      u           = .5*(qnew(2,i,j+1)/qnew(1,i,j+1)
     &                 +qnew(2,i,j)/qnew(1,i,j))
      v           = .5*(qnew(3,i,j+1)/qnew(1,i,j+1)
     &                 +qnew(3,i,j)/qnew(1,i,j))
      et          = .5*(qnew(4,i,j+1)  +qnew(4,i,j))
      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)**2))
      ej(1,i,j)   = rho*u
      ej(2,i,j)   = rho*u*u  +p 
      ej(3,i,j)   = rho*u*v -taumtj(i,j)
      ej(4,i,j)   = (et  +p)*u
      fj(1,i,j)   = rho*v
      fj(2,i,j)   = rho*u*v -taumtj(i,j)
      fj(3,i,j)   = rho*v*v  +p 
   30 fj(4,i,j)   = (et  +p)*v
	
c
c faces along blade surfaces
c
c **************
c analysis mode
c **************
c
      if (idesign .eq. 0) then
c
	
!HPF$ INDEPENDENT,NEW(j,jloc,rav,rho,u,v,et,p)
      do 40 i=ile+1,ite
c
c no-flux along lower boundary
c
      j           = 1
      jloc        = 2
      rav         = .5*( r(i) +r(i-1) )
      rho         = qnew(1,i,jloc)
      u           = qnew(2,i,jloc)/qnew(1,i,jloc)
      v           = qnew(3,i,jloc)/qnew(1,i,jloc)
      et          = qnew(4,i,jloc)
c      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
c     &               -(r(i)*omega)**2))
      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)*(rav*omega)))
      ej(1,i,j)   = 0.
      ej(2,i,j)   = p 
c      ej(3,i,j)   = 0. -tauwp(i)
      ej(3,i,j)   = 0. +tauwp(i)
      ej(4,i,j)   = 0.
      fj(1,i,j)   = 0.
      fj(2,i,j)   = 0. -tauwp(i)
      fj(3,i,j)   = p
      fj(4,i,j)   = 0.
c
c no-flux along upper boundary
c
      j           = my
      jloc        = my
      rho         = qnew(1,i,jloc)
      u           = qnew(2,i,jloc)/qnew(1,i,jloc)
      v           = qnew(3,i,jloc)/qnew(1,i,jloc)
      et          = qnew(4,i,jloc)
c      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
c     &               -(r(i)*omega)**2))
      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(rav*omega)*(rav*omega)))
      ej(1,i,j)   = 0.
      ej(2,i,j)   = p
c      ej(3,i,j)   = 0. -tauwm(i)
      ej(3,i,j)   = 0. +tauwm(i)
      ej(4,i,j)   = 0.
      fj(1,i,j)   = 0.
      fj(2,i,j)   = 0. -tauwm(i)
      fj(3,i,j)   = p
   40 fj(4,i,j)   = 0.
	
c
c **************
c inverse mode
c **************
c
      else
c

!HPF$ INDEPENDENT,NEW(rav,hav,rho_plus,u_plus,v_plus,et_plus,qq,
     $ p_plus, rho_minus , u_minus,v_minus,et_minus,p_minus,
     $ vbl,pbl,dx,dfdx,dtdx,tanp,tanm,viscor,drvavgdx,delta_p,
     $ delta_v,j,rho,u,v,p,et)
      do 50 i=ile+1,ite
c
c compute pressure jump across blade
c
c      dx          = x(i,1)  -x(i-1,1)
c      dfdx        = (f(i)  -f(i-1))/dx
c      dtdx        = (t(i)  -t(i-1))/dx
c      drvavgdx     = (rvavg(i)  -rvavg(i-1))/dx
c      delta_p     = xmdot*drvavgdx/(r(i)*h(i))
c
c flow conditions at blade surfaces
c
      rav         = .5*( r(i) + r(i-1) )
      hav         = .5*( h(i) + h(i-1) )
      rho_plus    = qnew(1,i,2)
      u_plus      = qnew(2,i,2)/qnew(1,i,2)
      v_plus      = qnew(3,i,2)/qnew(1,i,2)
      et_plus     = qnew(4,i,2)
      qq          = u_plus*u_plus  +v_plus*v_plus
      p_plus      = (gam  -1.)*(et_plus  -.5*rho_plus*(qq 
     &               -(rav*omega)**2))
c
      rho_minus   = qnew(1,i,my)
      u_minus     = qnew(2,i,my)/qnew(1,i,my)
      v_minus     = qnew(3,i,my)/qnew(1,i,my)
      et_minus    = qnew(4,i,my)
      qq          = u_minus*u_minus  +v_minus*v_minus
c      p_minus     = (gam  -1.)*(et_minus  -.5*rho_minus*(qq 
c     &               -(rav*omega)**2))
      p_minus     = (gam  -1.)*(et_minus  -.5*rho_minus*(qq 
     &               -(rav*omega)*(rav*omega)))
c
c compute "blade" conditions at blades
c
      vbl         = .5*(v_plus  +v_minus)
      pbl         = .5*(p_plus  +p_minus)
c
c compute "jump" conditions at blades
c
      dx          = x(i,1)  -x(i-1,1)
      dfdx        = (f(i)  -f(i-1))/dx
      dtdx        = (t(i)  -t(i-1))/dx
c
c -----> viscous correction
c
      tanp         = rav*(dfdx + .5*dtdx)
      tanm         = rav*(dfdx - .5*dtdx)
      viscor       = (tauwp(i)*tanp - tauwm(i)*tanm)
c
c      do j = 2,my
c         sidefaces = taumti(i,j)*r(i)*r(i)*h(i)*(y(i,j) -y(i,j-1)) 
c     &     -taumti(i+1,j)*r(i+1)*r(i+1)*h(i+1)*(y(i+1,j) -y(i+1,j-1)) 
c         sidefaces = sidefaces/(rav*hav)
c      enddo
c **********
      if (idelp .ne. 1) then
         drvavgdx     = (rvavg(i)  -rvavg(i-1))/dx
         delta_p     = xmdot*drvavgdx/(rav*hav) +viscor 
      else
         delta_p     = delpin(i) +viscor 
      endif
c **********
c      delta_v     = (u_plus  -u_minus)*dfdx
c     &              +.5*(u_plus  +u_minus)*dtdx
      delta_v     = rav*((u_plus  -u_minus)*dfdx
     &              +.5*(u_plus  +u_minus)*dtdx)
c
c      delta_v     = v_plus - v_minus
c
c along upper surface
c
      j           = 1
      rho         = rho_plus
      u           = u_plus
      v           = vbl  +.5*delta_v
      qq          = u*u  +v*v
      p           = pbl  +.5*delta_p
c      et          = p/(gam  -1.)  +.5*rho*(qq -(rav*omega)**2)
      et          = p/(gam  -1.)  +.5*rho*(qq -(rav*omega)*
     &                (rav*omega))
      ej(1,i,j)   = rho*u
      ej(2,i,j)   = rho*u*u  +p
c      ej(3,i,j)   = rho*u*v -tauwp(i)
      ej(3,i,j)   = rho*u*v +tauwp(i)
      ej(4,i,j)   = (et  +p)*u
      fj(1,i,j)   = rho*v
      fj(2,i,j)   = rho*u*v -tauwp(i)
      fj(3,i,j)   = rho*v*v  +p
      fj(4,i,j)   = (et  +p)*v
c
c along lower surface
c
      j           = my
      rho         = rho_minus
      u           = u_minus
      v           = vbl  -.5*delta_v
      qq          = u*u  +v*v
      p           = pbl  -.5*delta_p
c      et          = p/(gam  -1.)  +.5*rho*(qq -(rav*omega)**2)
      et          = p/(gam  -1.)  +.5*rho*(qq -(rav*omega)*
     &               (rav*omega))
      ej(1,i,j)   = rho*u
      ej(2,i,j)   = rho*u*u  +p
c      ej(3,i,j)   = rho*u*v -tauwm(i)
      ej(3,i,j)   = rho*u*v +tauwm(i)
      ej(4,i,j)   = (et  +p)*u
      fj(1,i,j)   = rho*v
      fj(2,i,j)   = rho*u*v -tauwm(i)
      fj(3,i,j)   = rho*v*v  +p
      fj(4,i,j)   = (et  +p)*v
c
   50 continue
c
	
      endif
c
c compute the source term
c

!HPF$ INDEPENDENT,NEW(i)
      do 60 j=2,my
!HPF$ INDEPENDENT,NEW(rav,hav,rho,u,v,et,p,drdm,dhdm)
      do 60 i=2,mx
      rav         = .5*(r(i) +r(i-1))
      hav         = .5*(h(i) +h(i-1))
      rho         = qnew(1,i,j)
      u           = qnew(2,i,j)/qnew(1,i,j)
      v           = qnew(3,i,j)/qnew(1,i,j)
      et          = qnew(4,i,j)
      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)*(r(i)*omega)))
c
      drdm        = (r(i) -r(i-1))/(x(i,j) -x(i-1,j))
      dhdm        = (h(i) -h(i-1))/(x(i,j) -x(i-1,j))
c
      source(1,i,j)   = 0.
      source(2,i,j)   = drdm*(p + rho*( v + rav*omega)*
     &                  ( v + rav*omega))/rav  + p*dhdm/hav
      source(3,i,j)   = -drdm*rho*u*( v + 2.*rav*omega)/rav
      source(4,i,j)   = 0.
c
c adding the viscous source terms
c
c      tauttav         = .25*( tautti(i,j) +tautti(i-1,j) +tauttj(i,j) 
c     &                        +tauttj(i,j-1) )
c      taunnav         = .25*( taunni(i,j) +taunni(i-1,j) +taunnj(i,j) 
c     &                        +taunnj(i,j-1) )
c      taumtav         = .25*( taumti(i,j) +taumti(i-1,j) +taumtj(i,j) 
c     &                        +taumtj(i,j-1) )
c
c      source(2,i,j)   = source(2,i,j) -tauttav*drdm/rav 
cc     &                                -taunnav*dhdm/hav
c      source(3,i,j)   = source(3,i,j) +taumtav*drdm/rav
c
 60   continue

c
c recomputing at the bladed surface
c
	
!HPF$ INDEPENDENT,NEW(i)
      do 70 j=2,my,my-2
!HPF$ INDEPENDENT,NEW(rav,hav,rho,u,v,et,p,drdm,dhdm)
      do 70 i=ile+1,ite
      rav         = .5*(r(i) +r(i-1))
      hav         = .5*(h(i) +h(i-1))
      rho         = qnew(1,i,j)
      u           = qnew(2,i,j)/qnew(1,i,j)
      v           = qnew(3,i,j)/qnew(1,i,j)
      et          = qnew(4,i,j)
      p           = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &              -(r(i)*omega)*(r(i)*omega)))
c
      drdm        = (r(i) -r(i-1))/(x(i,j) -x(i-1,j))
      dhdm        = (h(i) -h(i-1))/(x(i,j) -x(i-1,j))
c
      source(1,i,j)   = 0.
      source(2,i,j)   = drdm*(p + rho*( v + rav*omega)*
     &                  ( v + rav*omega))/rav  + p*dhdm/hav
      source(3,i,j)   = -drdm*rho*u*( v + 2.*rav*omega)/rav
      source(4,i,j)   = 0.
c
c adding the viscous source terms
c
c      tauttav         = .5*( tautti(i,j) +tautti(i-1,j) )
c      taunnav         = .5*( taunni(i,j) +taunni(i-1,j) )
c      taumtav         = .5*( taumti(i,j) +taumti(i-1,j) )
cc
c      source(2,i,j)   = source(2,i,j) -tauttav*drdm/rav 
c     &                                -taunnav*dhdm/hav
c      source(3,i,j)   = source(3,i,j) +taumtav*drdm/rav
c
 70   continue
	

c
c      do j=2,my,6
c         do i=ite,mx,2
c            print*,i,j,source(2,i,j), source(3,i,j)
c         enddo
c      enddo
c
      return                                                            
      end                                                               







