c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine init
c                                                                       
c initialize flowfield
c
      include 'dimpar.inc'
      include 'common.inc'
c                                                                       
c inflow condition (upstream phantom cell)
c
    
      tgam1       = (gam  -1.)/gam
      tgam2       = .5*(gam  -1.)
      tan1        = tan(pi*beta1/180.)
      jmid        = ny/2  +1
     
c
     
     
      if ((ibcout .eq. 1) .or. (ibcout .eq. 4)) then
      i           = 1
      do 10 j=2,my
      p           = pback/p0ratio
      xm2_abs     = ((pstagn(j)/p)**tgam1  -1.)/tgam2
      temp        = tstagn(j)/(1.  +tgam2*xm2_abs)
      qtot_abs    = sqrt(gam*xm2_abs*temp)
      v_abs       = vtheta1
      u_abs       = sqrt(qtot_abs**2 -v_abs**2)
c      print*,i,j,p,xm2_abs,temp,qtot_abs,u_abs,v_abs
c making v= relative velocity.
      v           = v_abs - r(i)*omega
      u           = u_abs
      rho         = p/temp
      
c changing et to the relative frame
      et          = p/(gam  -1.) +.5*rho*(u*u  +v*v -(r(i)*omega)**2)
      q(1,i,j)    = rho
      q(2,i,j)    = rho*u
      q(3,i,j)    = rho*v
   10 q(4,i,j)    = et
      do 12 n=1,4
      q(n,i,1)     = q(n,i,my)
   12 q(n,i,my+1)  = q(n,i,2)
      else
      endif
     
c
      if (ibcin .eq. 2) then
      i           = 1
      do 20 j=2,my
      xm2_abs     = fmach*fmach
      p           = pstagn(j)/((1.  +tgam2*xm2_abs)**(1./tgam1))
      temp        = tstagn(j)/(1.  +tgam2*xm2_abs)
      rho         = p/temp
      qtot_abs    = sqrt(xm2_abs*(gam*p/rho)) 
      u_abs       = qtot_abs/sqrt(1.  +tan1*tan1) 
      v_abs       = u_abs*tan1
c      v_abs       = vtheta1
c      u_abs       = sqrt(qtot_abs**2 -v_abs**2) 
c making v= relative velocity.
      v           = v_abs - r(i)*omega
      u           = u_abs
c changing et to the relative frame
      et          = p/(gam  -1.) +.5*rho*(u*u  +v*v -(r(i)*omega)**2)
      q(1,i,j)    = rho
      q(2,i,j)    = rho*u
      q(3,i,j)    = rho*v
   20 q(4,i,j)    = et
      do 22 n=1,4
      q(n,i,1)     = q(n,i,my)
   22 q(n,i,my+1)  = q(n,i,2)
      else
      endif
c
c guess initial flowfield
c
      t0ratio = p0ratio**((gam -1.)/gam)
c
c *************
c analysis mode
c *************
c
      if (idesign .eq. 0) then
c
      do 50 i=2,ile
      do 50 j=1,my+1
         rav          = .5*( r(i) + r(i-1) )
         q(1,i,j)     = q(1,1,j)
         q(2,i,j)     = q(2,1,j)
         v1           = q(3,1,j)/q(1,1,j)
         v_abs        = v1 +rav*omega
         v_absj       = r(1)*v_abs/rav
         v            = (v_absj -rav*omega)
         q(3,i,j)     = q(1,1,j)*v
         et           = q(4,1,j) +.5*q(1,1,j)*( (v*v -v1*v1) 
     &                  -(rav*rav -r(1)*r(1))*omega**2)
 50      q(4,i,j)     = et
c
      deltax       = x(ite,jmid) -x(ile,jmid)
c
      rho          = q(1,1,jmid)
      u            = q(2,1,jmid)/q(1,1,jmid)
      do 52 i=ile+1,ite
      rav          = .5*( r(i) + r(i-1) )
      dx           = x(i,jmid)  -x(i-1,jmid)
      dxile        = x(i,jmid)  -x(ile,jmid)
      rdy          = rav*(y(i,jmid)  -y(i-1,jmid))
c      dy           = y(i,jmid)  -y(i-1,jmid)
      slope        = rdy/dx
      v            = slope*u
      q2           = u*u  +v*v
c
      q2_abs       = u*u  +(v + rav*omega)*(v + rav*omega)
c
      do 52 j=1,my+1
         tstagni  = tstagn(j) + (t0ratio -tstagn(j))*dxile/deltax
      temp        = tstagni  -.5*tgam1*q2_abs
      xm2         = q2/(gam*temp)
      xm2_abs     = q2_abs/(gam*temp)
c         pstagni  = pstagn(j) + (p0ratio -pstagn(j))*dx/deltax
         pstagni  = pstagn(j)*(tstagni/tstagn(j))**(gam/(gam-1.))
      p           = pstagni/((1.  +tgam2*xm2_abs)**(1./tgam1))
c
      rho         = p/temp
c
      et          = p/(gam  -1.) +.5*rho*(u*u  +v*v -(r(i)*omega)**2)
      q(1,i,j)    = rho
      q(2,i,j)    = rho*u
      q(3,i,j)    = rho*v
   52 q(4,i,j)    = et
c
c
         ravte        = .5*(r(ite) + r(ite-1))
      do 54 i=ite+1,mx
      do 54 j=1,my+1
         rav          = .5*(r(i) + r(i-1))
         u            = q(2,ite,j)/q(1,ite,j)         
         v1           = q(3,ite,j)/q(1,ite,j)
         v_abs        = v1 +ravte*omega
         v_absj       = ravte*v_abs/rav
         v            = (v_absj -rav*omega)
         q2_abs       = u*u  +v_absj*v_absj
         temp         = t0ratio  -.5*tgam1*q2_abs
         xm2_abs      = q2_abs/(gam*temp)
         p            = p0ratio/((1.  +tgam2*xm2_abs)**(1./tgam1))
         rho          = p/temp
         et        = p/(gam  -1.) +.5*rho*(u*u  +v*v -(rav*omega)**2)
         q(1,i,j)     = rho
         q(2,i,j)     = rho*u
         q(3,i,j)     = rho*v
 54      q(4,i,j)     = et
c
c
         do j=1,my+1
            do n=1,4
               q(n,mx+1,j) = q(n,mx,j)
            enddo
         enddo
c
      else
      endif
c
c ************
c inverse mode
c ************
c
      if (idesign .eq. 1) then
c
c guess swirl
c
      i            = 1
      sum1         = 0.
      sum2         = 0.
      do 260 j=2,my
      rdy           = r(i)*sfy(j)  -r(i)*sfy(j-1)
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      v_abs        = v + r(i)*omega
      rvy          = v_abs*r(i)           
      sum1         = sum1  +(rho*u*rdy*h(i))
  260 sum2         = sum2  +rvy*(rho*u*rdy*h(i))
      xmdot        = sum1
c
c note here delvy actually is = del(r vtheta)
c so we keep the r vtheta constant along the streamtube in the 
c non bladed region
c
      rvy          = sum2/sum1
      b            = rvy
c      a            = delrvy/fload(ite)
      a            = delrvy/rhfload(ite)
      do 270 i=1,ile
  270 rvavg(i)     = b
      do 271 i=ile+1,ite
  271 rvavg(i)     =  a*rhfload(i)  +b
      do 272 i=ite+1,mx
  272 rvavg(i)     = rvavg(ite)
c
c note here rvavg is the ABSOLUTE  velocity IN Y DIRECTION *RADIUS
c
c guess flowfield
c
      do 60 i=2,ile
      rav          = .5*(r(i) + r(i-1))
      rho          = q(1,1,jmid)
      u            = q(2,1,jmid)/q(1,1,jmid)
      v_abs        = .5*(rvavg(i)/r(i)  +rvavg(i-1)/r(i-1))
      v            = v_abs - rav*omega
      q2           = u*u  +v*v
      q2_abs       = u*u  +(v+ r(i)*omega)*(v+ r(i)*omega) 
      do 60 j=2,my
      temp         = tstagn(j)  -.5*tgam1*q2_abs
      xm2          = q2/(gam*temp)
      xm2_abs      = q2_abs/(gam*temp)
      p            = pstagn(j)/((1.  +tgam2*xm2_abs)**(1./tgam1))
      rho         = p/temp
      et           = p/(gam  -1.) +.5*rho*(u*u +v*v -(r(i)*omega)**2)
      q(1,i,j)     = rho
      q(2,i,j)     = rho*u
      q(3,i,j)     = rho*v
   60 q(4,i,j)     = et
c
      deltax       = x(ite,jmid) - x(ile,jmid)
c
      do 62 i=ile+1,ite
      rav          = .5*(r(i) + r(i-1))
      rho          = q(1,1,jmid)
      u            = q(2,1,jmid)/q(1,1,jmid)
      dx           = x(i,jmid)  -x(i-1,jmid)
      dxile        = x(i,jmid)  -x(ile,jmid)
      v_abs        = .5*(rvavg(i)/r(i)  +rvavg(i-1)/r(i-1))
      v            = v_abs - rav*omega
      q2           = u*u  +v*v
      q2_abs       = u*u  +(v+ r(i)*omega)*(v+ r(i)*omega) 
      do 62 j=2,my
         tstagni  = tstagn(j) + (t0ratio -tstagn(j))*dxile/deltax
      temp         = tstagni  -.5*tgam1*q2_abs
      xm2          = q2/(gam*temp)
      xm2_abs      = q2_abs/(gam*temp)
c         pstagni  = pstagn(j) + (p0ratio -pstagn(j))*dx/deltax
         pstagni  = pstagn(j)*(tstagni/tstagn(j))**(gam/(gam-1.))
      p            = pstagni/((1.  +tgam2*xm2_abs)**(1./tgam1))
      rho          = p/temp
      et           = p/(gam  -1.) +.5*rho*(u*u +v*v -(r(i)*omega)**2)
      q(1,i,j)     = rho
      q(2,i,j)     = rho*u
      q(3,i,j)     = rho*v
 62   q(4,i,j)     = et
      do 64 i=ite,mx
      rav          = .5*(r(i) + r(i-1))
      u            = q(2,ite,jmid)/q(1,ite,jmid)
      v_abs        = .5*(rvavg(i)/r(i)  +rvavg(i-1)/r(i-1))
      v            = v_abs - rav*omega
      q2           = u*u  +v*v
      q2_abs       = u*u  +(v+ r(i)*omega)*(v+ r(i)*omega) 
      do 64 j=2,my
      temp         = t0ratio  -.5*tgam1*q2_abs
      xm2          = q2/(gam*temp)
      xm2_abs      = q2_abs/(gam*temp)
      p            = p0ratio/((1.  +tgam2*xm2_abs)**(1./tgam1))
      rho          = p/temp
      et           = p/(gam  -1.) +.5*rho*(u*u +v*v -(r(i)*omega)**2)
      q(1,i,j)     = rho
      q(2,i,j)     = rho*u
      q(3,i,j)     = rho*v
 64   q(4,i,j)     = et
      do 70 j=2,my
      do 70 i=2,mx
      do 70 n=1,4
   70 qnew(n,i,j)  = q(n,i,j)
      call bcper
      do 71 i=2,mx
      do 71 n=1,4
      q(n,i,1)     = qnew(n,i,1)
 71   q(n,i,my+1)  = qnew(n,i,my+1)
c
c      q(n,i,1)     = qnew(n,i,1)
c   71 q(n,i,my+1)  = qnew(n,i,my+1)
c
c      do j=1,my
c         do i= mx-1,mx+1
c            print*,i,j,qnew(1,i,j)
c         enddo
c      enddo
c
c      do 72 j=2,my
c      do 72 n=1,4
c   72 q(n,mx+1,j)  = qnew(n,mx+1,j)
c
c *****************guess
      if (ibcout .eq. 4) then

         do 72 j=2,my
         do 72 n=1,4
 72         q(n,mx+1,j)  = q(n,mx,j)

      else

         call bcout
         
         do 73 j=2,my
         do 73 n=1,4
 73         q(n,mx+1,j)  = qnew(n,mx+1,j)
      endif
c
c guess blade profile
c
      f(ile)       = 0.
      do 80 i=ile+1,ite
      dx           = x(i,1)  -x(i-1,1)
      u            = q(2,i,jmid)/q(1,i,jmid)
      v            = q(3,i,jmid)/q(1,i,jmid)
c ****** note: here the unints of f are radians *******
   80 f(i)         = (f(i-1)*r(i-1)  +(v/u)*dx)/r(i)
      slope        = (r(ite)*f(ite)  -r(ite-1)*f(ite-1))
     &                /(x(ite,1)  -x(ite-1,1))
      do 81 i=ite+1,mx
   81 f(i)         = (r(i-1)*f(i-1)  +slope*(x(i,1)  -x(i-1,1)))/r(i)
      slope        = (f(ile+1)*r(ile+1)  -f(ile)*r(ile))
     &                /(x(ile+1,1)  -x(ile,1))
c      slope        = tan1
      do 82 i=ile-1,1,-1
   82 f(i)         = (r(i+1)*f(i+1)  -slope*(x(i+1,1)  -x(i,1)))/r(i)
      do  i=1,ile-1
         f(i)         = f(ile)
      enddo
      do  i=ite+1,mx
         f(i)         = f(ite)
      enddo
c generate initial mesh
c
      do 90 i=1,mx
      do 90 j=1,my
      alpha        = .5*sc  +(1.  -t(i)/sc)*(sfy(j)  -.5*sc)
   90 y(i,j)       = alpha  +f(i)
c
      else
      endif
c
      return                                                            
      end                                                               






