c                                                                       
c 2D Euler analysis/inverse code for cascaded blades with finite thickness
c Jameson cell-centered finite-volume technique
c                                                                       
      include 'dimpar.inc'
      include 'common.inc'
!	use var_dec
	
      real start,end
c
c     dimension     timea(2)
c
c                                                                       
      open(1,file='ft01.dat')
      open(2,file='ft02.dat')
      open(3,file='ft03.dat')
      open(4,file='ft04.dat')
      open(7,file='it.dat')
      open(8,file='err.dat')
      open(9,file='errf.dat')
      open(10,file='mesh.dat')
c      open(11,file='x.dat')
c      open(12,file='y.dat')
      open(15,file='useful.dat')
      open(21,file='ft21.dat',form='unformatted')
      open(22,file='ft22.dat',form='unformatted')
      open(40,file='matlab.dat')
      open(41,file='load.dat')
c                        


      iread        = 1                                                     
      iwrit        = 2                                                     
      pi           = 4.*atan(1.)                                          
c
         imaxf = 0
         errf  = 0.
         res=1

c
c generate mesh
c
         
!      call input(idesign,nx,ny,ile,ite,imesh,imode,visc,
!     $  cfl_min,cfl_max,
!     $ cflnorm,factor,istart,icycle,ibcin,ibcout,iplot,pback,beta1,
!     $ fmach,gam,delrvy,p0ratio,xmout,vflag,renr,iupdv,incv,
!     $ omega,blades,ibl,nprad,nph,
!     &     xmin,xle,xte,xmax,reflen,sc,expx,expy
!     $ idesign,idelp,fic1,fic2,incf,relaxf_max,
!     &     npload,npthick,tmax )
     
	call input
      	
	

      
c
c read in the stream tube thickness and its radial location
c
      if (blades .ne. 0.)  sc = 2*pi/blades
c
c      if ( (blades .eq. 1.) .and. (irad .eq. 1) ) sc = sc/rr(1)
c
c NOTE: IF IBLADES = 0. THEN SC SHOULD BE IN RADIANS
c
c ************ By this point, sc should be defined *********
c
c generate mesh
c
!      if (idesign .eq. 0) call mesh0
      if (idesign .eq. 1) call mesh1



 

c
c read in the stream tube thickness and its radial location
c
c      if ( (irad .eq. 0) .or. (ih .eq. 0) ) 
c     &     call stream
c
c setup input data
c
c
c      do i = 1,mx,2
c         print*,i,xrad(i),rr(i),xh(i),hh(i)
c      enddo
c      print*,'****'
     
      call setup
    
c      do i = 1,mx,2
c         print*,i,xrad(i),rr(i),xh(i),hh(i)
c      enddo
c
c      do i = 1,mx,2
c         print*,i,r(i),h(i),t(i),rhfload(i)
c      enddo
c      stop
c
c guess initial flowfield
c
      call init
   
c
c calculate Prandtl mixing length
c
         call prandtl
c
c
c      if (vflag .ne. 0.) then
cc
c         call viscous
cc
c      else
         do j = 1,my
            do i = 1,mx
               taumti(i,j) =0.
               taumtj(i,j) =0.
               taummi(i,j) =0.
               taummj(i,j) =0.
               tautti(i,j) =0.
               tauttj(i,j) =0.
               taunni(i,j) =0.
               taunnj(i,j) =0.
	       xnuturbi(i,j) =0.
	       xnuturbj(i,j) =0.
            enddo
         enddo
         do i = ile+1,ite
            tauwp(i) = 0.
            tauwm(i) = 0.
         enddo
c      endif
c
c
c restart calculation
c
      icstrt       = 1
      if (istart .eq. 1) call rstart(icstrt)
c
c	print*,'imaxf,errf  1',imaxf,errf
c
      icycle       = icstrt  +icycle
c
c solution to time-dependent Euler equations
c
      write (    6,*)' '
      write (iwrit,*)' '
      write (    6,*)'------------------------------------------'
      write (iwrit,*)'------------------------------------------'
      write (    6,*)'  2D Euler Analysis/Inverse Calculation'
      write (iwrit,*)'  2D Euler Analysis/Inverse Calculation'
      write (    6,*)'------------------------------------------'
      write (iwrit,*)'------------------------------------------'
      write (    6,*)'   iterative history'
      write (iwrit,*)'   iterative history'
      write (    6,206)
      write (iwrit,206)                                                 
  206 format(12h     fdesign)
      fdesign      = float(idesign)
      write (    6,506) idesign
      write (iwrit,506) idesign
      write (    6,200)
      write (iwrit,200)                                                 
  200 format(12h       fmesh,12h          nx,12h          ny,
     &       12h         ile,12h         ite)
      write (    6,506) imesh,nx,ny,ile,ite
      write (iwrit,506) imesh,nx,ny,ile,ite
      write (    6,201)                                                 
      write (iwrit,201)                                                 
  201 format(12h       fmach,12h       pback,12h          sc)
      write (    6,508) fmach,pback,sc
      write (iwrit,508) fmach,pback,sc
      write (    6,207)                                                 
      write (iwrit,207)                                                 
  207 format(12h       beta1,12h     del[Vy],
     &       12h     del[P0],12h     del[T0])
      write (    6,508) beta1,delrvy,delp0,delt0
      write (iwrit,508) beta1,delrvy,delp0,delt0
      write (    6,204)
      write (iwrit,204)                                                 
  204 format(12h       ibcin,12h      ibcout)
      write (    6,506) ibcin,ibcout
      write (iwrit,506) ibcin,ibcout
      write (    6,202)                                                 
      write (iwrit,202)                                                 
  202 format(12h         CFL,12h       fmode,12h      fstart)
      fmode        = float(imode)
      fstart       = float(istart)
      write (    6,508) cfl,fmode,fstart
      write (iwrit,508) cfl,fmode,fstart
c
  203 format(6h   cyc,11h     min dt,
     &                11h  max resid,4h   i,3h  j,
     &                11h   max q(1),4h   i,3h  j,
     &                7h  df/dx,11h      max f,4h   i,
     &                11h       Mdot,5h nsup)
c
c set up calculation
c
      if (icycle .le. 0) go to 999
      nstep        = (icycle  -icstrt)/100
      if (nstep .le. 0) nstep = 1
      nn           = nstep  -1
c
c
c	print*,'imaxf,errf  1',imaxf,errf
c

c
      term         = float(icycle  -icstrt)
      fic1         = term*fic1
      fic2         = term*fic2
      if (fic1 .eq. fic2) then 
      	slope_f    = 1.
      else
      	slope_f      = 1./(fic2  -fic1)
      endif
      nincf        = 0
c
c      print*,'slope_f =',slope_f
c
c
c solution by Jameson Runge-Kutta scheme
c
      write (    6,205)                                                 
      write (iwrit,205)                                                 
  205 format(12h      fdissp,12h        visc)
      fdissp       = float(idissp)
      write (    6,508) fdissp,visc
      write (iwrit,508) fdissp,visc
      write (    6,203)
      write (iwrit,203)                                                 
c
      nincf        = 0
      nincv        = 0
      icamber      = 0
c
      call timer(start,0.0)
      do 20 ic=icstrt,icycle
      nn           = nn  +1
c
      cfl  = cfl_min +(cfl_max -cfl_min)*float(ic -icstrt)/
     &                float(icycle -icstrt)
    
c
c compute time step
c
      call step
	

c
c update flow variables
c
      call rk4 (ires,jres,resmax,resavg,
     &          iq1,jq1,q1max,q1avg,nsup)
c
c update viscous terms
c
      if (vflag .eq. 0.) goto 33
      if (ic .lt. iupdv) go to 33
      nincv        = nincv  +1
      if (nincv .eq. incv) then
         call prandtl
         call viscous(resavg)
      nincv        = 0
c      print*, 'viscous term calculated'
      else
      endif
c
 33   if (idesign .eq. 0) go to 21
c
c update camber line
c
      relaxf = slope_f*(float(ic) -fic1)
c
c      print*,relaxf
c
      if (relaxf .gt. relaxf_max) relaxf = relaxf_max
c
c      print*,relaxf
c
c      if (ic .lt. iupdf) go to 21
      if (relaxf .lt. 0.) go to 21
      nincf        = nincf  +1
      if (relaxf .eq. 0.) go to 21
c	print*,nincf,incf
      if (nincf .eq. incf) then
c
c
c         print*,nincf,incf
c
c
      call camber (imaxf,errf)
      call swirl
c
c	print*,imaxf,errf,incf,nincf
c
      nincf        = 0
      else
      endif
c
c convergence history
c
   21 continue
c
c	print*,nn,nstep,imaxf,errf,incf,nincf      
c
      if (nn .eq. nstep) then
      drfdx        = (r(ite)*f(ite)  -r(ite-1)*f(ite-1))/
     &               (x(ite,1)  -x(ite-1,1))
      drfdx        = (180./pi)*atan(drfdx)
      write (    6,507) ic,dtime,resmax,ires,jres,
     &                  resavg,iq1, jq1,drfdx,errf,imaxf,
     &                  xmdot,nsup
c     &                  xmdot,relaxf
!      write (iwrit,507) ic,dtime,resmax,ires,jres,
!     &                  q1max,iq1,jq1,drfdx,errf,imaxf,
!     &                  xmdot,nsup
c     &                  xmdot,relaxf
      nn           = 0
      else
      endif
c
c save convergence history
c
!      write (7,*) float(ic)
!      write (8,*) abs(resmax)
!      write (9,*) abs(errf)
c
   20 continue
      call timer(end,start)
      write(6,*) 'Execution took:',end,'seconds'
c
c check CPU time on IBM RISC machine
c
c     itime        = mclock(timea)
c     write (6,*) ' '
c     write (6,*) 'CPU time = ',itime,' E-02 seconds'
c
c output
c
  999 continue
c
c MAKE THE MESH DIMENSIONAL/NON-DIMENSIONAL IF REQUIRED
c
c ! for ireflen=1 leave it unchanged 
c
      if (ireflen .eq. -1) then ! MAKE DIMENSIONAL
         do i = 1,mx
            r(i) = h(i)*reflen
            h(i) = h(i)*reflen
            do j = 1,my
               x(i,j) = x(i,j)*reflen
            enddo
         enddo
      endif
c
      call pmesh
!      call matlab
      call save (ic)
!      if (iplot .eq. 1) call contour1
!      if (iplot .eq. 2) call contour2
c
c      call force
c
      call chart (iwrit)
c
      if (ibl .eq. 1) call blayer
c                                                                       
  501 format(a5)                                                        
  502 format(a60)                                                       
  503 format(1x,a60)                                                 
  504 format(8f10.6)                                                    
  505 format(1x,6f10.3)                                                 
  506 format(8i12)                                                   
c  507 format(1x,i5,e11.3,2(e11.3,i4,i3),f7.2,e11.3,i4,e11.3,i5)
  507 format(1x,i5,e11.3,2(e11.3,i4,i3),f7.2,e11.3,i4,e11.3,i5)
c  507 format(1x,i5,e11.3,2(e11.3,i4,i3),f7.2,e11.3,i4,e11.3,f5.3)
  508 format(8f12.3)                                              
  600 format(1h1)
c                                                                       
      stop                                                              
      end

        subroutine timer(return_time, initial_time)
         real, intent(in)  :: initial_time
        real,  intent(out) :: return_time
        integer finish,rate
        CALL system_clock( COUNT=finish,COUNT_RATE=rate)
        return_time = FLOAT(finish) / FLOAT(rate) - initial_time
        end subroutine


