c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine mesh0
c                                                                       
c read mesh for analysis mode
c
      include 'dimpar.inc'
      include 'common.inc'
c
c read mesh from unit 3
c
      read (3,*) mx,my,ile,ite
      do 1 i=1,mx
      do 1 j=1,my
    1 read (3,*) x(i,j),y(i,j)
c
c NORMALIZING
c
      if (reflen .gt. 0.) then
c
      do j = 1,my
         do i = 1,mx
            x(i,j) = x(i,j)/reflen
         enddo
      enddo

      endif
c
      sc      = y(1,my)  -y(1,1)
      do 2 i=1,mx
      f(i)    = .5*(y(i,1)  +y(i,my)  -sc)
    2 t(i)    = y(i,1)  -y(i,my)  +sc
c
      nx      = mx  -1
      ny      = my  -1
c
c coarsening mesh
c
      if (imesh .ne. 1) then
c
      i            = 0
      do 10 ii=1,mx,imesh
      i            = i  +1
      j            = 0
      do 10 jj=1,my,imesh
      j            = j  +1
      x(i,j)       = x(ii,jj)
   10 y(i,j)       = y(ii,jj)
c
      mx           = (mx  -1)/imesh  +1
      my           = (my  -1)/imesh  +1
      nx           = mx  -1
      ny           = my  -1
      ile          = (ile  -1)/imesh  +1
      ite          = (ite  -1)/imesh  +1
      else
      endif
c                                                                       
      return                                                            
      end                                                               
c                                                                       
c ----------------------------------------------------------------------
c
!       subroutine mesh1(x,y,ile,ite,imid,xle,xte,expy,expx,
!     $ xmax,xmin
!     $  , dx,mx,my,sc)

	subroutine mesh1
c                                                                       
c read mesh for design mode
c
      include 'dimpar.inc'
      include 'common.inc'
	
	

c
c generate nodal x mesh
c
c within bladed region
c
      imid      = (ile +ite)/2
      mm        = imid -ile +1
c
      x(1,1)    = xmin
      x(ile,1)  = xle
      x(ite,1)  = xte
      x(imid,1) = .5*(x(ile,1) +x(ite,1))
      x(mx,1)   = xmax
c
      dx1       = (x(imid,1) -x(ile,1))*(expx -1.)
      dx1       = dx1/(expx**(mm-1) -1.)

      dx     = dx1
      do i = ile+1,imid-1
	x(i,1) = x(i-1,1) + dx
	dx     = dx*expx
      enddo

      dx     = dx1
      do i = ite-1,imid+1,-1
	x(i,1) = x(i+1,1) - dx
	dx     = dx*expx
      enddo
c
c upstream region
c

      mm = ile
      dxu = x(ile,1) -x(1,1)
      halfc = x(imid,1) -x(ile,1)
      sexpua = 1.001
      sexpub = expx*dxu/halfc
	
c
c check if bounds are OK
c
 500  dxuc      = dx1*(sexpub**(mm-1) -1.)/(sexpub -1.)
      if (dxuc .le. dxu) then 
      sexpub    = sexpub + .1
      goto 500
      endif
      
      
      
      call bisection(dxu,dx1,sexpua,sexpub,sexpuc,mm)

	
      dx   = dx1
      do i = ile-1,1+1,-1
	x(i,1) = x(i+1,1) - dx
	dx     = dx*sexpuc
      enddo
	
c
c downstream region
c
      mm = mx -ite +1
      dxd = x(mx,1) -x(ite,1)
      halfc = x(imid,1) -x(ile,1)
      sexpua = 1.001
      sexpub = expx*dxd/halfc
	
c
c check if bounds are OK
c

 600  dxdc      = dx1*(sexpub**(real(mm-1)) -1.)/(sexpub -1.)
      if (dxdc .le. dxd) then 
      sexpub    = sexpub + .1
      goto 600
      endif

      call bisection(dxd,dx1,sexpua,sexpub,sexpuc,mm)

	
      dx   = dx1
      do i = ite+1,mx-1
	x(i,1) = x(i-1,1) + dx
	dx     = dx*sexpuc
      enddo
c 
      do 40 j=2,my
      do 40 i=1,mx
   40 x(i,j)    = x(i,1)
c
c generate nodal y mesh
c
      jmid       = (1 + my)/2
      mm         = jmid

      ymin       = 0.
      ymax       = sc
      ymid       = sc/2.

      dy1       = (ymid -ymin)*(expy -1.)
      dy1       = dy1/(expy**(mm-1) -1.)

      sfy(1)    = ymin
      sfy(jmid) = ymid
      sfy(my)   = ymax

      dy     = dy1
      do j = 2,jmid-1
	sfy(j) = sfy(j-1) + dy
	dy     = dy*expy
      enddo

      dy     = dy1
      do j = my-1,jmid+1,-1
	sfy(j) = sfy(j+1) - dy
	dy     = dy*expy
      enddo
c
c
c coarsening mesh
c
      if (imesh .ne. 1) then
c
      i            = 0
      do 60 ii=1,mx,imesh
      i            = i  +1
      j            = 0
      do 60 jj=1,my,imesh
      j            = j  +1
 60   x(i,j)       = x(ii,jj)
c
      j            = 0
      do 70 jj=1,my,imesh
      j            = j  +1
 70   sfy(j)       = sfy(jj)
c
      mx           = (mx  -1)/imesh  +1
      my           = (my  -1)/imesh  +1
      nx           = mx  -1
      ny           = my  -1
      ile          = (ile  -1)/imesh  +1
      ite          = (ite  -1)/imesh  +1
      else
      endif

c

      return	
      end
c
c ***********************************************************
c
	subroutine bisection (wanted,stepmin,aaa,bbb,ccc,m)

        Real wanted,stepmin,aaa,bbb,ccc
	Integer m
	Real mm
	icounter = 0
	allow = .001

	
 650	ccc   = .5*(aaa +bbb)
	mm=real(m)
	
	func  = stepmin*(ccc**(mm -1) -1.)/(ccc -1.)

	if ( abs(func -wanted) .le. allow ) goto 700

	if ( (func -wanted) .lt. 0.) then
	aaa   = ccc
	else
	bbb   = ccc
	endif
	icounter = icounter + 1
	if( icounter .gt. 100) then 
	print*,' eps guess does not seem to be converging '
	print*,'latest error =', func-wanted, 'for ccc =',ccc 
	stop
	else	
	goto 650
	endif
	
 700    continue

        return
	end
c
c ***********************************************************
c
c
c ----------------------------------------------------------------------
c                                                                       
      subroutine mesh2
c                                                                       
c read mesh for design mode
c
      include 'dimpar.inc'
      include 'common.inc'
c
c generate nodal x mesh
c
      x(1,1)    = xmin                                                  
      x(ile,1)  = 0.                                                    
      x(ite,1)  = 1.                                                    
      x(mx,1)   = xmax                                                  
      dxmin     = expx*(x(ite,1)  -x(ile,1))
c                                                                       
      xa        = x(1,1)                                                
      xb        = x(ile,1)                                              
      delxx     = 1./float(ile  -1)                                     
      xpb       = dxmin/delxx                      
      xx        = 0.                                                
      do 10 i=2,ile-1                                                   
      xx        = xx  +delxx                                            
   10 x(i,1)    = xa  +(xb  -xa)*xx  -(xpb  -xb  +xa)*sin(pi*xx)/pi     
c                                                                       
      xa        = x(ile,1)                                              
      xb        = x(ite,1)                                              
      delxx     = 1./float(ite - ile)
      xp        = dxmin/delxx                      
      xx        = 0.
      do 20 i=ile+1,ite-1                                               
      xx        = xx + delxx                                            
   20 x(i,1)    = xa + xp*xx                                            
     &               + (xb - xa - xp)*(10. - 15.*xx + 6.*xx*xx)*xx*xx*xx
c                                                                       
      xa        = x(ite,1)                                              
      xb        = x(mx,1)                                             
      delxx     = 1./float(mx  -ite)                                    
      xpa       = dxmin/delxx                      
      xx        = 0.                                                    
      do 30 i=ite+1,nx                                                  
      xx        = xx + delxx                                            
   30 x(i,1)    = xa + (xb - xa)*xx + (xpa - xb + xa)*sin(pi*xx)/pi     
c
      do 40 j=2,my
      do 40 i=1,mx
   40 x(i,j)    = x(i,1)
c
c generate nodal y mesh
c
      ymin       = 0.
      ymax       = sc
      dymin      = expy*(ymax  -ymin)
c                                                                       
      ya         = ymin                                              
      yb         = ymax                                              
      delyy      = 1./float(ny)
      yp         = dymin/delyy                      
      yy         = -delyy                                          
      do 50 j=1,my
      yy         = yy  +delyy                                            
   50 sfy(j)     = ya  +yp*yy                                            
     &            +(yb -ya -yp)*(10. -15.*yy +6.*yy*yy)*yy*yy*yy
c
c search for minimum dx
c
      j             = 1
      dxmin         = 1.0E+20
      do 100 i=2,mx
      dx            = x(i,j)  -x(i-1,j)
      if (dx .lt. dxmin) dxmin = dx
  100 continue
      write (6,*) ' '
      write (6,*) 'dxmin = ',dxmin
c
c search for minimum dy
c
      dymin         = 1.0E+20
      do 110 j=2,my
      dy            = sfy(j)  -sfy(j-1)
      if (dy .lt. dymin) dymin = dy
  110 continue
      write (6,*) ' '
      write (6,*) 'dymin = ',dymin
c
c coarsening mesh
c
      if (imesh .ne. 1) then
c
      i            = 0
      do 200 ii=1,mx,imesh
      i            = i  +1
      j            = 0
      do 200 jj=1,my,imesh
      j            = j  +1
  200 x(i,j)       = x(ii,jj)
c
      j            = 0
      do 210 jj=1,my,imesh
      j            = j  +1
  210 sfy(j)       = sfy(jj)
c
      mx           = (mx  -1)/imesh  +1
      my           = (my  -1)/imesh  +1
      nx           = mx  -1
      ny           = my  -1
      ile          = (ile  -1)/imesh  +1
      ite          = (ite  -1)/imesh  +1
      else
      endif
c                                                                       
      return                                                            
      end                                                               
