c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine prandtl
c                                                                       
c update prandtl mixing length 
c
      include 'dimpar.inc'
      include 'common.inc'
c ****************
c calculating viscous terms along constant i faces for INNER POINTS
c and PERIODIC BOUNDARY POINTS
c ****************
c
      pfactor = 1.0   ! note keep less than 2
c      blfactor= 2.
      blfactor= 1.    ! original
      Ao      = 26.
c
      do j = 1,my
            prlni(1,j)  = .041*sc*r(1)*pfactor*blfactor
      enddo
c
      do j = 1,my
         do i = 2,mx
            prlni(i,j) = .041*sc*r(i)*pfactor*blfactor
            prlnj(i,j) = .041*sc*.5*(r(i) +r(i-1))*pfactor
     &                    *blfactor
         enddo
      enddo
c
      do j = 1,my,my-1
         do i = ile+1,ite
            prlnj(i,j) = 0.0
         enddo
      enddo
c
c
c FIND THE  I  INDICES  FOR 5%, 95% DISTANCE IN THE CHORD
c
      xchord = x(ite,1) -x(ile,1)
      dx5  = .05*xchord
      dx95 = .95*xchord
      do i = ile,ite 
         dx = x(i,1) -x(ile,1)
         if (abs(dx -dx5) .lt. .01*xchord) then 
            ivle = i
         endif
         if (abs(dx -dx95) .lt. .01*xchord) then 
            ivte = i
         endif
      enddo
c
c FIND THE  I  INDICES  FOR 10% DISTANCE FROM LE AND TE
c
      xupstream    = x(ile,1) -x(1,1)
      xdownstream  = x(mx,1) -x(ite,1)
      dxup10       = .1*xupstream
      dxdown10     = .1*xdownstream
c      dxup10       = .2*xupstream
c      dxdown10     = .2*xdownstream
      do i = ile,1,-1
         dx = x(ile,1) -x(i,1)
         if (abs(dx -dxup10) .lt. .01*xupstream) then
            ivup  = i
         endif
      enddo
      do i = ite,mx
         dx = x(i,1) -x(ite,1)
         if (abs(dx -dxdown10) .lt. .01*xdownstream) then
            ivdown  = i
         endif
      enddo
c
c
c inside bladed region
c
c finding out the boundary layer spread (10% to 20% of spacing)
c
      jmid = (my+1)/2
      scle =abs(y(ile,my) -y(ile,1))
      do j = 2,jmid
         jp = j
         ydist = abs(y(ile,j) -y(ile,1))
         if ( ydist .gt. .1*blfactor*scle ) then 
            goto 20
         else
         endif
      enddo
 20   continue
      
      jm  = my -jp+1
c
c for prlnj
c
      do i = ivle+1,ivte
         dydx  = .5*(r(i) +r(i-1))*(y(i,1) -y(i-1,1))
     &             /(x(i,1) -x(i-1,1)) 
         cosang = 1./sqrt(1. + dydx**2)
         do j = 2,jp
            ydistj = abs( .5*(y(i,j) +y(i-1,j) -y(i,1) -y(i-1,1)) )
            ydistj = ydistj*cosang
c            rho    = .5*(q(1,i,j) +q(1,i,j+1))
c            vstar  = sqrt(abs(tauwp(i)/rho))
c            yplus  = ydistj*vstar/xnugas
            prlnj(i,j) = .41*ydistj*.5*(r(i) +r(i-1))*pfactor
c            prlnj(i,j) = prlnj(i,j)*(1. -exp(-yplus/Ao))
         enddo
c
         dydx  = .5*(r(i) +r(i-1))*(y(i,my) -y(i-1,my))
     &             /(x(i,my) -x(i-1,my)) 
         cosang = 1./sqrt(1. + dydx**2)
         do j = my-1,jm,-1
            ydistj = abs( .5*(y(i,j) +y(i-1,j) -y(i,my) -y(i-1,my)) )
            ydistj = ydistj*cosang
c            rho    = .5*(q(1,i,j) +q(1,i,j+1))
c            vstar  = sqrt(abs(tauwm(i)/rho))
c            yplus  = ydistj*vstar/xnugas
            prlnj(i,j) = .41*ydistj*.5*(r(i) +r(i-1))*pfactor
c            prlnj(i,j) = prlnj(i,j)*(1. -exp(-yplus/Ao))
         enddo
         
         dpr = prlnj(i,jm) -prlnj(i,jp)
         
         do j = jp+1,jm-1
            prlnj(i,j) = prlnj(i,jp) 
     &                   +dpr*float(j-jp)/float(jm -jp)
         enddo
      enddo
c
c for prlni
c
      do i = ivle,ivte
         dydx  = r(i)*(y(i,1) -y(i-1,1))
     &             /(x(i,1) -x(i-1,1)) 
         cosang = 1./sqrt(1. + dydx**2)
         do j = 2,jp
            ydisti = abs( .5*(y(i,j) +y(i,j-1)) -y(i,1) )
            ydisti = ydisti*cosang
c            rho    = .5*(q(1,i,j) +q(1,i+1,j))
c            vstar  = sqrt(abs(.5*(tauwp(i)+ tauwp(i+1))/rho))
c            yplus  = ydistj*vstar/xnugas
            prlni(i,j) = .41*ydisti*r(i)*pfactor
c            prlni(i,j) = prlni(i,j)*(1. -exp(-yplus/Ao))            
         enddo
c
         dydx  = r(i)*(y(i,my) -y(i-1,my))
     &             /(x(i,my) -x(i-1,my)) 
         cosang = 1./sqrt(1. + dydx**2)
         do j = my,jm+1,-1
            ydisti = abs( .5*(y(i,j) +y(i,j-1)) -y(i,my) )
            ydisti = ydisti*cosang
c            rho    = .5*(q(1,i,j) +q(1,i+1,j))
c            vstar  = sqrt(abs(.5*(tauwm(i)+ tauwm(i+1))/rho))
c            yplus  = ydistj*vstar/xnugas
            prlni(i,j) = .41*ydisti*r(i)*pfactor
c            prlni(i,j) = prlni(i,j)*(1. -exp(-yplus/Ao))            
         enddo

         dpr = prlni(i,jm+1) -prlnj(i,jp)
         
         do j = jp+1,jm
            prlni(i,j) = prlni(i,jp) 
     &                   +dpr*float(j-jp)/float(jm+1 -jp)
         enddo

      enddo
c
c EXTRAPOLATING TO THE LEADING AND TRAILING EDGES WITHIN THE 
c BLADED REGION
c
c prlnj
c
      do j = 1,my
         do i = ile+1,ivle
            prlnj(i,j) = prlnj(ivle+1,j)
         enddo
         do i = ivte+1,ite
            prlnj(i,j) = prlnj(ivte,j)
         enddo
      enddo
c
c prlni
c
      do j = 2,my
         do i = ile,ivle-1
            prlni(i,j) = prlni(ivle,j)
         enddo
         do i = ivte+1,ite
            prlni(i,j) = prlni(ivte,j)
         enddo
      enddo
c
c
c outside bladed region
c
c before leading edge
c
c for prlnj
c
c      iup  = 3*(ile -1)/4
      do j = 1,my
         dprj = prlnj(ivup-1,j) -prlnj(ile+1,j)
         do i = ivup,ile
         prlnj(i,j) = prlnj(ivup-1,j) 
     &               -dprj*float(i -ivup)/float(ile+1-ivup)
         enddo
      enddo
c
c for prlni
c
      do j = 2,my
         dpri = prlni(ivup-1,j) -prlni(ile,j)
         do i = ivup,ile-1
            prlni(i,j) = prlni(ivup-1,j) 
     &                  -dpri*float(i -ivup)/float(ile -ivup)
         enddo
      enddo
c
c
c after trailing edge
c
c
c for prlnj
c
      do i = ite+1,mx
         do j = 3,my-2
            prlnj(i,j) =  prlnj(ite,j)
         enddo
         prlnj(i,2)    = prlnj(i,3) 
         prlnj(i,my-1) = prlnj(i,my-2)
         prlnj(i,1)    = .5*(prlnj(i,2) +prlnj(i,my-1))
         prlnj(i,my)   = prlnj(i,1)
      enddo
c
c for prlni
c
      do i = ite+1,mx
         do j = 3,my-1
            prlni(i,j) =  prlni(ite,j)
         enddo
         prlni(i,2)    = .5*(prlni(i,3) +prlni(i,my-1))
         prlni(i,my)   = prlni(i,2)
      enddo
c
      return
      end

