c     
c ----------------------------------------------------------------------
c     
      subroutine setup
c
c setup input data
c
      include 'dimpar.inc'
      include 'common.inc'
c
c generate pitchwise variations in stagnation pressure and temperature
c
     

      if (idesign .eq. 0) then
      y1            = y(1,1)
      do 10 j=2,my
      yc            = (.5*(y(1,j)  +y(1,j-1))  -y1)/sc
      pstagn(j)     = 1.  +delp0*cos(2.*pi*yc)
   10 tstagn(j)     = 1.  +delt0*cos(2.*pi*yc)
      else
      sfy1          = sfy(1)
      do 20 j=2,my
      sfyc          = (.5*(sfy(j)  +sfy(j-1))  -sfy1)/sc
      pstagn(j)     = 1.  +delp0*cos(2.*pi*sfyc)
   20 tstagn(j)     = 1.  +delt0*cos(2.*pi*sfyc)
      endif
      pstagn(1)     = pstagn(my)
      pstagn(my+1)  = pstagn(2)
      tstagn(1)     = tstagn(my)
      tstagn(my+1)  = tstagn(2)
c
c      if (idesign .eq. 0) return
      if (idesign .eq. 0) then
         goto 265
      else
      endif
c
c set up blade thickness for inverse calculation
c
      do 100 n=1,npthick
      x1(n)     = xthick(n)
  100 f1(n)     = ythick(n)
      call diff(npthick,0)
      i         = 0
      do 110 ii=ile,ite
      i         = i + 1
  110 x2(i)     = x(ii,1)
      nnp       = i
      call interp(npthick,nnp)
      f2max     = -999.
      do 120 n=1,nnp
      if (f2(n) .gt. f2max) f2max = f2(n)
  120 continue
      do 150 i=1,ile
  150 t(i)      = 0.
      n         = 1
      do 151 i=ile+1,ite-1
      n         = n  +1
  151 t(i)      = sc*(tmax*f2(n)/f2max)
      do 152 i=ite,mx
  152 t(i)      = 0.
c
c set up loading shape for inverse calculation
c
      do 200 n=1,npload
      x1(n)     = xload(n)
  200 f1(n)     = yload(n)
      call diff(npload,0)
      i         = 0
      do 210 ii=ile,ite
      i         = i + 1
  210 x2(i)     = x(ii,1)
      nnp       = i
      call interp(npload,nnp)
      do 220 i=1,ile-1
  220 fp2(i)    = 0.
      ii        = 0
      do 230 i=ile,ite-1
      ii        = ii + 1
  230 fp2(i)    = f2(ii)
      do 240 i=ite,nx+1
  240 fp2(i)    = 0.
      fload(ile) = 0.
      do 250 i=ile+1,ite
      dx         = x(i,1) - x(i-1,1)
  250 fload(i)   = fload(i-1) + .5*(fp2(i) + fp2(i-1))*dx
c
c setup STREAMTUBE parameters
c
c Radial Location
c
 265     if (irad .eq. 1) then
         do 270 n=1,nprad
            x1(n)     = xrad(n)
 270        f1(n)     = rr(n)
            write(6,*) maxval(x1),maxval(f1)
         call diff(nprad,0)
         i         = 0
         do 280 ii=1,mx
            i         = i + 1
 280        x2(i)     = x(ii,1)
         nnp       = i
         call interp(nprad,nnp)
         ii        = 0
         do 290 i=1,mx
            ii        = ii + 1
 290        r(i)    = f2(ii)
      else
      endif
c
c Conserving R*V_theta to the inlet boundary
c
      tgam1       = (gam  -1.)/gam
      tgam2       = .5*(gam  -1.)
      sin1        = sin(pi*beta1/180.)
c
      temp        = 1./(1. + tgam2*fmach*fmach)
      vabs        = sqrt((1. -temp)*2./tgam1)
      vthetale    = vabs*sin1
c      print*, vabs,tgam1,tgam2,sin1,fmach,temp
      vtheta1     = r(ile)*vthetale/r(1)
      
c      print*,r(ile),vthetale,r(1)
c
c Stream-tube Thickness
c
      if (ih .eq. 1) then
         do 300 n=1,nph
            x1(n)     = xh(n)
 300        f1(n)     = hh(n)
         call diff(nph,0)
         i         = 0
         do 310 ii=1,mx
            i         = i + 1
 310        x2(i)     = x(ii,1)
         nnp       = i
         call interp(nph,nnp)
         ii        = 0
         do 320 i=1,mx
            ii        = ii + 1
 320        h(i)    = f2(ii)
      else
      endif
c
c defining a new variable rhfload(ile : ite) and using values
c rhfload(ile+1 : ite)
c
      rhfload(ile) = 0.
      do 330 i=ile+1,ite
         dx         = x(i,1) -x(i-1,1)
 330     rhfload(i) = rhfload(i-1) +.5*(r(i)*h(i)*fp2(i) +
     &                r(i-1)*h(i-1)*fp2(i-1))*dx
c         rav        = .5*(r(i) + r(i-1))
c         hav        = .5*(h(i) + h(i-1))
c 330     rhfload(i) = rhfload(i-1) +.5*(fp2(i) +
c     &                fp2(i-1))*dx*rav*hav
c
c
      if (idelp .gt. 0) then
         if (idelp .eq. 2) then
            ii = ile
            do n = 1,npload
               ii = ii +1
               delpin(ii) = yload(n)
            enddo
            idelp = 1
         else
            do i = ile+1,ite
               delpin(i) = .5*(fload(i) + fload(i-1))
            enddo
         endif
      endif
c
      return                                                            
      end                                                               
