c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine step 
c                                                                       
c compute time step size
c                                                                       
      include 'dimpar.inc'
      include 'common.inc'
c
c compute local time step and (dt)min                                   
c                                                                       
      dtime        = 999.                                               
c
c flow region
c
c Inviscid timestep
c
      if (vflag .eq. 0.) then
c
!HPF$ INDEPENDENT,NEW(i)
      do 10 j=2,my      
!HPF$ INDEPENDENT,NEW(xx,xy,yx,yy,vol,rho,u,v,et,p,cc,qs,sxa,cs,xlamda,
     & sya,ylamda)
      do 10 i=2,mx
      xx           = .5*(x(i,j)  -x(i-1,j)  +x(i,j-1)  -x(i-1,j-1))
      xy           = .5*(x(i,j)  +x(i-1,j)  -x(i,j-1)  -x(i-1,j-1))
c
      yx           = .5*(y(i,j)*r(i)  -y(i-1,j)*r(i-1)  +y(i,j-1)*r(i)
     &                -y(i-1,j-1)*r(i-1))
      yy           = .5*(y(i,j)*r(i)  +y(i-1,j)*r(i-1)  -y(i,j-1)*r(i)
     &                -y(i-1,j-1)*r(i-1))
      vol          = .5*((x(i,j)  -x(i-1,j-1))*(y(i-1,j)*r(i-1) 
     &               -y(i,j-1)*r(i))
     &               -(y(i,j)*r(i)  -y(i-1,j-1)*r(i-1))*(x(i-1,j)  
     &               -x(i,j-1)))
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(r(i)*omega)**2))
      cc           = gam*p/rho
      qs           = yy*u  -xy*v
      sxa          = sqrt(xy**2  +yy**2)
      cs           = sqrt(cc) *sxa
      xlamda       = abs(qs) +abs(cs)
c
      qs           = xx*v  -yx*u
      sya          = sqrt(xx**2  +yx**2)
      cs           = sqrt(cc) * sya
      ylamda       = abs(qs) +abs(cs)
c
c inviscid
  
c
   10  dt(i,j)      = cfl*vol/(xlamda +ylamda)
  
	dtime=minval(dt(2:mx,2:my))
c
      else
c
c Viscous timestep
c
      do 20 j=2,my                                                    
      do 20 i=2,mx
      xx           = .5*(x(i,j)  -x(i-1,j)  +x(i,j-1)  -x(i-1,j-1))
      xy           = .5*(x(i,j)  +x(i-1,j)  -x(i,j-1)  -x(i-1,j-1))
c
      yx           = .5*(y(i,j)*r(i)  -y(i-1,j)*r(i-1)  +y(i,j-1)*r(i)
     &                -y(i-1,j-1)*r(i-1))
      yy           = .5*(y(i,j)*r(i)  +y(i-1,j)*r(i-1)  -y(i,j-1)*r(i)
     &                -y(i-1,j-1)*r(i-1))
      vol          = .5*((x(i,j)  -x(i-1,j-1))*(y(i-1,j)*r(i-1) 
     &               -y(i,j-1)*r(i))
     &               -(y(i,j)*r(i)  -y(i-1,j-1)*r(i-1))*(x(i-1,j)  
     &               -x(i,j-1)))
      rho          = q(1,i,j)
      u            = q(2,i,j)/q(1,i,j)
      v            = q(3,i,j)/q(1,i,j)
      et           = q(4,i,j)
      p            = (gam  -1.)*(et  -.5*rho*(u*u  +v*v 
     &               -(r(i)*omega)**2))
      cc           = gam*p/rho
      qs           = yy*u  -xy*v
      sxa          = sqrt(xy**2  +yy**2)
      cs           = sqrt(cc) *sxa
      xlamda       = abs(qs) +abs(cs)
c
      qs           = xx*v  -yx*u
      sya          = sqrt(xx**2  +yx**2)
      cs           = sqrt(cc) * sya
      ylamda       = abs(qs) +abs(cs)
c
      xnu          = xnugas 
      xnu          = xnu +.25*(xnuturbi(i,j) +xnuturbi(i-1,j)
     &               +xnuturbj(i,j) +xnuturbj(i,j-1))
c viscous
      dt(i,j)      = cfl*vol/((xlamda +ylamda) 
     &               +2.*gam*xnu*(sxa*sxa +sya*sya)/vol)
c
   20 if (dt(i,j) .lt. dtime) dtime = dt(i,j)                             
c
      endif
c
c
      if (imode .eq. 0) then
      do 30 j=2,my
      do 30 i=2,mx
   30 dt(i,j)      = dtime
      else
      endif
c                                                                       
      return                                                            
      end                                                               
