c                                                                       
c ----------------------------------------------------------------------
c                                                                       
      subroutine viscous(resavg)
c                                                                       
c calculating viscous stresses - space-centered scheme
c
      include 'dimpar.inc'
      include 'common.inc'
c
      dimension vor(4),strain(4),strainmm(4),straintt(4),strainnn(4)
c
      convergence = 1.e-2
c      cffactor    = 3.5
      cffactor    = 1.  ! original
c
c ****************
c calculating viscous terms along constant i faces for INNER POINTS
c and PERIODIC BOUNDARY POINTS
c ****************
      do 1 j = 2,my
      do 1 i = 2,mx-1
c
         if ( (j .eq. 2) .or. (j .eq. my) ) then
            if ( (i .ge. ile) .and. (i .le. ite) ) goto 1
         else
         endif
c
c cell abcd (i,j)
c
      dxab        = x(i,j-1)  -x(i-1,j-1)
      dyab        = .5*(r(i) +r(i-1))*(y(i,j-1) -y(i-1,j-1))
c      dyab        = (y(i,j-1) -y(i-1,j-1))
      dxbc        = x(i,j)  -x(i,j-1)
      dybc        = y(i,j)*r(i) -y(i,j-1)*r(i)
      dxcd        = x(i-1,j)  -x(i,j)
      dycd        = .5*(r(i) +r(i-1))*(y(i-1,j) -y(i,j))
c      dycd        = (y(i-1,j) -y(i,j))
      dxda        = x(i-1,j-1)  -x(i-1,j)
      dyda        = y(i-1,j-1)*r(i-1)  -y(i-1,j)*r(i-1)
c
      dlab        = sqrt(dxab*dxab  +dyab*dyab)
      dlbc        = sqrt(dxbc*dxbc  +dybc*dybc)
      dlcd        = sqrt(dxcd*dxcd  +dycd*dycd)
      dlda        = sqrt(dxda*dxda  +dyda*dyda)
c
      dxdb        = x(i,j-1)  -x(i-1,j)
      dydb        = y(i,j-1)*r(i)  -y(i-1,j)*r(i-1)
      dxac        = x(i,j)  -x(i-1,j-1)
      dyac        = y(i,j)*r(i)  -y(i-1,j-1)*r(i-1)
      area        = .5*abs(dxdb*dyac  -dxac*dydb)
      hav         = .5*(h(i) +h(i-1))
      volabcd     = hav*area
c
c cell bfec (i+1,j)
c
      dxbf        = x(i+1,j-1)  -x(i,j-1)
      dybf        = .5*(r(i+1) +r(i))*(y(i+1,j-1) -y(i,j-1))
      dxfe        = x(i+1,j)  -x(i+1,j-1)
      dyfe        = y(i+1,j)*r(i+1) -y(i+1,j-1)*r(i+1)
      dxec        = x(i,j)  -x(i+1,j)
      dyec        = .5*(r(i+1) +r(i))*(y(i,j) -y(i+1,j))
      dxcb        = x(i,j-1)  -x(i,j)
      dycb        = y(i,j-1)*r(i)  -y(i,j)*r(i)
c
      dlbf        = sqrt(dxbf*dxbf  +dybf*dybf)
      dlfe        = sqrt(dxfe*dxfe  +dyfe*dyfe)
      dlec        = sqrt(dxec*dxec  +dyec*dyec)
      dlcb        = sqrt(dxcb*dxcb  +dycb*dycb)
c
      dxcf        = x(i+1,j-1)  -x(i,j)
      dycf        = y(i+1,j-1)*r(i+1)  -y(i,j)*r(i)
      dxbe        = x(i+1,j)  -x(i,j-1)
      dybe        = y(i+1,j)*r(i+1)  -y(i,j-1)*r(i)
      area        = .5*abs(dxcf*dybe  -dxbe*dycf)
      hav         = .5*(h(i+1) +h(i))
      volbfec     = hav*area
c
      vol         = .5*(volabcd +volbfec)
c
      vab         = .25*( q(3,i,j)/q(1,i,j) +q(3,i+1,j)/q(1,i+1,j) 
     &              +q(3,i,j-1)/q(1,i,j-1) +q(3,i+1,j-1)/q(1,i+1,j-1))
      vbc         = q(3,i+1,j)/q(1,i+1,j)
      vcd         = .25*( q(3,i,j)/q(1,i,j) +q(3,i+1,j)/q(1,i+1,j) 
     &              +q(3,i,j+1)/q(1,i,j+1) +q(3,i+1,j+1)/q(1,i+1,j+1))
      vda         = q(3,i,j)/q(1,i,j)
c
      uab         = .25*( q(2,i,j)/q(1,i,j) +q(2,i+1,j)/q(1,i+1,j) 
     &              +q(2,i,j-1)/q(1,i,j-1) +q(2,i+1,j-1)/q(1,i+1,j-1))
      ubc         = q(2,i+1,j)/q(1,i+1,j)
      ucd         = .25*( q(2,i,j)/q(1,i,j) +q(2,i+1,j)/q(1,i+1,j) 
     &              +q(2,i,j+1)/q(1,i,j+1) +q(2,i+1,j+1)/q(1,i+1,j+1))
      uda         = q(2,i,j)/q(1,i,j)
c
      rhoav       = .5*(q(1,i+1,j) +q(1,i,j))
c
c
c ____________
c
      dhdm        = (h(i+1) -h(i-1))/(.5*( x(i+1,j) +x(i+1,j-1) 
     &                                    -x(i-1,j) -x(i-1,j-1)))
c
      fluxtuab     = uab*h(i)*.5*(dxab +dxbf)
      fluxtubc     = ubc*.5*(h(i)*dxbc +h(i+1)*dxfe)
      fluxtucd     = ucd*h(i)*.5*(dxcd +dxec)
      fluxtuda     = uda*.5*(h(i-1)*dxda +h(i)*dxcb)
c
c ____________
c
      if (resavg .gt. convergence) then
c
      vabsab      = .25*( q(3,i,j)/q(1,i,j) +q(3,i+1,j)/q(1,i+1,j) 
     &              +q(3,i,j-1)/q(1,i,j-1) +q(3,i+1,j-1)/q(1,i+1,j-1))
     &              + r(i)*omega
      vabsbc      = (q(3,i+1,j)/q(1,i+1,j)) +.5*(r(i) +r(i+1))*omega
      vabscd      = .25*( q(3,i,j)/q(1,i,j) +q(3,i+1,j)/q(1,i+1,j) 
     &              +q(3,i,j+1)/q(1,i,j+1) +q(3,i+1,j+1)/q(1,i+1,j+1))
     &              + r(i)*omega
      vabsda      = (q(3,i,j)/q(1,i,j)) +.5*(r(i) +r(i-1))*omega
c
      fluxmabsab  = vabsab*h(i)*.5*(dyab +dybf)
      fluxmabsbc  = vabsbc*.5*(h(i)*dybc +h(i+1)*dyfe)
      fluxmabscd  = vabscd*h(i)*.5*(dycd +dyec)
      fluxmabsda  = vabsda*.5*(h(i-1)*dyda +h(i)*dycb)
c
c
c calculating turbulent viscocity
c
      vormag      =abs((fluxmabsab +fluxmabsbc +fluxmabscd +fluxmabsda  
     &                  +(fluxtuab +fluxtubc +fluxtucd +fluxtuda))/vol 
     &                -.5*(vabsbc +vabsda)*dhdm/h(i) )
      xnuturbi(i,j) = prlni(i,j)*prlni(i,j)*vormag
c
      endif
c
c finding the effective viscocity
c
c ____________
 1    continue
c
c ****************
c calculating viscous terms along constant j faces for INNER POINTS
c ****************
      do 11 j = 2,my-1
      do 11 i = 2,mx
c
c cell abcd (i,j)
c
      dxab        = x(i,j-1)  -x(i-1,j-1)
      dyab        = .5*(r(i) +r(i-1))*(y(i,j-1) -y(i-1,j-1))
c      dyab        = (y(i,j-1) -y(i-1,j-1))
      dxbc        = x(i,j)  -x(i,j-1)
      dybc        = y(i,j)*r(i) -y(i,j-1)*r(i)
      dxcd        = x(i-1,j)  -x(i,j)
      dycd        = .5*(r(i) +r(i-1))*(y(i-1,j) -y(i,j))
c      dycd        = (y(i-1,j) -y(i,j))
      dxda        = x(i-1,j-1)  -x(i-1,j)
      dyda        = y(i-1,j-1)*r(i-1)  -y(i-1,j)*r(i-1)
c
      dlab        = sqrt(dxab*dxab  +dyab*dyab)
      dlbc        = sqrt(dxbc*dxbc  +dybc*dybc)
      dlcd        = sqrt(dxcd*dxcd  +dycd*dycd)
      dlda        = sqrt(dxda*dxda  +dyda*dyda)
c
      dxdb        = x(i,j-1)  -x(i-1,j)
      dydb        = y(i,j-1)*r(i)  -y(i-1,j)*r(i-1)
      dxac        = x(i,j)  -x(i-1,j-1)
      dyac        = y(i,j)*r(i)  -y(i-1,j-1)*r(i-1)
      area        = .5*abs(dxdb*dyac  -dxac*dydb)
      hav         = .5*(h(i) +h(i-1))
      volabcd     = hav*area
c
c cell  dcfe bfec (i,j+1)
c
      dxdc        = x(i,j)  -x(i-1,j)
      dydc        = .5*(r(i) +r(i-1))*(y(i,j) -y(i-1,j))
      dxcf        = x(i,j+1)  -x(i,j)
      dycf        = y(i,j+1)*r(i) -y(i,j)*r(i)
      dxfe        = x(i-1,j+1)  -x(i,j+1)
      dyfe        = .5*(r(i) +r(i-1))*(y(i-1,j+1) -y(i,j+1))
      dxed        = x(i-1,j)  -x(i-1,j+1)
      dyed        = y(i-1,j)*r(i-1)  -y(i-1,j+1)*r(i-1)
c
      dlbf        = sqrt(dxbf*dxbf  +dybf*dybf)
      dlfe        = sqrt(dxfe*dxfe  +dyfe*dyfe)
      dlec        = sqrt(dxec*dxec  +dyec*dyec)
      dlcb        = sqrt(dxcb*dxcb  +dycb*dycb)
c
      dxec        = x(i,j)  -x(i-1,j+1)
      dyec        = y(i,j)*r(i)  -y(i-1,j+1)*r(i-1)
      dxdf        = x(i,j+1)  -x(i-1,j)
      dydf        = y(i,j+1)*r(i)  -y(i-1,j)*r(i-1)
      area        = .5*abs(dxec*dydf  -dxdf*dyec)
      hav         = .5*(h(i) +h(i-1))
      voldcfe     = hav*area
c
      vol         = .5*(volabcd +voldcfe)
c
      vab         = q(3,i,j)/q(1,i,j)
      vbc         = .25*( q(3,i,j)/q(1,i,j) +q(3,i,j+1)/q(1,i,j+1)
     &              +q(3,i+1,j)/q(1,i+1,j) +q(3,i+1,j+1)/q(1,i+1,j+1))
      vcd         = q(3,i,j+1)/q(1,i,j+1)
      vda         = .25*( q(3,i,j)/q(1,i,j) +q(3,i,j+1)/q(1,i,j+1) 
     &              +q(3,i-1,j)/q(1,i-1,j) +q(3,i-1,j+1)/q(1,i-1,j+1))
c
      uab         = q(2,i,j)/q(1,i,j)
      ubc         = .25*( q(2,i,j)/q(1,i,j) +q(2,i,j+1)/q(1,i,j+1)
     &              +q(2,i+1,j)/q(1,i+1,j) +q(2,i+1,j+1)/q(1,i+1,j+1))
      ucd         = q(2,i,j+1)/q(1,i,j+1)
      uda         = .25*( q(2,i,j)/q(1,i,j) +q(2,i,j+1)/q(1,i,j+1) 
     &              +q(2,i-1,j)/q(1,i-1,j) +q(2,i-1,j+1)/q(1,i-1,j+1))
c
      dhdm        = (h(i) -h(i-1))/(x(i,j) -x(i-1,j))
c
      rhoav       = .5*(q(1,i,j+1) +q(1,i,j))
c
c
      rab         = .5*(r(i) +r(i-1))
      rbc         = r(i) 
      rcd         = .5*(r(i) +r(i-1))
      rda         = r(i-1)
c
c ____________
c
c
      fluxtuab     = uab*.5*(h(i) +h(i-1))*.5*(dxab +dxdc)
      fluxtubc     = ubc*.5*h(i)*(dxbc +dxcf)
      fluxtucd     = ucd*.5*(h(i) +h(i-1))*.5*(dxcd +dxfe)
      fluxtuda     = uda*.5*h(i-1)*(dxda +dxed)
c
c ____________
c
      if (resavg .gt. convergence) then
c
      vabsab      = (q(3,i,j)/q(1,i,j)) +.5*(r(i) +r(i-1))*omega
      vabsbc      = .25*( q(3,i,j)/q(1,i,j) +q(3,i,j+1)/q(1,i,j+1)
     &              +q(3,i+1,j)/q(1,i+1,j) +q(3,i+1,j+1)/q(1,i+1,j+1))
     &              + r(i)*omega
      vabscd      = (q(3,i,j+1)/q(1,i,j+1)) +.5*(r(i) +r(i-1))*omega 
      vabsda      = .25*( q(3,i,j)/q(1,i,j) +q(3,i,j+1)/q(1,i,j+1) 
     &              +q(3,i-1,j)/q(1,i-1,j) +q(3,i-1,j+1)/q(1,i-1,j+1))
     &              + r(i-1)*omega
c
      fluxmabsab  = vabsab*.5*(h(i) +h(i-1))*.5*(dyab +dydc)
      fluxmabsbc  = vabsbc*.5*h(i)*(dybc +dycf)
      fluxmabscd  = vabscd*.5*(h(i) +h(i-1))*.5*(dycd +dyfe)
      fluxmabsda  = vabsda*.5*h(i-1)*(dyda +dyed)
c
c calculating turbulent viscocity
c
      vormag      =abs((fluxmabsab +fluxmabsbc +fluxmabscd +fluxmabsda  
     &                  +(fluxtuab +fluxtubc +fluxtucd +fluxtuda))/vol 
     &                -.5*(vabsab +vabscd)*dhdm/(.5*(h(i) +h(i-1))) )
c
      xnuturbj(i,j) = prlnj(i,j)*prlnj(i,j)*vormag
c
      endif
c
c finding the effective viscocity
c
      xmu         = rhoav*(xnugas +xnuturbj(i,j)) 
c
c ******* CALCULATING TAU ASSUMING GRID LINES AS STREAMLINES 
c
      u2    = q(2,i,j+1)/q(1,i,j+1)
      v2    = q(3,i,j+1)/q(1,i,j+1) +.5*(r(i-1) +r(i))*omega
      u1    = q(2,i,j)/q(1,i,j)
      v1    = q(3,i,j)/q(1,i,j) +.5*(r(i-1) +r(i))*omega

      sign2 = u2/abs(u2)
      sign1 = u1/abs(u1)
      q2    = sign2*sqrt(u2*u2 +v2*v2)
      q1    = sign1*sqrt(u1*u1 +v1*v1)
c      cos_a = (u1*u2 +v1*v2)/(q1*q2)
      qav   = sqrt(.25*((u1+u2)*(u1+u2) +(v1+v2)*(v1+v2))  )
      cos_a = .5*(u1 +u2)/(qav)
      rdy   = r(i)*y(i,j) -r(i-1)*y(i-1,j)
      dx    = x(i,j) -x(i-1,j)
      cos_b = dx/sqrt(dx*dx +rdy*rdy)

      ry2   = .25*( r(i-1)*(y(i-1,j) +y(i-1,j+1))  
     &             +r(i)*(y(i,j) +y(i,j+1)))
      ry1   = .25*( r(i-1)*(y(i-1,j) +y(i-1,j-1))  
     &             +r(i)*(y(i,j) +y(i,j-1)))
      dryn  = (ry2 -ry1)*cos_a

      taumtj(i,j) = xmu*(q2 -q1)/dryn*(cos_b/cos_a)

c      taumtj(i,j) = xmu*(-(fluxtuab +fluxtubc +fluxtucd +fluxtuda)
c     &             +fluxmvab +fluxmvbc +fluxmvcd +fluxmvda
c     &             +vbyrav*(fluxrab +fluxrbc +fluxrcd +fluxrda))/vol
c ____________
c
c
 11   continue
c
c ****************
c calculating viscous terms along constant j faces for BOUNDARY POINTS 
c ****************
c ****************
c BLADED REGION
c ****************
      do 12 i = ile +1,ite
         j = 1
         dx          = .5*( x(i,j+1) -x(i,j) 
     &                      +x(i-1,j+1) -x(i-1,j) )
         dy          = .5*( r(i)*(y(i,j+1) -y(i,j) )
     &                      +r(i-1)*(x(i-1,j+1) -x(i-1,j)) )
c
         dydx  = .5*(r(i) +r(i-1))*(y(i,j) -y(i-1,j))
     &             /(x(i,j) -x(i-1,j)) 
         cosang = 1./sqrt(1. + dydx**2)
c
         dl          = .5*sqrt(dx*dx +dy*dy)*cosang
         u           = q(2,i,j+1)/q(1,i,j+1)
         v           = q(3,i,j+1)/q(1,i,j+1)
         v_rel       = sqrt(u*u +v*v)
         rho         = q(1,i,j+1)
c         rey         = rho*v_rel*dl/mugas
         rey         = v_rel*dl/xnugas
         cf          = -0.001767 + 0.03177/alog(rey) 
     &                  + 0.25614/((alog(rey))**2)
         dxab        = x(i,j) -x(i-1,j)
         dyab        = .5*(r(i) +r(i-1))*(y(i,j) -y(i-1,j))
c
c         if  (dyab*u -dxab*v .lt. 0.) then
c            ss       = -1.
c         else
c            ss       = 1.
c         endif
c
         if  (u .lt. 0.) then
            ss       = -1.
         else
            ss       = 1.
         endif
c
         tauwp(i) = cffactor*ss*cf*rho*v_rel*v_rel/2.
c
         j = my
         dx          = .5*( x(i,j) -x(i,j-1) 
     &                      +x(i-1,j) -x(i-1,j-1) )
         dy          = .5*( r(i)*(y(i,j) -y(i,j-1) )
     &                      +r(i-1)*(x(i-1,j) -x(i-1,j-1)) )
c
         dydx  = .5*(r(i) +r(i-1))*(y(i,j) -y(i-1,j))
     &             /(x(i,j) -x(i-1,j)) 
         cosang = 1./sqrt(1. + dydx**2)
c
         dl          = .5*sqrt(dx*dx +dy*dy)*cosang
         u           = q(2,i,j)/q(1,i,j)
         v           = q(3,i,j)/q(1,i,j)
         v_rel       = sqrt(u*u +v*v)
         rho         = q(1,i,j)
c         rey         = rho*v_rel*dl/mugas
         rey         = v_rel*dl/xnugas
         cf           = -0.001767 + 0.03177/alog(rey) 
     &                  + 0.25614/((alog(rey))**2)
         dxcd        = x(i-1,j) -x(i,j)
         dycd        = .5*(r(i) +r(i-1))*(y(i-1,j) -y(i,j))
c
c         if  (dycd*u -dxcd*v .lt. 0.) then
c            ss       = -1.
c         else
c            ss       = 1.
c         endif
c
         if  (u .gt. 0.) then
            ss       = -1.
         else
            ss       = 1.
         endif
c
 12      tauwm(i)  = cffactor*ss*cf*rho*v_rel*v_rel/2.

c ****************
c NON-BLADED REGION
c ****************
         j    = my
      do 14 i = 2,mx
         if ( (i .ge. ile+1) .and. (i .le. ite) ) goto 14
c
c cell abcd (i,j)
c
      dxab        = x(i,j-1)  -x(i-1,j-1)
      dyab        = .5*(r(i) +r(i-1))*(y(i,j-1) -y(i-1,j-1))
c      dyab        = (y(i,j-1) -y(i-1,j-1))
      dxbc        = x(i,j)  -x(i,j-1)
      dybc        = y(i,j)*r(i) -y(i,j-1)*r(i)
      dxcd        = x(i-1,j)  -x(i,j)
      dycd        = .5*(r(i) +r(i-1))*(y(i-1,j) -y(i,j))
c      dycd        = (y(i-1,j) -y(i,j))
      dxda        = x(i-1,j-1)  -x(i-1,j)
      dyda        = y(i-1,j-1)*r(i-1)  -y(i-1,j)*r(i-1)
c
      dlab        = sqrt(dxab*dxab  +dyab*dyab)
      dlbc        = sqrt(dxbc*dxbc  +dybc*dybc)
      dlcd        = sqrt(dxcd*dxcd  +dycd*dycd)
      dlda        = sqrt(dxda*dxda  +dyda*dyda)
c
      dxdb        = x(i,j-1)  -x(i-1,j)
      dydb        = y(i,j-1)*r(i)  -y(i-1,j)*r(i-1)
      dxac        = x(i,j)  -x(i-1,j-1)
      dyac        = y(i,j)*r(i)  -y(i-1,j-1)*r(i-1)
      area        = .5*abs(dxdb*dyac  -dxac*dydb)
      hav         = .5*(h(i) +h(i-1))
      volabcd     = hav*area
c
c cell  dcfe  (i,j+1) : NOW THE PERIODIC CELL
c
      dxdc        = x(i,j)  -x(i-1,j)
      dydc        = .5*(r(i) +r(i-1))*(y(i,j) -y(i-1,j))

      dxcf        = x(i,2)  -x(i,j)
      dycf        = (y(i,2) +sc)*r(i) -y(i,j)*r(i)

c      dxcf        = x(i,j+1)  -x(i,j)
c      dycf        = y(i,j+1)*r(i) -y(i,j)*r(i)
c      dxfe        = x(i-1,j+1)  -x(i,j+1)
c      dyfe        = .5*(r(i) +r(i-1))*(y(i-1,j+1) -y(i,j+1))

      dxfe        = x(i-1,2)  -x(i,2)
      dyfe        = .5*(r(i) +r(i-1))*(y(i-1,2) -y(i,2))

      dxed        = x(i-1,j)  -x(i-1,2)
      dyed        = y(i-1,j)*r(i-1)  -(y(i-1,2) +sc)*r(i-1)
c
      dlbf        = sqrt(dxbf*dxbf  +dybf*dybf)
      dlfe        = sqrt(dxfe*dxfe  +dyfe*dyfe)
      dlec        = sqrt(dxec*dxec  +dyec*dyec)
      dlcb        = sqrt(dxcb*dxcb  +dycb*dycb)
c
      dxec        = x(i,j)  -x(i-1,2)
      dyec        = y(i,j)*r(i)  -(y(i-1,2) +sc)*r(i-1)
      dxdf        = x(i,2)  -x(i-1,j)
      dydf        = (y(i,2) +sc)*r(i)  -y(i-1,j)*r(i-1)
      area        = .5*abs(dxec*dydf  -dxdf*dyec)
      hav         = .5*(h(i) +h(i-1))
      voldcfe     = hav*area
c
      vol         = .5*(volabcd +voldcfe)
c
      vab         = q(3,i,j)/q(1,i,j)
      vbc         = .25*( q(3,i,j)/q(1,i,j) +q(3,i,2)/q(1,i,2)
     &              +q(3,i+1,j)/q(1,i+1,j) +q(3,i+1,2)/q(1,i+1,2))
      vcd         = q(3,i,2)/q(1,i,2)
      vda         = .25*( q(3,i,j)/q(1,i,j) +q(3,i,2)/q(1,i,2) 
     &              +q(3,i-1,j)/q(1,i-1,j) +q(3,i-1,2)/q(1,i-1,2))
c
      uab         = q(2,i,j)/q(1,i,j)
      ubc         = .25*( q(2,i,j)/q(1,i,j) +q(2,i,2)/q(1,i,2)
     &              +q(2,i+1,j)/q(1,i+1,j) +q(2,i+1,2)/q(1,i+1,2))
      ucd         = q(2,i,2)/q(1,i,2)
      uda         = .25*( q(2,i,j)/q(1,i,j) +q(2,i,2)/q(1,i,2) 
     &              +q(2,i-1,j)/q(1,i-1,j) +q(2,i-1,2)/q(1,i-1,2))
c
      dhdm        = (h(i) -h(i-1))/(x(i,j) -x(i-1,j))
c
      rhoav       = .5*(q(1,i,2) +q(1,i,j))
c
      rab         = .5*(r(i) +r(i-1))
      rbc         = r(i) 
      rcd         = .5*(r(i) +r(i-1))
      rda         = r(i-1)
c
c ____________
c
c
      fluxtuab     = uab*.5*(h(i) +h(i-1))*.5*(dxab +dxdc)
      fluxtubc     = ubc*.5*h(i)*(dxbc +dxcf)
      fluxtucd     = ucd*.5*(h(i) +h(i-1))*.5*(dxcd +dxfe)
      fluxtuda     = uda*.5*h(i-1)*(dxda +dxed)

c
c ____________
c
c
      if (resavg .gt. convergence) then
c
      vabsab      = (q(3,i,j)/q(1,i,j)) +.5*(r(i) +r(i-1))*omega
      vabsbc      = .25*( q(3,i,j)/q(1,i,j) +q(3,i,2)/q(1,i,2)
     &              +q(3,i+1,j)/q(1,i+1,j) +q(3,i+1,2)/q(1,i+1,2))
     &              +r(i)*omega
      vabscd      = (q(3,i,2)/q(1,i,2)) +.5*(r(i) +r(i-1))*omega
      vabsda      = .25*( q(3,i,j)/q(1,i,j) +q(3,i,2)/q(1,i,2) 
     &              +q(3,i-1,j)/q(1,i-1,j) +q(3,i-1,2)/q(1,i-1,2))
     &              +r(i-1)*omega
c
      fluxmabsab  = vabsab*.5*(h(i) +h(i-1))*.5*(dyab +dydc)
      fluxmabsbc  = vabsbc*.5*h(i)*(dybc +dycf)
      fluxmabscd  = vabscd*.5*(h(i) +h(i-1))*.5*(dycd +dyfe)
      fluxmabsda  = vabsda*.5*h(i-1)*(dyda +dyed)
c
c calculating turbulent viscocity
c
      vormag      =abs((fluxmabsab +fluxmabsbc +fluxmabscd +fluxmabsda  
     &                  +(fluxtuab +fluxtubc +fluxtucd +fluxtuda))/vol 
     &                -.5*(vabsab +vabscd)*dhdm/(.5*(h(i) +h(i-1))) )
c
      xnuturbj(i,j) = prlnj(i,j)*prlnj(i,j)*vormag
c
      endif
c
c finding the effective viscocity
c
      xmu         = rhoav*(xnugas +xnuturbj(i,j)) 
c
c ******* CALCULATING TAU ASSUMING GRID LINES AS STREAMLINES 
c
      jp2   = 1
      u2    = q(2,i,jp2+1)/q(1,i,jp2+1)
      v2    = q(3,i,jp2+1)/q(1,i,jp2+1) +.5*(r(i-1) +r(i))*omega
      u1    = q(2,i,j)/q(1,i,j)
      v1    = q(3,i,j)/q(1,i,j) +.5*(r(i-1) +r(i))*omega

      sign2 = u2/abs(u2)
      sign1 = u1/abs(u1)
      q2    = sign2*sqrt(u2*u2 +v2*v2)
      q1    = sign1*sqrt(u1*u1 +v1*v1)
c      cos_a = (u1*u2 +v1*v2)/(q1*q2)
      qav   = sqrt(.25*((u1+u2)*(u1+u2) +(v1+v2)*(v1+v2))  )
      cos_a = .5*(u1 +u2)/(qav)
      rdy   = r(i)*y(i,jp2) -r(i-1)*y(i-1,jp2)
      dx    = x(i,jp2) -x(i-1,jp2)
      cos_b = dx/sqrt(dx*dx +rdy*rdy)

      sc_i  = .5*(y(i,my) -y(i,1) +y(i-1,my) -y(i-1,1))
      rav   = .5*(r(i) +r(i-1))
      sc_i  = rav*sc_i

      ry2   = .25*( r(i-1)*(y(i-1,jp2) +y(i-1,jp2+1))  
     &             +r(i)*(y(i,jp2) +y(i,jp2+1)) ) +sc_i
      ry1   = .25*( r(i-1)*(y(i-1,j) +y(i-1,j-1))  
     &             +r(i)*(y(i,j) +y(i,j-1)))
      dryn  = (ry2 -ry1)*cos_a

      taumtj(i,j) = xmu*(q2 -q1)/dryn*(cos_b/cos_a)

c      taumtj(i,j) = xmu*(-(fluxtuab +fluxtubc +fluxtucd +fluxtuda)
c     &             +fluxmvab +fluxmvbc +fluxmvcd +fluxmvda
c     &             +vbyrav*(fluxrab +fluxrbc +fluxrcd +fluxrda))/vol
c
c ____________
c
      xnuturbj(i,1) = xnuturbj(i,j)
c
      taumtj(i,1) = taumtj(i,j)

c
 14   continue
c
c**********************************
c calculating viscous terms along constant i faces for
c points j = 2,my in the bladed region
c**********************************
c calculating viscous terms along constant i faces for
c points j = 2,my in the bladed region
c**********************************
c by EXTRAPOLATION
c**********************************
c

      do 16 i = ile,ite
c
         ja   = 2
         jb   = 3
         jc   = 1
         do jj = 2,my-1,my-3
            jindex = 1
            do j = ja,jb,jc
               jindex = jindex +1
c
c
c cell abcd (i,j)
c
      dxab        = x(i,j-1)  -x(i-1,j-1)
      dyab        = .5*(r(i) +r(i-1))*(y(i,j-1) -y(i-1,j-1))
c      dyab        = (y(i,j-1) -y(i-1,j-1))
      dxbc        = x(i,j)  -x(i,j-1)
      dybc        = y(i,j)*r(i) -y(i,j-1)*r(i)
      dxcd        = x(i-1,j)  -x(i,j)
      dycd        = .5*(r(i) +r(i-1))*(y(i-1,j) -y(i,j))
c      dycd        = (y(i-1,j) -y(i,j))
      dxda        = x(i-1,j-1)  -x(i-1,j)
      dyda        = y(i-1,j-1)*r(i-1)  -y(i-1,j)*r(i-1)
c
      dlab        = sqrt(dxab*dxab  +dyab*dyab)
      dlbc        = sqrt(dxbc*dxbc  +dybc*dybc)
      dlcd        = sqrt(dxcd*dxcd  +dycd*dycd)
      dlda        = sqrt(dxda*dxda  +dyda*dyda)
c
      dxdb        = x(i,j-1)  -x(i-1,j)
      dydb        = y(i,j-1)*r(i)  -y(i-1,j)*r(i-1)
      dxac        = x(i,j)  -x(i-1,j-1)
      dyac        = y(i,j)*r(i)  -y(i-1,j-1)*r(i-1)
      area        = .5*abs(dxdb*dyac  -dxac*dydb)
      hav         = .5*(h(i) +h(i-1))
      volabcd     = hav*area
c
c cell bfec (i+1,j)
c
      dxbf        = x(i+1,j-1)  -x(i,j-1)
      dybf        = .5*(r(i+1) +r(i))*(y(i+1,j-1) -y(i,j-1))
      dxfe        = x(i+1,j)  -x(i+1,j-1)
      dyfe        = y(i+1,j)*r(i+1) -y(i+1,j-1)*r(i+1)
      dxec        = x(i,j)  -x(i+1,j)
      dyec        = .5*(r(i+1) +r(i))*(y(i,j) -y(i+1,j))
      dxcb        = x(i,j-1)  -x(i,j)
      dycb        = y(i,j-1)*r(i)  -y(i,j)*r(i)
c
      dlbf        = sqrt(dxbf*dxbf  +dybf*dybf)
      dlfe        = sqrt(dxfe*dxfe  +dyfe*dyfe)
      dlec        = sqrt(dxec*dxec  +dyec*dyec)
      dlcb        = sqrt(dxcb*dxcb  +dycb*dycb)
c
      dxcf        = x(i+1,j-1)  -x(i,j)
      dycf        = y(i+1,j-1)*r(i+1)  -y(i,j)*r(i)
      dxbe        = x(i+1,j)  -x(i,j-1)
      dybe        = y(i+1,j)*r(i+1)  -y(i,j-1)*r(i)
      area        = .5*abs(dxcf*dybe  -dxbe*dycf)
      hav         = .5*(h(i+1) +h(i))
      volbfec     = hav*area
c
      vol         = .5*(volabcd +volbfec)
c
      vab         = .25*( q(3,i,j)/q(1,i,j) +q(3,i+1,j)/q(1,i+1,j) 
     &              +q(3,i,j-1)/q(1,i,j-1) +q(3,i+1,j-1)/q(1,i+1,j-1))
      vbc         = q(3,i+1,j)/q(1,i+1,j)
      vcd         = .25*( q(3,i,j)/q(1,i,j) +q(3,i+1,j)/q(1,i+1,j) 
     &              +q(3,i,j+1)/q(1,i,j+1) +q(3,i+1,j+1)/q(1,i+1,j+1))
      vda         = q(3,i,j)/q(1,i,j)
c
      uab         = .25*( q(2,i,j)/q(1,i,j) +q(2,i+1,j)/q(1,i+1,j) 
     &              +q(2,i,j-1)/q(1,i,j-1) +q(2,i+1,j-1)/q(1,i+1,j-1))
      ubc         = q(2,i+1,j)/q(1,i+1,j)
      ucd         = .25*( q(2,i,j)/q(1,i,j) +q(2,i+1,j)/q(1,i+1,j) 
     &              +q(2,i,j+1)/q(1,i,j+1) +q(2,i+1,j+1)/q(1,i+1,j+1))
      uda         = q(2,i,j)/q(1,i,j)
c
      rhoav       = .5*(q(1,i+1,j) +q(1,i,j))
c
c
c ____________
c
      dhdm        = (h(i+1) -h(i-1))/(.5*( x(i+1,j) +x(i+1,j-1) 
     &                                    -x(i-1,j) -x(i-1,j-1)))
c
      rab         = r(i)
      rbc         = .5*(r(i) +r(i+1))
      rcd         = r(i)
      rda         = .5*(r(i-1) +r(i))
c
      fluxtuab     = uab*h(i)*.5*(dxab +dxbf)
      fluxtubc     = ubc*.5*(h(i)*dxbc +h(i+1)*dxfe)
      fluxtucd     = ucd*h(i)*.5*(dxcd +dxec)
      fluxtuda     = uda*.5*(h(i-1)*dxda +h(i)*dxcb)
c
c
c ____________
c
      if (resavg .gt. convergence) then
c
      vabsab      = .25*( q(3,i,j)/q(1,i,j) +q(3,i+1,j)/q(1,i+1,j) 
     &              +q(3,i,j-1)/q(1,i,j-1) +q(3,i+1,j-1)/q(1,i+1,j-1))
     &              + r(i)*omega
      vabsbc      = (q(3,i+1,j)/q(1,i+1,j)) +.5*(r(i) +r(i+1))*omega
      vabscd      = .25*( q(3,i,j)/q(1,i,j) +q(3,i+1,j)/q(1,i+1,j) 
     &              +q(3,i,j+1)/q(1,i,j+1) +q(3,i+1,j+1)/q(1,i+1,j+1))
     &              + r(i)*omega
      vabsda      = (q(3,i,j)/q(1,i,j)) +.5*(r(i) +r(i-1))*omega
c
      fluxmabsab  = vabsab*h(i)*.5*(dyab +dybf)
      fluxmabsbc  = vabsbc*.5*(h(i)*dybc +h(i+1)*dyfe)
      fluxmabscd  = vabscd*h(i)*.5*(dycd +dyec)
      fluxmabsda  = vabsda*.5*(h(i-1)*dyda +h(i)*dycb)
c
c calculating turbulent viscocity
c
      vor(jindex) =abs((fluxmabsab +fluxmabsbc +fluxmabscd +fluxmabsda  
     &                  +(fluxtuab +fluxtubc +fluxtucd +fluxtuda))/vol 
     &                -.5*(vabsbc +vabsda)*dhdm/h(i) )
c
      endif
c
c
c ____________
c
c
         enddo 
c
c extrapolating vorticity and strain
c
      if (resavg .gt. convergence) then
c
         vor1           = 2.*vor(2) -vor(3)
         xnuturbi(i,jj) = prlni(i,jj)*prlni(i,jj)*abs(vor1)
c
      endif
c
         ja   = my-1
         jb   = my-2
         jc   = -1
c
      enddo 

 16   continue

c
      do 30 j = 2,my
c         taumti(1,j)  = 2.*taumti(2,j) -taumti(3,j)
c         taumti(mx,j) = 2.*taumti(mx-1,j) -taumti(mx-2,j)
c         taummi(1,j)  = 2.*taummi(2,j) -taummi(3,j)
c         taummi(mx,j) = 2.*taummi(mx-1,j) -taummi(mx-2,j)
c         tautti(1,j)  = 2.*tautti(2,j) -tautti(3,j)
c         tautti(mx,j) = 2.*tautti(mx-1,j) -tautti(mx-2,j)
c         taunni(1,j)  = 2.*taunni(2,j) -taunni(3,j)
c         taunni(mx,j) = 2.*taunni(mx-1,j) -taunni(mx-2,j)
c
c
         xnuturbi(1,j)  = 2.*xnuturbi(2,j) -xnuturbi(3,j)
         xnuturbi(mx,j) = 2.*xnuturbi(mx-1,j) -xnuturbi(mx-2,j)
c
 30   continue
c
c extrapolating for TURBULENT VISCOSITY at j = 2 and j = my
c in the bladed region
c
      do 40 i = ile+1,ite
         xnuturbj(i,1)  = 2.*xnuturbj(i,2) -xnuturbj(i,3)
         xnuturbj(i,my) = 2.*xnuturbj(i,my-1) -xnuturbj(i,my-2)         
 40   continue
c
      return                                                            
      end                                                               




