      Program Laplace
      use foomodule
!************************************************************
!*
!* This HPF program implements a finite difference method for
!* solving the Laplace Heat Equation via iteration.  Iteration
!* is continued until a steady state is reached to within some
!* epsilon.
!*
!************************************************************
      integer yyless 
      INTEGER maxX$,maxY$
      INTEGER count
      PARAMETER (maxX$=6)
      PARAMETER (maxY$=6)

           parameter ( N = 1000000)
       real, dimension(N) :: X, Y, Z, U
       real Q, R, T
       integer k
!HPF$   processors p(NUMBER_OF_PROCESSORS())
!HPF$   template d(1000000)
!HPF$   distribute d(block) onto p
!HPF$   align (:) with d(:) :: X, Y, Z, U



      !hpf$ template,distribute(block,block) :: earth(maxX$,maxY$)

      INTEGER S_ID,s_id1
      REAL surface(maxX$,maxY$) ,temp(maxX$,maxY$)
      real dummy(-2:4,5,-3:1)

!hpf$ align temp(i,j) with earth(i,j)
!HPF$ DISTRIBUTE surface(BLOCK,BLOCK)
!HPF$ DISTRIBUTE dummy(block,block,block)
      DOUBLE PRECISION epsilon,maxErr

      integer ndims,useless,uint
      integer dims(2),xcoor(5),i,j,tempval(10)  
!      integer  perol(2*110),pLOCAL_erol(2*110)
! hpf$ distribute (BLOCK) :: perol
! hpf$  sequence ::  share
!       common /share/perol,pLOCAL_erol
!      common /tint/ tempval
        
 
      ndims = 2
      port = 3336
      dims(1) = maxX$ 
      dims(2) = maxY$
      print *, maxX$, "**", maxY$ 
      temp = 101

      epsilon = 1.0E-6
      maxErr = 1.0E10

      forall(i=-2:4,j=1:5,k=-3:1)
         dummy(i,j,k) = i+j+k
      endforall

      
      call initialize()
      print *,'foodat ',foodat

      count = 0
      temp = surface
      do while (maxErr > epsilon)
         print *,"ITERATION: ",count
         temp = surface                  
         surface(2:maxX$-1,2:maxY$-1) = (temp(1:maxX$-2,2:maxY$-1) + & 
                                        temp(3:maxX$,2:maxY$-1) + &
                                        temp(2:maxX$-1,1:maxY$-2) + &
                                        temp(2:maxX$-1,3:maxY$))/4.0 
       	 maxErr = MAXVAL(ABS(surface-temp))
         if (MOD(count,100) .EQ. 0) then
          print *,count,maxErr
         end if
         count = count + 1

      end do
      m = 0
      i = 1/m
      print *,'end of loop'

      End program Laplace

!************************************************************
!*
!* Subroutine Init initializes a 2D surface with a random 
!* distribution of temperatures in the interior and with 
!* temperature, temp, at the edges.
!*
!************************************************************

