#include "debugger.h"

inithpfLines(int sourceLen)
{
   int i;

   for(i=0;i<sourceLen;i++)
   {
      hpfLines[i].scope  = -1;
      hpfLines[i].stmtID = -1;
      hpfLines[i].parent = -1;
      hpfLines[i].onbreak  = BREAKOFF; 
      hpfLines[i].set    = 0;
   }

}

int server (int myline, int scope, int stmtID, int parent,int sockfd)
{
   int Stop = 0;
   char variableName[256];
   static int curScope,curCmnd;
   static int nIterStartLine,curCounter;
   int    is_staying_in_server = 0,lineNumber,i;

   if ( !hpfLines[myline].set ){
      hpfLines[myline].scope  = scope;
      hpfLines[myline].stmtID = stmtID;
      hpfLines[myline].parent = parent;
      hpfLines[myline].set    = 1;
   }

   if (curCmnd == RUN)
        Stop = 0;
   else if (((curCmnd == STEPOVER)||(curCmnd == NSTEPOVER))&&
       (curScope == scope))
   { 
       if (curCounter > 0)
          curCounter --;
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == STEPINTO)||(curCmnd == NSTEPINTO))
   {
       if (curCounter > 0)
          curCounter --;  
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == CONTINUE)&&(hpfLines[myline].onbreak))
       Stop = 1;
   else if ((curCmnd == NITERATION)&&(myline ==  nIterStartLine))
     {
       if (curCounter > 0)
	   curCounter--;
       if (curCounter == 0) 
	   Stop = 1;
     }
   
   if (!Stop)
      return EXITFROMSERVER;

   /* Send myline to Java Applet which updates current line number */
   send_int(myline);
   
   curScope = scope;
   if (HOST)
      recv_int( sockfd,&curCmnd);
   distribute_oneitem_(&curCmnd);
   
   switch(curCmnd){
   case PUTBREAKON : 
     if (HOST)
        recv_int( sockfd,&lineNumber );  
     distribute_oneitem_(&lineNumber);
     hpfLines[lineNumber].onbreak = BREAKON;
     is_staying_in_server = 1;
     break;
   case PUTBREAKOFF:
     if (HOST) 
        recv_int( sockfd,&lineNumber);  
     distribute_oneitem_(&lineNumber);
     hpfLines[lineNumber].onbreak = BREAKOFF;
     is_staying_in_server = 1;
     break;
   case STEPOVER:case STEPINTO:
     curCounter = 1;
     break;
   case NSTEPOVER:case NSTEPINTO: 
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
     break;
   case CONTINUE:
     break;
   case RUN: 
     break;
   case NITERATION:
     if (HOST)
        recv_int( sockfd,&curCounter);
     if (!isInLoop(myline)){
        printf("Error : you are not in one loop \n"); 
        /* send error msg to Java Applet */
     }
     else{
        distribute_oneitem_(&curCounter);
        nIterStartLine = myline;
     }
     break;
   case DISPLAY:
     if (HOST)
       recv_String(sockfd,variableName);
     send_registered_data(scope,variableName,sockfd);
     is_staying_in_server = 1;
     break;
   case SETVARIABLE:
     if (HOST)
        recv_String(sockfd,variableName);
     set_variable(sockfd,variableName,scope);  
     is_staying_in_server = 1;   
     break;
   case SETPARVAR:
     if (HOST)
        recv_String(sockfd,variableName); 
     set_ParallelVar(sockfd,variableName, scope);
     is_staying_in_server = 1;
     break;    

     }
   return is_staying_in_server;
}


/*********************************************************/
/*********************************************************/
/*********************************************************/
/*********************************************************/
read_summary_dep_file(char *fileName)
{
  FILE *fp;
  char lines[256],*ptr,fname[64];
  int j,i,k,filelen,newfuncs;
  int nextfunc=0,nextfile=0;
 
  if (!(fp = fopen(fileName,"r"))){
    printf("I can not open the file : %s\n",fileName);
    exit(0);
  }
  nfiles = 0;
  nfuncs = 0;
  while(!feof(fp))
  {
     fgets(lines,256,fp);
     if ((strstr(lines,"//"))&&(strstr(lines,"number of functions"))){
        fgets(lines,256,fp);
        nfuncs += atoi(lines);
     }
     else if ((strstr(lines,"//"))&&(strstr(lines,"File name" )))
        nfiles++;
     else if((strstr(lines,"//"))&&(strstr(lines,"Length" ))){
        fgets(lines,256,fp);
        filesizes[nfiles-1] = atoi(lines);
     }
  }

  functab = (FTAB *)calloc(nfuncs,sizeof(FTAB));  
  files  = (FILES *)calloc(nfiles,sizeof(FILES)); 
  for(i=0;i<nfiles;i++)
    files[i].lineInfo = (SINFO *)calloc(filesizes[i],sizeof(SINFO));  

  rewind(fp);
  /* read comment "File Name" */
  fgets(lines,256,fp);
  while(!feof(fp))
  {
   
     /* read file name */
     fgets(lines,256,fp);
     strcpy(fname,strtok(lines,"\n\r\t "));
    
     /*read comment "Length of File " */
     fgets(lines,256,fp);
     /* read file length */
     fgets(lines,256,fp);
     filelen = atoi(lines);
    
     /* read comment "number of functions" */
     fgets(lines,256,fp);
     /* read number of functions */
     fgets(lines,256,fp);
     newfuncs = atoi(lines);
    
     /* read comment "LineNumber  FunctionName FileName" */
     fgets(lines,256,fp);

     for(i = nextfunc;i<nextfunc+newfuncs;i++){
       /* read one line of function info */
       fgets(lines,256,fp);
       ptr = strtok(lines,"\n\r\t ");
       functab[i].lineNum = atoi(ptr);
       strcpy(functab[i].funName, strtok(NULL,"\n\r\t "));
       strcpy(functab[i].fileName, fname);
      
     }

     /* accumulate total number of functions */
     nextfunc += newfuncs ; 

     /* read comment "LineNumber Scope stmtID parent isExecutable" */
     fgets(lines,256,fp);

     i = nextfile;
     for(j=0;j <filelen;j++){
       /* read line number */
       fgets(lines,256,fp);
       k = atoi(strtok(lines,"\n\r\t "));
       files[i].lineInfo[k].lineNum = k;
       files[i].lineInfo[k].scope = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].stmtID = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].parent = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isExecutable = atoi(strtok(NULL,"\n\r\t "));
       files[i].lineInfo[k].isInLoop = atoi(strtok(NULL,"\n\r\t "));
     }
     nextfile++;

     /* read comment "File Name" */
     fgets(lines,256,fp);
  }
  fclose(fp);
}
