#include <sys/types.h>
#include <rpc/types.h>
#include <netdb.h>
#include <stdarg.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <rpc/xdr.h> 
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/time.h>
#include "tags.h"
#include <string.h>

#define  MAXFILES 128
#define HOST   (pghpf_myprocnum_() == 0)  
#define ME     (pghpf_myprocnum_())
#define SERVER_CONNECT_RETRY_DELAY 1
#define QLEN            5
#define MAX_NAME_LENGTH 256
#define MAX_DIMS        7
#define MAX_VARS        256
#define REGBUFSIZE      5012   
#define UNCONNECTED     0
#define CONNECTED       1
#define MAXVARLEN       256
#define BREAKON         1
#define BREAKOFF        0  
#define STAYINSERVER    1
#define EXITFROMSERVER  2
/* Debugger commands */
#define PUTBREAKON     10
#define PUTBREAKOFF    11
#define STEPOVER       12
#define NSTEPOVER      13 
#define STEPINTO       14
#define NSTEPINTO      15
#define CONTINUE       16
#define RUN            17
#define STOP           18
#define NITERATION     19
#define GOUNTIL        20
#define DISPLAY        21
#define SETVARIABLE    22
#define SETPARVAR      23 /* update one parallel variable from java applet */
#define CONNECT        23 /* make conenction to HPF server */

typedef struct push_data{
  int  type;
  char name[MAXVARLEN];
  int  ndims;  /* 0 for simple variables,ndims for array vars */ 
  int  dim_info[MAX_DIMS] ;
  int  sockfd; /* socket file descriptor */
  int  port;
  int  sizeof_data; /* total size of push_data in bytes */
  long buf; /* includes actual data whatever it is */
  int  elsize; /* sizeof of each element */
  int  connected;
  int  nelems ; /* total element count */
  int  tind; /* index to type_list,returns the pointer to function */
  int  javabuflen;
  unsigned long  client_addr;
  int scope;
  
  long data_desc;
  int  isDistributed;
  int  localIndex;/* If I am distributed,this points to my local data */
  /* this will be used to transfer from parallel dat ato local data */
}DATA;

typedef struct send_buf{   
  char *sbuf;
  int   len;
  XDR   xdrs;
}SBUF;

typedef struct lineInfo{
  int scope ;   /* outher most enclosing function/subroutine */
  int stmtID;   /* statement ID */
  int parent;   /* its parent line number */
  int onbreak;    /* has break on or off */
  int isExecutable; /* Is this line executable */
  int set;      /* this information is set up before */ 
}LINES;

typedef struct functable{
 int lineNum;
 char funName[64];
 char fileName[64];
}FTAB;

typedef struct sourceinfo{
 int lineNum;
 int scope;
 int stmtID;
 int parent;
 int isExecutable;
 int isInLoop;
}SINFO;

typedef struct intermediateFiles{
  char   fileName[64];
  SINFO  *lineInfo;
}FILES ;

FILES *files=NULL;
FTAB  *functab=NULL;
int   nfuncs,nfiles;

int     msock;                  /* master server socket         */
fd_set  rfds;                   /* read file descriptor set     */
fd_set  afds;                   /* active file descriptor set   */
int     alen;                   /* from-address length          */
int     fd, nfds;
char    portnum;
int     max_push_id;
int     SOCK_RECV;
/* Use the registrated variable "sock_recv_bits " as temporary to
   copy the select events to other processors */

DATA  stack[MAX_VARS];   
LINES *hpfLines;
int filesizes[MAXFILES];

void err(char *) ;
void configure_client_(int *,char *,int *);
int server (int ,int ,int ,int ,int );
extern int   errno;
extern char  *sys_errlist[];
extern int  t_errno;
extern char *t_errlist[];
