       program SH
!       ===============================================================
!       array assignments with shifts
!       taken from the Livermore Loops, kernel 7
!       ===============================================================
!       please send comments to haupt@npac.syr.edu

       parameter ( N = 1000000)
       real, dimension(N) :: X, Y, Z, U
       real Q, R, T
       integer k
!HPF$   processors p(NUMBER_OF_PROCESSORS())
! HPF$   template d(1000000)
!HPF$   distribute X(block) onto p
!HPF$   align (:) with X(:) :: Y, Z, U
   
!     start_timer

!             Initialisation of scalars
            Q = 10.0
    	    R = 1.5
    	    T = 3.77
!            Initialization loop
    	    U = 7.0
            X = 8.0
            Y = 9.0
            Z = 10.0

            do it=1,5
!****************************************************************************
!***  KERNEL 7      EQUATION OF STATE FRAGMENT
!****************************************************************************
!
!
	    forall (k=1:N-6)      &
     &   X(k)=     U(k) + R*( Z(k) + R*Y(k)) +  &
     &        T*( U(k+3) + R*( U(k+2) + R*U(k+1)) +  &
     &        T*( U(k+6) + Q*( U(k+5) + Q*U(k+4))))
!
!
!****************************************************************************
          enddo
!         stop_timer

      print *,' ' 
      print *,'*******************************'
      print *,'         PARKBENCH '
      print *,' LOW LEVEL HPF BENCHMARK SUITE'
      print *,'         AS  KERNEL'
      print *,' PROBLEM SIZE: N =', N
      print *,' FINAL RESULT = ', X(N-6)
      print *,' EXPECTED VALUE FOR SIZE 1000000' 
      print *,' IS  11211.0 +/- 0.1'
      print *,'*******************************'

!     print execution time

      STOP
      END





