/* soputc.c - soputc */

#include <sys/types.h>

#include <stdio.h>

#include "telnet.h"
#include "local.h"

/*------------------------------------------------------------------------
 * soputc - move a character from the keyboard to the socket
 *------------------------------------------------------------------------
 */
/*ARGSUSED*/
int
soputc(sfp, tfp, c)
FILE	*sfp, *tfp;
int	c;
{
	if (sndbinary) {
		if (c == TCIAC)
			(void) putc(TCIAC, sfp); /* byte-stuff IAC	*/
		(void) putc(c, sfp);
		return 0;
	}
	c &= 0x7f;	/* 7-bit ASCII only */
	if (c == t_intrc || c == t_quitc) {	/* Interrupt		*/
		(void) putc(TCIAC, sfp);
		(void) putc(TCIP, sfp);
	} else if (c == sg_erase) {		/* Erase Char		*/
		(void) putc(TCIAC, sfp);
		(void) putc(TCEC, sfp);
	} else if (c == sg_kill) {		/* Erase Line		*/
		(void) putc(TCIAC, sfp);
		(void) putc(TCEL, sfp);
	} else if (c == t_flushc) {		/* Abort Output		*/
		(void) putc(TCIAC, sfp);
		(void) putc(TCAO, sfp);
	} else if (c >= ' ' && c < TCIAC)	/* printable ASCII only	*/
		(void) putc(c, sfp);
	else
		switch (c) {
		case VPLF:
		case VPCR:
		case VPBEL:
		case VPBS:
		case VPHT:
		case VPFF:
			(void) putc(c, sfp);
		default:
			break;	/* invalid character */
		}
	return 0;
}
