#include <stdio.h>
#include "compilerApi.h"

#define TIMER_CLEAR    0
#define TIMER_START    1
#define TIMER_STOP     2
#define TIMER_ELAPSED  3
#define BEFORE  0
#define AFTER   1

enum FLAG {off, on};
FLAG in_main_program;
FLAG in_procedure;
int tabnumber=0;

timer_start()
{
  ;
}

timer_clear()
{
  ;
}
timer_stop()
{
  ;
}
timer_elapsed()
{
  ;
}


// Insert a C function call statement
void 

InsertFCallNode(int event_type, SgStatement *s, int how)
{

  SgSymbol *symb ;
         
  switch (event_type) {
    case TIMER_CLEAR: symb = new SgVariableSymb("timer_clear");
      //symb = timer_clear;
                      break;
    case TIMER_START: symb = new SgVariableSymb("timer_start");
      //symb = timer_start;
                      break;
    case TIMER_STOP:  symb = new SgVariableSymb("timer_stop");
      ///symb = timer_stop;
                      break;
    case TIMER_ELAPSED:symb = new SgVariableSymb("timer_elapsed"); 
      //symb = timer_elapsed;
                       break;
  }


  SgCallStmt *func;
  SgValueExp *ev;
  
  func = new SgCallStmt(*symb);
  ev = new SgValueExp(event_type);
  func->addArg(*ev);
  delete(ev);

  switch (how) {
    case BEFORE: 
         s->insertStmtBefore(*func);
         break;
    case AFTER:
         s->insertStmtAfter(*func);
         break;
  }
}

void puttab(int number)
{
  for(int i=0; i<number; i++)
    printf("  ");
}

void action(SgStatement * s)
{
  puttab(tabnumber);
  printf("id:%4d   variant:%4d\n", s->id(), s->variant());
  if (isSgExecutableStatement(s)){
       printf("OK...\n");
       InsertFCallNode(TIMER_STOP, s, BEFORE);
   }
}

void transform(SgStatement * s) 
{
  int i=0;

  int org_numberOfChildren=s->numberOfChildrenList1();
   SgStatement * * children = new SgStatement * [org_numberOfChildren];
   SgStatement *st;
   SgStatement *line;
   
   
   for(line=s;line;line= line->lexNext()){
     st = line;
     action(st);
   }

      return;
      
  
  switch(s->variant()) {
  case GLOBAL:
    {
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      for (i=0; i<org_numberOfChildren; i++)
	transform(children[i]);
      
      delete [] children;
      break;
    };

  case PROG_HEDR:
    {
      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      in_main_program = on;

      action(s);
     
      tabnumber++;
      
      for (i=0; i<org_numberOfChildren; i++)
	transform(children[i]);

      tabnumber--;

      in_main_program=off;
      
      delete [] children;

      break;
    }

  case PROC_HEDR:
    {
      SgProcHedrStmt * prochedr = (SgProcHedrStmt *)s;

      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];
      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      in_procedure=on;

      action(s);
      
      tabnumber++;

      for (i=0; i<org_numberOfChildren; i++){
	
	transform(children[i]);
        InsertFCallNode(TIMER_STOP, s, AFTER);
      }
      

      tabnumber--;

      in_procedure = off;

      delete [] children;

      break;
    };

  case VAR_DECL:
  case ASSIGN_STAT:
    action(s);
        break;

  case FOR_NODE:
    {

      int org_numberOfChildren=s->numberOfChildrenList1();
      SgStatement * * children = new SgStatement * [org_numberOfChildren];

      for (i=0; i<org_numberOfChildren; i++)
	children[i]=s->childList1(i);

      action(s);
      
      tabnumber++;

      for (i=0; i<org_numberOfChildren; i++){
	
	transform(children[i]);
        InsertFCallNode(TIMER_STOP, s, AFTER);
      }
      

      tabnumber--;

      delete [] children;
      
      break;
    }

  case CONTROL_END: 
  case ENDDO_STMT:  
      break;
    
  default:
    printf("Not touched statement in transform phase on line %d\n", s->lineNumber());
    break;
  };
};

int main(int argc, char **argv){

  SgFile * file;
  SgProject * project = new SgProject("test", argc, argv);

  for (int i=0; i< project->numberOfFiles(); i++) {

    file = &(project->file(i));
    
    SgStatement * s = file->firstStatement();

    transform(s);
    // save a copy of the input file, if you like.
   file->saveDepFile("debug.dep");

  };

  return 0;
}







