// CMatrix.java 
// $Id$
// $Log$

import java.awt.*;
import java.lang.Math.*;
import java.io.*;
import java.net.*;
import java.util.*;
import gjt.*;



//*===========================
//* MatrixPanel
//*===========================
class MatrixPanel extends Panel implements Runnable {
  ParameterDialog paramDialog;
  ParameterObj    pobj = new ParameterObj();
  
  boolean inAnApplet = true;
  boolean sim_completed = false;
  int simTime = 0;
  int labelXPos, labelYPos;  
  int nodeX,nodeY, nodeH;
  boolean stepFlag;
  int panelW = 640;
  int panelH;
  // Chart params
  int chartW, chartH, chartX, chartY;
  int xGap, yGap;

  Font        titleF, labelF;
  FontMetrics titleFm, labelFM;
  String      title, labelX, labelY;

  Image offscreen;
  Dimension offscreensize;
  Graphics offgraphics;

  TwoDArrayObject array = new TwoDArrayObject();
 
  // ADDED BY EROL
  communication com_cmd;
  static filtered_functions fil_funs;
  int curIter;
  //------------- Wrapper definitions
  //-------------------------------------------
  float [][] data = new float[16][16];

  MatrixPanel(CMatrix graph){
     
    System.out.println("resetSimulation() going into");
    resetSimulation();
    System.out.println("MatrixPanel() done.");
    
  }


  //--------------------------------------------
public void resetSimulationWithParams(ParameterObj pobj) {
  resetSimulation();
  setParameters(pobj);
}

public void setParameters(ParameterObj pobj) 
  {
    this.pobj = pobj;
  }
public void setDefaultParameters() 
  {
/* BUG
    pobj.dim1[0] = array.lb1;
    pobj.dim1[1] = array.ub1;
    pobj.dim1[2] = array.st1;
    pobj.dim2[0] = array.lb2;
    pobj.dim2[1] = array.ub2;
    pobj.dim2[2] = array.st2;
    pobj.eps     = 0.001;
    pobj.step    = 1;
*/
  ParameterObj po = new ParameterObj();
  pobj = po;
  System.out.println("In setDefaultParameters:");
  pobj.print();
  
  }  

public void resetSimulation() {
  sim_completed = false;
  System.out.println("resetSimulation() in 1 ");
  resetChart();
  simTime = 0;
  curIter=0;

  //---- recv_data(name, dim1, dim2, type, data);
  //TEST>
  System.out.println("resetSimulation()");
  
  array.init_test();
  setDefaultParameters();

  
  //<TEST  
}

  //--------------------------------------------
public void run() {
  while (simTime++ < 921) {
    repaint();
    if (stepFlag) Thread.currentThread().suspend();   
    else {     
      try {
	Thread.sleep(2000);	
      } catch (InterruptedException e) {
	break;
      }
    }    
    Thread.yield();
  }
}
  //--------------------------------------------

/*
public void paintNodes(Graphics g, FontMetrics fm) {
  int x, y;
  for (int i=0; i<=array.dim1; i++)
    for (int j=0; j<array.dim2; j++) {
      y = chartY + yGap* j;
      x = chartX + xGap* i; //(int)(Math.random()*array.dim1);
      g.setColor(array.color[i][j]);
      g.fillRect(x+1, y+1, xGap-2, yGap-2);
    }
}
*/
public void paintNodes(Graphics g, FontMetrics fm) {
  int x, y;
  int ii, jj;
  pobj.print();
  
  for (int i=pobj.dim1[0]; i<=pobj.dim1[1]; i+=pobj.dim1[2])
    for (int j=pobj.dim2[0]; j<=pobj.dim2[1]; j+=pobj.dim2[2]) {
      ii = i - pobj.dim1[0];
      jj = j - pobj.dim2[0];
      y = chartY + yGap* jj; 
      x = chartX + xGap* ii; 
      g.setColor(array.color[ii][jj]);
      g.fillRect(x+1, y+1, xGap-2, yGap-2);
    }
}
//--------------------------------------------
public void resetChart() {
  xGap = 20;
  yGap = 20;
  chartW = xGap*array.dim1;
  chartH = yGap*array.dim2;
  chartX = (panelW - chartW)/2;
  labelXPos = chartX;
  labelYPos = 10;
  chartY = labelYPos + 30;
  //System.out.println(xGap+":"+yGap+":"+chartX+":"+chartY+":"+chartW+":"+chartH);            
}
   //--------------------------------------------
public void drawChart(Graphics g) {
  resetChart();     
  g.setColor(Color.black);
  g.drawRect(chartX, chartY, chartW, chartH);
  int y = chartY;
  for (int i=0; i<array.dim1; i++) {
    g.drawLine(chartX, y, chartX+chartH, y);
    y += yGap;
  }
  int x = chartX;
  for (int i=0; i<array.dim2; i++) {
    g.drawLine(x, chartY, x, chartY+chartW);
    x += xGap;
  }
  putTics(g); 
}

  //-------------------------------------------
  // Puts x and y axis tics.
  //-------------------------------------------
public void putTics(Graphics g) {
  int x, y, yoff;
  int dim1 = array.dim1;
  int dim2 = array.dim2;
  int labelW, labelH;
  String xticLabel, yticLabel;
  
  labelF = new Font("Helvetica", Font.PLAIN, 10);
  g.setFont(labelF);
  labelFM = g.getFontMetrics(labelF); 
  int ticLabelH = labelFM.getHeight();
  
  g.setColor(Color.black);       
  g.setFont(labelF);
  
  //String label = "www";
      
  //--- Put x axis tics
  //
  x = chartX;
  y = chartY; 
  for (int i=array.lb2; i<=array.ub2; i++) {
    xticLabel = ""+String.valueOf(i);
    labelW = labelFM.stringWidth(xticLabel);
    g.drawString(xticLabel, x, y-ticLabelH/2); 
    x = chartX + i * xGap + (xGap - labelW) /2;
  }
  //--- Put y axis tics
  //
  x = chartX;
  y = chartY; 
  yoff= (yGap-ticLabelH)/2 + ticLabelH; 
  
  for (int i=array.lb1; i<=array.ub1; i++) {
    yticLabel = ""+String.valueOf(i); 
    labelW = labelFM.stringWidth(yticLabel);
    x = chartX - labelW - 2;
    g.drawString(yticLabel, x, y+yoff);
    y += yGap;
  }
  g.drawString(array.name,labelXPos, labelYPos);       
}

   //--------------------------------------------

public synchronized void update(Graphics g) {
  Dimension d = size();
  if ((offscreen == null)) {
    offscreen = createImage(1000,1000);
    offscreensize = d;
    offgraphics = offscreen.getGraphics();
    offgraphics.setFont(getFont());
  }
  offgraphics.setColor(getBackground());
  offgraphics.fillRect(0, 0, d.width, d.height);
  
  FontMetrics fm = offgraphics.getFontMetrics();
  System.out.println("Updating ....");
  
   // ADDED BY EROL
 
  
  array.update_array(pobj,fil_funs);
  
   // ADDED BY EROL
 

drawChart(offgraphics);
paintNodes(offgraphics, fm);      
g.drawImage(offscreen, 0, 0, null);
}
  //---------------------------------------

}

//*====================================
//* CMatrix
//*====================================
public class CMatrix extends Frame  implements DialogClient{
   MatrixPanel panel;
   int simTime = 0;
   final String FILE_BUTTON    = " Display data";
   final String EXIT_BUTTON    = "  Exit ";
   final String RESTART_BUTTON = " Reset ";
   final String STEP_BUTTON    = "  Step   ";
   final String RESUME_BUTTON  = "  Resume ";
   final String START_BUTTON = " Start ";
   final String PARAM_BUTTON = " Parameters ";
   Thread aThread;

   final String HELP_MENU = " Help ";
   final String HMENU_help= " Help ";
   Button startButton;
   boolean startFlag; 

  ParameterObj pobj; // = new ParameterObj();
  ParameterDialog pd;
  Panel chartPanel = new Panel(); 
  InfoPanel infoPanel; //  = new InfoPanel();

  // ADDED BY EROL  
   String hpf_host ;
   int    hpf_port ;
  int    hpfprogram_port ;
   network nt;
   static public connection con;
   communication com_cmd;
   filtered_functions fil_funs;
  // ADDED BY EROL

   // fflag indicates arrays ar in colum or row order
   static public void Open_port(String hpf_host,int hpf_port,boolean fflag) 
   {
     System.out.println("host "+hpf_host+" hpf_port "+
       hpf_port+" fflag "+fflag);
  
     System.out.println("Before new connection ");

     boolean done = false;
     while(!done)
     { 
       //System.out.println("in try-catch");
       
        try {
          con = new connection(hpf_host, hpf_port,fflag); 
          done = true;
        }
        catch (IOException e) {
          System.out.println("IO Exception during new connection: "+e);
          done = false;
        }
     }
     System.out.println("after new connection to port  "+hpf_port); 
     System.out.println("after new connection to host  "+hpf_host);  
}
  
 
public CMatrix(String host,int port) {

  // ADDED BY EROL
  hpf_host = host;
  hpf_port = port;
  hpfprogram_port = 3336;
  setLayout(new BorderLayout());
  panel = new MatrixPanel(this);

  
  chartPanel.setLayout(new GridLayout(2,1));
  chartPanel.add(panel);


  add("Center", chartPanel);
  Panel p = new Panel();
  add("South", p);
  p.add(new Button(FILE_BUTTON));
  p.add(new Button(RESTART_BUTTON));
  p.add(new Button(STEP_BUTTON));
  p.add(new Button(EXIT_BUTTON));
  p.add(startButton = new Button(START_BUTTON));  
  p.add(new Button(PARAM_BUTTON));
  
  MenuBar mb = new MenuBar();
  Menu hm = new Menu(HELP_MENU);
  hm.add(new MenuItem(HMENU_help));
  mb.add(hm);
  setMenuBar(mb);

  // DELETED BY EROL
  aThread = new Thread(panel);
  aThread.start();
  pobj = panel.pobj;
  chartPanel.add(infoPanel = new InfoPanel(pobj));
    
  aThread.suspend();
  startFlag = true; 

  communication com_cmd;
  filtered_functions fil_funs;
  // ADDED BY EROL

  
  
}
   //--------------------------------------------
public boolean handleEvent(Event evt) {
  if (evt.id == Event.WINDOW_DESTROY) System.exit(0);
  return super.handleEvent(evt);
}

public void dialogDismissed(Dialog d) 
  {
    System.out.println("Dialog Down");
  }

   //--------------------------------------------
public boolean action(Event evt, Object arg) {
  System.out.println("in action()");
  if (evt.target instanceof Button) {
    if (arg.equals(startButton.getLabel())) {
      
      panel.stepFlag = false;
      if (startFlag) {
        //ADDED BY EROL        

        network nt = new network(hpf_host,hpf_port);
        String cmd = "fork.pl";
        nt.send_http_command(cmd);  
        Open_port(hpf_host,hpfprogram_port,true);
        com_cmd  = new communication(con);  
        fil_funs = new filtered_functions(com_cmd);
        MatrixPanel.fil_funs = fil_funs;
        // ADDED BY EROL
           
        new read_from_http_server (nt).start();
        // ADDED BY EROL
 
	startButton.setLabel(" Stop");
        //DELETED BY EROL
	//aThread.resume();

	startFlag = false; 
      }
      else {
	System.out.println("-------> Stopping .....");
	aThread.suspend();
	startButton.setLabel("  Resume  ");
	startFlag = true; 
      }
	   
/*TEMP_DISABLE
           new read_from_http_server (nt).start();
<*/
    }
    else if (arg.equals(STEP_BUTTON)) {
      panel.stepFlag = true;
      aThread.resume();      
    } 
    else if (arg.equals(PARAM_BUTTON)) {
      aThread.suspend();
      //System.out.println("I am skipping ParameterDialog for DEBUGGING");
      pd = new ParameterDialog(Util.getFrame(this), this, pobj, true);
      pobj = pd.getParameters();
      pobj.print();

      // ADDED BY EROL
      int dims[] = new int[6];
      for(int i=0,j=3;i<3;i++,j++){
         dims[i] = pobj.dim1[i];
         dims[j] = pobj.dim2[j-3]; //BUG pobj.dim1[j-3];
      }
      try {
        fil_funs.send_laplace_pars(pobj.eps,0.0005458D,pobj.step,dims); 
      }catch (IOException e) {
             System.out.println("IO Exception during send_laplace_pars "+e);}

      System.out.println("after send_laplace_pars");

      try {
         fil_funs.recv_data_field_info();
      }catch (IOException e) {
            System.out.println("IO Exception during recv_data_field_info "+e);}
      // ADDED BY EROL

      aThread.resume();
      // ADDED BY EROL

      panel.resetSimulationWithParams(pobj);
      infoPanel.refresh(pobj);
      aThread.resume();
      
    }        
    else if (arg.equals(EXIT_BUTTON)) {
/*TEMP_DISABLE
            try {
                  con.close_connection();  
             }
             catch (IOException e) {
                 System.out.println("IO Exception in Exit closing socket");
             }
             nt.send_http_command("kill.pl");
             System.out.println("Exit");
*/
      if (panel.inAnApplet) {
	System.out.println("Disposing");
	dispose();
	return(true);
      } else
	System.exit(0);
    } else if (arg.equals(RESTART_BUTTON)) {
      aThread.suspend();
      System.out.println("Restart");
      panel.resetSimulationWithParams(pobj);
      aThread.resume();      
    } else if (arg.equals(FILE_BUTTON)) {
      //PrintArray aWindow = new PrintArray(array);
      //aWindow.setTitle("Array Data Display");
      //aWindow.resize(640,640);
      //aWindow.show();
    }
    else
      return super.action(evt, arg);
    return true;
  } else if (evt.target instanceof MenuItem) {
    if (arg.equals(HMENU_help)) {
      HelpFrame hframe = new HelpFrame();
      hframe.show();
    } else {
      return super.action(evt, arg);
    }
  } else {
    System.out.println("What ?");
    System.out.println("done");
    return super.action(evt, arg);
  }
  return true;
}
  //--------------------------------------------
// public static void main(String args[]) {
//  CMatrix aWindow = new CMatrix();
//  aWindow.panel.inAnApplet = false;
//  aWindow.setTitle("Laplace Matrix");
//  aWindow.pack();
//  aWindow.resize(740,700);
//  aWindow.show();
//}
  }


class ParameterDialog extends Dialog
{
  ParameterObj pobj;
  int[] ar_info1 = new int[3];
  int[] ar_info2 = new int[3];
  int eps;
  int step;
  
  TextField fname   = new TextField(25);

  Button okButton = new Button(" OK ");
  Button cancelButton = new Button(" Cancel ");
  private DialogClient client;
  ParamPanel parPanel; // = new ParamPanel();
  
  Panel buttonsPanel = new Panel();
  ParameterObj initialpobj;

public ParameterDialog(Frame frame, 
			DialogClient client,
			ParameterObj pobj, 
			boolean modal) 
  {        
    super(frame, "Laplace Parameters", modal); 
    this.client = client;
    this.initialpobj = pobj;
    this.pobj = pobj; 
    
    parPanel = new ParamPanel(pobj);
     
    setLayout(new BorderLayout());
    add("North", new Label("Parameters", Label.CENTER)); 
    
    
    add("Center", parPanel); 

    buttonsPanel.setLayout(new RowLayout());
    buttonsPanel.add(cancelButton);
    buttonsPanel.add(okButton); 
    
    add("South", buttonsPanel); 
    this.pack();
    this.show();
  }

public ParameterObj getParameters() 
  {
    return pobj; 
  }

 public boolean handleEvent(Event event) 
   {
     if (event.id == Event.WINDOW_DESTROY) ;
     //done(null);
     return super.handleEvent(event);
   }

 public boolean action(Event e, Object what) {
   if (e.target == okButton) {
     pobj = parPanel.getValues();
     this.hide();
     this.dispose();
     return true;
   }
   if (e.target == cancelButton) {
     pobj = initialpobj; 
     this.hide();
     this.dispose();
     return true;
   }
   return false;
 }
}


class ParamPanel extends Panel 
{
  ParameterObj pobj;
  TextField[] dim1_fld = new TextField[3];
  TextField[] dim2_fld = new TextField[3];
  TextField  eps_fld, step_fld;
  
public ParamPanel(ParameterObj pobj) 
  {
    this.pobj = pobj;
    
    setLayout(new GridLayout(8,2));
    add(new Label("Dim1 lower bound: "));
    add(dim1_fld[0] = new TextField(4));
    add(new Label("Dim1 upper bound: "));
    add(dim1_fld[1] = new TextField(4));
    add(new Label("Dim1 stride     : "));
    add(dim1_fld[2] = new TextField(4));
    add(new Label("Dim2 lower bound: "));
    add(dim2_fld[0] = new TextField(4));
    add(new Label("Dim2 upper bound: "));
    add(dim2_fld[1] = new TextField(4));
    add(new Label("Dim2 stride     : "));
    add(dim2_fld[2] = new TextField(4));
    add(new Label("Epsilon         : "));
    add(eps_fld = new TextField(4));
    add(new Label("Display Step Size:"));
    add(step_fld = new TextField(4));
    showInitialValues(pobj);
  }
public void showInitialValues(ParameterObj pobj) 
  {
    for (int i=0; i<3; i++) {
      dim1_fld[i].setText(""+pobj.dim1[i]);
      dim2_fld[i].setText(""+pobj.dim2[i]);
    }
    eps_fld.setText(""+pobj.eps);
    step_fld.setText(""+pobj.step);
  }
  
  //--------------------------------------------------
public ParameterObj getValues() 
  {
    ParameterObj pobj  = new ParameterObj();

    int[] dim1 = new int[3];
    int[] dim2 = new int[3];
    double eps;
    int   step;
    
    for (int i=0; i<3; i++) {
      dim1[i] = (int)Integer.parseInt(dim1_fld[i].getText());
      dim2[i] = (int)Integer.parseInt(dim2_fld[i].getText());
    }
    eps = Double.valueOf(eps_fld.getText()).doubleValue();
    step = (int)Integer.parseInt(step_fld.getText());
    pobj.set(dim1, dim2, eps, step);
    return pobj;
  }
}



class ParameterObj extends Object 
{
  int[] dim1 =  new int[3];
  int[] dim2 = new int[3];
  double eps = 0.001;
  int step = 1;

public ParameterObj()  
  {
    dim1[0] = 1;
    dim1[1] = 16;
    dim1[2] = 1;
    dim2[0] = 1;
    dim2[1] = 16;
    dim2[2] = 1;
    eps = 0.00001;
    step = 1;
  }
  



public void set(int[] dim1, int[] dim2, double eps, int step) {
  for (int i=0; i<3; i++) {
    this.dim1[i] = dim1[i];
    this.dim2[i] = dim2[i];
  }
  this.eps = eps;
  this.step= step;
}
public void print() 
  {
    System.out.println("Dim1 ="+dim1[0]+":"+dim1[1]+":"+dim1[2]);
    System.out.println("Dim2 ="+dim2[0]+":"+dim2[1]+":"+dim2[2]);
    System.out.println("Epsilon ="+eps);
    System.out.println("Step    ="+step);
  }

}

class InfoPanel extends Panel 
{
  ParameterObj pobj;
  Label[] dim1_fld = new Label[3];
  Label[] dim2_fld = new Label[3];
  Label  eps_fld, step_fld;
  
public InfoPanel(ParameterObj pobj) 
  {
    this.pobj = pobj;
    
    setLayout(new ColumnLayout());    
    Panel p1 = new Panel();
    p1.setLayout(new GridLayout(1,2));
    Panel pl = new Panel();
    pl.setLayout(new ColumnLayout());
    Panel pr = new Panel();
    pr.setLayout(new ColumnLayout());
    p1.add(new ThreeDBorder(pl));
    p1.add(new ThreeDBorder(pr));
    pl.add(dim1_fld[0] = new Label("Dim1 lower bound: "+pobj.dim1[0]));
    pl.add(dim1_fld[1] = new Label("Dim1 upper bound: "+pobj.dim1[1]));
    pl.add(dim1_fld[2] = new Label("Dim1 stride     : "+pobj.dim1[2])); 
    pr.add(dim2_fld[0] = new Label("Dim2 lower bound: "+pobj.dim1[0]));
    pr.add(dim2_fld[1] = new Label("Dim2 upper bound: "+pobj.dim1[1]));
    pr.add(dim2_fld[2] = new Label("Dim2 stride     : "+pobj.dim1[2])); 

    Panel pb = new Panel();
    pb.setLayout(new ColumnLayout());
    pb.add(eps_fld = new Label("Epsilon          : "+pobj.eps));
    pb.add(step_fld = new Label("Step size       : "+pobj.step));

    add(p1);
    add(new ThreeDBorder(pb));
    
  }

public void refresh(ParameterObj pobj) 
  {
    this.pobj = pobj;
    
    dim1_fld[0].setText("Dim1 lower bound: "+pobj.dim1[0]);
    dim1_fld[1].setText("Dim1 upper bound: "+pobj.dim1[1]);
    dim1_fld[2].setText("Dim1 stride     : "+pobj.dim1[2]);
    dim2_fld[0].setText("Dim2 lower bound: "+pobj.dim2[0]);
    dim2_fld[1].setText("Dim2 upper bound: "+pobj.dim2[1]);
    dim2_fld[2].setText("Dim2 stride     : "+pobj.dim2[2]);
    eps_fld.setText("Epsilon          : "+pobj.eps);
    step_fld.setText("Step size       : "+pobj.step);

    System.out.println("refresh tamam.");
    
  }
  
}

// ADDED BY EROL

//===============================================


class network {
  
    private Socket s;
    private String host;
    private int port; 
    DataOutputStream os ;
    DataInputStream is;

   public  void send_http_command(String cmd)
   {

      // network nt = new network("osprey7.npac.syr.edu", 3768);

      String sdata = "Erol Akarsu";  
      String script = "/cgi-bin/"+cmd;
      System.out.println("Before communicate ");
      communicate(sdata,script);
      System.out.println("After  communicate ");
    }
   
    public network(String hostName,int portNo) {
      host = hostName;
      port = portNo;
      try {

        s  = new Socket(host, port);
        os = new DataOutputStream(s.getOutputStream());
        is = new DataInputStream(s.getInputStream());
      }catch (IOException e) {
        System.out.println("Io exception in network ");
      }  

      System.out.println("After opening socket to server ");  

    }

    public void  communicate (String sdata, String script)
    {
      String result = "";

      try {  
         
         System.out.println("After opening socket to server ");  
         os.writeBytes("GET " + script
            + " HTTP/1.0\r\n" 
            + "Accept: www/source\r\n"
            + "Accept: text/html\r\n"
            + "Accept: image/gif\r\n"
            + "Content-type: application/octet-stream\r\n"
            + "Content-length: " 
            + sdata.length() + "\r\n\r\n"); 
            //+ "\r\n\r\n"); 
         os.writeBytes(sdata); 

         System.out.println("Write ok..");

         //String line="";
         // while ((line = is.readLine()) != null)
         //  if (line.equals("CONTINUE")){
         //     System.out.println("I got BREAK the line   " +line) ; 
         //     break;
         //    }
         //System.out.println("I got the line   " +line) ; 
         //is.close();
         //os.close();
         //System.out.println("Read ok..");
      }

      catch (Exception e)
      {  
        if (s != null)
            try {
               s.close();
            }
            catch (IOException ex) {}
      }
      
   }
}

class read_from_http_server extends Thread{
   DataInputStream is;

   public read_from_http_server (network nt)
   {
     is = nt.is;
   }

   public void run  ()
   {
       String line = " ";
       byte chr;

       try{
	 
	 while ((line = is.readLine()) != null);
	 //System.out.println("I got line   " +line) ; 
       }
       catch(IOException ex) {
       }
       

       

       while(!line.equals(""))
       {
         line = " "; 
         System.out.println("I am reading from HTTP");
         try {
           while((chr = is.readByte()) != 0){
            line += Byte.toString(chr);
           }
         }catch (IOException ex) {}
         //System.out.println("I got the line   " +line) ;
          
         try {
               Thread.sleep(1000);
         }
         catch (InterruptedException ie) {break;}

         Thread.yield();
       }
    }
}



