// HelpFrame.java 05/28/1996
// $Id$
// $Log$

import java.awt.*;

class HelpLine {
  int typ;
  String msg;
  HelpLine(int typ_, String msg_) {
    typ = typ_;
    msg = msg_;
  }
}

//*===========================
//* HelpPanel
//*===========================
class HelpPanel extends Panel {
   boolean inAnApplet = true;

   private Font labelF;
   private FontMetrics labelFM;

   private Image offscreen;
   private Dimension offscreensize;
   private Graphics offgraphics;
   int len;
   final int M_0 = 0;
   final int M_1 = 1;
   HelpLine line[];
   int h;
   int y = 10;
   int yinit; // = 10;
   int x = 10;
   int w;
   int frameW, frameH;
   HelpFrame myParent;
   //-------------------------------------------
   HelpPanel(HelpFrame parent_) { 
     line = new HelpLine[15];

     myParent = parent_;
     
     computeWindowSize();
     repaint();     
   }
     
     void computeWindowSize() {
       labelF = new Font("Helvetica", Font.PLAIN, 16);
       labelFM= myParent.getFontMetrics(labelF);    
       h = labelFM.getHeight();
       for (int i=0; i<len; i++) {
          int siz = labelFM.stringWidth(line[i].msg);
          if (siz > frameW) frameW = siz;
       }
       frameW = frameW + labelFM.stringWidth("01234567890");
       frameH = (len+6)*h;
       yinit = 5 + h;
       myParent.resize(frameW, frameH);
    //   System.out.println(frameW + " " + frameH);
     }

     void printHelp(Graphics g) {
       y = yinit;
       for (int i=0; i<len; i++) {
	 g.drawString("This applet shows the stages during the solution",x,y);
	 y+=h;
	 
	 g.drawString("of the Laplace Equation on a 16 by 16 matrix.",x, y);
	 y+=h;
       }
       }
  
   //--------------------------------------------
   public synchronized void paint(Graphics g) {
      Dimension d = size();
      if ((offscreen == null)) { 
         //offscreen = createImage(d.width, d.height);
         offscreen = createImage(1000,1000);
	 offscreensize = d;
	 offgraphics = offscreen.getGraphics();
         offgraphics.setFont(labelF); 
      }
      offgraphics.setColor(getBackground());
      offgraphics.fillRect(0, 0, d.width, d.height);
      
      printHelp(offgraphics);
      g.drawImage(offscreen, 0,0, null);
   }
   //--------------------------------------------------

}

//*====================================
//*
//*====================================
public class HelpFrame extends Frame {
   HelpPanel panel;
   int simTime = 0;
   final String EXIT_BUTTON = "OK";

   public HelpFrame() {

      setLayout(new BorderLayout());
      panel = new HelpPanel(this);
      add("Center", panel);
      Panel p = new Panel();
      add("South", p);      
      p.add(new Button(EXIT_BUTTON));

      
    
   }

   //--------------------------------------------
   public boolean handleEvent(Event evt) {
      if (evt.id == Event.WINDOW_DESTROY) System.exit(0);
      return super.handleEvent(evt);
   }
   //--------------------------------------------
   public boolean action(Event evt, Object arg) {
      if ((evt.target instanceof Button) &&
          arg.equals(EXIT_BUTTON)) {
          if (panel.inAnApplet) {
             dispose();
             return(true);
          }else 
             System.exit(0);
	   }
       else return super.action(evt, arg);
	   return true;
   }

   //--------------------------------------------
   public static void main(String args[]) {
      HelpFrame aWindow = new HelpFrame();
      aWindow.panel.inAnApplet = false;
      aWindow.setTitle("Help");
      //aWindow.pack();
      //aWindow.resize(480,250);
      aWindow.show();

   }
}
 
