import java.io.*;
import java.net.*;
import java.util.*;


public class client1{

	public static void main(String argv[]) throws IOException{
          char ch,chr;
          connection con;
          communication cm;
          int intval;
          int[] dim_info = new int[6];
          char charval;
          float floatval,far[];
          int dims[]={3,6,1,1,9,2};
          char str[] ;
          int [][]i2dar ;
          
          for(int i=0;i<argv.length;i++)
            System.out.println(argv[i]);

          con = new connection(argv[0], Integer.parseInt(argv[1]),true);
          System.out.println("after connection to port  "+argv[1]);
          cm = new communication(con);          
        
          send_laplace_pars(0.000001D,0.0005458D,50,dims,cm);
          recv_filtered_data(cm) ;          

          cm.Register("Integer","intvar",0,dim_info);
          cm.Register("Character","charvar",0,dim_info);        
          cm.Register("Float","floatvar",0,dim_info); 
          dim_info[0] = 5;
          cm.Register("[F","floatar",1,dim_info);
          dim_info[0] = 11;
          cm.Register("[C","charar",1,dim_info);
          dim_info[0] = 2; dim_info[1]= 4;
          cm.Register("[[I","intar",2,dim_info);
          System.out.println("After registrations");

          cm.Receive();   
          cm.Receive(); 
          cm.Receive();   
          cm.Receive(); 
          cm.Receive();   
          cm.Receive();

          intval   = ((Integer)(cm.get_databuf(0))).intValue();
          charval  = ((Character)(cm.get_databuf(1))).charValue();
          floatval = ((Float)(cm.get_databuf(2))).floatValue();
          far      = (float[])(cm.get_databuf(3));
          str      = (char[])(cm.get_databuf(4));
          String instr = new String(str,0,str.length); 
          i2dar = (int[][])(cm.get_databuf(5));

          System.out.println(intval+"  "+charval+"  "+floatval);
          System.out.println(far[0]+" "+far[1]+" "+far[2]+" "+far[3]+" "+
                     far[4]+" ");
          
          for(int i=0;i<2;i++)
            for(int j=0;j<4;j++)
              System.out.println("i2dar "+i2dar[i][j]);
          
          System.out.println(instr);
         
          con.close_connection();

    }

    public static void send_laplace_pars(double epsilon,double maxerr,int step,
       int[] bounds ,communication cm) throws IOException
    {
       int i1,i2,i3,i4;
       int []dim_info = new int[1];
       dim_info[0] = 6;
       int lb,ub,s;
 
       i1 = cm.Register("Double","epsilon",0,dim_info);
       i2 = cm.Register("Double","maxerr",0,dim_info);
       i3 = cm.Register("Integer","step",0,dim_info);
       i4 = cm.Register("[I","bounds",1,dim_info);  
       // bounds includes lb1:ub1:s1 and lb2:ub2:s2 for both dimension.
      
       cm.put_databuf(new Double(epsilon),i1);
       cm.put_databuf(new Double(maxerr),i2);
       cm.put_databuf(new Integer(step),i3);
       cm.put_databuf(bounds,i4); 

       cm.Send(i1);
       cm.Send(i2);
       cm.Send(i3);
       cm.Send(i4);
       System.out.println(" after lapa_par");

    }

    public static Object recv_filtered_data(communication cm) throws IOException
    {
       // first read header : ndims and dim1,dim2,..,dimn values 
       // For now we have only two dimensions

       int []dim_info = new int[7];
       cm.rcon.recv_int(); // recv tag
       int ndims = cm.rcon.recv_int();
       System.out.println("ndims = "+ndims);
       cm.rcon.recv_int(); // recv tag
       for(int i=0;i<ndims;i++){
          dim_info[i]  = cm.rcon.recv_int();
          System.out.println("dim "+dim_info[i]);
       }

       cm.Register("[[D","filtered_data",ndims,dim_info);
       System.out.println("after filter");
       return (cm.Receive());
    }    

}


class communication {
  Vector vars ;
  DataInputStream  dis;
  DataOutputStream dos;
  recv_module rcon;
  send_module scon;

  public  communication(connection con)
  {
    vars = new Vector(5,5);
    dis = con.dis;
    dos = con.dos;
    rcon = new recv_module(con);
    scon = new send_module(con);
    
  }

  public int Register(String type_,String name_,int ndims_,int[] dim_info_)
  {
     comm_protocol cp = new comm_protocol(type_,name_, ndims_,dim_info_,
           rcon,scon);
     vars.addElement(cp);   
     return (vars.size()-1);
  }

  public Object Receive() throws IOException
  {
     int msg_tag = rcon.recv_int(); // get first message tag
     int index = msg_tag;
     System.out.println("tag ="+index);
     comm_protocol cp = (comm_protocol)(vars.elementAt(index));
     return cp.Receive();
  }

  public void Send(int index)throws IOException
  {
     comm_protocol cp = (comm_protocol)(vars.elementAt(index));
     scon.send_int(index); // send first message tag
     cp.Send();
  }

  public Object get_databuf(int index)
  {
     comm_protocol cp = (comm_protocol)(vars.elementAt(index));
     return (cp.buf);
  }

  public void put_databuf(Object obj,int index)
  {
     comm_protocol cp = (comm_protocol)(vars.elementAt(index));
     cp.buf = obj; 
  }

}
     



class comm_protocol {
  String type;
  String name;
  int    ndims;       //  0 for simple variables,ndims for array vars  
  int[]  dim_info; 
  int    sizeof_data; // total size of push_data in bytes 
  Object buf;         // includes actual data whatever it is 
  recv_module rcon;
  send_module scon;
 
  public  comm_protocol(String type_,String name_,int ndims_,int[] dim_info_,
          recv_module rcon_, send_module scon_) 
  {
          type     = type_;
          name     = name_;
          ndims    = ndims_;
          dim_info = dim_info_;
          int[] d  = dim_info;
          scon     = scon_;
          rcon     = rcon_;
          
             
          // arrays
          // Boolean arrays
          if (type.equals("[Z"))
             buf = new boolean[d[0]];
          else if (type.equals("[[Z"))
             buf = new boolean[d[0]][d[1]];
          else if (type.equals("[[[Z"))
             buf = new boolean[d[0]][d[1]][d[2]];

          //byte arrays   
          else if (type.equals("[B"))
             buf = new byte[d[0]];
          else if (type.equals("[[B"))
             buf = new byte[d[0]][d[1]];
          else if (type.equals("[[[B"))
             buf = new byte[d[0]][d[1]][d[2]];

          //char arrays 
          else if (type.equals("[C"))
             buf = new char[d[0]];
          else if (type.equals("[[C"))
             buf = new char[d[0]][d[1]];
          else if (type.equals("[[[C"))
             buf = new char[d[0]][d[1]][d[2]];
  
          //short arrays 
          else if (type.equals("[S"))
             buf = new short[d[0]];
          else if (type.equals("[[S"))
             buf = new short[d[0]][d[1]];
          else if (type.equals("[[[S"))
             buf = new short[d[0]][d[1]][d[2]];
  
          //int arrays 
          else if (type.equals("[I"))
             buf = new int[d[0]];
          else if (type.equals("[[I"))
             buf = new int[d[0]][d[1]];
          else if (type.equals("[[[I"))
             buf = new int[d[0]][d[1]][d[2]];
  
          //long arrays 
          else if (type.equals("[J"))
             buf = new long[d[0]];
          else if (type.equals("[[J"))
             buf = new long[d[0]][d[1]];
          else if (type.equals("[[[J"))
             buf = new long[d[0]][d[1]][d[2]];  

          //float arrays 
          else if (type.equals("[F"))
             buf = new float[d[0]];
          else if (type.equals("[[F"))
             buf = new float[d[0]][d[1]];
          else if (type.equals("[[[F"))
             buf = new float[d[0]][d[1]][d[2]];  

          //double arrays 
          else if (type.equals("[D"))
             buf = new double[d[0]];
          else if (type.equals("[[D"))
             buf = new double[d[0]][d[1]];
          else if (type.equals("[[[D"))
             buf = new double[d[0]][d[1]][d[2]];  
          //else
          //   System.out.println("Unknown type : "+type);      
         
     }

   
     public Object  Receive() throws IOException
     {

          if (type.lastIndexOf("Boolean") != -1)
              buf = new Boolean(rcon.recv_boolean());
          else if (type.lastIndexOf("Byte")!= -1)
              buf = new Byte(rcon.recv_byte());
          else if (type.lastIndexOf("Character")!= -1)
              buf = new Character(rcon.recv_char());
          else if (type.lastIndexOf("Short")!= -1)
              buf = new Short(rcon.recv_short());
          else if (type.lastIndexOf("Integer")!= -1)
              buf = new Integer(rcon.recv_int());
          else if (type.lastIndexOf("Long")!= -1)
              buf = new Long(rcon.recv_long());
          else if (type.lastIndexOf("Float")!= -1)
              buf = new Float(rcon.recv_float());
          else if (type.lastIndexOf("Double")!= -1)
              buf = new Double(rcon.recv_double());
             
          // arrays
          // Boolean arrays
          else if (type.equals("[Z"))
             rcon.recv_1Dboolean_array((boolean[])buf);
          else if (type.equals("[[Z"))
             rcon.recv_2Dboolean_array((boolean[][])buf);
          else if (type.equals("[[[Z"))
             rcon.recv_3Dboolean_array((boolean[][][])buf);

          //byte arrays   
          else if (type.equals("[B"))
             rcon.recv_1Dbyte_array((byte[])buf);
          else if (type.equals("[[B"))
             rcon.recv_2Dbyte_array((byte[][])buf);
          else if (type.equals("[[[B"))
             rcon.recv_3Dbyte_array((byte[][][])buf);

          //char arrays 
          else if (type.equals("[C"))
             rcon.recv_1Dchar_array((char[])buf); 
          else if (type.equals("[[C"))
             rcon.recv_2Dchar_array((char[][])buf);
          else if (type.equals("[[[C"))
             rcon.recv_3Dchar_array((char[][][])buf);
  
          //short arrays 
          else if (type.equals("[S"))
             rcon.recv_1Dshort_array((short[])buf); 
          else if (type.equals("[[S"))
             rcon.recv_2Dshort_array((short[][])buf); 
          else if (type.equals("[[[S"))
             rcon.recv_3Dshort_array((short[][][])buf);
  
          //int arrays 
          else if (type.equals("[I"))
             rcon.recv_1Dint_array((int[])buf);
          else if (type.equals("[[I"))
             rcon.recv_2Dint_array((int[][])buf);
          else if (type.equals("[[[I"))
             rcon.recv_3Dint_array((int[][][])buf);
  
          //long arrays 
          else if (type.equals("[J"))
             rcon.recv_1Dlong_array((long[])buf);
          else if (type.equals("[[J"))
             rcon.recv_2Dlong_array((long[][])buf);
          else if (type.equals("[[[J"))
             rcon.recv_3Dlong_array((long[][][])buf);

          //float arrays 
          else if (type.equals("[F"))
             rcon.recv_1Dfloat_array((float[])buf);
          else if (type.equals("[[F"))
             rcon.recv_2Dfloat_array((float[][])buf);
          else if (type.equals("[[[F"))
             rcon.recv_3Dfloat_array((float[][][])buf);

          //double arrays 
          else if (type.equals("[D"))
             rcon.recv_1Ddouble_array((double[])buf);
          else if (type.equals("[[D"))
             rcon.recv_2Ddouble_array((double[][])buf);
          else if (type.equals("[[[D"))
             rcon.recv_3Ddouble_array((double[][][])buf);
          else
             System.out.println("Unknown type : "+type);       

          return buf;

        }

      public void Send() throws IOException
      {


          if (type.lastIndexOf("Boolean") != -1)
              scon.send_boolean(((Boolean)buf).booleanValue());
          else if (type.lastIndexOf("Byte")!= -1)
              scon.send_byte(((Byte)buf).byteValue());
          else if (type.lastIndexOf("Character")!= -1)
              scon.send_char(((Character)buf).charValue());
          else if (type.lastIndexOf("Short")!= -1)
              scon.send_short(((Short)buf).shortValue());
          else if (type.lastIndexOf("Integer")!= -1)
              scon.send_int(((Integer)buf).intValue());
          else if (type.lastIndexOf("Long")!= -1)
              scon.send_long(((Long)buf).longValue());
          else if (type.lastIndexOf("Float")!= -1)
              scon.send_float(((Float)buf).floatValue());
          else if (type.lastIndexOf("Double")!= -1){
              scon.send_double(((Double)buf).doubleValue());
              System.out.println("double "+((Double)buf).doubleValue() );
          }
          // arrays
          // Boolean arrays
          else if (type.equals("[Z"))
             scon.send_1Dboolean_array((boolean[])buf);
          else if (type.equals("[[Z"))
             scon.send_2Dboolean_array((boolean[][])buf);
          else if (type.equals("[[[Z"))
             scon.send_3Dboolean_array((boolean[][][])buf);

          //byte arrays   
          else if (type.equals("[B"))
             scon.send_1Dbyte_array((byte[])buf);
          else if (type.equals("[[B"))
             scon.send_2Dbyte_array((byte[][])buf);
          else if (type.equals("[[[B"))
             scon.send_3Dbyte_array((byte[][][])buf);

          //char arrays 
          else if (type.equals("[C"))
             scon.send_1Dchar_array((char[])buf); 
          else if (type.equals("[[C"))
             scon.send_2Dchar_array((char[][])buf);
          else if (type.equals("[[[C"))
             scon.send_3Dchar_array((char[][][])buf);
  
          //short arrays 
          else if (type.equals("[S"))
             scon.send_1Dshort_array((short[])buf); 
          else if (type.equals("[[S"))
             scon.send_2Dshort_array((short[][])buf); 
          else if (type.equals("[[[S"))
             scon.send_3Dshort_array((short[][][])buf);
  
          //int arrays 
          else if (type.equals("[I"))
             scon.send_1Dint_array((int[])buf);
          else if (type.equals("[[I"))
             scon.send_2Dint_array((int[][])buf);
          else if (type.equals("[[[I"))
             scon.send_3Dint_array((int[][][])buf);
  
          //long arrays 
          else if (type.equals("[J"))
             scon.send_1Dlong_array((long[])buf);
          else if (type.equals("[[J"))
             scon.send_2Dlong_array((long[][])buf);
          else if (type.equals("[[[J"))
             scon.send_3Dlong_array((long[][][])buf);

          //float arrays 
          else if (type.equals("[F"))
             scon.send_1Dfloat_array((float[])buf);
          else if (type.equals("[[F"))
             scon.send_2Dfloat_array((float[][])buf);
          else if (type.equals("[[[F"))
             scon.send_3Dfloat_array((float[][][])buf);

          //double arrays 
          else if (type.equals("[D"))
             scon.send_1Ddouble_array((double[])buf);
          else if (type.equals("[[D"))
             scon.send_2Ddouble_array((double[][])buf);
          else if (type.equals("[[[D"))
             scon.send_3Ddouble_array((double[][][])buf);
          else
             System.out.println("Unknown type : "+type);       

      } 

}


class connection  {
  public String host;
  public int    port;
  Socket sock;
  DataInputStream dis;
  DataOutputStream dos;

  // If you want to get data from fortran program set it, and
  // but from C program reset it
  public  boolean FORTRAN_DEFINED ;
  public boolean record_comm;

  public connection (String ahost,int aport,boolean FD) throws IOException
  {

     host = ahost;
     port = aport;
     FORTRAN_DEFINED = FD;
     open_connection() ;
  }

  public void  open_connection() throws IOException
  {
    sock = new Socket(host,port);
    dis  = new DataInputStream( sock.getInputStream());
    dos  = new DataOutputStream( sock.getOutputStream()); 
  }

  public void close_connection() throws IOException
  {
    sock.close();
  }
  
  public DataInputStream  getInputS( ) throws IOException
  {
    
     return (dis);
  }

  public DataOutputStream  getOutputS( Socket sock) throws IOException
  {
    
     return (dos);
  }

  public Socket getSocket()
  {
    return sock;
  }
 }


 class recv_module {
  DataInputStream  dis;
  DataOutputStream dos;
  public boolean  FORTRAN_DEFINED;
 
/////////////////////////////////////
////////////////////////////////////
///////////////////////////////////

  public recv_module(connection con)
  {
     dis = con.dis;
     dos = con.dos;
     FORTRAN_DEFINED = con.FORTRAN_DEFINED;
  }

  public int recv_int() throws IOException
  {
     return dis.readInt();
  }

  public char recv_char()  throws IOException
  {
    return (char)(dis.readInt());
  }

  public boolean recv_boolean()  throws IOException
  {
    int intval ;

    intval = dis.readInt();
    if (intval ==  0)
      return true;
    else
      return false;
  }

  public byte recv_byte()  throws IOException
  {
    return (byte)(dis.readInt());
  }

  public short recv_short()  throws IOException
  {
    return (short)(dis.readInt());
  }

  public long  recv_long()  throws IOException
  {
     return dis.readLong();
  }

  public float  recv_float()  throws IOException
  {
     return dis.readFloat();
  }

  public double  recv_double()  throws IOException
  {
     return dis.readDouble();
  }

  

// FOR INTEGER ARRAYS///////////////////////////////////////
//////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

 public void  recv_1Dint_array(int []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_int();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dint_array(int[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     // nelems = recv_int() ; // number of elements in array 
         
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_int();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_int();
     
  }     
 
  public void  recv_3Dint_array(int[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_int();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_int();
    
  }

  // FOR CHARACTER  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

   public void  recv_1Dchar_array(char[] str)
  throws IOException
  {  int nelems;   

     int strlen = str.length;

     for(int i=0; i<strlen;i++) 
         str[i] = recv_char();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dchar_array(char[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
    
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_char();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_char();
     
  }     
 
  public void  recv_3Dchar_array(char[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_char();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_char();
    
  }



  
  // FOR BOOLEAN ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dboolean_array(boolean []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_boolean();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dboolean_array(boolean[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_boolean();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_boolean();
     
  }     

   
  public void  recv_3Dboolean_array(boolean[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_boolean();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_boolean();
    
  }


  // FOR BYTE ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dbyte_array(byte []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_byte();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dbyte_array(byte[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_byte();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_byte();
     
  }     

   
  public void  recv_3Dbyte_array(byte[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_byte();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_byte();
    
  }
  

  // FOR SHORT ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dshort_array(short []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_short();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dshort_array(short[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
      
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_short();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_short();
     
  }     
 
  public void  recv_3Dshort_array(short[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_short();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_short();
    
  }

 
  // FOR LONG  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  
  public void  recv_1Dlong_array(long []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array        
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_long();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dlong_array(long[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_long();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_long();
     
  }     
 
  public void  recv_3Dlong_array(long[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_long();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_long();
    
  }




  // FOR FLOAT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dfloat_array(float []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;
     // nelems = recv_int() ; // number of elements in array 
   
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_float();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dfloat_array(float[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
    
     // nelems = recv_int() ; // number of elements in array      
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_float();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_float();
     
  }     
 
  public void  recv_3Dfloat_array(float[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_float();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_float();
    
  }
 
  // FOR DOUBLE   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Ddouble_array(double []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array   
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_double();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Ddouble_array(double[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     // nelems = recv_int() ; // number of elements in array      
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_double();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_double();
     
  }     
 
  public void  recv_3Ddouble_array(double[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_double();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_double();
    
  }

  // FOR OBJECT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dobject_array(Object []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     for (int i=0;i<dims[0];i++)
        recv_structure(buf[i]);
  }


   public void  recv_2Dobject_array(Object [][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             recv_structure(buf[i][j]);  
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            recv_structure(buf[i][j]); 
     
  }     
 
  public void  recv_3Dobject_array(Object[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              recv_structure(buf[i][j][k]); 
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              recv_structure(buf[i][j][k]);
  }

  public void recv_structure(Object object) throws IOException
  {  
      java.lang.reflect.Field field[] ;


      field = object.getClass().getDeclaredFields();
            

      for(int i=0;i<field.length;i++){  
        String type = field[i].getType().getName();
        System.out.println("type  "+type);

        try{
          if (type.equals("boolean"))
             field[i].setBoolean(object,recv_boolean());
          else if (type.equals("byte"))
             field[i].setByte(object,recv_byte());
          else if (type.equals("char"))
             field[i].setChar(object,recv_char()); 
          else if (type.equals("short"))
             field[i].setShort(object,recv_short());  
          else if (type.equals("int"))
             field[i].setInt(object,recv_int());
          else if (type.equals("long"))
             field[i].setLong(object,recv_long());
          else if (type.equals("float"))
             field[i].setFloat(object,recv_float());
          else if (type.equals("double"))
             field[i].setDouble(object,recv_float());
         
        
          //boolean arrays 
          else if (type.equals("[Z"))
             recv_1Dboolean_array((boolean[])field[i].get(object));
          else if (type.equals("[[Z"))
             recv_2Dboolean_array((boolean[][])field[i].get(object));
          else if (type.equals("[[[Z"))
             recv_3Dboolean_array((boolean[][][])field[i].get(object));

          
           //byte arrays 
          else if (type.equals("[B"))
             recv_1Dbyte_array((byte[])field[i].get(object));
          else if (type.equals("[[B"))
             recv_2Dbyte_array((byte[][])field[i].get(object));
          else if (type.equals("[[[B"))
             recv_3Dbyte_array((byte[][][])field[i].get(object));

          //char arrays 
          else if (type.equals("[C"))
             recv_1Dchar_array((char[])field[i].get(object));
          else if (type.equals("[[C"))
             recv_2Dchar_array((char[][])field[i].get(object));
          else if (type.equals("[[[C"))
             recv_3Dchar_array((char[][][])field[i].get(object));
 
          //short arrays 
          else if (type.equals("[S"))
             recv_1Dshort_array((short[])field[i].get(object));
          else if (type.equals("[[S"))
             recv_2Dshort_array((short[][])field[i].get(object));
          else if (type.equals("[[[S"))
             recv_3Dshort_array((short[][][])field[i].get(object));
  
          //int arrays 
          else if (type.equals("[I"))
             recv_1Dint_array((int[])field[i].get(object));
          else if (type.equals("[[I"))
             recv_2Dint_array((int[][])field[i].get(object));
          else if (type.equals("[[[I"))
             recv_3Dint_array((int[][][])field[i].get(object));
 
          //long arrays 
          else if (type.equals("[J"))
             recv_1Dlong_array((long[])field[i].get(object));
          else if (type.equals("[[J"))
             recv_2Dlong_array((long[][])field[i].get(object));
          else if (type.equals("[[[J"))
             recv_3Dlong_array((long[][][])field[i].get(object));
 
        
          //float arrays 
          else if (type.equals("[F"))
             recv_1Dfloat_array((float[])field[i].get(object));
          else if (type.equals("[[F"))
             recv_2Dfloat_array((float[][])field[i].get(object));
          else if (type.equals("[[[F"))
             recv_3Dfloat_array((float[][][])field[i].get(object));

          //double arrays 
          else if (type.equals("[D"))
             recv_1Ddouble_array((double[])field[i].get(object));
          else if (type.equals("[[D"))
             recv_2Ddouble_array((double[][])field[i].get(object));
          else if (type.equals("[[[D"))
             recv_3Ddouble_array((double[][][])field[i].get(object));
          else if(field[i].getDeclaringClass().isInstance(object)) 
             recv_structure(field[i].get(object));
          else
             System.out.println("unknown data type  "+type);

         }catch ( IllegalAccessException e){
            System.out.println("IllegalAccessException ");};
     }
  }
}   
  
 
 class send_module {
  DataInputStream  dis;
  DataOutputStream dos;
  public boolean FORTRAN_DEFINED;
 
/////////////////////////////////////
////////////////////////////////////
///////////////////////////////////

  public  send_module(connection con)
  {
     dis = con.dis;
     dos = con.dos;
     FORTRAN_DEFINED = con.FORTRAN_DEFINED;
  }

  public void  send_int(int item) throws IOException
  {
      dos.writeInt(item);
  }

  public void  send_char(char ch)  throws IOException
  {
     dos.writeInt((int)ch);
  }
  

  public void  send_boolean(boolean vbool)  throws IOException
  {
    int intval ;

    if (vbool)
      intval = 1;
    else
      intval = 0;
    dos.writeInt(intval);
  }

  public void send_byte(byte vby)  throws IOException
  {
    dos.writeInt((int)vby);
  }

  public void  send_short(short vsho)  throws IOException
  {
    dos.writeInt((int)vsho);
  }

  public void   send_long(long vlong)  throws IOException
  {
      dos.writeLong(vlong);
  }

  public void  send_float(float vfloat)  throws IOException
  {
     dos.writeFloat(vfloat);
  }

  public void   send_double(double vdouble)  throws IOException
  {
      dos.writeDouble(vdouble);
  }

  public void  send_header(int[] dim,int ndims)  throws IOException
  {
     int nelems=1;
     for(int i=0;i<ndims;i++)
        nelems *= dim[i] ;
     send_int(nelems);    
  }

  // FOR INTEGER ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dint_array(int []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     for (int i=0;i<dims[0];i++){
        System.out.println("buf["+i+"]"+buf[i]);
        send_int(buf[i]);
     }
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dint_array(int[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_int(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_int(buf[i][j]);  
     
  }     
 
  public void  send_3Dint_array(int[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_int(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_int(buf[i][j][k]);  
    
  }

  // FOR CHARACTER  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

   public void  send_1Dchar_array(char [] buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_char(buf[i]);

  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dchar_array(char[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_char(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_char(buf[i][j]);  
     
  }     
 
  public void  send_3Dchar_array(char[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_char(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_char(buf[i][j][k]);  
    
  }

  
  // FOR BOOLEAN ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dboolean_array(boolean []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     
     for (int i=0;i<dims[0];i++)
        send_boolean(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dboolean_array(boolean[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_boolean(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_boolean(buf[i][j]);  
     
  }     

   
  public void  send_3Dboolean_array(boolean[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_boolean(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_boolean(buf[i][j][k]);  
    
  }


  // FOR BYTE ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dbyte_array(byte []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_byte(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dbyte_array(byte[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_byte(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_byte(buf[i][j]);  
     
  }     

   
  public void  send_3Dbyte_array(byte[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
    
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_byte(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_byte(buf[i][j][k]);  
    
  }
  

  // FOR SHORT ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dshort_array(short []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_short(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dshort_array(short[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_short(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_short(buf[i][j]);  
     
  }     
 
  public void  send_3Dshort_array(short[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_short(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_short(buf[i][j][k]);  
    
  }



 
  // FOR LONG  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  
  public void  send_1Dlong_array(long []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_long(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dlong_array(long[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_long(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_long(buf[i][j]);  
     
  }     
 
  public void  send_3Dlong_array(long[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_long(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_long(buf[i][j][k]);  
    
  }




  // FOR FLOAT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dfloat_array(float []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_float(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dfloat_array(float[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_float(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_float(buf[i][j]);  
     
  }     
 
  public void  send_3Dfloat_array(float[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_float(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_float(buf[i][j][k]);  
    
  }
 
  // FOR DOUBLE   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Ddouble_array(double []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_double(buf[i]);

  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Ddouble_array(double[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_double(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_double(buf[i][j]);  
     
  }     
 
  public void  send_3Ddouble_array(double[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_double(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_double(buf[i][j][k]);  
    
  }

  // FOR OBJECT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dobject_array(Object []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_structure(buf[i]);
  
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dobject_array(Object[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_structure(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_structure(buf[i][j]);  
     
  }     
 
  public void  send_3Dobject_array(Object[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_structure(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_structure(buf[i][j][k]);  
    
  }


  public void send_structure(Object object) throws IOException
  {
      java.lang.reflect.Field field[] ;

      field = object.getClass().getDeclaredFields();
      
      for(int i=0;i<field.length;i++){
        String type = field[i].getType().getName();

        try{
          if (type.equals("boolean"))
             send_boolean(field[i].getBoolean(object)); 
          else if (type.equals("byte"))
             send_byte(field[i].getByte(object)); 
          else if (type.equals("char"))
             send_char(field[i].getChar(object));  
          else if (type.equals("short"))
             send_short(field[i].getShort(object)); 
          else if (type.equals("int"))
             send_int(field[i].getInt(object)); 
          else if (type.equals("long"))
             send_long(field[i].getLong(object)); 
          else if (type.equals("float"))
             send_float(field[i].getFloat(object));   
          else if (type.equals("double"))
             send_double(field[i].getDouble(object)); 

          //boolean arrays 
          else if (type.equals("[Z"))
             send_1Dboolean_array((boolean[])field[i].get(object));
          else if (type.equals("[[Z"))
             send_2Dboolean_array( (boolean[][])field[i].get(object));
          else if (type.equals("[[[Z"))
             send_3Dboolean_array( (boolean[][][])field[i].get(object));
 
          //byte arrays 
          else if (type.equals("[B"))
             send_1Dbyte_array((byte[])field[i].get(object));
          else if (type.equals("[[B"))
             send_2Dbyte_array( (byte[][])field[i].get(object));
          else if (type.equals("[[[B"))
             send_3Dbyte_array( (byte[][][])field[i].get(object));
 
          // character arrays
          else if (type.equals("[C"))
             send_1Dchar_array((char[])field[i].get(object));
          else if (type.equals("[[C"))
             send_2Dchar_array( (char[][])field[i].get(object));
          else if (type.equals("[[[C"))
             send_3Dchar_array( (char[][][])field[i].get(object)); 
 
          //short  arrays 
           else if (type.equals("[S"))
             send_1Dshort_array((short[])field[i].get(object));
          else if (type.equals("[[S"))
             send_2Dshort_array( (short[][])field[i].get(object));
          else if (type.equals("[[[S"))
             send_3Dshort_array( (short[][][])field[i].get(object)); 
          
          //int  arrays 
          else if (type.equals("[I"))
             send_1Dint_array((int[])field[i].get(object));
          else if (type.equals("[[I"))
             send_2Dint_array( (int[][])field[i].get(object));
          else if (type.equals("[[[I"))
             send_3Dint_array( (int[][][])field[i].get(object)); 
         
          //long  arrays 
          else if (type.equals("[L"))
             send_1Dlong_array((long[])field[i].get(object));
          else if (type.equals("[[L"))
             send_2Dlong_array( (long[][])field[i].get(object));
          else if (type.equals("[[[L"))
             send_3Dlong_array( (long[][][])field[i].get(object));  
        
          //float   arrays 
          else if (type.equals("[F"))
             send_1Dfloat_array((float[])field[i].get(object));
          else if (type.equals("[[F"))
             send_2Dfloat_array( (float[][])field[i].get(object));
          else if (type.equals("[[[F"))
             send_3Dfloat_array( (float[][][])field[i].get(object)); 
          
          //double  arrays 
          else if (type.equals("[D"))
             send_1Ddouble_array((double[])field[i].get(object));
          else if (type.equals("[[D"))
             send_2Ddouble_array( (double[][])field[i].get(object));
          else if (type.equals("[[[D"))
             send_3Ddouble_array( (double[][][])field[i].get(object)); 
          else if(field[i].getDeclaringClass().isInstance(object)) 
             send_structure(field[i].get(object));
          else
             System.out.println("unknown data type  "+type);

       }catch ( IllegalAccessException e){
            System.out.println("IllegalAccessException ");};
     }
  }
}

