 
class send_module extends connection{

  public  send_module(String ahost,int aport)
  {
    super(ahost,aport);
  }

  public void  send_int(int item) throws IOException
  {
      dos.writeInt(item);
  }

  public void  send_char(char ch)  throws IOException
  {
     dos.writeInt((int)ch);
  }
  

  public void  send_boolean(boolean vbool)  throws IOException
  {
    int intval ;

    if (vbool)
      intval = 1;
    else
      intval = 0;
    dos.writeInt(intval);
  }

  public void send_byte(byte vby)  throws IOException
  {
    dos.writeInt((int)vby);
  }

  public void  send_short(short vsho)  throws IOException
  {
    dos.writeInt((int)vsho);
  }

  public void   send_long(long vlong)  throws IOException
  {
      dos.writeLong(vlong);
  }

  public void  send_float(float vfloat)  throws IOException
  {
     dos.writeFloat(vfloat);
  }

  public void   send_double(double vdouble)  throws IOException
  {
      dos.writeDouble(vdouble);
  }


  public void  send_header(int[] dim,int ndims)  throws IOException
  {
 
     for(int i=0, int nelems=1;i<ndims;i++)
        nelems *= dim[i] ;
     send_int(nelems);    
  }

  // FOR INTEGER ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dint_array(int []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     send_header(dims,1);
     for (int i=0;i<dims[0];i++)
        send_int(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dint_array(int[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     send_header(dims,2); 
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_int(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_int(buf[i][j]);  
     
  }     
 
  public void  send_3Dint_array(int[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     send_header(dims,3);
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_int(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_int(buf[i][j][k]);  
    
  }

  // FOR CHARACTER  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

   public void  send_1Dchar_array(char []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     send_header(dims,1);
     for (int i=0;i<dims[0];i++)
        send_char(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dchar_array(char[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
    
     send_header(dims,2);  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_char(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_char(buf[i][j]);  
     
  }     
 
  public void  send_3Dchar_array(char[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     send_header(dims,3);
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_char(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_char(buf[i][j][k]);  
    
  }



  
  // FOR BOOLEAN ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dboolean_array(boolean []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     send_header(dims,1);
     for (int i=0;i<dims[0];i++)
        send_boolean(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dboolean_array(boolean[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     send_header(dims,2);  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_boolean(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_boolean(buf[i][j]);  
     
  }     
 
  public void  send_3Dboolean_array(boolean[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     send_header(dims,3);
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_boolean(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_boolean(buf[i][j][k]);  
    
  }



  // FOR SHORT ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dshort_array(short []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     send_header(dims,1);
     for (int i=0;i<dims[0];i++)
        send_short(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dshort_array(short[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
      
     send_header(dims,2);
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_short(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_short(buf[i][j]);  
     
  }     
 
  public void  send_3Dshort_array(short[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     send_header(dims,3);
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_short(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_short(buf[i][j][k]);  
    
  }



 
  // FOR LONG  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  
  public void  send_1Dlong_array(long []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     send_header(dims,1);       
     for (int i=0;i<dims[0];i++)
        send_long(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dlong_array(long[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     send_header(dims,2);  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_long(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_long(buf[i][j]);  
     
  }     
 
  public void  send_3Dlong_array(long[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     send_header(dims,3);  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_long(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_long(buf[i][j][k]);  
    
  }




  // FOR FLOAT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dfloat_array(float []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     send_header(dims,1);  
     for (int i=0;i<dims[0];i++)
        send_float(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dfloat_array(float[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
    
     send_header(dims,2);     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_float(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_float(buf[i][j]);  
     
  }     
 
  public void  send_3Dfloat_array(float[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     send_header(dims,3); 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_float(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_float(buf[i][j][k]);  
    
  }
 
  // FOR DOUBLE   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Ddouble_array(double []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     send_header(dims,1);  
     for (int i=0;i<dims[0];i++)
        send_double(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Ddouble_array(double[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     send_header(dims,2);     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_double(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_double(buf[i][j]);  
     
  }     
 
  public void  send_3Ddouble_array(double[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     send_header(dims,3); 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_double(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_double(buf[i][j][k]);  
    
  }
}

