import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class testDebugger 
{

   
   public static void main(String argv[]) throws IOException{
   BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
    String str;
     debugger db = new debugger();

     db.connectToHPFServer("osprey1.npac.syr.edu",3335);
     System.out.println("Applet conected to HPF server ");
     while((str = input.readLine()) != null){
       db.sendRegDataReq(str,10);
     }
     
     //db.con.close_connection();
     
   }
 }


class debugger
{
  connection   con;
  recv_module  recv;
  send_module  send;
  // Debugger commands
  public static final int REGDATAREQ = 1;
  public static final int CONNECT    = 2;

  public static final int TCHAR   = 0;
  public static final int TINT    = 1;
  public static final int TFLOAT  = 2;
  public static final int TLONG   = 3;
  public static final int TDOUBLE = 4;
  public static final int TBOOL   = 5;
  public static final int TBYTE   = 6;
  public static final int TSHORT  = 7;
    
    
  public void connectToHPFServer(String host,int port)
    throws IOException
  {
    boolean done = false;
     while(!done)
     {
        try {
          con  = new connection(host,port,true);
          done = true;
        }
        catch (IOException e) {
          System.out.println("IO Exception in connectToHPFServer");
          done = false;
        }
     }

    recv  = new recv_module(con);
    send  = new send_module(con);
    
  }

  public void startHPFApplication(String progName)
  {
      ;
  
  }
  

  public void sendRegDataReq(String variableName,int lineNumber)
     throws IOException
  {
    send.send_int(REGDATAREQ);
    send.send_int(lineNumber);
    send.send_String(variableName);

    //float [][]buf = (float[][])recv_registrated_data();
    System.out.println("Got response ");

    //for(int i=0;i<buf.length;i++)
    //  for(int j=0;j<buf[0].length;j++)
    //    System.out.println("i&j -> buf "+i+" "+j+" "+buf[i][j]);
    
    
    

  }
  
  public Object  recv_registrated_data() throws IOException
  {
    Object buffer=null;

    // receive tag
    float fval ;
        
    int tag = recv.recv_int();
    StringBuffer varName=recv.recv_String();
    int type  = recv.recv_int();
    int ndims = recv.recv_int();
    int nelems = recv.recv_int();
    int []dims = new int[ndims];
    recv.recv_1Dint_array(dims);
        

    System.out.println("RECEVIDD  "+tag+" "+varName+" "+type+" "+ndims+" "+
    		       nelems+" "+dims[0]+" "+dims[1] );
    switch(type){
    case this.TINT:
      switch(ndims){
        case 1:
	  buffer = new int[dims[0]];
	  recv.recv_1Dint_array((int[])buffer);
	  break;
        case 2:  
          buffer = new int[dims[0]][dims[1]];
	  recv.recv_2Dint_array((int[][])buffer);
	  break;
        case 3:
          buffer = new int[dims[0]][dims[1]][dims[2]];
	  recv.recv_3Dint_array((int[][][])buffer);
	  break;
      }
      break;
      case TCHAR:
      switch(ndims){
        case 1:
	  buffer = new char[dims[0]];
	  recv.recv_1Dchar_array((char[])buffer);
	  break;
        case 2:  
          buffer = new char[dims[0]][dims[1]];
	  recv.recv_2Dchar_array((char[][])buffer);
	  break;
        case 3:
          buffer = new char[dims[0]][dims[1]][dims[2]];
	  recv.recv_3Dchar_array((char[][][])buffer);
	  break;
      }
      break;
      case TFLOAT:
      switch(ndims){
        case 1:
	  buffer = new float[dims[0]];
	  recv.recv_1Dfloat_array((float[])buffer);
	  break;
        case 2:  
          buffer = new float[dims[0]][dims[1]];
	  recv.recv_2Dfloat_array((float[][])buffer);
	  break;
        case 3:
          buffer = new float[dims[0]][dims[1]][dims[2]];
	  recv.recv_3Dfloat_array((float[][][])buffer);
	  break;
      }
      break;
      case TLONG:
      switch(ndims){
        case 1:
	  buffer = new long[dims[0]];
	  recv.recv_1Dlong_array((long[])buffer);
	  break;
        case 2:  
          buffer = new long[dims[0]][dims[1]];
	  recv.recv_2Dlong_array((long[][])buffer);
	  break;
        case 3:
          buffer = new long[dims[0]][dims[1]][dims[2]];
	  recv.recv_3Dlong_array((long[][][])buffer);
	  break;
      }
      break;
      case TDOUBLE:
      switch(ndims){
        case 1:
	  buffer = new double[dims[0]];
	  recv.recv_1Ddouble_array((double[])buffer);
	  break;
        case 2:  
          buffer = new double[dims[0]][dims[1]];
	  recv.recv_2Ddouble_array((double[][])buffer);
	  break;
        case 3:
          buffer = new double[dims[0]][dims[1]][dims[2]];
	  recv.recv_3Ddouble_array((double[][][])buffer);
	  break;
      }
      break;
      case TBOOL:
      switch(ndims){
        case 1:
	  buffer = new boolean[dims[0]];
	  recv.recv_1Dboolean_array((boolean[])buffer);
	  break;
        case 2:  
          buffer = new boolean[dims[0]][dims[1]];
	  recv.recv_2Dboolean_array((boolean[][])buffer);
	  break;
        case 3:
          buffer = new boolean[dims[0]][dims[1]][dims[2]];
	  recv.recv_3Dboolean_array((boolean[][][])buffer);
	  break;
      }
      break;
      case TBYTE:
      switch(ndims){
        case 1:
	  buffer = new byte[dims[0]];
	  recv.recv_1Dbyte_array((byte[])buffer);
	  break;
        case 2:  
          buffer = new byte[dims[0]][dims[1]];
	  recv.recv_2Dbyte_array((byte[][])buffer);
	  break;
        case 3:
          buffer = new byte[dims[0]][dims[1]][dims[2]];
	  recv.recv_3Dbyte_array((byte[][][])buffer);
	  break;
      }
      break;
      case TSHORT:
      switch(ndims){
        case 1:
	  buffer = new short[dims[0]];
	  recv.recv_1Dshort_array((short[])buffer);
	  break;
        case 2:  
          buffer = new short[dims[0]][dims[1]];
	  recv.recv_2Dshort_array((short[][])buffer);
	  break;
        case 3:
          buffer = new short[dims[0]][dims[1]][dims[2]];
	  recv.recv_3Dshort_array((short[][][])buffer);
	  break;
      }
      break;
    }
    return buffer;
    
  }
  
}

       
    
  
    
