import java.io.*;
import java.net.*;
import java.util.*;



public class connection  {
  public String host;
  public int    port;
  Socket sock;
  DataInputStream dis;
  DataOutputStream dos;

  // If you want to get data from fortran program set it, and
  // but from C program reset it
  public  boolean FORTRAN_DEFINED ;
  public boolean record_comm;

  public connection (String ahost,int aport,boolean FD) throws IOException
  {

     host = ahost;
     port = aport;
     FORTRAN_DEFINED = FD;
     open_connection() ;

     //try{
     //  sock.setTcpNoDelay(true);
     //}catch(SocketException e){
     //  System.out.println("setTcpNoDelay error :"+e);}
			       

  }

  public void  open_connection() throws IOException
  {
    sock = new Socket(host,port);
    dis  = new DataInputStream( sock.getInputStream());
    dos  = new DataOutputStream( sock.getOutputStream()); 
  }

  public void close_connection() throws IOException
  {
    sock.close();
  }
  
  public DataInputStream  getInputS( ) throws IOException
  {
    
     return (dis);
  }

  public DataOutputStream  getOutputS( Socket sock) throws IOException
  {
    
     return (dos);
  }

  public Socket getSocket()
  {
    return sock;
  }
 }


 class recv_module {
  DataInputStream  dis;
  DataOutputStream dos;
  public boolean  FORTRAN_DEFINED;
 
/////////////////////////////////////
////////////////////////////////////
///////////////////////////////////

  public recv_module(connection con)
  {
     dis = con.dis;
     dos = con.dos;
     FORTRAN_DEFINED = con.FORTRAN_DEFINED;
  }

   public int recv_int() throws IOException
  {
     return dis.readInt();
  }
 
  public char recv_char()  throws IOException
  {
    return (char)(dis.readInt());
  }
 
  public boolean recv_boolean()  throws IOException
  {
    int intval ;
 
    intval = dis.readInt();
    if (intval ==  0)
      return true;
    else
      return false;
  }
 
  public byte recv_byte()  throws IOException
  {
    return (byte)(dis.readInt());
  }
 
  public short recv_short()  throws IOException
  {
    return (short)(dis.readInt());
  }
 
  public long  recv_long()  throws IOException
  {
     return dis.readLong();
  }
 
  public float  recv_float()  throws IOException
  {
     return dis.readFloat();
  }
 
  public double  recv_double()  throws IOException
  {
     return dis.readDouble();
  }
 
  public byte recvByte() throws IOException
   {
     return dis.readByte();
   }

   public void flushSocket() throws IOException
   {
     dos.flush();
   }
   
   

// FOR INTEGER ARRAYS///////////////////////////////////////
//////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

 public void  recv_1Dint_array(int []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_int();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dint_array(int[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     // nelems = recv_int() ; // number of elements in array 
         
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_int();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_int();
     
  }     
 
  public void  recv_3Dint_array(int[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_int();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_int();
    
  }

  // FOR CHARACTER  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////
   public StringBuffer recv_String() throws IOException
   {
      byte val;
      int rem;

      int strLen = recv_int();
      System.out.println("strlen "+strLen);
      
      char [] charArray = new char[strLen];
      
      for(int i=0;i<strLen;i++)
         charArray[i] = (char)(recvByte());

      rem = 0;
      if ((strLen%4) != 0)
        rem = 4-strLen%4;
      // read padding zeros to make the total size multiple of 4
      for(int i=0; i <rem ; i++)
        recvByte();
      
      return new StringBuffer().append(charArray);
   }
   

   public void  recv_1Dchar_array(char[] str)
  throws IOException
  {  int nelems;   

     int strlen = str.length;

     for(int i=0; i<strlen;i++) 
         str[i] = recv_char();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dchar_array(char[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
    
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_char();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_char();
     
  }     
 
  public void  recv_3Dchar_array(char[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_char();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_char();
    
  }



  
  // FOR BOOLEAN ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dboolean_array(boolean []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_boolean();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dboolean_array(boolean[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_boolean();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_boolean();
     
  }     

   
  public void  recv_3Dboolean_array(boolean[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_boolean();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_boolean();
    
  }


  // FOR BYTE ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dbyte_array(byte []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_byte();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dbyte_array(byte[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_byte();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_byte();
     
  }     

   
  public void  recv_3Dbyte_array(byte[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_byte();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_byte();
    
  }
  

  // FOR SHORT ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dshort_array(short []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array 
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_short();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dshort_array(short[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
      
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_short();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_short();
     
  }     
 
  public void  recv_3Dshort_array(short[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_short();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_short();
    
  }

 
  // FOR LONG  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  
  public void  recv_1Dlong_array(long []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     // nelems = recv_int() ; // number of elements in array        
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_long();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dlong_array(long[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_long();
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_long();
     
  }     
 
  public void  recv_3Dlong_array(long[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array   
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_long();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_long();
    
  }




  // FOR FLOAT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dfloat_array(float []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;
     // nelems = recv_int() ; // number of elements in array 
   
     for (int i=0;i<dims[0];i++)
        buf[i] = recv_float();
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Dfloat_array(float[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
    
     // nelems = recv_int() ; // number of elements in array      
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             buf[i][j] = recv_float();

     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_float();
     
  }     
 
  public void  recv_3Dfloat_array(float[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_float();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_float();
    
  }
 
  // FOR DOUBLE   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Ddouble_array(double []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     System.out.println("ndims = "+dims[0]);
     for (int i=0;i<dims[0];i++){
        buf[i] = recv_double();
     }
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  recv_2Ddouble_array(double[][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     // nelems = recv_int() ; // number of elements in array      
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++){
             buf[i][j] = recv_double();
             System.out.println("i&j"+i+" "+j+" "+buf[i][j]);
          }

     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            buf[i][j] = recv_double();
     
  }     
 
  public void  recv_3Ddouble_array(double[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     // nelems = recv_int() ; // number of elements in array  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              buf[i][j][k] = recv_double();
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              buf[i][j][k] = recv_double();
    
  }

  // FOR OBJECT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  recv_1Dobject_array(Object []buf)
  throws IOException
  {  int nelems;   
     int []dims = new int[1];
     dims[0] = buf.length;

     for (int i=0;i<dims[0];i++)
        recv_structure(buf[i]);
  }


   public void  recv_2Dobject_array(Object [][] buf) 
  throws IOException
  {  int nelems;   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             recv_structure(buf[i][j]);  
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            recv_structure(buf[i][j]); 
     
  }     
 
  public void  recv_3Dobject_array(Object[][][] buf) 
   throws IOException
  {  int nelems;   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              recv_structure(buf[i][j][k]); 
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              recv_structure(buf[i][j][k]);
  }

  public void recv_structure(Object object) throws IOException
  {  
      java.lang.reflect.Field field[] ;


      field = object.getClass().getDeclaredFields();
            

      for(int i=0;i<field.length;i++){  
        String type = field[i].getType().getName();
        System.out.println("type  "+type);

        try{
          if (type.equals("boolean"))
             field[i].setBoolean(object,recv_boolean());
          else if (type.equals("byte"))
             field[i].setByte(object,recv_byte());
          else if (type.equals("char"))
             field[i].setChar(object,recv_char()); 
          else if (type.equals("short"))
             field[i].setShort(object,recv_short());  
          else if (type.equals("int"))
             field[i].setInt(object,recv_int());
          else if (type.equals("long"))
             field[i].setLong(object,recv_long());
          else if (type.equals("float"))
             field[i].setFloat(object,recv_float());
          else if (type.equals("double"))
             field[i].setDouble(object,recv_float());
         
        
          //boolean arrays 
          else if (type.equals("[Z"))
             recv_1Dboolean_array((boolean[])field[i].get(object));
          else if (type.equals("[[Z"))
             recv_2Dboolean_array((boolean[][])field[i].get(object));
          else if (type.equals("[[[Z"))
             recv_3Dboolean_array((boolean[][][])field[i].get(object));

          
           //byte arrays 
          else if (type.equals("[B"))
             recv_1Dbyte_array((byte[])field[i].get(object));
          else if (type.equals("[[B"))
             recv_2Dbyte_array((byte[][])field[i].get(object));
          else if (type.equals("[[[B"))
             recv_3Dbyte_array((byte[][][])field[i].get(object));

          //char arrays 
          else if (type.equals("[C"))
             recv_1Dchar_array((char[])field[i].get(object));
          else if (type.equals("[[C"))
             recv_2Dchar_array((char[][])field[i].get(object));
          else if (type.equals("[[[C"))
             recv_3Dchar_array((char[][][])field[i].get(object));
 
          //short arrays 
          else if (type.equals("[S"))
             recv_1Dshort_array((short[])field[i].get(object));
          else if (type.equals("[[S"))
             recv_2Dshort_array((short[][])field[i].get(object));
          else if (type.equals("[[[S"))
             recv_3Dshort_array((short[][][])field[i].get(object));
  
          //int arrays 
          else if (type.equals("[I"))
             recv_1Dint_array((int[])field[i].get(object));
          else if (type.equals("[[I"))
             recv_2Dint_array((int[][])field[i].get(object));
          else if (type.equals("[[[I"))
             recv_3Dint_array((int[][][])field[i].get(object));
 
          //long arrays 
          else if (type.equals("[J"))
             recv_1Dlong_array((long[])field[i].get(object));
          else if (type.equals("[[J"))
             recv_2Dlong_array((long[][])field[i].get(object));
          else if (type.equals("[[[J"))
             recv_3Dlong_array((long[][][])field[i].get(object));
 
        
          //float arrays 
          else if (type.equals("[F"))
             recv_1Dfloat_array((float[])field[i].get(object));
          else if (type.equals("[[F"))
             recv_2Dfloat_array((float[][])field[i].get(object));
          else if (type.equals("[[[F"))
             recv_3Dfloat_array((float[][][])field[i].get(object));

          //double arrays 
          else if (type.equals("[D"))
             recv_1Ddouble_array((double[])field[i].get(object));
          else if (type.equals("[[D"))
             recv_2Ddouble_array((double[][])field[i].get(object));
          else if (type.equals("[[[D"))
             recv_3Ddouble_array((double[][][])field[i].get(object));
          else if(field[i].getDeclaringClass().isInstance(object)) 
             recv_structure(field[i].get(object));
          else
             System.out.println("unknown data type  "+type);

         }catch ( IllegalAccessException e){
            System.out.println("IllegalAccessException ");};
     }
  }
}   
  
 
 class send_module {
  DataInputStream  dis;
  DataOutputStream dos;
  public boolean FORTRAN_DEFINED;
 
/////////////////////////////////////
////////////////////////////////////
///////////////////////////////////

  public  send_module(connection con)
  {
     dis = con.dis;
     dos = con.dos;
     FORTRAN_DEFINED = con.FORTRAN_DEFINED;
  }

  public void  send_int(int item) throws IOException
  {
      dos.writeInt(item);
  }

  public void  send_char(char ch)  throws IOException
  {
     dos.writeInt((int)ch);
  }
  

  public void  send_boolean(boolean vbool)  throws IOException
  {
    int intval ;

    if (vbool)
      intval = 1;
    else
      intval = 0;
    dos.writeInt(intval);
  }

  public void send_byte(byte vby)  throws IOException
  {
    dos.writeInt((int)vby);
  }

  public void  send_short(short vsho)  throws IOException
  {
    dos.writeInt((int)vsho);
  }

  public void   send_long(long vlong)  throws IOException
  {
      dos.writeLong(vlong);
  }

  public void  send_float(float vfloat)  throws IOException
  {
     dos.writeFloat(vfloat);
  }

  public void   send_double(double vdouble)  throws IOException
  {
      dos.writeDouble(vdouble);
  }

  public void  send_header(int[] dim,int ndims)  throws IOException
  {
     int nelems=1;
     for(int i=0;i<ndims;i++)
        nelems *= dim[i] ;
     send_int(nelems);    
  }

  // FOR INTEGER ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dint_array(int []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     for (int i=0;i<dims[0];i++)
        send_int(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dint_array(int[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_int(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_int(buf[i][j]);  
     
  }     
 
  public void  send_3Dint_array(int[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_int(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_int(buf[i][j][k]);  
    
  }

  // FOR CHARACTER  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////
   public void send_String(String str) throws IOException
   {  
      int rem;
      int len = str.length();
      char [] charArray = str.toCharArray();
      // send the total length of string 
         
      send_int(len);
      for(int i = 0;i<len;i++)
        dos.writeByte((byte)(charArray[i]));

      rem = 0;
      if ((len%4) != 0)
        rem = 4-len%4;
      // write concanated zeros to make the size of string multiple of 4
      for(int i=0; i <rem; i++)
	dos.writeByte(0);
      
   }
   

   public void  send_1Dchar_array(char [] buf)
     throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_char(buf[i]);

  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dchar_array(char[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_char(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_char(buf[i][j]);  
     
  }     
 
  public void  send_3Dchar_array(char[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_char(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_char(buf[i][j][k]);  
    
  }

  
  // FOR BOOLEAN ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dboolean_array(boolean []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;

     
     for (int i=0;i<dims[0];i++)
        send_boolean(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dboolean_array(boolean[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_boolean(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_boolean(buf[i][j]);  
     
  }     

   
  public void  send_3Dboolean_array(boolean[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_boolean(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_boolean(buf[i][j][k]);  
    
  }


  // FOR BYTE ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dbyte_array(byte []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_byte(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dbyte_array(byte[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_byte(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_byte(buf[i][j]);  
     
  }     

   
  public void  send_3Dbyte_array(byte[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
    
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_byte(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_byte(buf[i][j][k]);  
    
  }
  

  // FOR SHORT ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dshort_array(short []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_short(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dshort_array(short[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_short(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_short(buf[i][j]);  
     
  }     
 
  public void  send_3Dshort_array(short[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
     
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_short(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_short(buf[i][j][k]);  
    
  }



 
  // FOR LONG  ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  
  public void  send_1Dlong_array(long []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
     
     for (int i=0;i<dims[0];i++)
        send_long(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dlong_array(long[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
   
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_long(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_long(buf[i][j]);  
     
  }     
 
  public void  send_3Dlong_array(long[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
  
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_long(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_long(buf[i][j][k]);  
    
  }




  // FOR FLOAT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dfloat_array(float []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_float(buf[i]);
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dfloat_array(float[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_float(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_float(buf[i][j]);  
     
  }     
 
  public void  send_3Dfloat_array(float[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_float(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_float(buf[i][j][k]);  
    
  }
 
  // FOR DOUBLE   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Ddouble_array(double []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_double(buf[i]);

  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Ddouble_array(double[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_double(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_double(buf[i][j]);  
     
  }     
 
  public void  send_3Ddouble_array(double[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_double(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_double(buf[i][j][k]);  
    
  }

  // FOR OBJECT   ARRAYS///////////////////////////////////////
  //////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////

  public void  send_1Dobject_array(Object []buf)
  throws IOException
  {   
     int []dims = new int[1];
     dims[0] = buf.length;
   
     for (int i=0;i<dims[0];i++)
        send_structure(buf[i]);
  
  }
  
  // Fortran stores array elems in columwise but C in rowwise
  // make necessary changes 
  public void  send_2Dobject_array(Object[][] buf) 
  throws IOException
  {   
     int []dims = new int[2];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
  
     if (FORTRAN_DEFINED)
        for(int j=0;j<dims[1];j++)
          for (int i=0;i<dims[0];i++)
             send_structure(buf[i][j]); 
     else 
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
            send_structure(buf[i][j]);  
     
  }     
 
  public void  send_3Dobject_array(Object[][][] buf) 
   throws IOException
  {   
     int []dims = new int[3];
     dims[0] = buf.length;
     dims[1] = buf[0].length; 
     dims[2] = buf[0][0].length;  
 
     if (FORTRAN_DEFINED)
       for (int k=0;k<dims[2];k++)
         for(int j=0;j<dims[1];j++)
           for (int i=0;i<dims[0];i++)
              send_structure(buf[i][j][k]);
     else
       for (int i=0;i<dims[0];i++)
         for(int j=0;j<dims[1];j++)
           for (int k=0;k<dims[2];k++) 
              send_structure(buf[i][j][k]);  
    
  }


  public void send_structure(Object object) throws IOException
  {
      java.lang.reflect.Field field[] ;

      field = object.getClass().getDeclaredFields();
      
      for(int i=0;i<field.length;i++){
        String type = field[i].getType().getName();

        try{
          if (type.equals("boolean"))
             send_boolean(field[i].getBoolean(object)); 
          else if (type.equals("byte"))
             send_byte(field[i].getByte(object)); 
          else if (type.equals("char"))
             send_char(field[i].getChar(object));  
          else if (type.equals("short"))
             send_short(field[i].getShort(object)); 
          else if (type.equals("int"))
             send_int(field[i].getInt(object)); 
          else if (type.equals("long"))
             send_long(field[i].getLong(object)); 
          else if (type.equals("float"))
             send_float(field[i].getFloat(object));   
          else if (type.equals("double"))
             send_double(field[i].getDouble(object)); 

          //boolean arrays 
          else if (type.equals("[Z"))
             send_1Dboolean_array((boolean[])field[i].get(object));
          else if (type.equals("[[Z"))
             send_2Dboolean_array( (boolean[][])field[i].get(object));
          else if (type.equals("[[[Z"))
             send_3Dboolean_array( (boolean[][][])field[i].get(object));
 
          //byte arrays 
          else if (type.equals("[B"))
             send_1Dbyte_array((byte[])field[i].get(object));
          else if (type.equals("[[B"))
             send_2Dbyte_array( (byte[][])field[i].get(object));
          else if (type.equals("[[[B"))
             send_3Dbyte_array( (byte[][][])field[i].get(object));
 
          // character arrays
          else if (type.equals("[C"))
             send_1Dchar_array((char[])field[i].get(object));
          else if (type.equals("[[C"))
             send_2Dchar_array( (char[][])field[i].get(object));
          else if (type.equals("[[[C"))
             send_3Dchar_array( (char[][][])field[i].get(object)); 
 
          //short  arrays 
           else if (type.equals("[S"))
             send_1Dshort_array((short[])field[i].get(object));
          else if (type.equals("[[S"))
             send_2Dshort_array( (short[][])field[i].get(object));
          else if (type.equals("[[[S"))
             send_3Dshort_array( (short[][][])field[i].get(object)); 
          
          //int  arrays 
          else if (type.equals("[I"))
             send_1Dint_array((int[])field[i].get(object));
          else if (type.equals("[[I"))
             send_2Dint_array( (int[][])field[i].get(object));
          else if (type.equals("[[[I"))
             send_3Dint_array( (int[][][])field[i].get(object)); 
         
          //long  arrays 
          else if (type.equals("[L"))
             send_1Dlong_array((long[])field[i].get(object));
          else if (type.equals("[[L"))
             send_2Dlong_array( (long[][])field[i].get(object));
          else if (type.equals("[[[L"))
             send_3Dlong_array( (long[][][])field[i].get(object));  
        
          //float   arrays 
          else if (type.equals("[F"))
             send_1Dfloat_array((float[])field[i].get(object));
          else if (type.equals("[[F"))
             send_2Dfloat_array( (float[][])field[i].get(object));
          else if (type.equals("[[[F"))
             send_3Dfloat_array( (float[][][])field[i].get(object)); 
          
          //double  arrays 
          else if (type.equals("[D"))
             send_1Ddouble_array((double[])field[i].get(object));
          else if (type.equals("[[D"))
             send_2Ddouble_array( (double[][])field[i].get(object));
          else if (type.equals("[[[D"))
             send_3Ddouble_array( (double[][][])field[i].get(object)); 
          else if(field[i].getDeclaringClass().isInstance(object)) 
             send_structure(field[i].get(object));
          else
             System.out.println("unknown data type  "+type);

       }catch ( IllegalAccessException e){
            System.out.println("IllegalAccessException ");};
     }
  }
}

