import netscape.application.*;
import netscape.util.*;
import java.awt.AWTError;
import java.io.*;
import java.net.*;



public class javaGUI extends Application 
{
  


 public void init() {
  
   DesignManager manager;
   
   super.init();
   manager = new DesignManager();
   manager.addMenuItems();
   manager.addAllButtons();
   manager.addScrollBars ();
   manager.addDisplayWindow();
   
   manager.FinishDesign();

  }
}

//////////////
class myTextView extends TextView  implements Target
{
  Vector breakPoints;
  Rect pc;
  boolean startTrace;
  Range textLineRanges[];
  Vector textLineRects[];

public boolean isTransparent()
  {
    return false;
  }
  


  
public myTextView(int x, int y, int width, int height)
{
    super(x,y,width,height);
    breakPoints = new Vector();
    pc = new Rect();
    //super.setBuffered(true);
    startTrace = false;
    setTextColor(Color.gray);

    Vector textLines = readRemoteFile("osprey1.npac.syr.edu",3333,
                        "/hpf/laplace.f90");
    textLineRanges = new Range[textLines.size()];
    textLineRects  = new Vector[textLines.size()];
    for(int i=0;i<textLines.size();i++){
       String s = (String)(textLines.elementAt(i));
       //System.out.println(i+" s ="+s);
       String ts = "\t"+i+"> ";
       ts += s;
       ts += "\n\r";
       textLineRanges[i] = appendString(ts);
       textLineRects[i]  = rectsForRange(textLineRanges[i]);
    }
    
    
}

public void drawView (Graphics g)
{
   super.drawView(g);
   
   g.setColor(new Color(255,255,255));
   g.setXORMode(Color.green);

   //put program counter as fileed rectangle;
   int xPoints[] = new int[3];
   int yPoints[] = new int[3];
   xPoints[0] = pc.x;
   xPoints[1] = pc.x;
   xPoints[2] = (int)(pc.x+((pc.height)*(Math.sqrt(3.0f)))/2.0f);
   yPoints[0] = pc.y;
   yPoints[1] = pc.y+pc.height;
   yPoints[2] = pc.y+(pc.height)/2;
   g.fillPolygon(xPoints,yPoints,3);

   g.setColor(new Color(255,255,255));
   g.setXORMode(Color.green);
   //make green the current line
   g.fillRect(pc.x+pc.height,pc.y,pc.width,pc.height);

   for(int i=0;i<breakPoints.size();i++){
      g.setColor(new Color(255,255,255));
      g.setXORMode(Color.red);
      Rect rect = (Rect)(breakPoints.elementAt(i));
 
      //put stop red ball at the breakPoint
      g.fillArc(rect.x, rect.y, (int)(0.85f*rect.height), 
               (int)(0.85f*rect.height), 0, 360);
      //make red the reakpoint line
      g.fillRect(rect.x+rect.height, rect.y,rect.width,rect.height);
   }
}

public void keyDown(KeyEvent event)
{ 
  
  super.keyDown(event);
  
  if (event.key == KeyEvent.F4_KEY){
    System.out.println("F4 was pressed");
    putBreakPoint();
  }

  TextPositionInfo context = _selection._insertionPointInfo;
  Range prange = new Range(0,length());
  Vector vector = paragraphsForRange(prange);
  Range crange  = paragraphForPoint(context._x,context._y);
  int lineNumber = vector.indexOf(crange);
  System.out.println("LineNumber ...... ="+lineNumber);
  
} 

public void putBreakPoint()
{
   TextPositionInfo context = _selection._insertionPointInfo;
   Range range = runForPoint(context._x,context._y);
   Vector vecs = rectsForRange(range);
   if (!breakPoints.contains(vecs.elementAt(0))){
     breakPoints.addElement(vecs.elementAt(0));
   }
   else{
     breakPoints.removeElement(vecs.elementAt(0));
   }
   draw();
   System.out.println("context = "+context);

   Range prange = new Range(0,length());
   Vector vector = paragraphsForRange(prange);
   Range crange  = paragraphForPoint(context._x,context._y);
   
   int lineNumber = vector.indexOf(crange);
   

   System.out.println("LineNumber ...... ="+lineNumber);
   
   
   
   
}

public void trace()
{
  Rect visrect = new Rect();
  computeVisibleRect(visrect);
  System.out.println("visrect "+visrect+" pc "+pc);

  if (!containsPointInVisibleRect(pc.x+pc.width,pc.y+2*(pc.height))){
    Rect rect = new Rect(pc.x,pc.y,visrect.width,visrect.height);
    scrollRectToVisible(rect);
    System.out.println("Scrolled.. "+rect);
    
  }
  
  if (!startTrace){
      startTrace = true;
      TextPositionInfo context = _selection._insertionPointInfo;
      Range range = runForPoint(context._x,context._y);
      Range newrange = runForIndex(range.index);
      Vector vecs = rectsForRange(newrange);
      pc = (Rect)(vecs.elementAt(0));
      pc.width = visrect.width;
      
      draw();
  }
  else
    pc.y += pc.height;
    
  draw();
}


public void RealTrace()
{
  Rect visrect = new Rect();
  computeVisibleRect(visrect);
  System.out.println("visrect "+visrect+" pc "+pc);

   if ((pc.y+pc.height > visrect.y+visrect.height)&&
       (!containsPointInVisibleRect(pc.x,pc.y+2*(pc.height)))){
         Rect rect = new Rect(pc.x,pc.y,visrect.width,visrect.height);
         scrollRectToVisible(rect);
         System.out.println("Scrolled.. first "+rect);
    }
    else if (!containsPointInVisibleRect(pc.x,pc.y-2*(pc.height))) 
    {
      Rect rect = new Rect(pc.x,pc.y,visrect.width,visrect.height);
      scrollRectToVisible(rect);
      System.out.println("Scrolled.. second"+rect);
    } 
  
  draw();
}


public void performCommand(String command, Object anObject) 
  {
	
        if (command.equals("Break")) {
             RoundedButton rb = (RoundedButton)anObject; 
  	    System.out.println("breake");
            putBreakPoint();
            rb.closeLabelWin();
        }
        else if (command.equals("StepOver")) {
            RoundedButton rb = (RoundedButton)anObject;  
 	    System.out.println("trace");
            trace();
            rb.closeLabelWin();
	}
	else if (command.equals("lineNumber")) {
          String sline = ((TextField)anObject).stringValue();
	  int  linen = Integer.parseInt(sline);
	  Vector item = textLineRects[linen];
          Rect   rect = (Rect)(item.elementAt(0));
	  pc = rect;
	  RealTrace();
        	  	  	  
	  //System.out.println("line number "+(String)anObject);
	}
	
  }

public Vector readRemoteFile(String host,int port,String file)
{
  
    URL url_file=null;
    String s=null;
    BufferedReader dos=null;
    URLConnection opc=null;
    Vector textFile = new Vector();
    
    try
      {
	url_file = new URL("http",host,port,file); // "/hpf/laplace.f90"
      }catch (MalformedURLException ev){
      System.out.println("URL error " + ev);
    }
 
    try{
      opc = url_file.openConnection();
      dos = new  BufferedReader(new InputStreamReader(opc.getInputStream()));
      while((s = dos.readLine())!=null)
        textFile.addElement(s);
    }catch (IOException ev){
      System.out.println("IO error in getContent  "+ev);
    }
    return textFile;
    
}

// myTextView ....
}

// Layout all the coponents using PackLayout

class DesignManager 
{
  Vector buttons;
  PackLayout layoutManager,ButtonsLayoutManager;
  PackLayout MenuLayoutManager; 
  PackConstraints constraints;
  InternalWindow window;
  ScrollGroup infoGroup;
  myTextView text;
  ContainerView ButtonView;//put debug buttons inside;
  ContainerView ControlMenuView;  //put menu inside; 
  ContainerView displayWindow;
  
  MenuView menuView;
  TextView StatusDisplayArea ;
  
  public DesignManager()
  {
    window = new InternalWindow(0, 0, 700, 700);
    window.setResizable(true);
    window.setTitle("HPF Debugger/Visualization Tool");
    window.setCloseable(true);
    layoutManager = new PackLayout();
    window.contentView().setLayoutManager(layoutManager);
    //window.contentView().setColor(Color.pink);
    window.contentView().setColor(Color.lightGray);

    ButtonsLayoutManager = new PackLayout();
    ButtonView = new ContainerView(0,0,600,50);
    ButtonView.setLayoutManager(ButtonsLayoutManager);
    ButtonView.setBackgroundColor(Color.pink);
    LineBorder lb = new  LineBorder(Color.red);
    ButtonView.setBorder(lb);
    
    text = new myTextView(0,0,800,450);
    text.setBackgroundColor(Color.white);
    Font f = new Font("TimesRoman",Font.BOLD,16);
    text.setFont(f);
  
    displayWindow     = new ContainerView(0,0,700,100);
    StatusDisplayArea =  new TextView(0,0,700,100);
    StatusDisplayArea.setBackgroundColor(Color.blue);
    
  }
      
  public void addAllButtons()
  {
     addButton("Display","eval.gif");
     addButton("Break","break.gif");
     addButton("StepInto","stepinto.gif");
     addButton("StepOver","stepover.gif");
     addButton("GoUntil","gountil.gif");
     addButton("GoToCursor","runtocursor.gif");
     addButton("Run","startdebugger.gif");
     addButton("Stop","stop.gif");
     addButton("Pause","pause.gif");
     addButton("MoveDown","movedownlevel.gif");
     addButton("MoveUp","moveuplevel.gif");

     constraints = new PackConstraints();
     constraints.setSide(PackConstraints.SIDE_TOP);
     constraints.setAnchor(PackConstraints.ANCHOR_NORTHWEST);
     layoutManager.setConstraints(ButtonView ,constraints);
     window.addSubview(ButtonView);
  }

  public void addMenuItems()
  {
        MenuItem nm,menuItem;
    
        BezelBorder bb = new BezelBorder(BezelBorder.RAISED,
					 Color.lightGray);
        Menu menu = new Menu(true);
        menu.setBorder(bb);
        menu.setBackgroundColor(Color.lightGray);
        
        menuItem = menu.addItemWithSubmenu("File    ");
        menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("New","New",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Open","Open",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Reload Source File","Reload",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Save","Save",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);


        menuItem = menu.addItemWithSubmenu("Edit     ");
        menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Undo","Undo",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Redo","Redo",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Cut","Cut",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Copy","Copy",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);
        nm = new  MenuItem("Paste","Paste",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,4); 
        nm = new  MenuItem("Delete Line","Delete_Line",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,5); 
        nm = new  MenuItem("Insert Line","Insert_Line",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,6); 
        nm = new  MenuItem("Find","Find",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,7);
        nm = new  MenuItem("Replace","Replace",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,8);
        nm = new  MenuItem("Goto Line","GotoLine",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,9);
       

        menuItem = menu.addItemWithSubmenu("Debug     ");
        menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Start/Restart","Start/Restart",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Resume","Resume",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Run to here","Runtohere",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Step Over","StepOver",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);
        nm = new  MenuItem("Step Into","StepInto",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,4); 
        nm = new  MenuItem("Evaluate","Evaluate",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,5); 
        nm = new  MenuItem("Breakpoints","Breakpoints",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,6); 
        nm = new  MenuItem("Goto Interpreter","GotoInterpreter",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,7); 


 
        menuItem = menu.addItemWithSubmenu("Preferences   ");
        menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Source Editor","SourceEditor",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Remote host","Remotehost",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);

        menuView = new MenuView(0,0,600,100,menu);
   
        constraints = new PackConstraints();
        constraints.setInternalPadY(15);
        constraints.setPadY(5);
		
        constraints.setSide(PackConstraints.SIDE_TOP);
        constraints.setAnchor(PackConstraints.ANCHOR_NORTHWEST);
        layoutManager.setConstraints(menuView ,constraints);
        window.addSubview(menuView);
  }
  
  
  public void addButton(String title,String imgname)
  {
     RoundedButton button;
    
     button = new RoundedButton(1,1,1,1,title,imgname,text);
     //(1,1,30,30,title,imgname,text);
     ButtonView.addSubview(button);     
     constraints = new PackConstraints();
     constraints.setSide(PackConstraints.SIDE_LEFT);
     constraints.setAnchor(PackConstraints.ANCHOR_NORTH);
     ButtonsLayoutManager.setConstraints( button, constraints);
     
  }
  
  public void addScrollBars ()
  {

      infoGroup = new ScrollGroup(0,0,600,450);
      infoGroup.setHasVertScrollBar(true); // Vertical only
      infoGroup.setBorder(new BezelBorder(BezelBorder.LOWERED,
                                            Color.lightGray));
      infoGroup.scrollView().setBackgroundColor(Color.white);
        // The following causes the bottom of the group to be fixed
        // (i.e., it's margin, the space below it, can stretch)
      infoGroup.setHasHorizScrollBar(true);
      infoGroup.setHasVertScrollBar(true);
      infoGroup.setVertResizeInstruction(View.BOTTOM_MARGIN_CAN_CHANGE);
      infoGroup.setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);

      infoGroup.scrollView().setContentView(text);
       
      window.addSubview(infoGroup);
      constraints = new PackConstraints();
      constraints.setInternalPadY(180); 
      constraints.setPadY(20);
      constraints.setExpand(true);
      constraints.setFillX(true);
      constraints.setFillY(true);
      constraints.setSide(PackConstraints.SIDE_TOP);
      constraints.setAnchor(PackConstraints.ANCHOR_SOUTHWEST);
      layoutManager.setConstraints(infoGroup ,constraints);
  }

  public void addDisplayWindow()
  {

    ScrollGroup infoGroup = new ScrollGroup(0,0,700,100);
    infoGroup.setHasVertScrollBar(true); // Vertical only
    infoGroup.setBorder(new BezelBorder(BezelBorder.LOWERED,
					Color.lightGray));
    infoGroup.scrollView().setBackgroundColor(Color.white);
        // The following causes the bottom of the group to be fixed
        // (i.e., it's margin, the space below it, can stretch)
    infoGroup.setHasHorizScrollBar(true);
    infoGroup.setHasVertScrollBar(true);
    infoGroup.setVertResizeInstruction(View.BOTTOM_MARGIN_CAN_CHANGE);
    infoGroup.setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);
    infoGroup.scrollView().setContentView(StatusDisplayArea);
    
    //displayWindow.setTitle("Display Window");
    //displayWindow.setBackgroundColor(Color.red);
    //displayWindow.addSubview(infoGroup);
    //window.addSubview(displayWindow);
    

    window.addSubview(infoGroup);
    constraints = new PackConstraints();
    constraints.setExpand(true);
    //constraints.setInternalPadY(150);
    //constraints.setPadY(10);
    constraints.setFillX(true);
    constraints.setFillY(true);
    constraints.setSide(PackConstraints.SIDE_TOP);
    constraints.setAnchor(PackConstraints.ANCHOR_SOUTHWEST);
    layoutManager.setConstraints(infoGroup ,constraints);
   
  }
  

  public void FinishDesign()
  {
     window.contentView().layoutView(0, 0);
     window.show();
  }
  
  
}


class RoundedButton extends Button {
    Bitmap bitmap = null;         // Stores a bitmap of the interior
    InternalWindow descW;
    TextField label;
    String titleCommand;
    
    // --------------  Constructors and initialization  --------------

    public RoundedButton(int x, int y, int width, int height,
           String title,String imgname, Object target) 
    {
        super(x, y, width, height);

        setImage(Bitmap.bitmapNamed(imgname));
        setTarget((Target)target);
        setCommand(title);
        titleCommand = title;
	
    }

   public void mouseEntered(MouseEvent e)
   {

      int x = x()+superview().x();
      int y = y()+superview().y();
      descW = new InternalWindow(x+width()/2,y+height()+3,150,35);

      descW.setResizable(true);
      descW.setType(Window.BLANK_TYPE);
      label = new TextField(0,0,150,35);
      label.setBackgroundColor(new Color(255,255,125));
      if (titleCommand.equals("Display"))
        label.setStringValue("Evaluate an Expression");
      else if (titleCommand.equals("Break"))
        label.setStringValue("Toggle Breakpoint(F4)");
      else if (titleCommand.equals("StepInto"))
        label.setStringValue("Step into(Alt-Nstep)");
      else if (titleCommand.equals("StepOver"))
        label.setStringValue("Step over(Alt-Nstep)");
      else if (titleCommand.equals("GoUntil"))
        label.setStringValue("Go until true");
      else if (titleCommand.equals("GoToCursor"))
        label.setStringValue("Go to Cursor");
      else if (titleCommand.equals("NIter"))
        label.setStringValue("N iteration");
      else if (titleCommand.equals("Continue"))
        label.setStringValue("Continue");
      else if (titleCommand.equals("Run"))
        label.setStringValue("Run/Restart");
      else if (titleCommand.equals("Stop"))
        label.setStringValue("Stop");
      else if (titleCommand.equals("Pause"))
        label.setStringValue("Pause");
      else if (titleCommand.equals("MoveDown"))
        label.setStringValue("Caller's stack frame");
      else if (titleCommand.equals("MoveUp"))
        label.setStringValue("Callee's stack frame");
     
      
      descW.addSubview(label);
      this.superview().superview().addSubview(descW);
      descW.show();
     	
  }

  public void mouseExited(MouseEvent e)
  {
    descW.hide();
        
  }

  public boolean mouseDown(MouseEvent event)
  {
    super.mouseDown(event);
    return true;
     
  }
  
  public void closeLabelWin()
  {
    descW.hide();
  }
     
  
}
