import netscape.application.*;
import netscape.util.*;
import java.awt.AWTError;
import java.io.*;
import java.net.*;



public class javaGUI extends Application 
{
public static final int   PUTBREAKONOFF  = 11;
public static final int   STEPOVER       = 12;
public static final int   NSTEPOVER      = 13 ;
public static final int   STEPINTO       = 14;
public static final int   NSTEPINTO      = 15;
public static final int   CONTINUE       = 16;
public static final int   RUN            = 17;
public static final int   STOP           = 18;
public static final int   NITERATION     = 19;
public static final int   GOUNTIL        = 20;
public static final int   DISPLAY        = 21;
public static final int   SETVARIABLE    = 22;
public static final int   SETPARVAR      = 23; 
public static final int   CONNECT        = 24; 
public static final int   GOTOCURSOR     = 25;


 public void init() {
  
   DesignManager manager;
   
   super.init();
   manager = new DesignManager();
   manager.addMenuItems();
   manager.addAllButtons();
   manager.addScrollBars ();
   manager.addDisplayWindow();
   
   manager.FinishDesign();

  }
}
  
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
class HPFTextView extends TextView  implements Target
{
  Vector breakPoints;
  Rect pc; // program counter 
  boolean startTrace;
  Range textLineRanges[];
  Vector textLineRects[];
  readValue readWindow ; 
  String HTTPHost = "osprey2.npac.syr.edu";
  int    HTTPPort = 3333;
  int HPFServerPort = 3336;
  int numOfProcs    = 4;
  String HPFFileName;
  connection hpfCon ;
  recv_module rlib;
  send_module slib;
  DesignManager manager;

public boolean isTransparent()
  {
    return false;
  }
  


  
public HPFTextView(int x, int y, int width, int height,DesignManager manager_ )
{
    super(x,y,width,height);
    breakPoints = new Vector();
    pc = new Rect();
    //super.setBuffered(true);
    startTrace = false;
    setTextColor(Color.gray);
    manager = manager_;
        
}

public void setTextViewContent(String host,int port,String fileName)
{

    Vector textLines =  readRemoteFile(host,port,"/hpf/"+fileName);
    textLineRanges = new Range[textLines.size()];
    textLineRects  = new Vector[textLines.size()];
    for(int i=0;i<textLines.size();i++){
       String s = (String)(textLines.elementAt(i));
       //System.out.println(i+" s ="+s);
       String ts = "\t"+i+"> ";
       ts += s;
       ts += "\n\r";
       textLineRanges[i] = appendString(ts);
       textLineRects[i]  = rectsForRange(textLineRanges[i]);
    }
    
}
    

public void drawView (Graphics g)
{
   super.drawView(g);
   
   g.setColor(new Color(255,255,255));
   g.setXORMode(Color.green);

   //put program counter as filled rectangle;
   int xPoints[] = new int[3];
   int yPoints[] = new int[3];
   xPoints[0] = pc.x;
   xPoints[1] = pc.x;
   xPoints[2] = (int)(pc.x+((pc.height)*(Math.sqrt(3.0f)))/2.0f);
   yPoints[0] = pc.y;
   yPoints[1] = pc.y+pc.height;
   yPoints[2] = pc.y+(pc.height)/2;
   g.fillPolygon(xPoints,yPoints,3);

   g.setColor(new Color(255,255,255));
   g.setXORMode(Color.green);
   //make green the current line
   g.fillRect(pc.x+pc.height,pc.y,pc.width,pc.height);

   for(int i=0;i<breakPoints.size();i++){
      g.setColor(new Color(255,255,255));
      g.setXORMode(Color.red);
      Rect rect = (Rect)(breakPoints.elementAt(i));
 
      //put stop red ball at the breakPoint
      g.fillArc(rect.x, rect.y, (int)(0.85f*rect.height), 
               (int)(0.85f*rect.height), 0, 360);
      //make red the reakpoint line
      g.fillRect(rect.x+rect.height, rect.y,rect.width,rect.height);
   }
}

public void keyDown(KeyEvent event) 
{ 
  
  super.keyDown(event);
  
  if (event.key == KeyEvent.F4_KEY){
    System.out.println("F4 was pressed");
    try{
      putBreakPointOnOff();
    }catch(IOException ev){
      System.out.println("IOException in keyDown "+ev);}
  }

  TextPositionInfo context = _selection._insertionPointInfo;
  Range prange = new Range(0,length());
  Vector vector = paragraphsForRange(prange);
  Range crange  = paragraphForPoint(context._x,context._y);
  int lineNumber = vector.indexOf(crange);
  System.out.println("LineNumber ...... ="+lineNumber);
  
} 

public int readAck()
{
   StringBuffer errMsg=null;
   int status = 0;

   // get result from HPF server
   try{
      status   = rlib.recv_int();
      errMsg   = rlib.recv_String();  
   }catch(IOException ev){
     System.out.println("IOException in  readAck "+ev);}

   System.out.println("errcode :"+status+" errmsg : "+errMsg);
   // send command "errMsg" to display window
   CommandEvent cev = new CommandEvent((Target)manager,"Display",errMsg);
   Application.application().eventLoop().addEvent(cev);
   return status;
}


public void putBreakPointOnOff() throws IOException
{
   StringBuffer errMsg=null;
   int status = 0;

   TextPositionInfo context = _selection._insertionPointInfo;

   // find the line number on which we put breakPoint
   Range prange = new Range(0,length());
   Vector vector = paragraphsForRange(prange);
   Range crange  = paragraphForPoint(context._x,context._y);
   int lineNumber = vector.indexOf(crange);
   
   // send breakPoint command to HPF server:
   // PUTBREAKONOFF + lineNumber
   slib.send_int(javaGUI.PUTBREAKONOFF);
   slib.send_int(lineNumber+1);//we stars lines at zero: i->i+1//
   System.out.println("linenumber = "+lineNumber);

   // get result from HPF server
   status = readAck();

   if (status ==  0)
   {
      Range range = runForPoint(context._x,context._y);
      Vector vecs = rectsForRange(range);
      if (!breakPoints.contains(vecs.elementAt(0))){
         breakPoints.addElement(vecs.elementAt(0));
      }
      else{
         breakPoints.removeElement(vecs.elementAt(0));
      }
      draw();
   }
   System.out.println("after putbreakpoint to line :"+(lineNumber+1));
}

public void stepOver() throws IOException
{
   // send stepOver command to HPF server:
   // STEPOVER 
   slib.send_int(javaGUI.STEPOVER);

    // get result from HPF server
   int status = readAck();
 
   int newLineNum =  rlib.recv_int();
   gotoLine(newLineNum-1);
   System.out.println("after stepOver new line Num :"+newLineNum);
}

public void stepInto() throws IOException
{
   // send stepOver command to HPF server:
   // STEPINTO
   slib.send_int(javaGUI.STEPINTO);

    // get result from HPF server
   int status = readAck();
 
   int newLineNum =  rlib.recv_int();
   gotoLine(newLineNum-1);
   System.out.println("after stepInto new line Num :"+newLineNum);
}

public void NStepOver(int N) throws IOException
{
   // send stepOver command to HPF server:
   // NSTEPOVER +N
   slib.send_int(javaGUI.NSTEPOVER);
   slib.send_int(N); 

    // get result from HPF server
   int status = readAck();
 
   int newLineNum =  rlib.recv_int();
   gotoLine(newLineNum-1);
   System.out.println("after stepOver new line Num :"+newLineNum);
}


public void NStepInto(int N) throws IOException
{
   // send stepInto command to HPF server:
   // NSTEPINTO+N
   slib.send_int(javaGUI.NSTEPINTO);
   slib.send_int(N); 

    // get result from HPF server
   int status = readAck();
 
   int newLineNum =  rlib.recv_int();
   gotoLine(newLineNum-1);
   System.out.println("after stepInto new line Num :"+newLineNum);
}

public void goToCursor() throws IOException
{
   
    // find the line number on which we are going to go
   TextPositionInfo context = _selection._insertionPointInfo;
   Range prange = new Range(0,length());
   Vector vector = paragraphsForRange(prange);
   Range crange  = paragraphForPoint(context._x,context._y);
   int lineNumber = vector.indexOf(crange);

   // send stepOver command to HPF server:
   // GOTOCURSOR +N
   slib.send_int(javaGUI.GOTOCURSOR);
   slib.send_int(lineNumber+1); 

    // get result from HPF server
   int status = readAck();
   if(status == 0) 
      gotoLine(lineNumber);
   System.out.println("after gotoCursor new line Num :"+lineNumber);

}



public void gotoLine(int newLine)
{
   Rect rect,visrect;

   Vector item = textLineRects[newLine];
   rect = (Rect)(item.elementAt(0));
   pc = rect;

   visrect = new Rect();
   computeVisibleRect(visrect);
   System.out.println("visrect "+visrect+" pc "+pc+ "  linen :"+newLine);


   if ((pc.y+pc.height > visrect.y+visrect.height)&&
       (!containsPointInVisibleRect(pc.x,pc.y+2*(pc.height)))){
         rect = new Rect(pc.x,pc.y,visrect.width,visrect.height);
         scrollRectToVisible(rect);
         System.out.println("Scrolled  0");
    }
    else if (!containsPointInVisibleRect(pc.x,pc.y-pc.height)) 
    {
      rect = new Rect(pc.x,pc.y,visrect.width,visrect.height);
      scrollRectToVisible(rect);
      System.out.println("Scrolled  1");
    } 
    draw();
}

public void performCommand(String command, Object anObject) 
{
      System.out.println("new command  "+command);
    
     if (command.equals("Break")) {
         RoundedButton rb = (RoundedButton)anObject;
         try{ 
           putBreakPointOnOff();
         }catch(IOException ev){
           System.out.println(" IOException in performCommand(Break) "+ev);
          }

         //close icon window for breakPoint
         rb.closeLabelWin();
      }
      else if (command.equals("StepOver")) {
         RoundedButton rb = (RoundedButton)anObject;  
         if (rb.lastEvent.isShiftKeyDown()){
             readWindow = new readValue(superview(),"Number of Lines :",
                    this,"GetSOverNumber");
             readWindow.show();
         }
         else{    
            try{ 
             stepOver();
           }catch(IOException ev){
            System.out.println(" IOException in performCommand(StepOver) "+ev);
           }
	 }
          rb.closeLabelWin();
      }

      else if (command.equals("StepInto")) {
         RoundedButton rb = (RoundedButton)anObject;  
         if (rb.lastEvent.isShiftKeyDown()){
             readWindow = new readValue(superview(),"Number of Lines :",
                    this,"GetSIntoNumber");
             readWindow.show();
         }
         else {
           try{ 
             stepInto();
           }catch(IOException ev){
            System.out.println(" IOException in performCommand(StepInto) "+ev);
           }
	 }
         rb.closeLabelWin();
      }
    
      else if (command.equals("GetFile")){
         readWindow = new readValue(superview(),"File Name :",
                    this,"GetHPFSource");
         readWindow.show();
      }

      else if (command.equals("GetHPFSource")){
         HPFFileName = ((TextField)anObject).stringValue();
         setTextViewContent(HTTPHost,HTTPPort,HPFFileName);
         readWindow.hide();
      }
  
     else if (command.equals("GetSIntoNumber")){
         System.out.println("Nstep into method called ");
         String s = ((TextField)anObject).stringValue();
	 int    N = Integer.parseInt(s);
         readWindow.hide();
         try{
           NStepInto(N);
         }catch(IOException ev){
	    System.out.println("Exception in NStepInto "+ev);}
     }
    
      else if (command.equals("GetSOverNumber")){
         System.out.println("Nstep Over method called ");
         String s = ((TextField)anObject).stringValue();
	 int    N = Integer.parseInt(s);
         readWindow.hide();
         try{
           NStepOver(N);
         }catch(IOException ev){
	    System.out.println("Exception in NStepOver "+ev);}
     }

     else if (command.equals("GoToCursor")){
        try{ 
             goToCursor();
           }catch(IOException ev){
            System.out.println("IOException in performCommand(GoToCursor)"+ev);
           }
     } 


     else if (command.equals("Run"))
	 startHPFApplication();

     // handle CONNECT requests
      else if (command.equals("Connect")){
          try{
            connectToHPFServer();
   	  }catch(IOException ev){
	    System.out.println("Exception in connectToHPFServer() "+ev);}
      }
  }


public void startHPFApplication()
{

    URL url_file=null;
    String s=null;
    BufferedReader dos=null;
    URLConnection opc=null;
    String hpfFile = HPFFileName.substring(0,HPFFileName.indexOf((int)'.'));
    
    String cmnd = "/cgi-bin/runHPF.pl"+"?"+hpfFile+"+"
          +HPFServerPort+"+"+numOfProcs;
    System.out.println("command = "+cmnd);

     try
      {
        String thisLine;
	url_file = new URL("http",HTTPHost,HTTPPort,cmnd);
        DataInputStream theHTML = new DataInputStream(url_file.openStream());
        new readFromHttp(theHTML).start();
      }catch (MalformedURLException ev)
       {
         System.out.println("URL error in startHPFApplication  " + ev);
       } 
     catch (IOException e) {
      System.err.println(e);
    }
 

      
}

public void connectToHPFServer() throws IOException
{
 
     boolean done = false;
     while(!done)
     {
        try {
          hpfCon = new connection(HTTPHost,HPFServerPort,true);
          done = true;
        }
        catch (IOException e) {
          System.out.println("IO Exception CMatrix");
          done = false;
        }
     }
     System.out.println("after connection to HPServer");

     rlib   = new recv_module(hpfCon);
     slib   = new send_module(hpfCon);

     slib.send_int(javaGUI.CONNECT);
     int line = rlib.recv_int();
     gotoLine(line-1); // array in JAVA starts at zero   
     System.out.println("after connectToHPFServer ");

     //get result from HPF server
     int status = readAck();  
}

public Vector readRemoteFile(String host,int port,String file)
{
  
    URL url_file=null;
    String s=null;
    BufferedReader dos=null;
    URLConnection opc=null;
    Vector textFile = new Vector();
    
    try
      {
	url_file = new URL("http",host,port,file); 
      }catch (MalformedURLException ev){
      System.out.println("URL error " + ev);
    }
 
    try{
      opc = url_file.openConnection();
      dos = new  BufferedReader(new InputStreamReader(opc.getInputStream()));
      while((s = dos.readLine())!=null)
        textFile.addElement(s);
    }catch (IOException ev){
      System.out.println("IO error in getContent  "+ev);
    }
    return textFile;
    
}

// HPFTextView ....
}

// Layout all the coponents using PackLayout
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

class DesignManager implements Target 
{
  Vector buttons;
  PackLayout layoutManager,ButtonsLayoutManager;
  PackLayout MenuLayoutManager; 
  PackConstraints constraints;
  InternalWindow window;
  ScrollGroup infoGroup;
  HPFTextView textSource;
  ContainerView ButtonView;//put debug buttons inside;
  ContainerView ControlMenuView;  //put menu inside; 
  ContainerView displayWindow;
  
  MenuView menuView;
  TextView StatusDisplayArea ;
  
  public DesignManager()
  {
    window = new InternalWindow(0, 0, 700, 700);
    window.setResizable(true);
    window.setTitle("HPF Debugger/Visualization Tool");
    window.setCloseable(true);
    layoutManager = new PackLayout();
    window.contentView().setLayoutManager(layoutManager);
    //window.contentView().setColor(Color.pink);
    window.contentView().setColor(Color.lightGray);

    ButtonsLayoutManager = new PackLayout();
    ButtonView = new ContainerView(0,0,600,50);
    ButtonView.setLayoutManager(ButtonsLayoutManager);
    ButtonView.setBackgroundColor(Color.pink);
    LineBorder lb = new  LineBorder(Color.red);
    ButtonView.setBorder(lb);
    
    textSource = new HPFTextView(0,0,800,450,this);
    textSource.setBackgroundColor(Color.white);
    Font f = new Font("TimesRoman",Font.BOLD,16);
    textSource.setFont(f);
  
    displayWindow     = new ContainerView(0,0,700,100);
    StatusDisplayArea =  new TextView(0,0,700,100);
    StatusDisplayArea.setBackgroundColor(Color.blue);
    
  }
      
  public void addAllButtons()
  {
     addButton("Display","eval.gif");
     addButton("Break","break.gif");
     addButton("StepInto","stepinto.gif");
     addButton("StepOver","stepover.gif");
     addButton("GoUntil","gountil.gif");
     addButton("GoToCursor","runtocursor.gif");
     addButton("GetFile","editor.gif"); 
     addButton("Run","startdebugger.gif");
     addButton("Connect","connect.gif"); 
     addButton("Stop","stop.gif");
     addButton("Pause","pause.gif");
     addButton("MoveDown","movedownlevel.gif");
     addButton("MoveUp","moveuplevel.gif");

     constraints = new PackConstraints();
     constraints.setSide(PackConstraints.SIDE_TOP);
     constraints.setAnchor(PackConstraints.ANCHOR_NORTHWEST);
     layoutManager.setConstraints(ButtonView ,constraints);
     window.addSubview(ButtonView);
  }


  public void addMenuItems()
  {
        MenuItem nm,menuItem;
    
        BezelBorder bb = new BezelBorder(BezelBorder.RAISED,
					 Color.lightGray);
        Menu menu = new Menu(true);
        menu.setBorder(bb);
        menu.setBackgroundColor(Color.lightGray);
        
        menuItem = menu.addItemWithSubmenu("File    ");
        menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("New","New",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Open","Open",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Reload Source File","Reload",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Save","Save",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);


        menuItem = menu.addItemWithSubmenu("Edit     ");
        menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Undo","Undo",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Redo","Redo",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Cut","Cut",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Copy","Copy",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);
        nm = new  MenuItem("Paste","Paste",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,4); 
        nm = new  MenuItem("Delete Line","Delete_Line",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,5); 
        nm = new  MenuItem("Insert Line","Insert_Line",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,6); 
        nm = new  MenuItem("Find","Find",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,7);
        nm = new  MenuItem("Replace","Replace",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,8);
        nm = new  MenuItem("Goto Line","GotoLine",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,9);
       

        menuItem = menu.addItemWithSubmenu("Debug     ");
        menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Start/Restart","Start/Restart",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Resume","Resume",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);    
        nm = new  MenuItem("Run to here","Runtohere",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,2);
        nm = new  MenuItem("Step Over","StepOver",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,3);
        nm = new  MenuItem("Step Into","StepInto",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,4); 
        nm = new  MenuItem("Evaluate","Evaluate",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,5); 
        nm = new  MenuItem("Breakpoints","Breakpoints",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,6); 
        nm = new  MenuItem("Goto Interpreter","GotoInterpreter",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,7); 


 
        menuItem = menu.addItemWithSubmenu("Preferences   ");
        menuItem.setSelectedColor(Color.pink);
        menuItem.submenu().setBackgroundColor(Color.lightGray);
        menuItem.submenu().setBorder(bb);
        nm = new  MenuItem("Source Editor","SourceEditor",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,0);
	nm = new  MenuItem("Remote host","Remotehost",null);
	nm.setSelectedColor(Color.pink);
        menuItem.submenu().addItemAt(nm,1);

        menuView = new MenuView(0,0,600,100,menu);
   
        constraints = new PackConstraints();
        constraints.setInternalPadY(15);
        constraints.setPadY(5);
		
        constraints.setSide(PackConstraints.SIDE_TOP);
        constraints.setAnchor(PackConstraints.ANCHOR_NORTHWEST);
        layoutManager.setConstraints(menuView ,constraints);
        window.addSubview(menuView);
  }
  
  
  public void addButton(String title,String imgname)
  {
     RoundedButton button;
    
     button = new RoundedButton(1,1,1,1,title,imgname,textSource);
     //(1,1,30,30,title,imgname,textSource);
     ButtonView.addSubview(button);     
     constraints = new PackConstraints();
     constraints.setSide(PackConstraints.SIDE_LEFT);
     constraints.setAnchor(PackConstraints.ANCHOR_NORTH);
     ButtonsLayoutManager.setConstraints( button, constraints);
     
  }
  
  public void addScrollBars ()
  {

      infoGroup = new ScrollGroup(0,0,600,450);
      infoGroup.setHasVertScrollBar(true); // Vertical only
      infoGroup.setBorder(new BezelBorder(BezelBorder.LOWERED,
                                            Color.lightGray));
      infoGroup.scrollView().setBackgroundColor(Color.white);
        // The following causes the bottom of the group to be fixed
        // (i.e., it's margin, the space below it, can stretch)
      infoGroup.setHasHorizScrollBar(true);
      infoGroup.setHasVertScrollBar(true);
      infoGroup.setVertResizeInstruction(View.BOTTOM_MARGIN_CAN_CHANGE);
      infoGroup.setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);

      infoGroup.scrollView().setContentView(textSource);
       
      window.addSubview(infoGroup);
      constraints = new PackConstraints();
      constraints.setInternalPadY(180); 
      constraints.setPadY(20);
      constraints.setExpand(true);
      constraints.setFillX(true);
      constraints.setFillY(true);
      constraints.setSide(PackConstraints.SIDE_TOP);
      constraints.setAnchor(PackConstraints.ANCHOR_SOUTHWEST);
      layoutManager.setConstraints(infoGroup ,constraints);
  }

  public void addDisplayWindow()
  {

    ScrollGroup infoGroup = new ScrollGroup(0,0,700,100);
    infoGroup.setHasVertScrollBar(true); // Vertical only
    infoGroup.setBorder(new BezelBorder(BezelBorder.LOWERED,
					Color.lightGray));
    infoGroup.scrollView().setBackgroundColor(Color.white);
        // The following causes the bottom of the group to be fixed
        // (i.e., it's margin, the space below it, can stretch)
    infoGroup.setHasHorizScrollBar(true);
    infoGroup.setHasVertScrollBar(true);
    infoGroup.setVertResizeInstruction(View.BOTTOM_MARGIN_CAN_CHANGE);
    infoGroup.setHorizResizeInstruction(View.WIDTH_CAN_CHANGE);
    infoGroup.scrollView().setContentView(StatusDisplayArea);
    
    //displayWindow.setTitle("Display Window");
    //displayWindow.setBackgroundColor(Color.red);
    //displayWindow.addSubview(infoGroup);
    //window.addSubview(displayWindow);
    

    window.addSubview(infoGroup);
    constraints = new PackConstraints();
    constraints.setExpand(true);
    //constraints.setInternalPadY(150);
    //constraints.setPadY(10);
    constraints.setFillX(true);
    constraints.setFillY(true);
    constraints.setSide(PackConstraints.SIDE_TOP);
    constraints.setAnchor(PackConstraints.ANCHOR_SOUTHWEST);
    layoutManager.setConstraints(infoGroup ,constraints);
   
  }
  

  public void FinishDesign()
  {
     window.contentView().layoutView(0, 0);
     window.show();
  }

  public void performCommand(String command, Object anObject) 
  {
     
    if (command.equals("Display")){
       String s = ((StringBuffer)anObject).toString(); 
       StatusDisplayArea.appendString(s);
    }
  }
  
  
}


///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////

class RoundedButton extends Button implements Target{
    Bitmap bitmap = null;         // Stores a bitmap of the interior
    InternalWindow descW;
    TextField label;
    String titleCommand;
    MouseEvent lastEvent;
    
    // --------------  Constructors and initialization  --------------

    public RoundedButton(int x, int y, int width, int height,
           String title,String imgname, Object target) 
    {
        super(x, y, width, height);

        setImage(Bitmap.bitmapNamed(imgname));
        setTarget((Target)target);
        setCommand(title);
        titleCommand = title;
	
    }

   public void mouseEntered(MouseEvent e)
   {

      int x = x()+superview().x();
      int y = y()+superview().y();
      descW = new InternalWindow(x+width()/2,y+height()+3,150,35);

      descW.setResizable(true);
      descW.setType(Window.BLANK_TYPE);
      label = new TextField(0,0,150,35);
      label.setBackgroundColor(new Color(255,255,125));
      if (titleCommand.equals("Display"))
        label.setStringValue("Evaluate an Expression");
      else if (titleCommand.equals("Break"))
        label.setStringValue("Toggle Breakpoint(F4)");
      else if (titleCommand.equals("StepInto"))
        label.setStringValue("Step into(Alt-Nstep)");
      else if (titleCommand.equals("StepOver"))
        label.setStringValue("Step over(Alt-Nstep)");
      else if (titleCommand.equals("GoUntil"))
        label.setStringValue("Go until true");
      else if (titleCommand.equals("GoToCursor"))
        label.setStringValue("Go to Cursor");
      else if (titleCommand.equals("NIter"))
        label.setStringValue("N iteration");
      else if (titleCommand.equals("Continue"))
        label.setStringValue("Continue");
      else if (titleCommand.equals("Run"))
        label.setStringValue("Run/Restart");
      else if (titleCommand.equals("Stop"))
        label.setStringValue("Stop");
      else if (titleCommand.equals("Pause"))
        label.setStringValue("Pause");
      else if (titleCommand.equals("MoveDown"))
        label.setStringValue("Caller's stack frame");
      else if (titleCommand.equals("MoveUp"))
        label.setStringValue("Callee's stack frame");
      else if (titleCommand.equals("GetFile"))
	label.setStringValue("Get HPF Program");
      else if (titleCommand.equals("Connect"))
	label.setStringValue("Connect to HPF Server ");
     
      
      descW.addSubview(label);
      this.superview().superview().addSubview(descW);
      descW.show();
     	
  }

  public void mouseExited(MouseEvent e)
  {
    descW.hide();
        
  }

  public boolean mouseDown(MouseEvent event)
  {

    lastEvent = event;
    super.mouseDown(event);
    return true;
     
  }
  
  public void closeLabelWin()
  {
    descW.hide();
  }

 
    
}

class readValue extends InternalWindow implements Target {

 TextField itemValue;
 String labelText;
 Target target;
 String hpfCommand;
 TextField   entryTextField;

 public readValue(View parent,String labelText_,
          Object target_,String command_)  
 {
     super(parent.x()+ parent.width()/2,parent.y()+ parent.height()/2,
         100,100 );
     labelText = labelText_;
     target = (Target)target_;
     hpfCommand = command_;

     setTitle("Dialog Window");
     setResizable(true);

     contentView().setLayoutManager(new PackLayout());
     itemValue = newTextFieldRow(labelText,"");
     SelectButton();
 }



 public TextField newTextFieldRow(String labelText, String defaultValue) 
   {
        PackLayout      layoutManager;
        PackConstraints constraints;
        ContainerView   containerView;
        TextField       label;
        //TextField       entryTextField;

        containerView = newContainerView();
        containerView.setBorder(null);
        layoutManager = (PackLayout)containerView.layoutManager();

        label = new TextField(1, 1, 1, 1);
        label.setBorder(null);
        label.setBackgroundColor(Color.lightGray);
        label.setStringValue(labelText);
        label.setEditable(false);
        label.setSelectable(false);
        label.sizeToMinSize();
        containerView.addSubview(label);
        constraints = new PackConstraints();
        constraints.setSide(PackConstraints.SIDE_LEFT);
        constraints.setPadX(2);
        layoutManager.setConstraints(label, constraints);

        entryTextField = new TextField(1, 1, 1, 1);
        entryTextField.setStringValue(defaultValue);
        entryTextField.sizeToMinSize();
        containerView.addSubview(entryTextField);
        constraints.setExpand(true);
        constraints.setFillX(true);
        layoutManager.setConstraints(entryTextField, constraints);
        return entryTextField;
    }

 public ContainerView newContainerView() {
        ContainerView   containerView;
        PackLayout      layoutManager;
        PackConstraints constraints;

        containerView = new ContainerView(1, 1, 1, 1);
        containerView.setLayoutManager(new PackLayout());
        contentView().addSubview(containerView);
        layoutManager = (PackLayout)contentView().layoutManager();
        constraints = new PackConstraints();
        constraints.setSide(PackConstraints.SIDE_TOP);
        constraints.setExpand(true);
        constraints.setFillX(true);
        constraints.setFillY(true);
        layoutManager.setConstraints(containerView, constraints);
        return containerView;
    }
   
    public void SelectButton()  {
        PackLayout      layoutManager;
        PackConstraints constraints;
        ContainerView   containerView;
        Button          button;

        containerView = newContainerView();
        containerView.setBorder(null);
        layoutManager = (PackLayout)containerView.layoutManager();

        button = new Button(1,1,1,1);
        button.setTitle("OK");
        button.setTarget(this);
        if (hpfCommand.equals("GetHPFSource"))
            button.setCommand("ForwardFileName");
        else if (hpfCommand.equals("GetSIntoNumber"))
            button.setCommand("ForwardNum");
        else if (hpfCommand.equals("GetSOverNumber"))
            button.setCommand("ForwardNum");
        containerView.addSubview(button);
        constraints = new PackConstraints();
        constraints.setExpand(true);
        constraints.setFillX(true);
        constraints.setFillY(true);
        constraints.setPadY(5);
        constraints.setPadX(5);
        constraints.setSide(PackConstraints.SIDE_LEFT);
        layoutManager.setConstraints(button, constraints);
    }

    public void performCommand(String command, Object anObject) 
    {
        System.out.println("new commmand in window :"+command);
        if (command.equals("ForwardFileName")) {
           CommandEvent evc=new CommandEvent(target,hpfCommand,entryTextField);
           Application.application().eventLoop().addEvent(evc);
        }  
        else if (command.equals("ForwardNum")) { 
           CommandEvent evc=new CommandEvent(target,hpfCommand,entryTextField);
           Application.application().eventLoop().addEvent(evc);
        }     
    }
}

class readFromHttp extends Thread{
   DataInputStream is;

   public readFromHttp(DataInputStream is_)
   {
     is = is_;
     //setPriority(7);
   }
 
   public void run()
   {
     String thisLine;
     boolean flag = true;

     while(flag)
     {
        try{
             thisLine = is.readLine();
             System.out.println("here..."+thisLine);
         }catch (IOException ev){
	   System.out.println("IOException during reading ");}

         try{
              Thread.sleep(100);
         } catch (InterruptedException ie) {break;}
         Thread.yield();
      }
   }
}   

