#include "debugger.h"

void stop_program(int sockfd,int AppletStop)
{
    #include "pglocal.h"   
    int cmnd,fd;
    sigset_t oset;
    int nprocs = __hpf_nprocs(),ack,np;

    fprintf(fpout,"stop_program: I am stopping program now.... \n");
    if (HOST){
       if (AppletStop)
	 recv_int(sockfd,&cmnd);
       for(np=1;np<nprocs;np++)
	  __hpf_crecv(np,&ack,sizeof(int),1,PGLCL_INT4);
       send_int(SageServerSock,EXIT);
       close(SageServerSock);
    }
    else  
    {
       close(SageServerSock);
       __hpf_csend(0,&ack,sizeof(int),1,PGLCL_INT4);
    }
    
    if (HOST){
      for (fd=0; fd<nfds; ++fd)
	if (FD_ISSET(fd, &afds))
	  close(fd);
    }
    distribute_oneitem_(&ack);
  
    
    if (DEBUG)
       fprintf(fpout,"ME = %d I stopped command \n",ME);
    exit(0);
}


int setjmp_(int *myline,char *fileName)
{
  /*return setjmp(files[curFile].lineInfo[*myline].jmpbuffer);  */
 return setjmp(files[findFileIndex(fileName)].lineInfo[*myline].jmpbuffer);
}

int amIinCurrentLoop(int myline,int currentLoopHeader)
{
  int k;

  k = myline;
  while(k > 0)
  {
    if ((files[curFile].lineInfo[k].isInLoop == currentLoopHeader)||
	(files[curFile].lineInfo[k].isInLoop == 0))
      break;
    k = files[curFile].lineInfo[k].parent;
 }
  if (DEBUG)
      fprintf(fpout,"myline=%d and insinloop=%d currentHeader=%d\n",
       myline,files[curFile].lineInfo[k].isInLoop,currentLoopHeader);
  if (files[curFile].lineInfo[k].isInLoop == currentLoopHeader)
    return 1;
  else
    return 0;

}

int DoWeStopHere(int myline,char *funcName,char *fileName,int sockfd)
{
   int Stop = 0,lineNumber,n; 
   int nextFindex,index;
   PARSTRUCT parstruct;
   sigset_t new,oset;
   pthread_t tid;	

   prevLineNum = curLineNum;
   curLineNum = myline;
   prevFileName = curFileName;
   curFileName  = fileName;
   prevFuncName = curFuncName;
   curFuncName  = funcName;
   if (prevFileName == NULL){
     prevFuncName = (char *)alloca(2);
     strcpy(prevFuncName,"");
   }
   if (prevFileName == NULL ){
     prevFuncName =  (char *)alloca(2);
     strcpy(prevFuncName,"");
   }
    
  if (DEBUG)
     fprintf(fpout,
     "inside server myline = %d sock=%d ME=%d cmnd=%d stacktop=%d fn=%s curFile=%d funcName=%s max_push_id=%d\n", myline,sockfd,ME,curCmnd,cstack.top,fileName,curFile,curFuncName,max_push_id); 
  
   if (files[curFile].lineInfo[myline].numOfAttachedFcalls > 0){
      /* Call attached functions for my line */
     
     fprintf(fpout," About entering callToAttachedFuncs \n");
     
     sigfillset(&new); 
     pthread_sigmask(SIG_BLOCK, &new, NULL); 
    
     parstruct.myline = myline;
     parstruct.myFuncName = curFuncName;
     parstruct.sockfd = sockfd;
         
     if ( n = pthread_create( &tid, NULL, callToAttachedFuncs, 
			    (void *)(&parstruct)) ) {
       fprintf( stderr, "pthread_create: %s\n", strerror( n ) );
       exit( 1 );
     }
    
     if ( n = pthread_join( tid, NULL ) ) {
	fprintf( stderr, "pthread_join: %s\n", strerror( n ) );
	exit( 1 );
     } 
    
     /* callToAttachedFuncs(&parstruct); */
     if (DEBUG)
        fprintf(fpout,"in debugger: after callToAttachedFuncs \n");
   }

   updateControlStack(myline);
   
   if ((curCmnd == GOTOSTACKDOWN)||(curCmnd == GOTOSTACKUP))
     Stop = 1;
   if (curCmnd == GOTOCURSOR){
        if (myline == goToCursorLine)
	   Stop = 1;
   } 
     
   else if (((curCmnd == STEPOVER)||(curCmnd == NSTEPOVER)) &&
         (cstack.top <= prevStackTop ))
   { 
       if (DEBUG)
          fprintf(fpout,"Previos Command STEP cnt = %d\n",curCounter);
       if (curCounter > 0)
          curCounter --;
       if (curCounter == 0) 
	  Stop = 1;

   }
   else if ((curCmnd == STEPINTO)||(curCmnd == NSTEPINTO))
   {
       if (curCounter > 0)
          curCounter --;  
       if (curCounter == 0) 
	  Stop = 1;
   }
   else if ((curCmnd == CONTINUE)&&(files[curFile].lineInfo[myline].onbreak))
       Stop = 1;
   else if ((curCmnd == NITERATION)&&(cstack.top <= prevStackTop ))
     {
       if (!amIinCurrentLoop(myline,loopHeaderLine)){
          Stop = 1;    
          if (DEBUG)
	  fprintf(fpout,
	  "Ok ME = %d I went oout of loop before indicated times:%d - %d\n",
           ME,files[curFile].lineInfo[myline].isInLoop,loopHeaderLine);
       }
       else if ((curCounter > 0)&&
		((myline ==  nIterStartLine)||
		 ((nIterStartLine == loopHeaderLine)&&
		  (loopHeaderLine == files[curFile].lineInfo[myline].prev))))
	 {
	    if (DEBUG)
	      fprintf(fpout,"ITERATION : %d\n", curCounter);
            curCounter--;
	 }
       if (curCounter == 0) 
	   Stop = 1;
     }
   if (is_staying_in_server == STAYINSERVER)
      Stop = 1; 
  


   nextFindex = findFileIndex(curFileName);
   /* check the program termination */
   if ((!strcasecmp(mainFuncName,curFuncName))&&
       (files[nextFindex].lineInfo[myline].isReturnPoint)&&
       (!Stop)){
      send_int(sockfd,STOPPROGRAM);
      stop_program(sockfd,1);
   }

   if (!Stop){ 
      if (DEBUG)
         fprintf(fpout,"I am exiting now,non-stop \n"); 
      is_staying_in_server = EXITFROMSERVER; 
      return EXITFROMSERVER;
   }

   
   /* Send myline to Java Applet which updates current line number */
   /* for beginning, wait for connection request */
   /* do not send the myline number to Applet */
   if (is_staying_in_server == EXITFROMSERVER){
           /*If we moved to one function code which is in another file 
           other than current one, Applet will request new file source 
           code from HTTP server if it doesnt have */

     if (strcmp(curFileName,prevFileName)){ 
           /* We are going to debug one function in another file, 
	   send command to applet which will request  this file, 
	   and open  its parse tree */
 
           int index;
           if (DEBUG)
             fprintf(fpout,"I(%d) am sending the file : %s\n",ME,curFileName);
	   index = nextFindex; /*findFileIndex(curFileName); */

           if (HOST){
             send_int(sockfd,GETNEWFILE);
             send_String(sockfd, curFileName);
	   }
           curFile = index;
	   curFunction = findFuncIndex(curFuncName,curFileName);
           /* openNewProject(files[curFile].depFileName); */
	   send_int(SageServerSock,OPEN_PROJECT);  
	   send_String(SageServerSock,files[curFile].depFileName);

           if (DEBUG)
             fprintf(fpout,"I(%d) sent the file : %s\n",ME,curFileName);
	   
     }
     
       /* check the program termination */
       if ((!strcasecmp(mainFuncName,curFuncName))&&
	   (files[curFile].lineInfo[myline].isReturnPoint))
	 {
          fprintf(fpout,"ME=%d I stop program now \n",ME);
	  fprintf(fpout,"ME=% stops program line=%d\n",ME,myline);
	  send_int(sockfd,STOPPROGRAM);
          stop_program(sockfd,1);
	 }
       /* Send my line */
       else  if (HOST)
	 send_int(sockfd,myline); 
       if (DEBUG)
	 fprintf(fpout,
		 "We ME = %d send current line = %d toApplet \n",ME,myline);
	    
   }
      
   
   if (DEBUG)
     fprintf(fpout,"after DoWeStopHere..\n");
   is_staying_in_server = STAYINSERVER;
   
   /* Stop at this line, and wait for user commands */
   return is_staying_in_server;
  
}
   


int server (int myline,char *funcName,char *fileName,int sockfd)
{
   int Stop = 0,lineNumber,i; 
   char variableName[256],SciVisHost[256],SciVisPort[256];
   static char tmp1[256];
   static char tmp2[256];
   char *sp1,*sp2;
   int newLineNum;
   int status,temp;
   char msg[256];
   int errcode=0,fd,ret,nextFindex,index;
   PARSTRUCT parstruct;
   sigset_t new,oset;
   int n,recv_status,ack;  
   pthread_t tid;
   static char curWebFlowConfig[MAXVARLEN];
      
   if (DEBUG)
     fprintf(fpout,"Waiting command from client ...\n");

   /* save last connecton socket */  
   last_sockfd = sockfd;
   if (HOST)
      recv_status = recv_int( sockfd,&curCmnd );

   distribute_oneitem_(&recv_status);
   /* If client closed its connection to server or reset */
   printf("recv_status = %d nclients = %d\n",recv_status,nclients);
   
   if (recv_status < 0)
   {
     printf("Client closed connection \n");
     if (HOST)
     {
       close(sockfd);
       FD_CLR(sockfd, &afds);
     }
     nclients--;
     /* If All of the clients connected to me exited */
     if ( nclients == 0){
       close(SageServerSock);
       distribute_oneitem_(&ack);
       exit(0);
     }
     is_staying_in_server = STAYINSERVER; 
     return is_staying_in_server;
   }
   distribute_oneitem_(&curCmnd);
   prevStackTop = cstack.top;

   if (DEBUG)
      fprintf(fpout,"read new command = %d\n",curCmnd);

   switch(curCmnd){
   case GOTOCURSOR:
     curCounter = 0;
     if (HOST)     
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
   
     if (!(files[curFile].lineInfo[curCounter].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd,
		    prevFileName,curFileName);
        errcode = -1;
        is_staying_in_server = STAYINSERVER; 
        return is_staying_in_server; 
     }
     else{
        goToCursorLine = curCounter;
        is_staying_in_server = EXITFROMSERVER;
     }
     if (DEBUG)
       fprintf(fpout,"Current counter = %d myline : %d\n",curCounter,myline);
     if (curCounter < myline){
        if (DEBUG)
	  fprintf(fpout,"I am going back to line : %d\n",goToCursorLine);
        send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);  
        longjmp(files[curFile].lineInfo[curCounter].jmpbuffer,1);
     } 

     break; 

   case CONNECT :
     if (HOST)
        send_int(sockfd,myline);
     is_staying_in_server = STAYINSERVER; 
     if (DEBUG) 
        fprintf(fpout,"We processed connect request ME = %d\n",ME);
     break;

   case PUTBREAKONOFF :
     lineNumber = 0; 
     if (HOST)
        recv_int( sockfd,&lineNumber );  
     distribute_oneitem_(&lineNumber);
    
     if (DEBUG)
        fprintf(fpout,"line number = %d\n",lineNumber);
     if (!(files[curFile].lineInfo[lineNumber].isExecutable)){
        send_errmsg(-1,"This Line is not executable ",myline,sockfd,
		    prevFileName,curFileName);
        errcode = -1;
     }
     else{
       if (files[curFile].lineInfo[lineNumber].onbreak == BREAKON){
          files[curFile].lineInfo[lineNumber].onbreak = BREAKOFF;
	  numberOfBreakPoints--;
       }
       else{
          files[curFile].lineInfo[lineNumber].onbreak = BREAKON;
	  numberOfBreakPoints++;
       }
       
     }
     is_staying_in_server = STAYINSERVER;
     break;

   case STEPOVER:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     break;
   case STEPINTO:
     curCounter = 1;
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NSTEPOVER:
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);
    
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NSTEPINTO: 
     curCounter = 0;
     if (HOST) 
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);

     is_staying_in_server = EXITFROMSERVER;
     break;

   case CONTINUE:
     is_staying_in_server = EXITFROMSERVER;
     break;

   case RUN: 
     is_staying_in_server = EXITFROMSERVER;
     break;

   case NITERATION:
     curCounter = 0;
     if (HOST)
        recv_int( sockfd,&curCounter);
     distribute_oneitem_(&curCounter);

     if (!(files[curFile].lineInfo[myline].isInLoop)){
        send_errmsg(-3,"You are not in one loop",myline,sockfd,
		    prevFileName,curFileName);
        is_staying_in_server = STAYINSERVER;
        errcode = -3;
     }
     else{
        nIterStartLine = myline;
        loopHeaderLine = files[curFile].lineInfo[myline].isInLoop;
        is_staying_in_server = EXITFROMSERVER;
     }
     if (nIterStartLine == loopHeaderLine)
       curCounter++;
     break;

   case DISPLAY:
     status = 0;
     if (HOST){
        recv_String(sockfd,variableName);
        status = find_var(funcName,variableName);
     }
     distribute_oneitem_(&status);

     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-4,msg,myline,sockfd,prevFileName,curFileName);
        errcode = -4;
     }
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);
       status = send_registered_data(variableName,status,sockfd);    
     } 
     is_staying_in_server = STAYINSERVER;
     break;

   case DISARRAYSECTION:
     arraysec_thread(myline,sockfd,prevFileName,curFileName,funcName);
     is_staying_in_server = STAYINSERVER;
     fprintf(fpout,"after DISARRAYSECTION \n");
     
     break;

   case SETVARIABLE:
     status = 0;
     if (HOST){
        recv_String(sockfd,variableName);
        status = find_var(funcName,variableName);
     }
     distribute_oneitem_(&status);

     if (status < 0){
        sprintf(msg,"We could not find the variable : %s",variableName);
        send_errmsg(-5,msg,myline,sockfd,prevFileName,curFileName);
        errcode = -5; 
     } 
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);  
       status = set_variable(sockfd,status);
     }
     is_staying_in_server = STAYINSERVER;   
     break;

   case SETPARVAR:
     status = 0;
     if (HOST){
        recv_String(sockfd,variableName);
	status = find_var(funcName,variableName);
     }
     distribute_oneitem_(&status);
     
     if (status < 0){
        sprintf(msg,"We could not find parallel  variable : %s",variableName);
        send_errmsg(-6,msg,myline,sockfd,prevFileName,curFileName);
        errcode = -6; 
     } 
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);  
       set_ParallelVar(sockfd,status);
     }

     is_staying_in_server = STAYINSERVER;
     break;    

   case INTERPRET :
     interpretHPFStmt(sockfd,funcName);
     is_staying_in_server = STAYINSERVER;
     break;

   case STOP:
     stop_program(sockfd,0);
     exit(0);
     break;
   case  SCIVISENV :
     if (HOST){
       recv_String(sockfd,SciVisHost);
       recv_String(sockfd,SciVisPort);
       /* put environment variabels SciVis will use later */

       strcpy(tmp1,"JSERHOST=");
       strcat(tmp1,SciVisHost);
       ret=putenv(tmp1);
       if (ret != 0)
	 fprintf(fpout,"1:setenev error \n");
       strcpy(tmp2,"JSERPORT=");
       strcat(tmp2,SciVisPort);
       ret=putenv(tmp2); 
       if (ret != 0)
	 fprintf(fpout,"2:setenev error \n");

       sp1 = getenv("JSERHOST"); 
       sp2 = getenv("JSERPORT"); 
       if ((!sp1)||(!sp2))
	 fprintf(fpout,"getenv error \n");
       if (DEBUG)
	 fprintf(fpout,"GETENV SciVisHost : %s SciVisPort : %s \n",sp1,sp2);
     }
     is_staying_in_server = STAYINSERVER;
     break;
   
   case GOTOSTACKDOWN:
     if (cstack.top == stackLength){
       errcode = -7;
       if (HOST){
	 strcpy(msg,"You can not go stack down.!!!");
	 send_errmsg(-7,msg,myline,sockfd,prevFileName,curFileName);
       } 
       is_staying_in_server = STAYINSERVER; 
       return is_staying_in_server;
     }
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);
       is_staying_in_server = EXITFROMSERVER;
       gotoStackDown(sockfd);
     }
     break;
   
  case GOTOSTACKUP:
     if (cstack.top == 0){
       errcode = -8;
       if (HOST){
	 strcpy(msg,"You can not go stack up.!!!");
	 send_errmsg(-8,msg,myline,sockfd,prevFileName,curFileName);
       } 
       is_staying_in_server = STAYINSERVER;
       return is_staying_in_server;
     }
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);
       is_staying_in_server = EXITFROMSERVER;
       gotoStackUp(sockfd);
     }
     break;

   case SCIVIS_FUNCTION_LIST:   
     send_scivizFlist(sockfd);
     is_staying_in_server = STAYINSERVER;
     
     break;

   case SEND_LOCALS:
     send_localVars(sockfd,curFuncName);
     is_staying_in_server = STAYINSERVER;
     
     break;

   case ADD_ACTION: case DELETE_ACTION:
     /* receive function call string "java_ser_(...params..) */
     if (HOST) 
	recv_String(sockfd, receivedHPFList); 
     distribute_string_(); 

     /* Receive line number on which you put function call */
     if (HOST)
	recv_int( sockfd,&newLineNum); 
     distribute_oneitem_(&newLineNum);

     is_staying_in_server = STAYINSERVER;
     if ((newLineNum != -1)&&
	 (!(files[curFile].lineInfo[newLineNum].isExecutable))){
        send_errmsg(-8,
	 "You can not add/delete action to this line which is not executable",
          myline,sockfd,
	  prevFileName,curFileName);
        errcode = -8;
     }
     else{
       send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);  
       /* Register received function */
       if (newLineNum != -1)
	  processAction(receivedHPFList,newLineNum,curFile); 
       else {
  	 int fsize = files[curFile].fileSize;
	 
	 for(i=0;i<fsize;i++)
	   if (files[curFile].lineInfo[i].isExecutable)
	       processAction(receivedHPFList,i,curFile); 
       }
     }
     return is_staying_in_server; 
     break;

     case ACTION_LIST:
       if (HOST)
	 send_action_points(sockfd);
       is_staying_in_server = STAYINSERVER;
       break;

     case GET_FUNCTION:
       if (HOST)
 	  send_function_params(sockfd,myline);
       is_staying_in_server = STAYINSERVER;
       return;
       break;
   
     case STORE_CONFIG:
       if (HOST){
	 recv_String(sockfd,receivedHPFList);
         store_config(receivedHPFList);
       }
       distribute_string_();
       /* Store config file name for the WebFlow command */
       strcpy(curWebFlowConfig,receivedHPFList);
       is_staying_in_server = STAYINSERVER;   
       break;
       
     
     case GET_PROFILE_DATA:
       if (HOST)
	 send_profile_data(sockfd);
       is_staying_in_server = STAYINSERVER;
       return;
       break;

     case WEBFLOW:  
       read_Config_File(curWebFlowConfig,sockfd);
       
       is_staying_in_server = STAYINSERVER;
       return; /* For now do not return anything to WebFlow Module */
       break;
     case APPLY_CONFIG :  
       if (HOST)
	 recv_String(sockfd,receivedHPFList);
       distribute_string_();
       apply_Config_File(receivedHPFList, myline,sockfd);
       is_staying_in_server = STAYINSERVER;
       return is_staying_in_server;
       break;
     case SEND_CONFIGS  :
       if (HOST)
	 readConfigAndSend(".config", sockfd);
       is_staying_in_server = STAYINSERVER;
       return is_staying_in_server;
       break;
       
 
   } /* switch */

    
   /* If there is no error,send Ok message to Applet */
   if ((errcode == 0)&&(curCmnd != DISPLAY)
       &&(curCmnd != SETVARIABLE)&&(curCmnd != DISARRAYSECTION)&&
         (curCmnd != INTERPRET))
      send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);
    
   return is_staying_in_server;
}

void store_config(char *ConfigFile)   
{
   FILE *fp;
   char HPFExecName[MAXVARLEN];
   int i,fsize,k,j,myNumOfFuncs;
        
   if (!(fp = fopen(ConfigFile,"w"))){
     fprintf(fpout,"I could not open the file : %s\n",ConfigFile);
     return;
   }
   sprintf(HPFExecName,"demo_%s",projectName);
   *strrchr(HPFExecName,'.') = 0;   
   /* Write HPF executable name */
   fprintf(fp,"%s\n",HPFExecName);
   /* Write the port number I am listening */
   fprintf(fp,"%s\n",hpf_portnum);

   /* Write total number of action points */
   fprintf(fp,"%d\n",numberOfActionPoints);
   /* write action points as : lineNumber and fcall  and filename  */
   /* Get the file size of current file */

   
   for (k=0;k<nfiles;k++)
   {
     fsize = files[k].fileSize;
     for(i=0;i<fsize;i++){
       myNumOfFuncs = files[k].lineInfo[i].numOfAttachedFcalls;
       if (myNumOfFuncs > 0){
         for(j=0;j<myNumOfFuncs;j++)
	    fprintf(fp,"%d %s %s\n",
		 i,files[k].lineInfo[i].attachedFcalls[j].fcallString,
		    files[k].fileName);
       }
     }
   }
     
   /* Write total number of break points */
   fprintf(fp,"%d\n",numberOfBreakPoints);
   /* write break points as : lineNumber and filename pairs */
   for (k=0;k<nfiles;k++)
   {
     fsize = files[k].fileSize;
     for(i=0;i<fsize;i++){
       if (files[k].lineInfo[i].onbreak == BREAKON)
	 fprintf(fp,"%d %s\n",i,files[k].fileName);
     }
   }
      
   
   fclose(fp);

   /* copy this file under dir. ../../../htdocs/VPL-html */
   sprintf(HPFExecName,"cp %s  ../../../htdocs/VPL-html/", ConfigFile);
   system(HPFExecName);
}


void read_Config_File(char *ConfigFile,int sockfd)
{
  FILE *fp;
  char buf[REGBUFSIZE],*sp,sline[64],fcall[REGBUFSIZE];
  int  numOfActions,k,lineNumber,index,findex,WebSock;
  char host[REGBUFSIZE],port[REGBUFSIZE];
      
  if (!(fp = fopen(ConfigFile,"r"))){
     fprintf(fpout,"I could not open the file : %s\n",ConfigFile);
     exit(1);
  }
  /* Read HPF Executable name, 
     HPF Server port and number of action points respectively*/
  fgets(buf,sizeof(buf),fp);
  fgets(buf,sizeof(buf),fp);
  /* We need only number of action points */
  fgets(buf,sizeof(buf),fp);
  numOfActions = atoi(buf);

  /*Configuration file will includes linenumber and function call string
    -lineNumber WeBFlow_xxx/java_xxx/timer(varname)-
    there is at least one space between them  at each line of file */
  /*****************************************************************/
  for(k=0;k<numOfActions;k++){
    fgets(buf,sizeof(buf),fp);
    /*Extract line Number  */
    sp = strchr(buf,' ');
    strncpy(sline,buf,sp-buf);
    sline[sp-buf] = 0;
    lineNumber = atoi(sline);
    /*Extract function call string */    
    strcpy(fcall,sp);
    
    /* If WebFlow function */
    if (strstr(fcall,"WebFlow_")){
      if (HOST){
	 recv_String(sockfd,host);
	 recv_String(sockfd,port);
	 WebSock = connectsock( host, port,"tcp");
      }
     if (DEBUG)
       fprintf(fpout,"-%s- with  has webflow sock=%d\n",
	       fcall,WebSock);
    }
    
    /*****************************************************/
    /* Because only HOST will connect to WebFlow module,**/ 
    /****"WebSock" is not important for other processors.*/
    /*** So we did not distribute it *********************/
    /*****************************************************/
    if (index >= 0){
      AFCALLS *pf;
      pf = &(files[curFile].lineInfo[lineNumber].attachedFcalls[index]);
      pf->WebFlowSockfd = WebSock;
    }  
    
  }
  fclose(fp);
     
}


void apply_Config_File(char *ConfigFile,int myline,int sockfd)
{
  FILE *fp;
  char buf[REGBUFSIZE],*sp,sline[128],*filename,fcall[REGBUFSIZE];
  int  numOfActions,k,lineNumber,index,findex,WebSock,numOfBreaks;
  char host[REGBUFSIZE],port[REGBUFSIZE];
  int  *lines,nlines=0;
  char **fnames;
          
  if (!(fp = fopen(ConfigFile,"r"))){
     fprintf(fpout,"I could not open the file : %s\n",ConfigFile);
     exit(1);
  }
  /* Read HPF Executable name, 
     HPF Server port and number of action points respectively*/
  fgets(buf,sizeof(buf),fp);
  fgets(buf,sizeof(buf),fp);
  /* We need only number of action points */
  fgets(buf,sizeof(buf),fp);
  numOfActions = atoi(buf);
  lines = (int *)calloc(numOfActions,sizeof(int));
  fnames = (char **)malloc(sizeof(char *)*numOfActions);
  
  /*Configuration file will includes linenumber and function call string
    -lineNumber WeBFlow_xxx/java_xxx/timer(varname)-
    there is at least one space between them  at each line of file */
  /*****************************************************************/
  for(k=0;k<numOfActions;k++){
    fgets(buf,sizeof(buf),fp);
    /*Extract line Number  */
    sp = strchr(buf,' ');
    strncpy(sline,buf,sp-buf);
    sline[sp-buf] = 0;
    lineNumber = atoi(sline);
    /*Extract function call string an filename*/    
    strcpy(sline,sp);  
    strcpy(fcall,strtok(sline,")\n\r"));
    strcat(fcall,")");
    filename =  strtok(NULL,")\n\r");
    filename++; /* there is blank between fcall and filename */
    
     if (DEBUG) 
      fprintf(fpout,"Apply action point with line=%d fcall=%s file=%s l=%d\n",
		lineNumber,fcall,filename,strlen(filename));
    findex = findFileIndex(filename);
    /*Add this Function Call to the corresponding line */
    index = processAction(fcall,lineNumber,findex);
    if (index >= 0){
      lines[nlines] = lineNumber;
      fnames[nlines] = (char *)malloc(strlen(filename)+1);
      strcpy(fnames[nlines],filename);
      nlines++;
      
    }
    
  }
  
  /* Send the action pint lines to Applet */
  if (HOST){
    send_int(sockfd,nlines);
    for(k=0;k<nlines;k++){
      send_int(sockfd, lines[k]);
      send_String(sockfd,fnames[k]);
    }
  }

  /* Delete allocated stuff */  
  for(k=0;k<nlines;k++)
    free(fnames[k]);
  free(lines);
  free(fnames);

  /* Attach break points */
  fgets(buf,sizeof(buf),fp);
  numOfBreaks = atoi(buf);
  lines = (int *)malloc(numOfBreaks*sizeof(int));
  fnames = (char **)malloc(numOfBreaks*sizeof(char *));
  nlines = 0;
  
  for(k=0;k<numOfBreaks;k++){
    fgets(buf,sizeof(buf),fp);
    lineNumber = atoi(strtok(buf,"\n\r "));
    filename = strtok(NULL,"\n\r ");
    findex = findFileIndex(filename);
    if (DEBUG) 
        fprintf(fpout,"Apply break point with line=%d file=%s\n",
		lineNumber,filename);
    if (files[findex].lineInfo[lineNumber].isExecutable){
      if (files[findex].lineInfo[lineNumber].onbreak == BREAKON){
          files[findex].lineInfo[lineNumber].onbreak = BREAKOFF;
	  numberOfBreakPoints--;
      }
      else{
	  files[findex].lineInfo[lineNumber].onbreak = BREAKON;
	  numberOfBreakPoints++;
      }
      lines[nlines] = lineNumber;
      fnames[nlines] = (char *)malloc(strlen(filename)+1);
      strcpy(fnames[nlines],filename);
      nlines++;

    }
  }
  fclose(fp);

  if (HOST){
    send_int(sockfd,nlines);
    for(k=0;k<nlines;k++){
      send_int(sockfd, lines[k]);
      send_String(sockfd,fnames[k]);
    }
  }
  /* Delete allocated stuff */  
  for(k=0;k<nlines;k++)
    free(fnames[k]);
  free(lines);
  free(fnames);
     
}

void readConfigAndSend(char *ext,int sockfd)
{
  DIR *dirp;
  struct dirent *dp;
  char cfiles[64][128];
  int  cn=0,k;
    
  dirp = opendir("./");
  while(dp = readdir(dirp))
    if (strstr(dp->d_name,ext))
      strcpy(cfiles[cn++],dp->d_name);

  /* send the number of config files and themselves */
  send_int(sockfd,cn);
  for(k=0;k<cn;k++)
    send_String(sockfd,cfiles[k]);
  closedir(dirp);
   
}


int send_function_params(int sockfd,int myline)
{
  int linenum,nthf=0,i,fsize,numOfFunctions;
  AFCALLS *pf;

  recv_int(sockfd,&linenum);
  if (linenum == -1){
    recv_int(sockfd,&linenum);
    recv_int(sockfd,&nthf);
  }
  
  fsize = files[curFile].fileSize;
  numOfFunctions = files[curFile].lineInfo[linenum].numOfAttachedFcalls;
  if (linenum >= fsize){
    send_errmsg(-9,"LineNum is bigger than filesize", myline,sockfd,
	  prevFileName,curFileName);
    return;
  }
  else if (!(files[curFile].lineInfo[linenum].isExecutable)){
     send_errmsg(-9,"Line is not executable", myline,sockfd,
	  prevFileName,curFileName);
     return;
  }
  else if (nthf >= numOfFunctions){
     send_errmsg(-9,"Function order is too big", myline,sockfd,
	  prevFileName,curFileName);
     return;
  }
  else
     send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);

  pf = &(files[curFile].lineInfo[linenum].attachedFcalls[nthf]);
  /* Send function name */
  send_String(sockfd, pf->fname);

  send_int(sockfd,pf->numOfParams);
  /* Send parameters */
  for(i=0;i< (pf->numOfParams) ;i++)
    send_String(sockfd,pf->params[i]);

}
  
double  timer()
{
   static clock_t save_time = 0;
   clock_t new_time,elapsed_time;

   new_time     = clock();
   elapsed_time = new_time-save_time;
   save_time    = new_time;
   return (((double) elapsed_time)/ CLOCKS_PER_SEC);

}

  
void send_scivizFlist(int sockfd)
{
   /* I found ther error really. You can not initialize sciviz functions
      in the following way. Maybe C++ does not like this type of 
      initialization. You have to give initial values in different way */
  /* scivizFlist[18] = {"java_fser_","java_ser_",...,"timer"} 
     --this is wrong-- */

   int funcsLength,i ;
   char *scivizFlist[21];

   funcsLength = sizeof(scivizFlist)/sizeof(scivizFlist[0]);  
   for(i=0;i<funcsLength;i++)
    scivizFlist[i] = (char *)alloca(128);
   
   
    strcpy(scivizFlist[0],"java_ser_");
    strcpy(scivizFlist[1],"java_bser2d_");
    strcpy(scivizFlist[2],"WebFlow_1");
    strcpy(scivizFlist[3],"WebFlow_2");
    strcpy(scivizFlist[4],"WebFlow_3");

    strcpy(scivizFlist[5],"java_fser_");
    strcpy(scivizFlist[6],"java_mser_");
    strcpy(scivizFlist[7],"java_fser2d_");
    strcpy(scivizFlist[8],"java_ser2d_");
    strcpy(scivizFlist[9],"java_mser2d_");
    strcpy(scivizFlist[10],"java_bmser2d_");
    strcpy(scivizFlist[11],"java_bbser2d_");
    strcpy(scivizFlist[12],"java_bbmser2d_");
    strcpy(scivizFlist[13],"java_vser_");
    strcpy(scivizFlist[14],"java_vmser_");
    strcpy(scivizFlist[15],"java_bbser_");
    strcpy(scivizFlist[16],"java_bbmser_");
    strcpy(scivizFlist[17],"java_pser_");
    strcpy(scivizFlist[18],"java_pser2d_");
    strcpy(scivizFlist[19],"java_pbbser2d_");
    strcpy(scivizFlist[20],"timer");		   
   
   /* Send the number of functions */
   if (HOST){
     send_int(sockfd,funcsLength);
     /* Send the funtions names of sciviz server */
     for(i=0;i<funcsLength;i++)
       send_String(sockfd,scivizFlist[i]); 
   }
   
   /*for(i=0;i<funcsLength;i++)
     free(scivizFlist[i]); */
}
  

void *callToAttachedFuncs(void *x_pars)
{
  int myNumOfFuncs,i;
  AFCALLS *pf;
  char temps[4096];
  int myline;
  char *myFuncName;
  PARSTRUCT *parstruct = (PARSTRUCT *)x_pars;

  /* Set signal handler */
  /* set_signal_handler(interrupt);  */


  myline = parstruct->myline;
  myFuncName = parstruct->myFuncName ;
  myNumOfFuncs = files[curFile].lineInfo[myline].numOfAttachedFcalls;
  if (DEBUG){
    fprintf(fpout,"myNumOfFuncs : %d myline=%d\n",myNumOfFuncs,myline);
  }
  for(i=0;i<myNumOfFuncs;i++)
    executeActionPoints(myline,i,parstruct->sockfd);
}

write_int(char *s,int n)
{

   if (ME){
     fpout = fopen("output_1","a+");
     fprintf(fpout,"%s-%n\n",s,n);
     fclose(fpout);
   }


}

write_me(char *s)
{
  char fname[64];
  FILE *fx;
  sprintf(fname,"output_%d",ME);
  fx = fopen(fname,"a+");
  fprintf(fx,"%s\n",s);
  fclose(fx);  

}

void send_action_points(int sockfd)
{
   int i,fsize,myNumOfFuncs;

   /* Get the file size of current file */
   fsize = files[curFile].fileSize;
   for(i=0;i<fsize;i++){
     myNumOfFuncs = files[curFile].lineInfo[i].numOfAttachedFcalls;
     if (myNumOfFuncs > 0){
       if (myNumOfFuncs > 1){
	 send_int(sockfd,-1);
	 send_int(sockfd,i);
	 send_int(sockfd,myNumOfFuncs);
       }
       else
	 send_int(sockfd,i);
     }
   }
   /* Send the end of action point list */
   send_int(sockfd,-2);    

}

void free_space_for_fcall(AFCALLS *pf)
{
  int k;
  
  free(pf->fname);
  free(pf->parIndices);
  free(pf->fcallString);
  for(k=0;k<pf->numOfParams;k++)
    free(pf->params[k]);
    
}


/* fcallString : java_ser_(..params..) */
int  processAction(char *fcallString,int myline,int curFile)
{
   char *funcName,*sp,dummy[16];
   char *params[64],temps[2048],saveFcall[2048];
   int pcnt,myNumOfFuncs,i,findex;
   char    *fname;
   AFCALLS *pf,*pf_1,*pf_2;
   int ssize,index,nextpIndex ;
   char *pp,*p;
   int startLoop;
   
   fprintf(fpout,"We got fcall string : %s\n",fcallString);

   strcpy(dummy,"dummy");
   strcpy(saveFcall,fcallString);
   /* grab the function name and its parameters */
   funcName = strtok(fcallString,"\n\r\t&(), ");

   pcnt = 0;
   while((sp = strtok(NULL,"\n\r\t&(), ")))
     params[pcnt++] = sp;
      
   /* Look for whether there is same function call registered before 
      at this line with same name and same parameters */
   myNumOfFuncs = files[curFile].lineInfo[myline].numOfAttachedFcalls;
   for(i=0,findex=-1;i<myNumOfFuncs;i++){
     pf = &(files[curFile].lineInfo[myline].attachedFcalls[i]);
     if (isItSameFunction(funcName,params,pcnt,pf)){
       findex = i;
       break;
     }
   }
   
   fprintf(fpout,"myNumOfFuncs : %d\n",myNumOfFuncs);
   if (DEBUG){  
     if (findex < 0)
       fprintf(fpout,"Function call:  is not attached to this line :%d\n",
	   myline);
     else 
       fprintf(fpout,
               "Function call:  has been already attached this line :%d\n",
	          myline); 
   }  
   if ((curCmnd == DELETE_ACTION)&&(findex >= 0))
   {  
      if (DEBUG) 
        fprintf(fpout,"deleting functioncall : %s\n",saveFcall);

      ssize = sizeof(AFCALLS);
      for(i=findex;i<myNumOfFuncs-1;i++){
	pf_1 = &(files[curFile].lineInfo[myline].attachedFcalls[i]);
	pf_2 = &(files[curFile].lineInfo[myline].attachedFcalls[i+1]);
	free_space_for_fcall(pf_1);
	memcpy(pf_1,pf_2,ssize);
      }
      pf = &(files[curFile].lineInfo[myline].attachedFcalls[myNumOfFuncs]);
      free_space_for_fcall(pf);
      /*decrase the number of attached fcalls for this line */
      (files[curFile].lineInfo[myline].numOfAttachedFcalls)--;
      return -1;
   }
  
   /* It was already attached */
   if (findex >= 0){
     if (DEBUG) 
       fprintf(fpout,"%s is already attached \n",saveFcall);
     return -1;
   }

   if (DEBUG) 
     fprintf(fpout,"Append this function call : %s with pcnt=%d \n",
	      saveFcall,pcnt);
   
   /*** Append this function call to my fcall attached list ***/
   pf = &(files[curFile].lineInfo[myline].attachedFcalls[myNumOfFuncs]);

   pf->params     = (char **)malloc(sizeof(char *)*pcnt);

   pf-> parIndices = (int *)malloc(sizeof(int)*pcnt);

   /* Set number of parameters */
   pf->numOfParams = pcnt;
   /* keep the function call string as string */
   pf->fcallString = (char *)malloc(strlen(saveFcall)+1);
   pf->fname       = (char *)malloc(strlen(funcName)+1);
   strcpy(pf->fcallString,saveFcall);
   strcpy(pf->fname,funcName);

   /* If SCIVIS function, store windowname */
   if (strstr(pf->fname,"java_")){
     
     startLoop = 1;
     pf->params[0] = (char *)malloc(strlen(params[0])+1);
     strcpy(pf->params[0],params[0]);
     
   }
   else
     startLoop = 0;

   if (DEBUG) 
     fprintf(fpout,"number of parameters : %d\n",pcnt);
   
   for(i=startLoop;i<pcnt;i++){
     index = find_var(curFuncName,params[i]);
     
     if (index< 0){
       printf("I could not find the variable : -%s-\n",params[i]);
       params[i] = dummy;
       /* exit(0); */
     }    
     else if (stack[index].isDistributed)
       index = stack[index].localIndex;

     pf->params[i] = (char *)malloc(strlen(params[i])+1);
     strcpy(pf-> params[i],params[i]);  
     pf-> parIndices[i] = index;
     if (DEBUG) 
       fprintf(fpout,"I added the parameter : %s\n",pf-> params[i]);    
   }
   
   /*** increase the number of attached fcalls for this line ***/
   (files[curFile].lineInfo[myline].numOfAttachedFcalls)++;
   if (DEBUG) 
     fprintf(fpout,"I attached the Fcall string :%s  to line : %d\n",
	     pf->fcallString,myline);
   /* We modified original functionCall string. So restore it */
   strcpy(fcallString,saveFcall);
   /* Store how many action points we attached to executable lines */
   numberOfActionPoints++;
   return (myNumOfFuncs);
   
} 
  
void send_profile_data(int sockfd) 
{
   int lineNum,numOfFiles = nfiles; 
   int k,j,fsize,funcIndex,stmtID,nexecution;
   double elapsed_time;
   char *funcName;

   send_int(sockfd,numOfFiles);
   for(k=0;k<numOfFiles;k++){
     fsize = files[k].fileSize;
     for(j=0;j<fsize;j++){
       lineNum      = files[k].lineInfo[j].lineNum;
       funcIndex    = files[k].lineInfo[j].funcIndex;
       funcName     = files[k].functab[funcIndex].funcName;
       stmtID       = files[k].lineInfo[j].stmtID;
       nexecution   = files[k].lineInfo[j].nexecution;
       elapsed_time = files[k].lineInfo[j].elapsed_time;

       if (!(files[k].lineInfo[j].isExecutable))
	 continue;
       send_int(sockfd,-1);
       send_int(sockfd,lineNum);
       send_String(sockfd,funcName);
       send_int(sockfd,stmtID);
       send_int(sockfd,nexecution);
       send_double(sockfd,elapsed_time);
     }
     send_int(sockfd,-2);
   }
}  


void executeActionPoints(int myline,int nthf,int sockfd)
{

   #define PI(i) ((int *)(stack[pf->parIndices[i]].buf))
   #define PD(i) ((double *)(stack[pf->parIndices[i]].buf))
   char funcName[256],windowName[256],*sp;
   AFCALLS *pf;
   int nparams,i,index,tnum=0;

   pf = &(files[curFile].lineInfo[myline].attachedFcalls[nthf]);
   nparams = pf->numOfParams;
   strcpy(funcName,pf->fname);
   if (strstr(funcName,"java_")){
     sp = pf->params[0];
     strcpy(windowName,sp+1);
     sp = strchr(windowName,'\"');
     if (sp)
       *sp = 0;
     
     /* strcpy(windowName,pf->params[0]);  */
   }
   
   
   if (!strcasecmp(funcName,"timer")){
      double timeval;
      timeval = timer();
      files[curFile].lineInfo[myline].elapsed_time += timeval;
      (files[curFile].lineInfo[myline].nexecution)++;
      if (DEBUG)
        fprintf(fpout,"Clock timeval : %f\n",timeval);
      return;
   }

    /*************************************************************/
   /* If we are calling function sending data to webflow module */
   if (strstr(funcName,"WebFlow_")){
     int parIndex,WebSock,fd,isContinue;    
     /* This function has only one parameter, variable name to send its
	contents to WebFlow Module */
     if (DEBUG)
       fprintf(fpout,"I am callind WEBFLOW send function \n");

     if (strstr(stack[pf->parIndices[0]].name,"LOCAL_"))
        parIndex = stack[pf->parIndices[0]].distIndex;
     else
        parIndex = pf->parIndices[0];
     
     /* parIndex = stack[pf->parIndices[0]].distIndex; */
     WebSock  = pf->WebFlowSockfd; 
     fprintf(fpout,"parIndex = %d WebSock = %d params=%s\n",
	    parIndex,WebSock,pf->params[0]);
     send_registered_data(pf->params[0],parIndex,WebSock);
     if (DEBUG)
       fprintf(fpout,"Host send the data for %s\n",pf->params[0]);
     return;
     
    
   }
   /* Finished of WebFlow */
   /*************************************************************/


   if (DEBUG)
     fprintf(fpout,"ME =%d fname : %s windowName:%s nparams=%d\n",
	     ME,funcName,windowName,nparams);

   for(i=1;i<nparams;i++){
     fprintf(fpout,"params[%d] = %s\n",i,stack[pf->parIndices[i]].name);
        
     /* If the corresponding variable is distributed, copy it to local var.*/
     if (strstr(stack[pf->parIndices[i]].name,"LOCAL_")){
        index = stack[pf->parIndices[i]].distIndex;
        copy_from_parallel_to_serial(index);
     }
   }

   if (!HOST)
     return;  
      
   if (DEBUG)
     fprintf(fpout,"I am ready to call the function : -%s- %d \n",
	  funcName,strlen(funcName));
   
   fprintf(fpout,"I am ready to call the function : -%s- %d \n",
	  funcName,strlen(funcName));

   if (!strcasecmp(funcName,"java_ser_")){
     java_ser_(windowName,PD(1),PD(2),PD(3),PI(4));
   }
   else if (!strcasecmp(funcName,"store1d_data_")){
     if (DEBUG)
       fprintf(fpout,"Before calling : %s\n","store1d_data_");
     if (HOST)
       store1d_data_(windowName,PD(1),PD(2),PD(3),PI(4));
   }
   else if (!strcasecmp(funcName,"java_fser_")){
     java_fser_(windowName,PD(1),PD(2),PD(3),PI(4));
   }
   else  if (!strcasecmp(funcName,"java_mser_")){
     java_mser_(windowName,PI(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"java_ser2d_")){
     java_ser2d_(windowName,PD(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"java_ser2d_")){
     java_ser2d_(windowName,PD(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"store2d_data_")){
     if (HOST)
       store2d_data_(windowName,PD(1),PD(2),PD(3),PD(4),PI(5));
   }
   else  if (!strcasecmp(funcName,"java_mser2d_")){
     java_mser2d_(windowName,PI(1),PD(2),PD(3),PD(4),PD(5),PI(6));
   }
   else  if (!strcasecmp(funcName,"java_bser2d_")){
     java_bser2d_(windowName,PD(1),PD(2),PI(3),PD(4),PI(5),PD(6));
   }
   else  if (!strcasecmp(funcName,"java_bmser2d_")){
     java_bmser2d_(windowName,PI(1),PD(2),PD(3),PI(4),PD(5),PI(6),PD(7));
   }
   else  if (!strcasecmp(funcName,"java_bbser2d_")){
     java_bbser2d_(windowName,PD(1),PD(2),PI(3),PI(4),PD(5));
   }
   else  if (!strcasecmp(funcName,"java_bbmser2d_")){
     java_bbmser2d_(windowName,PI(1),PD(2),PD(3),PI(4),PI(5),PD(6));
   }
   else  if (!strcasecmp(funcName,"java_vser_")){
     java_vser_(windowName,PD(1),PD(2),PD(3),PD(4),PD(5),PI(6));
   }
   else  if (!strcasecmp(funcName,"java_vmser_")){
     java_vmser_(windowName,PI(1),PD(2),PD(3),PD(4),PD(5),PD(6), PI(7));
   }
   else  if (!strcasecmp(funcName,"java_bbser_")){
     if (DEBUG)
       fprintf(fpout,"Before  java_bbser_ \n");
     java_bbser_(windowName,PD(1),PD(2),PI(3),PD(4));
     if (DEBUG)
       fprintf(fpout,"After java_bbser_ \n");
   }
   else  if (!strcasecmp(funcName,"java_bbmser_")){
     java_bbmser_(windowName,PI(1),PD(2),PD(3),PI(4),PD(5));
   }
   

}



int isItSameFunction(char *newFname,char *newParams[],
		     int nparams,AFCALLS *pf)
{
   int i,foundFlag;

   /* Is it same function name */
   if (strcasecmp(newFname,pf->fname))
     return 0;
   /* Does it has same number of parameters */
   if (nparams != (pf->numOfParams))
     return 0;
   for(i=0,foundFlag=1;i<nparams;i++)
     if (strcasecmp(newParams[i],pf->params[i])){
       foundFlag = 0;
       break;
     }
   
   return foundFlag;
}


void send_errmsg(int errorcode,char *errormsg,int myline,int sockfd,
	    char *prevFileName,char *curFileName)
{
   char msg[256];

   if (HOST){
     sprintf(msg,"%s : %d\n",errormsg,myline);
     if (DEBUG)
        fprintf(fpout,"I will send errmsg =%s code=%d\n",msg,errorcode);

     send_int(sockfd,errorcode);
     send_String(sockfd, msg);
   }
}

int findFileIndex(char *curFileName)
{
   int i,index=-1;

   for(i=0;i<nfiles;i++){
     if (!strcmp(files[i].fileName,curFileName))
       index = i;
   }
   
   if (index < 0){
     fprintf(fpout,"ME:%d I could not found the file : %s\n",ME,curFileName);
     exit(0);
   }
   return index;
}
  
int findFuncIndex(char *curFuncName,char *curFileName)
{
   int i,fileInd,index=-1;

   
   fileInd = findFileIndex(curFileName);

   for(i=0;i<files[fileInd].nfuncs;i++){
     
     if (!strcmp(files[fileInd].functab[i].funcName,curFuncName)){
       index = i;
       break;
     }
   }
   if (index < 0){
     if (DEBUG)
        fprintf(fpout,"findFuncIndex : ME= %d I could not find the function : %s\n",
		ME,curFuncName);
     exit(0);
   }
   return index;
}
  
void sendFileIndex(char *curf,char *nextf,int sockfd)
{
  int index;
   
  /* If files are same, Do not send new file index to applet */
  if (!strcasecmp(curf,nextf))
    return;

  index = findFileIndex(nextf);
  if (HOST){
      send_int(sockfd,GETNEWFILE);
      send_String(sockfd, nextf);
   }
   curFile = index;
   /* openNewProject(files[curFile].depFileName); */
   send_int(SageServerSock,OPEN_PROJECT);
   send_String(SageServerSock,files[curFile].depFileName);   

   if (DEBUG)
      fprintf(fpout,"sendFileIndex : I(%d) sent the file : %s\n",
	      ME,nextf);
   curFileName  = nextf;
}

int gotoStackUp(int sockfd)
{
   int index,fileInd,lineNum;

   index = cstack.top ;

   fileInd = findFileIndex(cstack.sInfo[index].fileName);
   if (DEBUG)
     fprintf(fpout,"In gotoStackUp: prevfile:%s fileind:%d\n",
	    cstack.sInfo[index].fileName,fileInd);

   lineNum = cstack.sInfo[index].lineNum;
   if (DEBUG)
     fprintf(fpout,"prev lineNumber : %d index=%d\n",lineNum,index);

   /* Store my old enviroment at the stack so that 
      "gotoStackDown" should use it */
   cstack.sInfo[index].curLineNum  = curLineNum;
   cstack.sInfo[index].curFuncName = curFuncName;
   cstack.sInfo[index].curFileName = curFileName;

   sendFileIndex(curFileName,cstack.sInfo[index].fileName ,sockfd);
   --(cstack.top);
   prevStackTop = cstack.top;
   curFileName  = cstack.sInfo[index].fileName;
   curFuncName  = cstack.sInfo[index].funcName;
   curLineNum   = cstack.sInfo[index].lineNum;
   longjmp(files[fileInd].lineInfo[lineNum].jmpbuffer,1);
   return 0;
}

/* stack is growing downward */
int gotoStackDown(int sockfd)
{
   int index,fileInd,lineNum;

   index = cstack.top +1;

   fileInd = findFileIndex(cstack.sInfo[index].curFileName);
   if (DEBUG)
     fprintf(fpout,"In gotoStackDown: prevfile:%s fileind:%d\n",
	    cstack.sInfo[index].curFileName,fileInd);

   lineNum = cstack.sInfo[index].curLineNum;
   if (DEBUG)
     fprintf(fpout,"prev lineNumber : %d index=%d\n",lineNum,index);
   
   sendFileIndex(curFileName,cstack.sInfo[index].curFileName ,sockfd);
   ++(cstack.top);
   prevStackTop = cstack.top;
   curFileName  = cstack.sInfo[index].curFileName;
   curFuncName  = cstack.sInfo[index].curFuncName;
   curLineNum   = cstack.sInfo[index].curLineNum;
   longjmp(files[fileInd].lineInfo[lineNum].jmpbuffer,1);
   return 0;
}

void updateControlStack(int myline)
{
  int i,fexec,findex,fileInd;

  fileInd = findFileIndex(curFileName);
  findex = findFuncIndex(curFuncName,curFileName);
  /* First executable stmt */
  fexec =  files[fileInd].functab[findex].fExecStmt;  

  /* Subroutine called */
  if (strcmp(prevFuncName,curFuncName)&&(myline == fexec)){
      files[fileInd].functab[findex].isVisited = 1; 
      i = ++(cstack.top);
      cstack.sInfo[i].SaveRegStackTop = max_push_id;
      cstack.sInfo[i].lineNum  = prevLineNum;
      cstack.sInfo[i].funcName = prevFuncName;
      cstack.sInfo[i].fileName = prevFileName;

      if (DEBUG)
         fprintf(fpout,"Subroutine called  TOP =%d\n",i);
  }
  /* Return from function */
  else if (strcmp(prevFuncName,curFuncName)&&(myline != fexec)){
      (cstack.top)--;
      max_push_id = cstack.sInfo[cstack.top].SaveRegStackTop;
      if (DEBUG)
          fprintf(fpout,"Subroutine returned   TOP =%d \n",cstack.top);
  }
  stackLength = cstack.top;

}

void interpretHPFStmt(int sockfd,char *funcName)
{
   int  retval,cnt;
   char buf[256],*sp;
   FILE *fp;
   ERRBUF errbuf;
   char tempbuf[REGBUFSIZE];
   sigset_t oset;   

   if (HOST){
     recv_String(sockfd,tempbuf);
     strcpy(receivedHPFList,tempbuf);
   }
   distribute_string_();
   
   if (DEBUG) 
     fprintf(fpout,"I Distributed interpretd HPF Stmts : ME=%d str:%s\n",
	    ME,receivedHPFList);

   /* If user wants to make some visualization, his command will be
      plot("java_serxXXX",...) */
   /*
   strcpy(tempbuf,receivedHPFList);
   sp = strtok(tempbuf,"\n\t( ");
   if (!strcasecmp(sp,"plot")){
     if (DEBUG)
       fprintf(fpout,"PLOT COMMAND : \n");
     executeFunctionCall(receivedHPFList,funcName);
     if (HOST){
       retval = 0;
       send_int(sockfd, retval);
     }
     return;
   }
   */
   /* ************************/
  
   retval = callFuncDynamic(sockfd,receivedHPFList,funcName,&errbuf);
   if (!HOST)
     return;

    /* send error code */
   if (retval == 0){
      send_int(sockfd, retval);
      return;
   }
   
   send_int(sockfd, errbuf.type); 
   if (errbuf.type == RUNTIME_ERROR)
      send_String(sockfd,strsignal(errbuf.status));
   else if (errbuf.type == COMPILE_ERROR){
      /* send the pghpf compiler output for syntax errors */
      fp = fopen("errout","r");
      while(!feof(fp)){
        fgets(buf,256,fp);
        send_String(sockfd, buf);
      }
      strcpy(buf,"bitti");
      send_String(sockfd, buf);
      fclose(fp);
   }

}

int itemAddr(int ndims,int *coor,int *dims,long *lb)
{
   int i,j,k,m;
   int a ;

   for(j=1,a=coor[0]-lb[0];j<ndims;j++){
     for(k=0,m=coor[j]-lb[j];k<j;k++)
       m *= dims[k];
     a += m;
   }
   return a;
}

void interrupt_prog(int sig)
{
  char ebuf[1024];

  if (!HOST)
    return;

  fprintf(fpout,"I have catched one signal : %d \n",sig);
  fclose(fpout);
  
  sprintf(ebuf,"%d :%s at line :%d \n",sig,strsignal(sig),curLineNum);
  send_int(last_sockfd,ABNORMALTERM);
  send_String(last_sockfd,ebuf);
  stop_program(last_sockfd,1);
}


void set_signal_handler(handler)
void (*handler)(); 
{
 sigset_t new;
 struct sigaction act;

 sigfillset(&new);
 pthread_sigmask(SIG_UNBLOCK, &new, NULL);
 act.sa_handler = handler;
 act.sa_flags   = 0;
 
 sigaction(SIGHUP, &act, NULL); 
 sigaction(SIGINT, &act, NULL);   
 sigaction(SIGQUIT, &act, NULL);  
 sigaction(SIGILL, &act, NULL);   
 sigaction(SIGTRAP, &act, NULL);  
 sigaction(SIGIOT, &act, NULL);   
 sigaction(SIGABRT, &act, NULL);  
 sigaction(SIGEMT, &act, NULL);   
 sigaction(SIGFPE, &act, NULL);   
 sigaction(SIGKILL, &act, NULL);  
 sigaction(SIGBUS, &act, NULL);   
 sigaction(SIGSEGV, &act, NULL);  
 sigaction(SIGSYS , &act, NULL); 
 sigaction(SIGPIPE, &act, NULL); 
 sigaction(SIGALRM, &act, NULL);  
 sigaction(SIGTERM, &act, NULL);  
 sigaction(SIGUSR1, &act, NULL);  
 sigaction(SIGUSR2, &act, NULL);  
 sigaction(SIGCLD, &act, NULL);   
 sigaction(SIGCHLD, &act, NULL);  
 sigaction(SIGPWR, &act, NULL);   
 sigaction(SIGWINCH, &act, NULL); 
 sigaction(SIGURG, &act, NULL);   
 sigaction(SIGPOLL, &act, NULL);  
 sigaction(SIGIO, &act, NULL);    
 sigaction(SIGSTOP, &act, NULL);  
 sigaction(SIGTSTP, &act, NULL);  
 sigaction(SIGCONT, &act, NULL);  
 sigaction(SIGTTIN, &act, NULL);  
 sigaction(SIGTTOU, &act, NULL);  
 sigaction(SIGVTALRM, &act, NULL);  
 sigaction(SIGPROF, &act, NULL);  
 sigaction(SIGXCPU, &act, NULL);  
 sigaction(SIGXFSZ, &act, NULL);  
 sigaction(SIGWAITING, &act, NULL);  
 sigaction(SIGLWP, &act, NULL);   
 sigaction(SIGFREEZE, &act, NULL);  
 sigaction(SIGTHAW, &act, NULL);  
 sigaction(SIGCANCEL, &act, NULL); 
  
}

void arraysec_thread(myline,sockfd,prevFileName,curFileName,funcName)
int myline,sockfd;
char *prevFileName,*curFileName,*funcName;
{
    pthread_t	tid;
    int n;
    sigset_t new;
    PARAMBUF parbuf;
    
    parbuf.myline =  myline ; 
    parbuf.sockfd = sockfd ;
    parbuf.prevFileName = prevFileName ;
    parbuf.curFileName = curFileName ; 
    parbuf.funcName = funcName ;

   
    sigfillset(&new);
    pthread_sigmask(SIG_UNBLOCK, &new, NULL);
    if ( n = pthread_create( &tid, NULL, sendArraySection, (void *)(&parbuf) ) ) {
	fprintf( stderr, "pthread_create: %s\n", strerror( n ) );
	exit( 1 );
    }

    if ( n = pthread_join( tid, NULL ) ) {
	fprintf( stderr, "pthread_join: %s\n", strerror( n ) );
	exit( 1 );
    }
   
}


void interrupt_arraysec(int sig)
{
   char ebuf[1024];

   if (curCmnd != DISARRAYSECTION)
     interrupt_prog(sig);

   fprintf(fpout,"interrupt_arraysec: I catched signal :%d ME=%d\n",sig,ME);
   
   if (!HOST){
      pthread_exit( 0 ); 
      return;
   }

   sprintf(ebuf,"Array section error : %d :%s at line :%d \n",
	  sig,strsignal(sig),curLineNum);
   send_int(last_sockfd,ARRAYSECERROR);
   send_String(last_sockfd,ebuf);
   pthread_exit( 0 ); 
}  

void *sendArraySection(void *parbuf_) 
{
     PARAMBUF *parbuf;
     int myline,sockfd;
     char *prevFileName,*curFileName,*funcName;
     sigset_t oset;

     char variableName[256],msg[256];
     int nums,nbytes,i,j,k,vindex,*subs;
     int slb[7],sub[7],sst[7],elsize;
     long *lb,*ub;
     int coor[7],cnt,id,totelems,ndims,index,type;
     static char *sendbuf;
     static char *buf,*buf_t;
     struct rlimit limit;
     
     
     XDR xdrs;
     bool_t ret;
     
     /* set signal header */
     set_signal_handler(interrupt_arraysec); 

     funcCallStatus = 0;
     parbuf = (PARAMBUF *)parbuf_;
     myline = parbuf->myline ;
     sockfd = parbuf->sockfd ;
     prevFileName = parbuf->prevFileName ;
     curFileName = parbuf->curFileName ;
     funcName = parbuf->funcName ;

     if (HOST){
        recv_String(sockfd,variableName);
        recv_int(sockfd,&nums);
        nbytes = nums*sizeof(int);
        buf  = (char *)alloca(nbytes);
	subs = (int *)alloca(nbytes);
        recv_raw_data(sockfd, buf, nbytes);
        xdrmem_create(&xdrs,buf,nbytes,XDR_DECODE); 
        ret = xdr_vector(&xdrs,(char *)subs,nums,sizeof(int),xdr_int);
        xdr_destroy(&xdrs);
        if (ret == FALSE){
	  fprintf(fpout,"There is encoding error \n");
	  if (DEBUG)
	    fprintf(fpout,"There is encoding error \n");
	}
	
        
        vindex = find_var(funcName,variableName);
        if (vindex < 0){
           sprintf(msg,"We could not find the variable : %s",variableName);
           send_errmsg(-5,msg,myline,sockfd,prevFileName,curFileName);
        }
        
     }
     distribute_oneitem_(&vindex);
     if (vindex < 0){
        pthread_exit( 0 ); 
        return;
     }

     if (!(stack[vindex].isDistributed ))
       id = vindex;
     else{
       copy_from_parallel_to_serial(vindex);
       id = stack[vindex].localIndex;
     }
     if (!HOST ){
       pthread_exit( 0 ); 
       return;
     }

     type = stack[id].type;     
     ndims = stack[id].ndims;
     lb = stack[id].lbounds;
     ub = stack[id].ubounds;

     	   
     for(i=0,k=0;k<ndims;k++)
     {       
       if (subs[i] == 1){ /* one element*/
	 slb[k] = subs[i+1];
         sub[k] = slb[k];
         sst[k] = 1;
         i+=2;
	 fprintf(fpout,"one element %d:%d:%d \n", slb[k],sub[k],sst[k]);
	 
       }    
       else if (subs[i] == 2){ /* section with no stride*/
         slb[k] = subs[i+1];
         sub[k] = subs[i+2];
	 sst[k] = 1;
         if (subs[i+1] == NUSEDDIM )
	   slb[k] = lb[k];
         if (subs[i+2] == NUSEDDIM )
	   sub[k] = ub[k];
         i+=3;
         fprintf(fpout,"section with no stride \n");
	 
       }

       else if (subs[i] == 3){ /* section with  stride*/
	 slb[k] = subs[i+1];
         sub[k] = subs[i+2];
	 sst[k] = subs[i+3];
         if (subs[i+1] == NUSEDDIM )
	   slb[k] = lb[k];
         if (subs[i+2] == NUSEDDIM )
	   sub[k] = ub[k];
	 if (subs[i+3] == NUSEDDIM )
	   sst[k] = 1;
	 i+=4;
	 fprintf(fpout,"section with  stride \n");
	 
       }
     }
 
     elsize = stack[id].elsize;
     for(k=0,totelems=1;k<ndims;k++)
       totelems *= ((sub[k]-slb[k])/sst[k]+1);
     sendbuf = (char *)alloca(elsize*totelems);
     for(k=0;k<ndims;k++) 
       coor[k] = slb[k];
    
     for(k=0;k<totelems;k++){
      index = itemAddr(ndims,coor,stack[id].dim_info,lb);
       
      memcpy(&sendbuf[k*elsize],((char *)(stack[id].buf)+index*elsize),elsize);
      
      coor[0] += sst[0];
      if (coor[0] > sub[0])
	 coor[0] = slb[0];
      for(j=1;j<ndims;j++){
	 if (coor[j-1] == slb[j-1]){
	   coor[j] += sst[j];
	   if (coor[j] > sub[j])
	     coor[j] = slb[j];
	 }
      }
     }
         
      /* send the ack. to Applet*/
     send_errmsg(0,"OK ",myline,sockfd,prevFileName,curFileName);   
     /* send the distribution info */
     send_int(sockfd,stack[vindex].isDistributed);
     /* send the registration info */
     /* tag = 0, ndims=1(because we are sending array section as 1D array */
     send_registration_info_(0,variableName, type, 1,
		        totelems,&totelems,sockfd);

     nbytes = totelems*elsize;
     buf = (char *)alloca(nbytes); 
     xdrmem_create(&xdrs,buf,nbytes,XDR_ENCODE);
        
     putArraySection(&xdrs,sendbuf,totelems,elsize,type);
     /* send the actual data */
     send_raw_data(sockfd,buf,nbytes);
     
     xdr_destroy(&xdrs);
       
     pthread_exit( 0 );  
}      

void putArraySection(XDR *xdrs,char *sendbuf,int nelems,int elsize,int type)
{

  bool_t ret;

  switch(type){
    case T_CHAR  : 
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_char);
      break;
    case T_INT   : 
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_int);
      break;
    case T_FLOAT : 
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_float);
      break;
    case T_LONG  :
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_long);
      break;
    case T_DOUBLE:
      ret = xdr_vector(xdrs,sendbuf,nelems,elsize,xdr_double);
      break;  
  }
  if (ret == FALSE)
     fprintf(fpout,"there is error during encoding (in putArraySection) \n");

}
