#include <stdio.h>
#include "compilerApi.h"
#include <malloc.h>
#include <string.h>

#define TIMER_CLEAR    0
#define TIMER_START    1
#define TIMER_STOP     2
#define TIMER_ELAPSED  3
#define REGISTER       4
#define HPF_SERVER     5
#define INIT           6
#define SLOCAL       1
#define DISTRIBUTED 2

#define BEFORE  0
#define AFTER   1
#define MAX_FUNC_NUM 300
#define MAX_PAIR     300

enum FLAG {off, on};
FLAG in_main_program;
FLAG in_procedure;
int tabnumber=0;
void doFullType(SgType *t);
void doSymbAttribs(SgSymbol *s);
void doRoutineHeader(SgStatement *s);
void doSymb(SgSymbol *s);
void register_var();
void timer_start(),timer_clear(),timer_stop(),timer_elapsed();
void configure();
void insert_register_and_config_params(SgStatement *);
int give_type_symbol();
SgStatement *find_first_exec_stmt(SgStatement *);
void hpf_server();
void find_exec_next_stmt(SgStatement *,int *,int *);
SgStatement *find_outermost_scope(SgStatement *);
void create_one_func(SgStatement *);
SgVariableSymb *DeclareTemporaryLike(SgSymbol * ,int );
void insert_decls(SgStatement *);
void build_function(int ,SgStatement *);
int isInLoop(SgStatement *);
int isTemplate(SgSymbol *symb);
void insertInitStmt(SgFile *file);
void create_functionTable_file(SgProject * project,int *nfuncs, int *nfiles);
void transform_registration(SgStatement * s) ;
void write_summary(char *outFile,int nfuncs,int nfiles);

char projectName[256];
SgStatement *first;
typedef struct festmts
{
  char *fname;
  int  feline;
  SgStatement *s;
}FUNCS;
int nextp;
FUNCS funcs[MAX_FUNC_NUM];
int nextf ;

typedef struct functable{
 int lineNum;
 char funName[256];
 char fileName[256];
}FTAB;

typedef struct sourceinfo{
 int lineNum;
 int stmtID;
 int parent;
 int isExecutable;
 int isInLoop;
}SINFO;

typedef struct intermediateFiles{
  int    isIncludeMain; /* if it includes main, then 1 ,0 otherwise */
  char   fileName[256];
  SINFO  *lineInfo;
}FILES ;

FILES *files;
int   *lengthOfFiles;
FTAB  *functab;
int fileIndex;
SgVariableSymb *hpf_server_symb,*jmp_symb;
SgVariableSymb *register_var_symb;
char *curFileName,*curFuncName;



int main(int argc, char **argv)
{
  char inst_file[256],temp[256];
  int nfuncs,nfiles;
  SgStatement *sp;
  if( argc < 2){
     printf("Enter project file name \n");
     exit(0);
  }
  
  strcpy(projectName,argv[2]);
  argc--;
  argv[2] = (char *)NULL;
  printf("pname : %s\n",projectName);
  SgProject * project = new SgProject("test.prj",argc,argv);
  create_functionTable_file(project,&nfuncs,&nfiles);
  
  for (int i=0; i< project->numberOfFiles(); i++) {
    printf("file = %s will be instrumented \n",project->fileName(i));
    nextf = 0;
    nextp = 0;
    fileIndex = i;
    SgFile *file = &(project->file(i));
    SgStatement * s = file->firstStatement();
    first = s;
    curFileName = project->fileName(i);

    insert_decls(first);
    printf("AFTER INSERT_DECLS ...\n");
    transform_registration(s);
    printf("AFTER TRANSFORM_REGISTRATION..\n");

    insertInitStmt(file) ;       
    // save a copy of the input file, if you like.
    strcpy(temp,project->fileName(i));
    sprintf(inst_file,"instrumented_%s.dep",temp);
    file->saveDepFile(inst_file);
  }
  strcpy(temp,"summary_dep_files");
  write_summary(temp, nfuncs, nfiles);
  printf("end of session\n");  

}
