program test2d
integer, parameter         :: rsize=25
integer, parameter         :: asize=25
integer, parameter         :: bsize=25
integer, parameter         :: csize=100
real(KIND=8), dimension(rsize,rsize,rsize) :: r
real(KIND=8), dimension(asize,asize) :: a
real(KIND=8), dimension(bsize,bsize) :: b
real(KIND=8), dimension(rsize,rsize) :: p1x,p1y,p1z
real(KIND=8), dimension(asize)     :: xa,ya
real(KIND=8), dimension(bsize)     :: xb,yb
real(KIND=8), dimension(rsize)     :: xr,yr
real(KIND=8), dimension(csize)     :: c,xc
real(KIND=8) sigma, ampl, timei,offset
integer ndelay
real(KIND=8) resulti

!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE (*,BLOCK) ONTO P :: b,p1x,p1y,p1z
!HPF$ DISTRIBUTE ya(BLOCK) ONTO P
!HPF$ DISTRIBUTE yb(BLOCK) ONTO P
!HPF$ DISTRIBUTE yr(BLOCK) ONTO P
!HPF$ DISTRIBUTE r(*,BLOCK,*) ONTO P

interface

subroutine compute_r(ampl,sigma,r)

real(KIND=8) ampl,sigma
real(KIND=8), dimension(:,:,:), intent(out) :: r
!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE *(*,BLOCK,*) ONTO *P :: r

end subroutine

end interface  

integer i,j,k,l,m

np=NUMBER_OF_PROCESSORS()
ampl=1.0d-02
sigma=20.d0
offset=asize/2.0d0
ndelay=6000000

forall(i=1:asize) xa(i)=i*1.d0
forall(i=1:asize) ya(i)=i*1.d0
forall(i=1:bsize) xb(i)=i*1.d0
forall(i=1:bsize) yb(i)=i*1.d0
forall(i=1:rsize) xr(i)=i*1.d0
forall(i=1:rsize) yr(i)=i*1.d0
forall(i=1:csize) xc(i)=i*1.d0

w=3.0
do k=1,20

call delayit(ndelay,resulti)
write(6,*) resulti
sigma=sigma*1.25

call compute_r(ampl,sigma,r)

forall(i=1:asize,j=1:asize) &
  a(i,j)=ampl* exp(-((xa(i)-offset)**2/sigma))*   &
               exp(-((ya(j)-offset)**2/sigma))

forall(i=1:bsize,j=1:bsize) &
  b(i,j)=ampl*sin(0.1d0*(xb(i)+k))*cos(0.1d0*(yb(j)-k))

forall(i=1:csize) c(i)=ampl*sin(0.314d0*i+k)
p1x=r(10,:,:)
p1y=r(:,10,:)
p1z=r(:,:,10)

timei=1.0d0*k

!call SciViz2d(2,timei,xb,yb,b,np)
!call SciViz1d(3,timei,xc,c,np)
!call SciViz2d(1,timei,xr,yr,p1z,np)
!call SciViz2d(4,timei,xr,yr,p1x,np)
!call SciViz2d(5,timei,xr,yr,p1y,np)

enddo

do l=1,19

call delayit(ndelay,resulti)
write(6,*) resulti
sigma=sigma/1.25

call compute_r(ampl,sigma,r)

forall(i=1:asize,j=1:asize) &
  a(i,j)=ampl* exp(-((xa(i)-offset)**2/sigma))*   &
               exp(-((ya(j)-offset)**2/sigma))

forall(i=1:bsize,j=1:bsize) &
  b(i,j)=ampl*sin(0.1d0*(xb(i)+k))*cos(0.1d0*(yb(j)-k))

forall(i=1:csize) c(i)=ampl*sin(0.314d0*i+k)

p1x=r(10,:,:)
p1y=r(:,10,:)
p1z=r(:,:,10)
k=k+1
timei=1.0d0*k

!call SciViz2d(1,timei,xr,yr,p1z,np)
!call SciViz2d(2,timei,xb,yb,b,np)
!call SciViz1d(3,timei,xc,c,np)
!call SciViz2d(4,timei,xr,yr,p1x,np)
!call SciViz2d(5,timei,xr,yr,p1y,np)

enddo


do l=k,k+100
call delayit(ndelay,resulti)
write(6,*) resulti
forall(i=1:csize) c(i)=ampl*sin(0.314d0*i+k)
timei=1.0d0*l
!call SciViz1d(3,timei,xc,c,np)
enddo

end

subroutine compute_r(ampl,sigma,r)

real(KIND=8) ampl,sigma
real(KIND=8), dimension(:,:,:), intent(out) :: r

real(KIND=8), dimension(size(r,dim=1)):: x,y,z

!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE *(*,BLOCK,*) ONTO *P :: r

!HPF$ DISTRIBUTE (BLOCK) :: y

integer asize,offset
integer i,j,k

asize=size(r,dim=1)
offset=asize/2

forall(i=1:asize) x(i)=i*1.d0
forall(i=1:asize) y(i)=i*1.d0
forall(i=1:asize) z(i)=i*1.d0

forall(i=1:asize,j=1:asize,k=1:asize) &
  r(i,j,k)=ampl*sin(0.1d0*(x(i)+k))*   &
               exp(-((y(j)-offset)**2/sigma))*   &
               exp(-((z(k)-offset)**2/sigma))

end

subroutine delayit(n,resulti)
integer n
real(KIND=8) resulti
integer i
real(KIND=8) c1,c2,c3

c1=1.34d0
c2=2.34d0
c3=3.45d0

resulti=1.0d0
do i=1,n
  resulti=sqrt(i*c1+c2)/sqrt(i*c3-c1)+resulti
enddo
return
end






