program test2d
integer, parameter         :: size=25
real*8, dimension(size,size,size) :: r
real*8, dimension(size,size) :: a,b,p1x,p1y,p1z
real*8, dimension(size)     :: x,y,z,c
real*8 sigma, ampl, time,offset

!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE (*,BLOCK) ONTO P :: a,b,p1x,p1y,p1z
!HPF$ DISTRIBUTE y(BLOCK) ONTO P
!HPF$ DISTRIBUTE r(*,BLOCK,*) ONTO P

interface
EXTRINSIC (HPF_LOCAL) subroutine SciViz2d(iflag,time,x,y,fx,np)
real*8, dimension(:)    ::  x,y
real*8, dimension(:,:)  ::  fx
real*8                  ::  time
integer                 ::  np,iflag
!HPF$ DISTRIBUTE *(*,BLOCK) :: fx
!HPF$ DISTRIBUTE *(BLOCK) :: y
end subroutine

EXTRINSIC (HPF_LOCAL) subroutine SciViz1d(iflag,time,x,f,np)
real*8, dimension(:)    ::  x
real*8, dimension(:)    ::  f
real*8                  ::  time
integer                 ::  np,iflag
end subroutine

subroutine compute_r(ampl,sigma,r)

real*8 ampl,sigma
real*8, dimension(:,:,:), intent(out) :: r
!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE *(*,BLOCK,*) ONTO *P :: r

end subroutine



end interface  

integer i,j,k,l,m

np=NUMBER_OF_PROCESSORS()
ampl=1.0d-02
sigma=20.d0
offset=size/2.0d0

forall(i=1:size) x(i)=i*1.d0
forall(i=1:size) y(i)=i*1.d0
forall(i=1:size) z(i)=i*1.d0

w=3.0
do k=1,20,2

do ii=1,1000000
xx=(xx+1)**3+(xx-1)**5
enddo

sigma=sigma*1.25

call compute_r(ampl,sigma,r)






!forall(i=1:size,j=1:size,k=1:size) &
!  r(i,j,k)=ampl*sin(0.1d0*(x(i)+k))*   &
!               exp(-((y(j)-offset)**2/sigma))*   &
!               exp(-((z(k)-offset)**2/sigma))

forall(i=1:size,j=1:size) &
  a(i,j)=ampl* exp(-((x(i)-offset)**2/sigma))*   &
               exp(-((y(j)-offset)**2/sigma))

forall(i=1:size,j=1:size) &
  b(i,j)=ampl*sin(0.1d0*(x(i)+k))*cos(0.1d0*(y(j)-k))

c=a(:,10)
p1x=r(10,:,:)
p1y=r(:,10,:)
p1z=r(:,:,10)

time=1.0d0*k

call SciViz2d(1,time,x,y,p1z,np)
call SciViz2d(2,time,x,y,b,np)
call SciViz1d(3,time,x,c,np)
call SciViz2d(4,time,x,y,p1x,np)
call SciViz2d(5,time,x,y,p1y,np)

enddo

do l=1,19,2

sigma=sigma/1.25

call compute_r(ampl,sigma,r)

forall(i=1:size,j=1:size) &
  a(i,j)=ampl* exp(-((x(i)-offset)**2/sigma))*   &
               exp(-((y(j)-offset)**2/sigma))

forall(i=1:size,j=1:size) &
  b(i,j)=ampl*sin(0.1d0*(x(i)+k))*cos(0.1d0*(y(j)-k))

c=a(:,10)
p1x=r(10,:,:)
p1y=r(:,10,:)
p1z=r(:,:,10)
k=k+1
time=1.0d0*k

call SciViz2d(1,time,x,y,p1z,np)
call SciViz2d(2,time,x,y,b,np)
call SciViz1d(3,time,x,c,np)
call SciViz2d(4,time,x,y,p1x,np)
call SciViz2d(5,time,x,y,p1y,np)

enddo

end

subroutine compute_r(ampl,sigma,r)

real*8 ampl,sigma
real*8, dimension(:,:,:), intent(out) :: r

real*8, dimension(size(r,dim=1)):: x,y,z

!HPF$ PROCESSORS P(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE *(*,BLOCK,*) ONTO *P :: r

!HPF$ DISTRIBUTE (BLOCK) :: y

integer asize,offset
integer i,j,k

asize=size(r,dim=1)
offset=asize/2

forall(i=1:asize) x(i)=i*1.d0
forall(i=1:asize) y(i)=i*1.d0
forall(i=1:asize) z(i)=i*1.d0

forall(i=1:asize,j=1:asize,k=1:asize) &
  r(i,j,k)=ampl*sin(0.1d0*(x(i)+k))*   &
               exp(-((y(j)-offset)**2/sigma))*   &
               exp(-((z(k)-offset)**2/sigma))

end


EXTRINSIC (HPF_LOCAL) subroutine SciViz2d(iflag,time,x,y,fx,np)


USE HPF_LOCAL_LIBRARY

real*8, dimension(:)    ::  x,y
real*8, dimension(:,:)  ::  fx
real*8                  ::  time
integer                 ::  np,iflag
!HPF$ DISTRIBUTE *(*,BLOCK) :: fx
!HPF$ DISTRIBUTE *(BLOCK)   :: y

integer isrv 
real*8, dimension(4)    ::  bb
integer                 ::  nx,ny,me
integer,dimension(2)    ::  ylocal,yglobal
integer, dimension(1)   :: tt

nx=size(x)
ny=size(y)

me=MY_PROCESSOR()

!ylocal(1)=1
!ylocal(2)=ny
!
!call local_to_global(y,ylocal,yglobal)


bb(1)=1
bb(2)=nx
bb(3)=me*ny+1
bb(4)=(me+1)*ny

write(6,100) time,np,nx,ny,bb(3),bb(4),me

100 Format(G17.3,1x,i3,1x,i3,1x,i3,2(1x,g8.3),1x,i2)

!isrv=java_pbbser2d("2d Gauss",time,bb,nx,ny,fx,np)

np=NUMBER_OF_PROCESSORS()
select case (iflag)


case(1)
     isrv=java_bbser2d("a",time,bb,nx,ny,fx,np)
case(2) 
     isrv=java_bbser2d("b",time,bb,nx,ny,fx,np)   
case(4) 
     isrv=java_bbser2d("px",time,bb,nx,ny,fx,np)   
case(5) 
     isrv=java_bbser2d("py",time,bb,nx,ny,fx,np)   

end select
return

end




EXTRINSIC (HPF_LOCAL) subroutine SciViz1d(iflag,time,x,f,np)

USE HPF_LOCAL_LIBRARY

real*8, dimension(:)    ::  x
real*8, dimension(:)    ::  f
real*8                  ::  time
integer                 ::  np,iflag

integer isrv 
real*8, dimension(2)    ::  bb
integer                 ::  nx,me
integer,dimension(2)    ::  ylocal,yglobal
integer, dimension(1)   :: tt

nx=size(x)

me=MY_PROCESSOR()

bb(1)=1
bb(2)=nx

!if(iflag==1) then
!     isrv=java_bbser2d("Gauss",time,bb,nx,ny,fx)
!else if(iflag==2) then 
!     isrv=java_bbser2d("SinCos",time,bb,nx,ny,fx)   
!else
     isrv=java_bbser("c",time,bb,nx,f)        
!endif
return

end






